--[[
 Guild Event Manager GUI
 -------------------------------------
  Code: Movix - Conseil des Ombres - EU
  Constants  
]]

-- HELP SOURCES
if not GEM3_CHANGELOG then
    GEM3_CHANGELOG = {}
end

if not GEM3_FAQ then
    GEM3_FAQ = {}
end

--GridLib.SuperUser = true


GEM3_UI_SECTIONS = {}

GEM3UI_CFGChanEditAllowed = true;
GEM3UIDBG = false;

-- VERSION STUFF
GEM3UI_MAJOR = 2;
GEM3UI_MINOR = 0;
GEM3UI_REVISION = 5;
GEM3UI_MINCOREVERSION = "3.75";

GEM3UI_SAMEVERSION = 0;
GEM3UI_NEWERMAJOR = 1;
GEM3UI_NEWERMINOR = 2;
GEM3UI_NEWERREVISION = 4;
GEM3UI_OLDERMAJOR = 8;
GEM3UI_OLDERMINOR = 16;
GEM3UI_OLDERREVISION = 32;

-- REFRESHING CONSTANTS
GEM3UI_REFRESH_CLOSE_OPEN_EVENTLINE = 1;
GEM3UI_REFRESH_NO_CLOSE_OPEN_EVENTLINE = 2;
GEM3UI_REFRESH_NO_CALENDARREFRESH = 4;

GEM3UI_EVENT_CHANGE_VIEWED = 0;
GEM3UI_EVENT_CHANGE_NEW = 1;
GEM3UI_EVENT_CHANGE_DELETE = 2;
GEM3UI_EVENT_CHANGE_UPDATE = 4;
GEM3UI_EVENT_CHANGE_DATECHANGE = 8;
GEM3UI_EVENT_CHANGE_SUBSCHANGE = 16;
GEM3UI_EVENT_CHANGE_CLOSE = 32;


-- CONSTANTS For UI STUFF
GEM3UI_FrameRatio = 1;
GEM3UI_MainWidth = 718;
GEM3UI_MainHeight = 480;
GEM3UI_OldScale =  1;
GEM3UI_DefaultDDLines = 15;
GEM3UI_DefaultChannelLines = 5;
GEM3UI_DefaultLines = 25;
GEM3UI_DefaultPlayerLines = 16;
GEM3UI_DefaultDayEvents = 6;
GEM3UI_DefaultPlugins = 6;
GEM3UI_DefaultChannelPlayerLines = 23;
GEM3UI_lines = GEM3UI_DefaultLines;
GEM3UI_DefaultLineHeight = 14;
GEM3UI_DefaultLineExpandedMultiplicator = 23;
GEM3UI_EventlineXOffset = 3;

-- DATA CONSTANTS
GEM3UI_OLD = {};
GEM3UIDBGSCRL = {};
GEM3UI_DEBUGDATA = GA_GetTable();
GEM3UI_DebugNav_actPage = 1;
GEM3UI_DEBUGTOTALSHOWNMSG = 0;
GEM3UI_MAXDEBUGLINES = 30000;
GEM3UI_DEBUGLINESPERPAGE = 150;
GEM3UI_MaxLevel = 80;
GEM3UI_IsSizing = false;
GEM3UI_EventSource = nil;
GEM3UI_PluginList = {};
MyEvent = {};
GEM3UI_Popupdata = {};
GEM3UI_EventTypePresent = {};
GEM3UI_EventChannelFilters = {}
GEM3UI_expandedLine = 0;
GEM3_NewEvents = 0;
GEM3UI_DatePickTarget = "date";
GEM3UI_eventcount = 0;
GEM3UI_eventmembercount = 0;
GEM3UI_DayEventCount = 0;
GEM3UI_tabid = 1;
GEM3UI_today = "";
GEM3UI_month = "";
GEM3UI_SELDAY = "";

GEM3UI_totalEvents = 0;
GEM3UI_subsEvents =0;
GEM3UI_closedEvents =0;
GEM3UI_ignoredEvents =0;
GEM3UI_newEvents ={};

GEM3UI_ConnectedMembers = 0;
GEM3UI_ignoredMembers =0;
GEM3UI_totalMembers=0;


-- VARIOUS CONSTANTS FOR EVENT DISPLAYING
GEM3UI_Classes = {
  [1] =  {gemid = "DRUID",   edid=21 , name_loc = GEM3UI_CLASS_STRINGS["DRUID"],   icon = "ability_druid_maul",active = true },
  [2] =  {gemid = "HUNTER",  edid=25 , name_loc = GEM3UI_CLASS_STRINGS["HUNTER"],  icon = "inv_weapon_bow_07", active = true },
  [3] =  {gemid = "MAGE",    edid=29 , name_loc = GEM3UI_CLASS_STRINGS["MAGE"],    icon = "inv_staff_13", active = true },
  [4] =  {gemid = "PALADIN", edid=33 , name_loc = GEM3UI_CLASS_STRINGS["PALADIN"], icon = "inv_hammer_01", active = true },
  [5] =  {gemid = "PRIEST",  edid=37 , name_loc = GEM3UI_CLASS_STRINGS["PRIEST"],  icon = "inv_staff_30", active = true },
  [6] =  {gemid = "ROGUE",   edid=23 , name_loc = GEM3UI_CLASS_STRINGS["ROGUE"],   icon = "inv_throwingknife_04", active = true },
  [7] =  {gemid = "SHAMAN",  edid=27 , name_loc = GEM3UI_CLASS_STRINGS["SHAMAN"],  icon = "spell_nature_bloodlust", active = true },
  [8] =  {gemid = "WARLOCK", edid=31 , name_loc = GEM3UI_CLASS_STRINGS["WARLOCK"], icon = "spell_nature_faeriefire", active = true },
  [9] =  {gemid = "WARRIOR", edid=35 , name_loc = GEM3UI_CLASS_STRINGS["WARRIOR"], icon = "inv_sword_27",  active = true },
  [10] = {gemid = "DEATHKNIGHT",    edid=39 , name_loc = GEM3UI_CLASS_STRINGS["DEATHKNIGHT"],    icon = "inv_helmet_70",  active = true },
}

GEM3UI_Roles = {
 [0] = { gemid = 0, edid=nil , name = "UNKNOWN", name_loc = "", icon ="", active = false},
 [1] = { gemid = 1, edid=41 , name = "TANK", name_loc = GEM3UI_LocalizedStrings["_Tank"], icon ="ability_warrior_defensivestance", active = true},
 [2] = { gemid = 2, edid=47 , name = "CDPS", name_loc = GEM3UI_LocalizedStrings["_Contact"], icon ="ability_parry", active = true},
 [3] = { gemid = 4, edid=45 , name = "RDPS", name_loc = GEM3UI_LocalizedStrings["_Range"], icon ="inv_ammo_snowball", active = true},
 [4] = { gemid = 6, edid=nil , name = "DPS",  name_loc = GEM3UI_LocalizedStrings["_DPS"], icon ="ability_parry", active = false},
 [5] = { gemid = 8, edid=43 , name = "HEAL", name_loc = GEM3UI_LocalizedStrings["_Heal"], icon ="spell_holy_sealofsacrifice", active = true},
}
 

GEM3UI_Queues = {
 [0] = {name=GEM3UI_LocalizedStrings["_unknown"], short=GEM3UI_LocalizedStrings["_unknownshort"], icon=""},
 [1] = {name=GEM3UI_LocalizedStrings["_titular"], short=GEM3UI_LocalizedStrings["_titularshort"], icon="inv_chest_cloth_52" },
 [2] = {name=GEM3UI_LocalizedStrings["_substitute"], short=GEM3UI_LocalizedStrings["_substituteshort"], icon="inv_chest_cloth_53" },
 [3] = {name=GEM3UI_LocalizedStrings["_replacement"], short=GEM3UI_LocalizedStrings["_replacementshort"], icon="inv_chest_cloth_54" },
 [4] = {name=GEM3UI_LocalizedStrings["_not_coming"], short=GEM3UI_LocalizedStrings["_not_comingshort"], icon="" },
 [5] = {name=GEM3UI_LocalizedStrings["_not_ackned"], short=GEM3UI_LocalizedStrings["_not_acknedshort"], icon="inv_chest_cloth_55" },
 [6] = {name=GEM3UI_LocalizedStrings["_discard"], short=GEM3UI_LocalizedStrings["_discarshort"], icon="" },
 [7] = {name=GEM3UI_LocalizedStrings["_unsubscribing"], short=GEM3UI_LocalizedStrings["_unsubscribingshort"], icon="" },
 }


GEM3UI_EV_STATE_NORMAL   = 0;
GEM3UI_EV_STATE_NAK      = 1;
GEM3UI_EV_STATE_SUBS     = 2;
GEM3UI_EV_STATE_CLOSED   = 4;
GEM3UI_EV_STATE_IGNORED  = 8;
GEM3UI_EV_STATE_OUTDATED = 16;
GEM3UI_EV_STATE_BANNED   = 32;
GEM3UI_EV_STATE_DELETED   = 64;
GEM3UI_EV_STATE_UPDATED   = 128;
GEM3UI_EV_STATE_NEW   = 256;
GEM3UI_EV_STATE_PASSED   = 512;

GEM3UI_EVLINE = { -- Eventline icon and color formats
 [GEM3UI_EV_STATE_NORMAL] = {icon="", icon_color = {r = 1, g = 1, b = 1, a = 1 }, texc=nil, line_color = {r = 1, g = 1, b = 1, a = 1 } },
 [GEM3UI_EV_STATE_NAK] = {icon="interface\\AddOns\\GEM3UI\\sub_nak", texc=nil,  icon_color = {r = 0.1, g = 1, b = 0.1, a = 1 }, line_color= {r = 0, g = 1, b = 1, a = 1 }  },
 [GEM3UI_EV_STATE_SUBS] = {icon="interface\\AddOns\\GEM3UI\\check", texc= {l=0, r=0.62, t=0, b=0.68},  icon_color = {r = 0, g = 0.5, b = 0, a = 1 }, line_color= {r = 0, g = 1, b = 1, a = 1 }  }, 
 [GEM3UI_EV_STATE_CLOSED] = {icon="interface\\AddOns\\GEM3UI\\gfx\\lock", texc= nil, icon_color = {r = 1, g = 1, b = 1, a = 1 }, line_color= {r = 1, g = 1, b = 1, a = 0.5 }  },
 [GEM3UI_EV_STATE_IGNORED] = {icon="interface\\AddOns\\GEM3UI\\X", icon_color = {r = 1, g = 0, b = 0, a = 1 },  texc=nil, line_color= {r = 1, g = 0.2, b = 0.2, a = 0.8 }  },
 [GEM3UI_EV_STATE_OUTDATED] = {icon="interface\\AddOns\\GEM3UI\\bell", icon_color = {r = 1, g = 1, b = 1, a = 1 },  texc=nil, line_color= {r = 1, g = 1, b = 1, a = 1 }  },
 [GEM3UI_EV_STATE_BANNED] = {icon="interface\\spellshadow\\spell-shadow-unacceptable", icon_color = nil,  texc=nil, line_color= {r = 0.2, g = 0.2, b = 0.2, a = 0.5 }  },
 [GEM3UI_EV_STATE_DELETED] = {icon="interface\\AddOns\\GEM3UI\\X", icon_color = nil,  texc=nil, line_color= {r = 0.2, g = 0.2, b = 0.2, a = 0.5 }  },
 [GEM3UI_EV_STATE_UPDATED] = {icon="interface\\spellshadow\\spell-shadow-unacceptable", icon_color = nil,  texc=nil, line_color= {r = 0.2, g = 0.2, b = 0.2, a = 0.5 }  },
 [GEM3UI_EV_STATE_NEW] = {icon="interface\\gossipframe\\availablequesticon", icon_color = nil,  texc=nil, line_color= {r = 1, g = 1, b = 1, a = 1 }  },
 [GEM3UI_EV_STATE_PASSED] = {icon="interface\\AddOns\\GEM3UI\\bell", icon_color = nil,  texc=nil, line_color= {r = 1, g = 1, b = 1, a = 0.5 }  },
};

GEM3UI_EVSUBS = { -- Subscription colors
 [0] = {name="NONE", icon_color = {r = 1, g = 1, b = 1, a = 1 }, text_color = {r = 1, g = 1, b = 1, a = 1 } },
 [1] = {name="TIT",  icon_color = {r = 0, g = 1, b = 0, a = 1 }, text_color = {r = 0, g = 1, b = 0, a = 1 }  },
 [2] = {name="SUBS", icon_color = {r = 1, g = 0.85, b = 0.1, a = 1 }, text_color = {r = 1, g = 0.85, b = 0.1, a = 1 }  },
 [3] = {name="REPL", icon_color = {r = 0, g = 0.5, b = 1, a = 1 }, text_color = {r = 0, g = 0.5, b = 1, a = 1 }  },
 [4] = {name="NC",   icon_color = {r = 0.8, g = 0.64, b = 0.42, a = 1 }, text_color = {r = 0.8, g = 0.64, b = 0.42, a = 1 }  },
 [5] = {name="NONE", icon_color = {r = 1, g = 1, b = 1, a = 1 }, text_color = {r = 1, g = 1, b = 1, a = 1 } },
 [6] = {name="NONE", icon_color = {r = 1, g = 1, b = 1, a = 1 }, text_color = {r = 1, g = 1, b = 1, a = 1 } },
 [7] = {name="NONE", icon_color = {r = 1, g = 1, b = 1, a = 1 }, text_color = {r = 1, g = 1, b = 1, a = 1 } },
};


-- CALENDAR CONSTANTS
GEM3UI_monthdays = {
  [1] = 31,
  [2] = 28,
  [3] = 31,
  [4] = 30,
  [5] = 31,
  [6] = 30,
  [7] = 31,
  [8] = 31,
  [9] = 30,
  [10] = 31,
  [11] = 30,
  [12] = 31,
}

GEM3UI_COLOR_CAL_TOPLEFTFIELD = 0;
GEM3UI_COLOR_CAL_DAYHEADER = 1;
GEM3UI_COLOR_CAL_WEEKNUMHEADER = 2;
GEM3UI_COLOR_CAL_DAYLASTNEXTMONTH = 3;
GEM3UI_COLOR_CAL_NORMAL = 4;
GEM3UI_COLOR_CAL_TODAY = 5;
GEM3UI_COLOR_CAL_WITHEVENT = 6;
GEM3UI_COLOR_CAL_WITHSUBSCRIBEDEVENT = 7;
GEM3UI_COLOR_CAL_SELECTEDDAY = 8;
GEM3UI_COLOR_CAL_MOUSEOVER = 9;


-- Calendarfield background color (larger frame, outer)
GEM3UI_calcol = {
		{
			["a"] = 1,
			["r"] = 0.6196078431372549,
			["g"] = 0.6196078431372549,
			["b"] = 0.6196078431372549,
		}, -- [1]
		{
			["a"] = 1,
			["r"] = 0.6196078431372549,
			["g"] = 0.6196078431372549,
			["b"] = 0.6196078431372549,
		}, -- [2]
		{
			["a"] = 1,
			["r"] = 0.2156862745098039,
			["g"] = 0.2156862745098039,
			["b"] = 0.2156862745098039,
		}, -- [3]
		{
			["a"] = 0,
			["r"] = 0.1372549019607843,
			["g"] = 0.1372549019607843,
			["b"] = 0.1372549019607843,
		}, -- [4]
		{
			["a"] = 1,
			["r"] = 0.5058823529411765,
			["g"] = 0.5058823529411765,
			["b"] = 0.5058823529411765,
		}, -- [5]
		{
			["a"] = 1,
			["r"] = 0.5725490196078431,
			["g"] = 0.592156862745098,
			["b"] = 0,
		}, -- [6]
		{
			["a"] = 1,
			["r"] = 0,
			["g"] = 0.04705882352941176,
			["b"] = 0.984313725490196,
		}, -- [7]
		{
			["a"] = 1,
			["r"] = 1,
			["g"] = 1,
			["b"] = 1,
		}, -- [8]
		{
			["a"] = 1,
			["r"] = 1,
			["g"] = 0,
			["b"] = 0,
		}, -- [9]
		[0] = {
			["a"] = 1,
			["r"] = 0.6196078431372549,
			["g"] = 0.6196078431372549,
			["b"] = 0.6196078431372549,
		},
	};

-- Calendarfield color (smaller framer, inner)
GEM3UI_daycol = {
		{
			["a"] = 0.949999988079071,
			["b"] = 0.5529411764705883,
			["g"] = 0.5529411764705883,
			["r"] = 0.5529411764705883,
		}, -- [1]
		{
			["a"] = 0.949999988079071,
			["b"] = 0.5529411764705883,
			["g"] = 0.5529411764705883,
			["r"] = 0.5529411764705883,
		}, -- [2]
		{
			["a"] = 0,
			["b"] = 0.2156862745098039,
			["g"] = 0.2156862745098039,
			["r"] = 0.2156862745098039,
		}, -- [3]
		{
			["a"] = 0.5099999904632568,
			["b"] = 0.1372549019607843,
			["g"] = 0.1372549019607843,
			["r"] = 0.1372549019607843,
		}, -- [4]
		{
			["a"] = 1,
			["b"] = 0.796078431372549,
			["g"] = 0.796078431372549,
			["r"] = 0.796078431372549,
		}, -- [5]
		{
			["a"] = 1,
			["b"] = 0.3333333333333333,
			["g"] = 0.3333333333333333,
			["r"] = 0.3333333333333333,
		}, -- [6]
		{
			["a"] = 1,
			["b"] = 0,
			["g"] = 0.396078431372549,
			["r"] = 0.05490196078431373,
		}, -- [7]
		{
			["a"] = 1,
			["b"] = 0,
			["g"] = 0,
			["r"] = 1,
		}, -- [8]
		{
			["a"] = 1,
			["b"] = 0,
			["g"] = 0,
			["r"] = 1,
		}, -- [9]
		[0] = {
			["a"] = 0,
			["b"] = 0.6901960784313725,
			["g"] = 0.6901960784313725,
			["r"] = 0.6901960784313725,
		},
	};
-- Calendarfield text
GEM3UI_caltext = {
		{
			["a"] = 1,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		}, -- [1]
		{
			["a"] = 1,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		}, -- [2]
		{
			["a"] = 0,
			["b"] = 0.2156862745098039,
			["g"] = 0.2156862745098039,
			["r"] = 0.2156862745098039,
		}, -- [3]
		{
			["a"] = 1,
			["b"] = 0.6666666666666666,
			["g"] = 0.6666666666666666,
			["r"] = 0.6666666666666666,
		}, -- [4]
		{
			["a"] = 1,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		}, -- [5]
		{
			["a"] = 1,
			["b"] = 0,
			["g"] = 1,
			["r"] = 1,
		}, -- [6]
		{
			["a"] = 1,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		}, -- [7]
		{
			["a"] = 1,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		}, -- [8]
		{
			["a"] = 1,
			["b"] = 0,
			["g"] = 0,
			["r"] = 1,
		}, -- [9]
		[0] = {
			["a"] = 1,
			["b"] = 0.6078431372549019,
			["g"] = 0.6078431372549019,
			["r"] = 0.6078431372549019,
		},
	};


-- CONSTANTS FOR TEMPLATE TEMPLATES
GEM3UI_DefaultEvents = {

 [GEM3UI_LocalizedStrings["guildEvents"]] = {
   [GEM3UI_LocalizedStrings["OfficerMeeting"]] = { ev_place=GEM3UI_LocalizedStrings["OfficerMeeting"], ev_comment=GEM3UI_LocalizedStrings["OfficerMeetingComment"], channel="", min_lvl=1, max_lvl=GEM3UI_MaxLevel, max_count=99, sortstring="", ev_type=GEM3_EVT_TYPE_GUILD_EVENT},
   [GEM3UI_LocalizedStrings["GuildSocialEvent"]] = { ev_place=GEM3UI_LocalizedStrings["GuildSocialEvent"], ev_comment=GEM3UI_LocalizedStrings["GuildSocialEventComment"], channel="", min_lvl=1, max_lvl=GEM3UI_MaxLevel, max_count=99, sortstring="", ev_type=GEM3_EVT_TYPE_GUILD_EVENT},
   [GEM3UI_LocalizedStrings["Birthday"]] = { ev_place=GEM3UI_LocalizedStrings["Birthday"], ev_comment=GEM3UI_LocalizedStrings["BirthdayComment"], channel="", min_lvl=1, max_lvl=GEM3UI_MaxLevel, max_count=99, sortstring="", ev_type=GEM3_EVT_TYPE_GUILD_EVENT},
   [GEM3UI_LocalizedStrings["Quest5"]] = { ev_place=GEM3UI_LocalizedStrings["Quest5"], ev_comment=GEM3UI_LocalizedStrings["Quest5Comment"], channel="", min_lvl=1, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_NONE, ev_inst_tag=GEM3_INST_TAG_NONE},
   [GEM3UI_LocalizedStrings["Quest10"]] = { ev_place=GEM3UI_LocalizedStrings["Quest10"], ev_comment=GEM3UI_LocalizedStrings["Quest10Comment"], channel="", min_lvl=1, max_lvl=GEM3UI_MaxLevel, max_count=10, sortstring="", ev_type=GEM3_EVT_TYPE_NONE, ev_inst_tag=GEM3_INST_TAG_NONE},
   [GEM3UI_LocalizedStrings["DailyQuest"]] = { ev_place=GEM3UI_LocalizedStrings["DailyQuest"], ev_comment=GEM3UI_LocalizedStrings["DailyQuestComment"], channel="", min_lvl=50, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_NONE, ev_inst_tag=GEM3_INST_TAG_NONE},
   [GEM3UI_LocalizedStrings["WeeklyRaid"]] = { ev_place=GEM3UI_LocalizedStrings["WeeklyRaid"], ev_comment=GEM3UI_LocalizedStrings["WeeklyRaidComment"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=10, sortstring="", ev_type=GEM3_EVT_TYPE_NONE, ev_inst_tag=GEM3_INST_TAG_NONE},
   [GEM3UI_LocalizedStrings["DailyHero"]] = { ev_place=GEM3UI_LocalizedStrings["DailyHero"], ev_comment=GEM3UI_LocalizedStrings["DailyHeroComment"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_NONE, ev_inst_tag=GEM3_INST_TAG_NONE},

 },
 [GEM3UI_LocalizedStrings["PreBCEventsRaid"]] = {
  [GEM3UI_LocalizedStrings["UBRS"]] = { ev_place=GEM3UI_LocalizedStrings["UBRS"], ev_comment=GEM3UI_LocalizedStrings["UBRSComment"], channel="", min_lvl=45, max_lvl=GEM3UI_MaxLevel, max_count=10, sortstring=""},
  [GEM3UI_LocalizedStrings["ZG"]] = { ev_place=GEM3UI_LocalizedStrings["ZG"], ev_comment=GEM3UI_LocalizedStrings["ZGComment"], channel="", min_lvl=50, max_lvl=GEM3UI_MaxLevel, max_count=20, sortstring="", ev_type=GEM3_EVT_TYPE_RAID, ev_inst_tag=GEM3_INST_TAG_ZG},
  [GEM3UI_LocalizedStrings["AQ20"]] = { ev_place=GEM3UI_LocalizedStrings["AQ20"], ev_comment=GEM3UI_LocalizedStrings["AQ20Comment"], channel="", min_lvl=50, max_lvl=GEM3UI_MaxLevel, max_count=20, sortstring="", ev_type=GEM3_EVT_TYPE_RAID, ev_inst_tag=GEM3_INST_TAG_AQ20},
  [GEM3UI_LocalizedStrings["AQ40"]] = { ev_place=GEM3UI_LocalizedStrings["AQ40"], ev_comment=GEM3UI_LocalizedStrings["AQ40Comment"], channel="", min_lvl=50, max_lvl=GEM3UI_MaxLevel, max_count=40, sortstring="", ev_type=GEM3_EVT_TYPE_RAID, ev_inst_tag=GEM3_INST_TAG_AQ40},
  [GEM3UI_LocalizedStrings["ONY"]] = { ev_place=GEM3UI_LocalizedStrings["ONY"], ev_comment=GEM3UI_LocalizedStrings["ONYComment"], channel="", min_lvl=50, max_lvl=GEM3UI_MaxLevel, max_count=40, sortstring="", ev_type=GEM3_EVT_TYPE_RAID, ev_inst_tag=GEM3_INST_TAG_ONY},
  [GEM3UI_LocalizedStrings["MC"]] = { ev_place=GEM3UI_LocalizedStrings["MC"], ev_comment=GEM3UI_LocalizedStrings["MCComment"], channel="", min_lvl=50, max_lvl=GEM3UI_MaxLevel, max_count=40, sortstring="", ev_type=GEM3_EVT_TYPE_RAID, ev_inst_tag=GEM3_INST_TAG_MC},
  [GEM3UI_LocalizedStrings["NAX"]] = { ev_place=GEM3UI_LocalizedStrings["NAX"], ev_comment=GEM3UI_LocalizedStrings["NAXComment"], channel="", min_lvl=60, max_lvl=GEM3UI_MaxLevel, max_count=40, sortstring="", ev_type=GEM3_EVT_TYPE_RAID, ev_inst_tag=GEM3_INST_TAG_NAX},
  [GEM3UI_LocalizedStrings["BWL"]] = { ev_place=GEM3UI_LocalizedStrings["BWL"], ev_comment=GEM3UI_LocalizedStrings["BWLComment"], channel="", min_lvl=60, max_lvl=GEM3UI_MaxLevel, max_count=40, sortstring="", ev_type=GEM3_EVT_TYPE_RAID, ev_inst_tag=GEM3_INST_TAG_BWL},
 },
 [GEM3UI_LocalizedStrings["BCEventsInstance5"]] = {
   [GEM3UI_LocalizedStrings["HellfireRamp"]] = { ev_place=GEM3UI_LocalizedStrings["HellfireRamp"], ev_comment=GEM3UI_LocalizedStrings["HellfireRampComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BC},
   [GEM3UI_LocalizedStrings["BloodFum"]] = { ev_place=GEM3UI_LocalizedStrings["BloodFum"], ev_comment=GEM3UI_LocalizedStrings["BloodFumComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BC},
   [GEM3UI_LocalizedStrings["SlavePens"]] = { ev_place=GEM3UI_LocalizedStrings["SlavePens"], ev_comment=GEM3UI_LocalizedStrings["SlavePensComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BC},
   [GEM3UI_LocalizedStrings["Underbog"]] = { ev_place=GEM3UI_LocalizedStrings["Underbog"], ev_comment=GEM3UI_LocalizedStrings["UnderbogComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BC},
   [GEM3UI_LocalizedStrings["ManaTomb"]] = { ev_place=GEM3UI_LocalizedStrings["ManaTomb"], ev_comment=GEM3UI_LocalizedStrings["ManaTombComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BC},
   [GEM3UI_LocalizedStrings["Crypt"]] = { ev_place=GEM3UI_LocalizedStrings["Crypt"], ev_comment=GEM3UI_LocalizedStrings["CryptComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BC},
   [GEM3UI_LocalizedStrings["Sethek"]] = { ev_place=GEM3UI_LocalizedStrings["Sethek"], ev_comment=GEM3UI_LocalizedStrings["SethekComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BC},
   [GEM3UI_LocalizedStrings["Steamvault"]] = { ev_place=GEM3UI_LocalizedStrings["Steamvault"], ev_comment=GEM3UI_LocalizedStrings["SteamvaultComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BC},
   [GEM3UI_LocalizedStrings["ShadowLab"]] = { ev_place=GEM3UI_LocalizedStrings["ShadowLab"], ev_comment=GEM3UI_LocalizedStrings["ShadowLabComment"], channel="", min_lvl=65, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BC},
   [GEM3UI_LocalizedStrings["Mechenar"]] = { ev_place=GEM3UI_LocalizedStrings["Mechenar"], ev_comment=GEM3UI_LocalizedStrings["MechenarComment"], channel="", min_lvl=68, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BC},
   [GEM3UI_LocalizedStrings["Botanica"]] = { ev_place=GEM3UI_LocalizedStrings["Botanica"], ev_comment=GEM3UI_LocalizedStrings["BotanicaComment"], channel="", min_lvl=68, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BC},
   [GEM3UI_LocalizedStrings["Arcatraz"]] = { ev_place=GEM3UI_LocalizedStrings["Arcatraz"], ev_comment=GEM3UI_LocalizedStrings["ArcatrazComment"], channel="", min_lvl=68, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BC},
   [GEM3UI_LocalizedStrings["ShatHall"]] = { ev_place=GEM3UI_LocalizedStrings["ShatHall"], ev_comment=GEM3UI_LocalizedStrings["ShatHallComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BC},
   [GEM3UI_LocalizedStrings["CoT1"]] = { ev_place=GEM3UI_LocalizedStrings["CoT1"], ev_comment=GEM3UI_LocalizedStrings["CoT1Comment"], channel="", min_lvl=66, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BC},
   [GEM3UI_LocalizedStrings["CoT2"]] = { ev_place=GEM3UI_LocalizedStrings["CoT2"], ev_comment=GEM3UI_LocalizedStrings["CoT2Comment"], channel="", min_lvl=66, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BC},
 },

 [GEM3UI_LocalizedStrings["BCEventsInstance5Heroic"]] = {
   [GEM3UI_LocalizedStrings["HellfireRampH"]] = { ev_place=GEM3UI_LocalizedStrings["HellfireRampH"], ev_comment=GEM3UI_LocalizedStrings["HellfireRampHComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BCH},
   [GEM3UI_LocalizedStrings["BloodFumH"]] = { ev_place=GEM3UI_LocalizedStrings["BloodFumH"], ev_comment=GEM3UI_LocalizedStrings["BloodFumHComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BCH},
   [GEM3UI_LocalizedStrings["SlavePensH"]] = { ev_place=GEM3UI_LocalizedStrings["SlavePensH"], ev_comment=GEM3UI_LocalizedStrings["SlavePensHComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BCH},
   [GEM3UI_LocalizedStrings["UnderbogH"]] = { ev_place=GEM3UI_LocalizedStrings["UnderbogH"], ev_comment=GEM3UI_LocalizedStrings["UnderbogHComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BCH},
   [GEM3UI_LocalizedStrings["ManaTombH"]] = { ev_place=GEM3UI_LocalizedStrings["ManaTombH"], ev_comment=GEM3UI_LocalizedStrings["ManaTombHComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BCH},
   [GEM3UI_LocalizedStrings["CryptH"]] = { ev_place=GEM3UI_LocalizedStrings["CryptH"], ev_comment=GEM3UI_LocalizedStrings["CryptHComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BCH},
   [GEM3UI_LocalizedStrings["SethekH"]] = { ev_place=GEM3UI_LocalizedStrings["SethekH"], ev_comment=GEM3UI_LocalizedStrings["SethekHComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BCH},
   [GEM3UI_LocalizedStrings["SteamvaultH"]] = { ev_place=GEM3UI_LocalizedStrings["SteamvaultH"], ev_comment=GEM3UI_LocalizedStrings["SteamvaultHComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BCH},
   [GEM3UI_LocalizedStrings["ShadowLabH"]] = { ev_place=GEM3UI_LocalizedStrings["ShadowLabH"], ev_comment=GEM3UI_LocalizedStrings["ShadowLabHComment"], channel="", min_lvl=65, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BCH},
   [GEM3UI_LocalizedStrings["MechenarH"]] = { ev_place=GEM3UI_LocalizedStrings["MechenarH"], ev_comment=GEM3UI_LocalizedStrings["MechenarHComment"], channel="", min_lvl=68, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BCH},
   [GEM3UI_LocalizedStrings["BotanicaH"]] = { ev_place=GEM3UI_LocalizedStrings["BotanicaH"], ev_comment=GEM3UI_LocalizedStrings["BotanicaHComment"], channel="", min_lvl=68, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BCH},
   [GEM3UI_LocalizedStrings["ArcatrazH"]] = { ev_place=GEM3UI_LocalizedStrings["ArcatrazH"], ev_comment=GEM3UI_LocalizedStrings["ArcatrazHComment"], channel="", min_lvl=68, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BCH},
   [GEM3UI_LocalizedStrings["ShatHallH"]] = { ev_place=GEM3UI_LocalizedStrings["ShatHallH"], ev_comment=GEM3UI_LocalizedStrings["ShatHallHComment"], channel="", min_lvl=55, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BCH},
   [GEM3UI_LocalizedStrings["CoT1H"]] = { ev_place=GEM3UI_LocalizedStrings["CoT1H"], ev_comment=GEM3UI_LocalizedStrings["CoT1HComment"], channel="", min_lvl=66, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BCH},
   [GEM3UI_LocalizedStrings["CoT2H"]] = { ev_place=GEM3UI_LocalizedStrings["CoT2H"], ev_comment=GEM3UI_LocalizedStrings["CoT2HComment"], channel="", min_lvl=66, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_BCH},
 },
 
 [GEM3UI_LocalizedStrings["BCEventsRaid"]] = {
   [GEM3UI_LocalizedStrings["Karazhan"]] = { ev_place=GEM3UI_LocalizedStrings["Karazhan"], ev_comment=GEM3UI_LocalizedStrings["KarazhanComment"], channel="", min_lvl=68, max_lvl=GEM3UI_MaxLevel, max_count=10, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_BC, ev_inst_tag=GEM3_INST_TAG_KARA},
   [GEM3UI_LocalizedStrings["ZA"]] = { ev_place=GEM3UI_LocalizedStrings["ZA"], ev_comment=GEM3UI_LocalizedStrings["ZAComment"], channel="", min_lvl=68, max_lvl=GEM3UI_MaxLevel, max_count=10, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_BC, ev_inst_tag=GEM3_INST_TAG_ZA},
   [GEM3UI_LocalizedStrings["Gruul"]] = { ev_place=GEM3UI_LocalizedStrings["Gruul"], ev_comment=GEM3UI_LocalizedStrings["GruulComment"], channel="", min_lvl=65, max_lvl=GEM3UI_MaxLevel, max_count=25, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_BC, ev_inst_tag=GEM3_INST_TAG_GRUUL},
   [GEM3UI_LocalizedStrings["Magtheridon"]] = { ev_place=GEM3UI_LocalizedStrings["Magtheridon"], ev_comment=GEM3UI_LocalizedStrings["MagtheridonComment"], channel="", min_lvl=65, max_lvl=GEM3UI_MaxLevel, max_count=25, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_BC, ev_inst_tag=GEM3_INST_TAG_MAGTH},
   [GEM3UI_LocalizedStrings["SSC"]] = { ev_place=GEM3UI_LocalizedStrings["SSC"], ev_comment=GEM3UI_LocalizedStrings["SSCComment"], channel="", min_lvl=70, max_lvl=GEM3UI_MaxLevel, max_count=25, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_BC, ev_inst_tag=GEM3_INST_TAG_SSC},
   [GEM3UI_LocalizedStrings["TheEye"]] = { ev_place=GEM3UI_LocalizedStrings["TheEye"], ev_comment=GEM3UI_LocalizedStrings["TheEyeComment"], channel="", min_lvl=70, max_lvl=GEM3UI_MaxLevel, max_count=25, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_BC, ev_inst_tag=GEM3_INST_TAG_EYE},
   [GEM3UI_LocalizedStrings["Hyjal"]] = { ev_place=GEM3UI_LocalizedStrings["Hyjal"], ev_comment=GEM3UI_LocalizedStrings["HyjalComment"], channel="", min_lvl=70, max_lvl=GEM3UI_MaxLevel, max_count=25, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_BC, ev_inst_tag=GEM3_INST_TAG_HYJAL},
   [GEM3UI_LocalizedStrings["BlackTemple"]] = { ev_place=GEM3UI_LocalizedStrings["BlackTemple"], ev_comment=GEM3UI_LocalizedStrings["BlackTempleComment"], channel="", min_lvl=70, max_lvl=GEM3UI_MaxLevel, max_count=25, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_BC, ev_inst_tag=GEM3_INST_TAG_BT},
   [GEM3UI_LocalizedStrings["Sunwell"]] = { ev_place=GEM3UI_LocalizedStrings["Sunwell"], ev_comment=GEM3UI_LocalizedStrings["SunwellComment"], channel="", min_lvl=70, max_lvl=GEM3UI_MaxLevel, max_count=25, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_BC, ev_inst_tag=GEM3_INST_TAG_SWP},
 },


 [GEM3UI_LocalizedStrings["WOLKInstanceHeroic"]] = {
   [GEM3UI_LocalizedStrings["UKH"]] = { ev_place=GEM3UI_LocalizedStrings["UKH"], ev_comment=GEM3UI_LocalizedStrings["UKCommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLKH},
   [GEM3UI_LocalizedStrings["NexusH"]] = { ev_place=GEM3UI_LocalizedStrings["NexusH"], ev_comment=GEM3UI_LocalizedStrings["NexusCommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLKH},
   [GEM3UI_LocalizedStrings["ANH"]] = { ev_place=GEM3UI_LocalizedStrings["ANH"], ev_comment=GEM3UI_LocalizedStrings["ANCommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLKH},
   [GEM3UI_LocalizedStrings["AKH"]] = { ev_place=GEM3UI_LocalizedStrings["AKH"], ev_comment=GEM3UI_LocalizedStrings["AKCommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLKH},
   [GEM3UI_LocalizedStrings["DTKH"]] = { ev_place=GEM3UI_LocalizedStrings["DTKH"], ev_comment=GEM3UI_LocalizedStrings["DTKCommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLKH},
   [GEM3UI_LocalizedStrings["VHH"]] = { ev_place=GEM3UI_LocalizedStrings["VHH"], ev_comment=GEM3UI_LocalizedStrings["VHCommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLKH},
   [GEM3UI_LocalizedStrings["GUNH"]] = { ev_place=GEM3UI_LocalizedStrings["GUNH"], ev_comment=GEM3UI_LocalizedStrings["GUNCommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLKH },
   [GEM3UI_LocalizedStrings["COT_SH"]] = { ev_place=GEM3UI_LocalizedStrings["COT_SH"], ev_comment=GEM3UI_LocalizedStrings["COT_SCommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLKH },
   [GEM3UI_LocalizedStrings["HOSH"]] = { ev_place=GEM3UI_LocalizedStrings["HOSH"], ev_comment=GEM3UI_LocalizedStrings["HOSCommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLKH},
   [GEM3UI_LocalizedStrings["UPH"]] = { ev_place=GEM3UI_LocalizedStrings["UPH"], ev_comment=GEM3UI_LocalizedStrings["UPCommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLKH},
   [GEM3UI_LocalizedStrings["OculusH"]] = { ev_place=GEM3UI_LocalizedStrings["OculusH"], ev_comment=GEM3UI_LocalizedStrings["OculusCommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLKH},
   [GEM3UI_LocalizedStrings["HOLH"]] = { ev_place=GEM3UI_LocalizedStrings["HOLH"], ev_comment=GEM3UI_LocalizedStrings["HOLCommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLKH},
--   [GEM3UI_LocalizedStrings["CC5H"]] = { ev_place=GEM3UI_LocalizedStrings["CC5H"], ev_comment=GEM3UI_LocalizedStrings["CC5H"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLKH, ev_inst_tag=GEM3_INST_TAG_TRIAL_CRUSADER},
 },
 [GEM3UI_LocalizedStrings["WOLKInstance"]] = {
   [GEM3UI_LocalizedStrings["UK"]] = { ev_place=GEM3UI_LocalizedStrings["UK"], ev_comment=GEM3UI_LocalizedStrings["UKComment"], channel="", min_lvl=70, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLK},
   [GEM3UI_LocalizedStrings["Nexus"]] = { ev_place=GEM3UI_LocalizedStrings["Nexus"], ev_comment=GEM3UI_LocalizedStrings["NexusComment"], channel="", min_lvl=71, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLK},
   [GEM3UI_LocalizedStrings["AN"]] = { ev_place=GEM3UI_LocalizedStrings["AN"], ev_comment=GEM3UI_LocalizedStrings["ANComment"], channel="", min_lvl=72, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLK},
   [GEM3UI_LocalizedStrings["AK"]] = { ev_place=GEM3UI_LocalizedStrings["AK"], ev_comment=GEM3UI_LocalizedStrings["AKComment"], channel="", min_lvl=73, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLK},
   [GEM3UI_LocalizedStrings["DTK"]] = { ev_place=GEM3UI_LocalizedStrings["DTK"], ev_comment=GEM3UI_LocalizedStrings["DTKComment"], channel="", min_lvl=74, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLK},
   [GEM3UI_LocalizedStrings["VH"]] = { ev_place=GEM3UI_LocalizedStrings["VH"], ev_comment=GEM3UI_LocalizedStrings["VHComment"], channel="", min_lvl=75, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLK},
   [GEM3UI_LocalizedStrings["GUN"]] = { ev_place=GEM3UI_LocalizedStrings["GUN"], ev_comment=GEM3UI_LocalizedStrings["GUNComment"], channel="", min_lvl=76, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLK },
   [GEM3UI_LocalizedStrings["COT_S"]] = { ev_place=GEM3UI_LocalizedStrings["COT_S"], ev_comment=GEM3UI_LocalizedStrings["COT_SComment"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLK },
   [GEM3UI_LocalizedStrings["HOS"]] = { ev_place=GEM3UI_LocalizedStrings["HOS"], ev_comment=GEM3UI_LocalizedStrings["HOSComment"], channel="", min_lvl=77, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLK},
   [GEM3UI_LocalizedStrings["UP"]] = { ev_place=GEM3UI_LocalizedStrings["UP"], ev_comment=GEM3UI_LocalizedStrings["UPComment"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLK},
   [GEM3UI_LocalizedStrings["Oculus"]] = { ev_place=GEM3UI_LocalizedStrings["Oculus"], ev_comment=GEM3UI_LocalizedStrings["OculusComment"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLK},
   [GEM3UI_LocalizedStrings["HOL"]] = { ev_place=GEM3UI_LocalizedStrings["HOL"], ev_comment=GEM3UI_LocalizedStrings["HOLComment"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_INSTANCE5_WOTLK},
--   [GEM3UI_LocalizedStrings["CC5"]] = { ev_place=GEM3UI_LocalizedStrings["CC5"], ev_comment=GEM3UI_LocalizedStrings["CC5Comment"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLKH, ev_inst_tag=GEM3_INST_TAG_TRIAL_CRUSADER},

 },
 [GEM3UI_LocalizedStrings["WOLKRaids"]] = {
   [GEM3UI_LocalizedStrings["NAXX"]] = { ev_place=GEM3UI_LocalizedStrings["NAXX"], ev_comment=GEM3UI_LocalizedStrings["NAXXComment"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=10, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLK, ev_inst_tag=GEM3_INST_TAG_NAXXRAMAS},
   [GEM3UI_LocalizedStrings["OS"]] = { ev_place=GEM3UI_LocalizedStrings["OS"], ev_comment=GEM3UI_LocalizedStrings["OSComment"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=10, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLK, ev_inst_tag=GEM3_INST_TAG_CHAMBEROFASPECTS},
   [GEM3UI_LocalizedStrings["EOE"]] = { ev_place=GEM3UI_LocalizedStrings["EOE"], ev_comment=GEM3UI_LocalizedStrings["EOEComment"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=10, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLK, ev_inst_tag=GEM3_INST_TAG_EYEOFETERNITY},
   [GEM3UI_LocalizedStrings["VOA"]] = { ev_place=GEM3UI_LocalizedStrings["VOA"], ev_comment=GEM3UI_LocalizedStrings["VOAComment"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=10, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLK, ev_inst_tag=GEM3_INST_TAG_WINTERGRASP},
   [GEM3UI_LocalizedStrings["Ulduar"]] = { ev_place=GEM3UI_LocalizedStrings["Ulduar"], ev_comment=GEM3UI_LocalizedStrings["UlduarComment"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=10, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLK, ev_inst_tag=GEM3_INST_TAG_ULDUAR},
   [GEM3UI_LocalizedStrings["CC10"]] = { ev_place=GEM3UI_LocalizedStrings["CC10"], ev_comment=GEM3UI_LocalizedStrings["CC10Comment"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=10, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLKH, ev_inst_tag=GEM3_INST_TAG_TRIAL_CRUSADER},
--   [GEM3UI_LocalizedStrings["CC25"]] = { ev_place=GEM3UI_LocalizedStrings["CC25"], ev_comment=GEM3UI_LocalizedStrings["CC25Comment"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=25, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLKH, ev_inst_tag=GEM3_INST_TAG_TRIAL_GRAND_CRUSADER},

   [GEM3UI_LocalizedStrings["ICC"]] = { ev_place=GEM3UI_LocalizedStrings["ICC"], ev_comment=GEM3UI_LocalizedStrings["ICCComment"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=10, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLK, ev_inst_tag=GEM3_INST_TAG_ICC},
 },
 
 [GEM3UI_LocalizedStrings["WOLKRaidsHeroic"]] = {
   [GEM3UI_LocalizedStrings["NAXXH"]] = { ev_place=GEM3UI_LocalizedStrings["NAXXH"], ev_comment=GEM3UI_LocalizedStrings["NAXXCommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=25, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLKH, ev_inst_tag=GEM3_INST_TAG_NAXXRAMAS},
   [GEM3UI_LocalizedStrings["OSH"]] = { ev_place=GEM3UI_LocalizedStrings["OSH"], ev_comment=GEM3UI_LocalizedStrings["OSCommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=25, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLKH, ev_inst_tag=GEM3_INST_TAG_CHAMBEROFASPECTS},
   [GEM3UI_LocalizedStrings["EOEH"]] = { ev_place=GEM3UI_LocalizedStrings["EOEH"], ev_comment=GEM3UI_LocalizedStrings["EOECommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=25, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLKH, ev_inst_tag=GEM3_INST_TAG_EYEOFETERNITY},
   [GEM3UI_LocalizedStrings["VOAH"]] = { ev_place=GEM3UI_LocalizedStrings["VOAH"], ev_comment=GEM3UI_LocalizedStrings["VOACommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=25, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLKH, ev_inst_tag=GEM3_INST_TAG_WINTERGRASP},
   [GEM3UI_LocalizedStrings["UlduarH"]] = { ev_place=GEM3UI_LocalizedStrings["UlduarH"], ev_comment=GEM3UI_LocalizedStrings["UlduarCommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=25, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLKH, ev_inst_tag=GEM3_INST_TAG_ULDUAR},
   [GEM3UI_LocalizedStrings["CC10H"]] = { ev_place=GEM3UI_LocalizedStrings["CC10H"], ev_comment=GEM3UI_LocalizedStrings["CC10CommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=10, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLKH, ev_inst_tag=GEM3_INST_TAG_TRIAL_CRUSADER},
--   [GEM3UI_LocalizedStrings["CC25H"]] = { ev_place=GEM3UI_LocalizedStrings["CC25H"], ev_comment=GEM3UI_LocalizedStrings["CC25CommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=25, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLKH, ev_inst_tag=GEM3_INST_TAG_TRIAL_GRAND_CRUSADER},
   [GEM3UI_LocalizedStrings["ICCH"]] = { ev_place=GEM3UI_LocalizedStrings["ICCH"], ev_comment=GEM3UI_LocalizedStrings["ICCCommentH"], channel="", min_lvl=80, max_lvl=GEM3UI_MaxLevel, max_count=25, sortstring="", ev_type=GEM3_EVT_TYPE_RAID_WOTLKH, ev_inst_tag=GEM3_INST_TAG_ICC},
 }, 
 
 [GEM3UI_LocalizedStrings["PvPEvents"]] = {
   [GEM3UI_LocalizedStrings["Arena2vs2"]] = { ev_place=GEM3UI_LocalizedStrings["Arena2vs2"], ev_comment=GEM3UI_LocalizedStrings["Arena2vs2Comment"], channel="", min_lvl=70, max_lvl=GEM3UI_MaxLevel, max_count=2, sortstring="", ev_type=GEM3_EVT_TYPE_PVP},
   [GEM3UI_LocalizedStrings["Arena3vs3"]] = { ev_place=GEM3UI_LocalizedStrings["Arena3vs3"], ev_comment=GEM3UI_LocalizedStrings["Arena3vs3Comment"], channel="", min_lvl=70, max_lvl=GEM3UI_MaxLevel, max_count=3, sortstring="", ev_type=GEM3_EVT_TYPE_PVP},
   [GEM3UI_LocalizedStrings["Arena5vs5"]] = { ev_place=GEM3UI_LocalizedStrings["Arena5vs5"], ev_comment=GEM3UI_LocalizedStrings["Arena5vs5Comment"], channel="", min_lvl=70, max_lvl=GEM3UI_MaxLevel, max_count=5, sortstring="", ev_type=GEM3_EVT_TYPE_PVP},
   [GEM3UI_LocalizedStrings["PvPRaid"]] = { ev_place=GEM3UI_LocalizedStrings["PvPRaid"], ev_comment=GEM3UI_LocalizedStrings["PvPRaidComment"], channel="", min_lvl=60, max_lvl=GEM3UI_MaxLevel, max_count=40, sortstring="", ev_type=GEM3_EVT_TYPE_PVP},
   [GEM3UI_LocalizedStrings["BGAlterac"]] = { ev_place=GEM3UI_LocalizedStrings["BGAlterac"], ev_comment=GEM3UI_LocalizedStrings["BGAlteracComment"], channel="", min_lvl=51, max_lvl=GEM3UI_MaxLevel, max_count=40, sortstring="", ev_type=GEM3_EVT_TYPE_PVP},
   [GEM3UI_LocalizedStrings["BGArathi"]] = { ev_place=GEM3UI_LocalizedStrings["BGArathi"], ev_comment=GEM3UI_LocalizedStrings["BGArathiComment"], channel="", min_lvl=20, max_lvl=GEM3UI_MaxLevel, max_count=15, sortstring="", ev_type=GEM3_EVT_TYPE_PVP},
   [GEM3UI_LocalizedStrings["BGWarsong"]] = { ev_place=GEM3UI_LocalizedStrings["BGWarsong"], ev_comment=GEM3UI_LocalizedStrings["BGWarsongComment"], channel="", min_lvl=10, max_lvl=GEM3UI_MaxLevel, max_count=10, sortstring="", ev_type=GEM3_EVT_TYPE_PVP},
   [GEM3UI_LocalizedStrings["EoTS"]] = { ev_place=GEM3UI_LocalizedStrings["EoTS"], ev_comment=GEM3UI_LocalizedStrings["EoTSComment"], channel="", min_lvl=61, max_lvl=GEM3UI_MaxLevel, max_count=15, sortstring="", ev_type=GEM3_EVT_TYPE_PVP},
   [GEM3UI_LocalizedStrings["IOC"]] = { ev_place=GEM3UI_LocalizedStrings["IOC"], ev_comment=GEM3UI_LocalizedStrings["IOCComment"], channel="", min_lvl=71, max_lvl=GEM3UI_MaxLevel, max_count=40, sortstring="", ev_type=GEM3_EVT_TYPE_PVP},
 },
}

GEM3UI_INST_TYPE_GUILD              = GEM3_EVT_TYPE_CUSTOM_START + 1;

GEM3UI_INST_TAG_GUILD_OFFMETTING    = GEM3_INST_TYPE_CUSTOM_START + 1;
GEM3UI_INST_TAG_GUILD_SOCIAL        = GEM3_INST_TYPE_CUSTOM_START + 2;
GEM3UI_INST_TAG_GUILD_BIRTHDAY      = GEM3_INST_TYPE_CUSTOM_START + 3;
GEM3UI_INST_TAG_GUILD_QUEST5        = GEM3_INST_TYPE_CUSTOM_START + 4;
GEM3UI_INST_TAG_GUILD_QUEST10       = GEM3_INST_TYPE_CUSTOM_START + 5;
GEM3UI_INST_TAG_GUILD_DAILYQUEST    = GEM3_INST_TYPE_CUSTOM_START + 6;
GEM3UI_INST_TAG_GUILD_DAILYHERO     = GEM3_INST_TYPE_CUSTOM_START + 7;
GEM3UI_INST_TAG_GUILD_WEEKLYRAID    = GEM3_INST_TYPE_CUSTOM_START + 8;

GEM3UI_INST_TAG_PVP_2V2             = GEM3_INST_TYPE_CUSTOM_START + 20;
GEM3UI_INST_TAG_PVP_3V3             = GEM3_INST_TYPE_CUSTOM_START + 21;
GEM3UI_INST_TAG_PVP_5V5             = GEM3_INST_TYPE_CUSTOM_START + 22;
GEM3UI_INST_TAG_PVP_RAID            = GEM3_INST_TYPE_CUSTOM_START + 23;
GEM3UI_INST_TAG_PVP_ALTE            = GEM3_INST_TYPE_CUSTOM_START + 24;
GEM3UI_INST_TAG_PVP_ARATHI          = GEM3_INST_TYPE_CUSTOM_START + 25;
GEM3UI_INST_TAG_PVP_WARSONG         = GEM3_INST_TYPE_CUSTOM_START + 26;
GEM3UI_INST_TAG_PVP_EOTS            = GEM3_INST_TYPE_CUSTOM_START + 27;
GEM3UI_INST_TAG_PVP_IOC             = GEM3_INST_TYPE_CUSTOM_START + 28;
GEM3UI_INST_TAG_PVP_SOA             = GEM3_INST_TYPE_CUSTOM_START + 29;

GEM3UI_INST_TAG_BC5_HELLFIRERAMP    = GEM3_INST_TYPE_CUSTOM_START + 30;
GEM3UI_INST_TAG_BC5_BLOODFUM        = GEM3_INST_TYPE_CUSTOM_START + 31;
GEM3UI_INST_TAG_BC5_SLAVEPENS       = GEM3_INST_TYPE_CUSTOM_START + 32;
GEM3UI_INST_TAG_BC5_UNDERBOG        = GEM3_INST_TYPE_CUSTOM_START + 33;
GEM3UI_INST_TAG_BC5_MANATOMB        = GEM3_INST_TYPE_CUSTOM_START + 34;
GEM3UI_INST_TAG_BC5_CRYPT           = GEM3_INST_TYPE_CUSTOM_START + 35;
GEM3UI_INST_TAG_BC5_SETHEK          = GEM3_INST_TYPE_CUSTOM_START + 36;
GEM3UI_INST_TAG_BC5_STEAMVAULT      = GEM3_INST_TYPE_CUSTOM_START + 37;
GEM3UI_INST_TAG_BC5_SHADOWLAB       = GEM3_INST_TYPE_CUSTOM_START + 38;
GEM3UI_INST_TAG_BC5_MECHENAR        = GEM3_INST_TYPE_CUSTOM_START + 39;
GEM3UI_INST_TAG_BC5_BOTANICA        = GEM3_INST_TYPE_CUSTOM_START + 40;
GEM3UI_INST_TAG_BC5_ARCATRAZ        = GEM3_INST_TYPE_CUSTOM_START + 41;
GEM3UI_INST_TAG_BC5_SHATHALL        = GEM3_INST_TYPE_CUSTOM_START + 42;
GEM3UI_INST_TAG_BC5_COT1            = GEM3_INST_TYPE_CUSTOM_START + 43;
GEM3UI_INST_TAG_BC5_COT2            = GEM3_INST_TYPE_CUSTOM_START + 44;
--WOTLK
GEM3UI_INST_TAG_WOTLK5_UK           = GEM3_INST_TYPE_CUSTOM_START + 60;
GEM3UI_INST_TAG_WOTLK5_NEXUS        = GEM3_INST_TYPE_CUSTOM_START + 61;
GEM3UI_INST_TAG_WOTLK5_AN           = GEM3_INST_TYPE_CUSTOM_START + 62;
GEM3UI_INST_TAG_WOTLK5_AK           = GEM3_INST_TYPE_CUSTOM_START + 63;
GEM3UI_INST_TAG_WOTLK5_DTK          = GEM3_INST_TYPE_CUSTOM_START + 64;
GEM3UI_INST_TAG_WOTLK5_VH           = GEM3_INST_TYPE_CUSTOM_START + 65;
GEM3UI_INST_TAG_WOTLK5_GUN          = GEM3_INST_TYPE_CUSTOM_START + 66;
GEM3UI_INST_TAG_WOTLK5_COT_S        = GEM3_INST_TYPE_CUSTOM_START + 67;
GEM3UI_INST_TAG_WOTLK5_HOS          = GEM3_INST_TYPE_CUSTOM_START + 68;
GEM3UI_INST_TAG_WOTLK5_UP           = GEM3_INST_TYPE_CUSTOM_START + 69;
GEM3UI_INST_TAG_WOTLK5_OCULUS       = GEM3_INST_TYPE_CUSTOM_START + 70;
GEM3UI_INST_TAG_WOTLK5_HOL          = GEM3_INST_TYPE_CUSTOM_START + 71;



TaggedInstances = {
 [GEM3_INST_TAG_NONE]               = {players=0, minlvl=1, name = "",            icon = "interface\\icons\\inv_misc_questionmark"},
 [GEM3_INST_TAG_UBRS]               = {players=10, minlvl=45, name = "UBRS",        icon = "interface\\lfgframe\\MoltenCore"},
 [GEM3_INST_TAG_ZG]                 = {players=20, minlvl=50, name = "ZG",          icon = "interface\\lfgframe\\LFGIcon-ZulGurub"},
 [GEM3_INST_TAG_MC]                 = {players=40, minlvl=50, name = "MC",          icon = "interface\\lfgframe\\LFGIcon-MoltenCore"},
 [GEM3_INST_TAG_AQ20]               = {players=20, minlvl=50, name = "AQ20",        icon = "interface\\lfgframe\\LFGIcon-AQRuins"},
 [GEM3_INST_TAG_AQ40]               = {players=40, minlvl=50, name = "AQ40",        icon = "interface\\lfgframe\\LFGIcon-AQTemple"},
 [GEM3_INST_TAG_NAX]                = {players=25, minlvl=60, name = "NAX",         icon = "interface\\lfgframe\\LFGIcon-Naxxramas"},
 [GEM3_INST_TAG_BWL]                = {players=40, minlvl=60, name = "BWL",         icon = "interface\\lfgframe\\LFGIcon-BlackwingLair"},
 [GEM3_INST_TAG_ONY]                = {players=20, minlvl=50, name = "ONY",         icon = "interface\\icons\\inv_misc_head_dragon_red"},
 [GEM3_INST_TAG_KARA]               = {players=10, minlvl=68, name = "Karazhan",    icon = "interface\\lfgframe\\LFGIcon-Karazhan"},
 [GEM3_INST_TAG_ZA]                 = {players=10, minlvl=68, name = "ZA",          icon = "interface\\lfgframe\\LFGIcon-ZulAman"},
 [GEM3_INST_TAG_MAGTH]              = {players=25, minlvl=65, name = "Magtheridon", icon = "interface\\lfgframe\\LFGIcon-HellfireCitadelRaid"},
 [GEM3_INST_TAG_GRUUL]              = {players=25, minlvl=65, name = "Gruul",       icon = "interface\\lfgframe\\LFGIcon-GruulsLair"},
 [GEM3_INST_TAG_SSC]                = {players=25, minlvl=70, name = "SSC",         icon = "interface\\lfgframe\\LFGIcon-SerpentshrineCavern"},
 [GEM3_INST_TAG_EYE]                = {players=25, minlvl=70, name = "TheEye",      icon = "interface\\lfgframe\\LFGIcon-TempestKeep"},
 [GEM3_INST_TAG_HYJAL]              = {players=25, minlvl=70, name = "Hyjal",       icon = "interface\\lfgframe\\LFGIcon-HyjalPast"},
 [GEM3_INST_TAG_BT]                 = {players=25, minlvl=70, name = "BlackTemple", icon = "interface\\lfgframe\\LFGIcon-BlackTemple"},
 [GEM3_INST_TAG_SWP]                = {players=25, minlvl=70, name = "Sunwell",     icon = "interface\\lfgframe\\LFGIcon-Sunwell"},
 [GEM3_INST_TAG_NAXXRAMAS]          = {players=25, minlvl=80, name = "NAX",         icon = "interface\\lfgframe\\LFGIcon-Naxxramas"},
 [GEM3_INST_TAG_CHAMBEROFASPECTS]   = {players=25, minlvl=80, name = "OS",          icon = "interface\\lfgframe\\LFGIcon-chamberofaspects"},
 [GEM3_INST_TAG_EYEOFETERNITY]      = {players=25, minlvl=80, name = "EOE",         icon = "interface\\lfgframe\\LFGIcon-malygos"},
 [GEM3_INST_TAG_WINTERGRASP]        = {players=25, minlvl=80, name = "VOA",         icon = "interface\\lfgframe\\LFGIcon-VaultOfArchavon"},
 [GEM3_INST_TAG_ULDUAR]             = {players=25, minlvl=80, name = "Ulduar",      icon = "interface\\lfgframe\\LFGIcon-UlduarRaid"},
 [GEM3_INST_TAG_TRIAL_CRUSADER]     = {players=25, minlvl=80, name = "CC",        icon = "interface\\lfgframe\\LFGIcon-ArgentRaid"},
 [GEM3_INST_TAG_ICC]                = {players=25, minlvl=80, name = "ICC",         icon = "interface\\lfgframe\\LFGIcon-IcecrownCitadel"},
[GEM3UI_INST_TAG_GUILD_OFFMETTING]  = {players=99, minlvl=1, name = "OfficerMeeting",         icon = "interface\\lfgframe\\LFGIcon-ArgentDungeon"},
[GEM3UI_INST_TAG_GUILD_SOCIAL]      = {players=99, minlvl=1, name = "GuildSocialEvent",         icon = "interface\\lfgframe\\LFGIcon-ArgentDungeon"},
[GEM3UI_INST_TAG_GUILD_BIRTHDAY]    = {players=1, minlvl=1, name = "Birthday",         icon = "interface\\lfgframe\\LFGIcon-ArgentDungeon"},
[GEM3UI_INST_TAG_GUILD_QUEST5]      = {players=5, minlvl=1, name = "Quest5",         icon = "interface\\lfgframe\\LFGIcon-QUEST"},
[GEM3UI_INST_TAG_GUILD_QUEST10]     = {players=10, minlvl=45, name = "Quest10",         icon = "interface\\lfgframe\\LFGIcon-quest"},
[GEM3UI_INST_TAG_GUILD_DAILYQUEST]  = {players=5, minlvl=70, name = "DailyQuest",         icon = "interface\\lfgframe\\LFGIcon-quest"},
[GEM3UI_INST_TAG_GUILD_DAILYHERO]   = {players=5, minlvl=80, name = "DailyHero",         icon = "interface\\lfgframe\\LFGIcon-quest"},
[GEM3UI_INST_TAG_GUILD_WEEKLYRAID]  = {players=10, minlvl=80, name = "WeeklyRaid",         icon = "interface\\lfgframe\\LFGIcon-quest"},

[GEM3UI_INST_TAG_BC5_HELLFIRERAMP] = {players = 5, minlvl=55, name = "HellfireRamp",         icon = "interface\\lfgframe\\LFGIcon-hellfirecitadel5man"},
[GEM3UI_INST_TAG_BC5_BLOODFUM] = {players = 5, minlvl=55, name = "BloodFum",         icon = "interface\\lfgframe\\LFGIcon-hellfirecitadel5man"},
[GEM3UI_INST_TAG_BC5_SLAVEPENS] = {players = 5, minlvl=55, name = "SlavePens",         icon = "interface\\lfgframe\\ffgicon-hellfirecitadel5man"},       
[GEM3UI_INST_TAG_BC5_UNDERBOG] = {players = 5, minlvl=65, name = "Underbog",         icon = "interface\\lfgframe\\LFGIcon-auchindoun"},        
[GEM3UI_INST_TAG_BC5_MANATOMB] = {players = 5, minlvl=65, name = "ManaTomb",         icon = "interface\\lfgframe\\LFGIcon-auchindoun"},        
[GEM3UI_INST_TAG_BC5_CRYPT] = {players = 5, minlvl=65, name = "Crypt",         icon = "interface\\lfgframe\\LFGIcon-auchindoun"},           
[GEM3UI_INST_TAG_BC5_SETHEK] = {players = 5, minlvl=65, name = "Sethek",         icon = "interface\\lfgframe\\LFGIcon-auchindoun"},          
[GEM3UI_INST_TAG_BC5_STEAMVAULT] = {players = 5, minlvl=70, name = "Steamvault",         icon = "interface\\lfgframe\\LFGIcon-ArgentDungeon"},      
[GEM3UI_INST_TAG_BC5_SHADOWLAB] = {players = 5, minlvl=65, name = "ShadowLab",         icon = "interface\\lfgframe\\LFGIcon-auchindoun"},       
[GEM3UI_INST_TAG_BC5_MECHENAR] = {players = 5, minlvl=68, name = "Mechenar",         icon = "interface\\lfgframe\\LFGIcon-ArgentDungeon"},        
[GEM3UI_INST_TAG_BC5_BOTANICA] = {players = 5, minlvl=68, name = "Botanica",         icon = "interface\\lfgframe\\LFGIcon-ArgentDungeon"},        
[GEM3UI_INST_TAG_BC5_ARCATRAZ] = {players = 5, minlvl=68, name = "Arcatraz",         icon = "interface\\lfgframe\\LFGIcon-ArgentDungeon"},        
[GEM3UI_INST_TAG_BC5_SHATHALL] = {players = 5, minlvl=68, name = "ShatHall",         icon = "interface\\lfgframe\\LFGIcon-ArgentDungeon"},        
[GEM3UI_INST_TAG_BC5_COT1] = {players = 5, minlvl=66, name = "CoT1",         icon = "interface\\lfgframe\\LFGIcon-cavernsoftime"},            
[GEM3UI_INST_TAG_BC5_COT2] = {players = 5, minlvl=66, name = "CoT2",         icon = "interface\\lfgframe\\LFGIcon-cavernsoftime"},            
--WOTLK
[GEM3UI_INST_TAG_WOTLK5_UK] = {players = 5, minlvl=70, name = "UK",         icon = "interface\\lfgframe\\LFGIcon-Utgarde"},           
[GEM3UI_INST_TAG_WOTLK5_NEXUS] = {players = 5, minlvl=71, name = "Nexus",         icon = "interface\\lfgframe\\LFGIcon-TheOculus"},        
[GEM3UI_INST_TAG_WOTLK5_AN] = {players = 5, minlvl=72, name = "AN",         icon = "interface\\lfgframe\\LFGIcon-AzjolNerub"},           
[GEM3UI_INST_TAG_WOTLK5_AK] = {players = 5, minlvl=73, name = "AK",         icon = "interface\\lfgframe\\LFGIcon-Ahnkalet"},           
[GEM3UI_INST_TAG_WOTLK5_DTK] = {players = 5, minlvl=74, name = "DTK",         icon = "interface\\lfgframe\\LFGIcon-DrakTharon"},          
[GEM3UI_INST_TAG_WOTLK5_VH] = {players = 5, minlvl=75, name = "VH",         icon = "interface\\lfgframe\\LFGIcon-TheVioletHold"},           
[GEM3UI_INST_TAG_WOTLK5_GUN] = {players = 5, minlvl=76, name = "GUN",         icon = "interface\\lfgframe\\LFGIcon-Gundrak"},          
[GEM3UI_INST_TAG_WOTLK5_COT_S] = {players = 5, minlvl=80, name = "COT_S",         icon = "interface\\lfgframe\\LFGIcon-OldStratholme"},        
[GEM3UI_INST_TAG_WOTLK5_HOS] = {players = 5, minlvl=77, name = "HOS",         icon = "interface\\lfgframe\\LFGIcon-HallsofStone"},          
[GEM3UI_INST_TAG_WOTLK5_UP] = {players = 5, minlvl=80, name = "UP",         icon = "interface\\lfgframe\\LFGIcon-UtgardePinnacle"},           
[GEM3UI_INST_TAG_WOTLK5_OCULUS] = {players = 5, minlvl=80, name = "Oculus",         icon = "interface\\lfgframe\\LFGIcon-TheOculus"},       
[GEM3UI_INST_TAG_WOTLK5_HOL] = {players = 5, minlvl=80, name = "HOL",         icon = "interface\\lfgframe\\LFGIcon-HallsofLightning"},          

[GEM3UI_INST_TAG_PVP_2V2] = {players=2, minlvl=70, name = "Arena2vs2",         icon = "interface\\lfgframe\\LFGIcon-battleground"},
[GEM3UI_INST_TAG_PVP_3V3] = {players=3, minlvl=70, name = "Arena3vs3",         icon = "interface\\lfgframe\\LFGIcon-battleground"},
[GEM3UI_INST_TAG_PVP_5V5] = {players=5, minlvl=70, name = "Arena5vs5",         icon = "interface\\lfgframe\\LFGIcon-battleground"},
[GEM3UI_INST_TAG_PVP_RAID] = {players=40, minlvl=60, name = "PvPRaid",         icon = "interface\\lfgframe\\LFGIcon-battleground"},
[GEM3UI_INST_TAG_PVP_ALTE] = {players=40, minlvl=60, name = "BGAlterac",         icon = "interface\\lfgframe\\LFGIcon-battleground"},
[GEM3UI_INST_TAG_PVP_ARATHI] = {players=20, minlvl=30, name = "BGArathi",         icon = "interface\\lfgframe\\LFGIcon-arathibasin"},
[GEM3UI_INST_TAG_PVP_WARSONG] = {players=10, minlvl=10, name = "BGWarsong",         icon = "interface\\lfgframe\\LFGIcon-battleground"},
[GEM3UI_INST_TAG_PVP_EOTS] = {players=40, minlvl=70, name = "EoTS",         icon = "interface\\lfgframe\\LFGIcon-battleground"},
[GEM3UI_INST_TAG_PVP_IOC] = {players=40, minlvl=70, name = "IOC",         icon = "interface\\lfgframe\\LFGIcon-isleofconquest"},
[GEM3UI_INST_TAG_PVP_SOA] = {players=40, minlvl=80, name = "SoA",         icon = "interface\\lfgframe\\LFGIcon-battleground"},
}

GEM3UI_TagVersions = {
    [GEM3UI_INST_TYPE_GUILD] = "Guild",
    [GEM3_INST_TYPE_NONE] = "Standard",
    [GEM3_INST_TYPE_BG] = "BG",
    [GEM3_INST_TYPE_ARENA] = "Arena",
    [GEM3_INST_TYPE_PARTY] = "5",
    [GEM3_INST_TYPE_PARTY_HEROIC] = "5h",
    [GEM3_INST_TYPE_RAID_10] = "10",
    [GEM3_INST_TYPE_RAID_25] = "25",
    [GEM3_INST_TYPE_RAID_10_HEROIC] = "10H",
    [GEM3_INST_TYPE_RAID_25_HEROIC] = "25H",
    [GEM3_INST_TYPE_RAID_20] = "20"; -- Vanilla
    [GEM3_INST_TYPE_RAID_40] = "40"; -- Vanilla
}


GEM3UI_Gridtheme_Neutral = {
            ["DGridParams"] = {
				["inherits"] = "GEM3UI_GridDefaults",
				["GridBGcolor"] = {
					0, -- [1]
					0, -- [2]
					0, -- [3]
					0.4599999785423279, -- [4]
				},
				["OddLineColor"] = {
					0.4313725490196079, -- [1]
					0.4470588235294117, -- [2]
					0.4431372549019608, -- [3]
					0.2299999892711639, -- [4]
				},
				["HeaderBGcolor"] = {
					0.5019607843137255, -- [1]
					0.3019607843137255, -- [2]
					0.4, -- [3]
					0.5999999642372131, -- [4]
				},
				["DefaultTextColor"] = {
					1, -- [1]
					1, -- [2]
					1, -- [3]
					1, -- [4]
				},
				["DefaultTextureColor"] = {
					1, -- [1]
					1, -- [2]
					1, -- [3]
					1, -- [4]
				},
				["HeaderTextColor"] = {
					1, -- [1]
					0.9647058823529412, -- [2]
					0.9411764705882353, -- [3]
					1, -- [4]
				},
        }
}

GEM3UI_Gridtheme_Horde = {
            ["DGridParams"] = {
                ["inherits"] = "GEM3UI_GridDefaults",
				["GridBGcolor"] = {
					0.4117647058823529, -- [1]
					0.05098039215686274, -- [2]
					0.02745098039215686, -- [3]
					0.3700000047683716, -- [4]
				},
				["OddLineColor"] = {
					0.4313725490196079, -- [1]
					0.4470588235294117, -- [2]
					0.4431372549019608, -- [3]
					0.2299999892711639, -- [4]
				},
				["HeaderBGcolor"] = {
					0.7254901960784314, -- [1]
					0.03137254901960784, -- [2]
					0, -- [3]
					0.9599999785423279, -- [4]
				},
				["DefaultTextColor"] = {
					1, -- [1]
					1, -- [2]
					1, -- [3]
					1, -- [4]
				},
				["DefaultTextureColor"] = {
					1, -- [1]
					1, -- [2]
					1, -- [3]
					1, -- [4]
				},
				["HeaderTextColor"] = {
					1, -- [1]
					0.9647058823529412, -- [2]
					0.9411764705882353, -- [3]
					1, -- [4]
				},
        }
}

GEM3UI_Gridtheme_Alliance = {
            ["DGridParams"] = {
                ["inherits"] = "GEM3UI_GridDefaults",
				["GridBGcolor"] = {
					0.03529411764705882, -- [1]
					0.05098039215686274, -- [2]
					0.4117647058823529, -- [3]
					0.3700000047683716, -- [4]
				},
				["OddLineColor"] = {
					0.4313725490196079, -- [1]
					0.4470588235294117, -- [2]
					0.4431372549019608, -- [3]
					0.2299999892711639, -- [4]
				},
				["HeaderBGcolor"] = {
					0.09019607843137255, -- [1]
					0.07843137254901961, -- [2]
					0.8705882352941177, -- [3]
					0.5299999713897705, -- [4]
				},
				["DefaultTextColor"] = {
					1, -- [1]
					1, -- [2]
					1, -- [3]
					1, -- [4]
				},
				["DefaultTextureColor"] = {
					1, -- [1]
					1, -- [2]
					1, -- [3]
					1, -- [4]
				},
				["HeaderTextColor"] = {
					1, -- [1]
					0.9019607843137255, -- [2]
					0, -- [3]
					1, -- [4]
				},

        }
}



GEM3UI_EVENTS_LeaderDefaults = {
            ["DGridParams"] = {
				["inherits"] = "GEM3UI_THEME_Neutral",
				["LineHeight"] = 21,
				["ValueFontSize"] = 6,
				["resetfoo"] = "GEM3UI_ResetEventGrid",
				["headerheight"] = 20.88505787372714,
				["LabelFontSize"] = 7,
				["DataSource"] = "MyEvent",
			},
			["GridParams"] = {
				["OnClickFoo"] = "GEM3UI_GridEventLineOnClick",
				["OnRclickFoo"] = "GEM3UI_GridEventMenu",
				["OnLeaveFoo"] = "GEM3UI_GridEventLineOnLeave",
				["OnEnterFoo"] = "GEM3UI_GridEventLineOnEnter",
				["headerheight"] = 15,
				["OnDclickFoo"] = "GEM3UI_GridEventLineOnDClick",
				["disableAdvancedCFG"] = 1,
				["sortcol"] = {
					-5, -- [1]
				},
			},
			["Headers"] = {
				{
					["lbl"] = "#_Show Event Details",
					["valmaxw"] = 14,
					["clickfoo"] = "GEM3UI_GridEventLineopen",
					["Rpoint"] = 11.787250272882,
					["val"] = "MovixLibID",
					["visible"] = true,
					["ComputedH"] = 14,
					["sortorder"] = false,
					["size"] = 10.287250272882,
					["disablehedit"] = 1,
					["type"] = "custombutton",
					["valfoo"] = "GEM3UI_GetOpenButtonText",
					["valminw"] = 14,
					["tooltip"] = "Show Event Details",
					["disablefilter"] = 1,
					["justify"] = "LEFT",
					["valminh"] = 14,
					["valmaxh"] = 14,
					["ComputedW"] = 14,
					["Lpoint"] = 3,
					["disablesort"] = 1,
					["disabledatatype"] = 1,
					["disablecolreset"] = 1,
					["pos"] = 1,
				}, -- [1]
				{
					["lbl"] = "#_Eventtype Icon",
					["valmaxw"] = 15,
					["Rpoint"] = 27.281484784078,
					["ComputedH"] = 15,
					["size"] = 12.494234511196,
					["disablehedit"] = 1,
					["type"] = "texture",
					["justify"] = "LEFT",
					["val"] = "EventTexture",
					["valminw"] = 15,
					["visible"] = true,
					["disablefilter"] = 1,
					["texturecolor"] = {
						1, -- [1]
						1, -- [2]
						1, -- [3]
						1, -- [4]
					},
					["valminh"] = 15,
					["valmaxh"] = 15,
					["sortorder"] = false,
					["Lpoint"] = 16.287250272882,
					["ComputedW"] = 15,
					["disabledatatype"] = 1,
					["disablecolreset"] = 1,
					["pos"] = 2,
				}, -- [2]
				{
					["lbl"] = "#_Subscription Status",
					["valmaxw"] = 12,
					["colorfooval"] = "EventStatusColor",
					["Rpoint"] = 36.89083649288036,
					["ComputedH"] = 12,
					["val"] = "StatusTexture",
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "texture",
					["justify"] = "LEFT",
					["visible"] = true,
					["valminw"] = 12,
					["sortorder"] = false,
					["disablefilter"] = 1,
					["ComputedW"] = 12,
					["valminh"] = 12,
					["valmaxh"] = 12,
					["colorfoo"] = "GEM3UI_GetEventStatusColor",
					["Lpoint"] = 31.781484784078,
					["size"] = 6.609351708802358,
					["disabledatatype"] = 1,
					["filtertbl"] = {
						["interface\\AddOns\\GEM3UI\\check"] = true,
						["interface\\AddOns\\GEM3UI\\sub_nak"] = true,
					},
					["pos"] = 3,
				}, -- [3]
				{
					["visible"] = true,
					["disablesort"] = 1,
					["Rpoint"] = 58.51526375829836,
					["ComputedH"] = 14,
					["val"] = "id",
					["size"] = 18.624427265418,
					["disablehedit"] = 1,
					["type"] = "custom",
					["justify"] = "RIGHT",
					["disablecolreset"] = 1,
					["valminw"] = 14,
					["tooltip"] = "Allows fast subscription to an event with your default role",
					["disablefilter"] = 1,
					["ComputedW"] = 14,
					["formfoo"] = "GEM3UI_EventGridQuickSubscribeGetButton",
					["valmaxh"] = 14,
					["lbl"] = "#_quick subscribe",
					["Lpoint"] = 41.39083649288036,
					["valmaxw"] = 14,
					["disabledatatype"] = 1,
					["valminh"] = 14,
					["pos"] = 4,
				}, -- [4]
				{
					["visible"] = true,
					["Rpoint"] = 121.8255059578614,
					["fontsize"] = 8,
					["ComputedH"] = 21,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "%d%m%y%ReplWeek%ReplTomorrow%ReplToday%ReplYesterday",
					["justify"] = "RIGHT",
					["tooltip"] = "Date the event is scheduled",
					["disablefilter"] = 1,
					["val"] = "ev_date",
					["size"] = 60.310242199563,
					["sortorder"] = false,
					["colorfoo"] = "GEM3UI_GetEventStatusColor",
					["Lpoint"] = 63.01526375829836,
					["colorfooval"] = "EventStatusColor",
					["ComputedW"] = 60.310242199563,
					["lbl"] = "_Date",
					["pos"] = 5,
				}, -- [5]
				{
					["visible"] = true,
					["colorfooval"] = "EventStatusColor",
					["Rpoint"] = 166.0094501248774,
					["fontsize"] = 8,
					["ComputedH"] = 21,
					["size"] = 41.183944167016,
					["disablehedit"] = 1,
					["colorfoo"] = "GEM3UI_GetEventStatusColor",
					["justify"] = "LEFT",
					["tooltip"] = "Time the event is schedules",
					["disablefilter"] = 1,
					["val"] = "ev_date",
					["type"] = "%H%M",
					["sortorder"] = false,
					["Lpoint"] = 126.3255059578614,
					["disablecolreset"] = 1,
					["ComputedW"] = 41.183944167016,
					["lbl"] = "_Time",
					["pos"] = 6,
				}, -- [6]
				{
					["visible"] = true,
					["valmaxw"] = 15,
					["Rpoint"] = 182.2393693916894,
					["friendlyfoo"] = "GEM3UI_GetTagName",
					["ComputedH"] = 15,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "texture",
					["valfoo"] = "GEM3UI_GetTagIcon",
					["valminw"] = 15,
					["val"] = "ev_inst_tag",
					["lbl"] = "#_Instance Icon",
					["sortorder"] = false,
					["valminh"] = 15,
					["valmaxh"] = 15,
					["size"] = 13.229919266812,
					["Lpoint"] = 170.5094501248774,
					["justify"] = "LEFT",
					["ComputedW"] = 15,
					["disabledatatype"] = 1,
					["pos"] = 7,
				}, -- [7]
				{
					["lbl"] = "_Event",
					["colorfooval"] = "EventStatusColor",
					["Rpoint"] = 285.2740673673094,
					["fontsize"] = 9,
					["ComputedH"] = 21,
					["size"] = 100.03469797562,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "LEFT",
					["tooltip"] = "Name or description of the event",
					["pos"] = 8,
					["sortorder"] = false,
					["ComputedW"] = 100.03469797562,
					["disablecolreset"] = 1,
					["Lpoint"] = 186.7393693916894,
					["colorfoo"] = "GEM3UI_GetEventStatusColor",
					["disabledatatype"] = 1,
					["visible"] = true,
					["val"] = "ev_place",
				}, -- [8]
				{
					["visible"] = true,
					["valmaxw"] = 20,
					["Rpoint"] = 293.4120145506134,
					["friendlyfoo"] = "GEM3UI_GetFriendlyAmILeader",
					["val"] = "id",
					["ComputedH"] = 20,
					["type"] = "texture",
					["size"] = 5.137947183304,
					["disablehedit"] = 1,
					["errorfoo"] = "GEM3UI_GridError",
					["justify"] = "CENTER",
					["sortorder"] = false,
					["valminw"] = 20,
					["tooltip"] = "Shows a ! if i am leader of the event",
					["valfoo"] = "GEM3UI_IsMyEvent",
					["texturecolor"] = {
						1, -- [1]
						1, -- [2]
						1, -- [3]
						0.2699999809265137, -- [4]
					},
					["valminh"] = 20,
					["valmaxh"] = 20,
					["lbl"] = "#_Am i Leader",
					["Lpoint"] = 289.7740673673094,
					["disablecolreset"] = 1,
					["ComputedW"] = 20,
					["disabledatatype"] = 1,
					["pos"] = 9,
				}, -- [9]
				{
					["visible"] = true,
					["valmaxw"] = 12,
					["Rpoint"] = 298.6072227114546,
					["friendlyfoo"] = "GEM3UI_GetFirendlyOnline",
					["fontsize"] = 7,
					["ComputedH"] = 12,
					["size"] = 2.1952081608412,
					["disablehedit"] = 1,
					["type"] = "texture",
					["justify"] = "CENTER",
					["pos"] = 10,
					["valminw"] = 12,
					["lbl"] = "#_Leader Online",
					["ComputedW"] = 12,
					["errorfoo"] = "GEM3UI_GridError",
					["valminh"] = 12,
					["valmaxh"] = 12,
					["valfoo"] = "GEM3UI_GetOnlineIcon",
					["Lpoint"] = 297.9120145506134,
					["disablecolreset"] = 1,
					["sortorder"] = false,
					["disabledatatype"] = 1,
					["val"] = "leader_connected",
				}, -- [10]
				{
					["lbl"] = "_Leader",
					["Rpoint"] = 356.0324420515576,
					["fontsize"] = 7,
					["ComputedH"] = 21,
					["size"] = 54.425219340103,
					["disablehedit"] = 1,
					["errorfoo"] = "GEM3UI_GridError",
					["justify"] = "LEFT",
					["pos"] = 11,
					["ComputedW"] = 54.425219340103,
					["sortorder"] = true,
					["disablecolreset"] = 1,
					["colorfoo"] = "GEM3UI_GetLeaderStatusColor",
					["Lpoint"] = 303.1072227114546,
					["type"] = "string",
					["disabledatatype"] = 1,
					["visible"] = true,
					["val"] = "leader",
				}, -- [11]
				{
					["lbl"] = "Slots",
					["Rpoint"] = 384.0325120800906,
					["fontsize"] = 7,
					["ComputedH"] = 21,
					["size"] = 25.000070028533,
					["disablehedit"] = 1,
					["colorfoo"] = "GEM3UI_GetPlayerCountColor",
					["justify"] = "CENTER",
					["tooltip"] = "tt_GEM3UIeventDetailsLimitsFrameLimitHeaderTIT1",
					["val"] = "max_count",
					["ComputedW"] = 25.000070028533,
					["sortorder"] = false,
					["disablecolreset"] = 1,
					["Lpoint"] = 360.5324420515576,
					["type"] = "string",
					["disabledatatype"] = 1,
					["visible"] = true,
					["pos"] = 12,
				}, -- [12]
				{
					["visible"] = true,
					["Rpoint"] = 393.6417237318265,
					["ComputedH"] = 21,
					["size"] = 6.6092116517359,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "CENTER",
					["tooltip"] = "tt_GEM3UIeventDetailsLimitsFrameLimitHeaderSUB1",
					["val"] = "sub_count",
					["sortorder"] = false,
					["ComputedW"] = 6.6092116517359,
					["lbl"] = "_substituteshort",
					["Lpoint"] = 388.5325120800906,
					["disablecolreset"] = 1,
					["disabledatatype"] = 1,
					["valfoo"] = "GEM3UI_GetZeroValueString",
					["pos"] = 13,
				}, -- [13]
				{
					["lbl"] = "_replacementshort",
					["Rpoint"] = 406.1975609896189,
					["ComputedH"] = 21,
					["size"] = 9.555837257792334,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "CENTER",
					["tooltip"] = "tt_GEM3UIeventDetailsLimitsFrameLimitHeaderTIT1",
					["val"] = "repl_count",
					["sortorder"] = false,
					["ComputedW"] = 9.555837257792334,
					["visible"] = true,
					["Lpoint"] = 398.1417237318265,
					["disablecolreset"] = 1,
					["disabledatatype"] = 1,
					["valfoo"] = "GEM3UI_GetZeroValueString",
					["pos"] = 14,
				}, -- [14]
				{
					["lbl"] = "_discarshort",
					["Rpoint"] = 417.2778970527202,
					["ComputedH"] = 21,
					["size"] = 8.080336063101299,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "CENTER",
					["tooltip"] = "tt_GEM3UIeventDetailsLimitsFrameLimitHeaderREJ1",
					["val"] = "rej_count",
					["ComputedW"] = 8.080336063101299,
					["sortorder"] = false,
					["visible"] = true,
					["Lpoint"] = 410.6975609896189,
					["disablecolreset"] = 1,
					["disabledatatype"] = 1,
					["valfoo"] = "GEM3UI_GetZeroValueString",
					["pos"] = 15,
				}, -- [15]
				{
					["visible"] = true,
					["color"] = {
						1, -- [1]
						0.07058823529411765, -- [2]
						0.08235294117647059, -- [3]
						1, -- [4]
					},
					["Rpoint"] = 434.2433960323485,
					["ComputedH"] = 21,
					["size"] = 13.96549897962833,
					["disablehedit"] = 1,
					["type"] = "string",
					["valfoo"] = "GEM3UI_GetZeroValueString",
					["tooltip"] = "tt_GEM3UIeventDetailsLimitsFrameLimitHeaderNC1",
					["val"] = "NAcount",
					["lbl"] = "_not_comingshort",
					["ComputedW"] = 13.96549897962833,
					["Lpoint"] = 421.7778970527202,
					["disablecolreset"] = 1,
					["disabledatatype"] = 1,
					["justify"] = "CENTER",
					["pos"] = 16,
				}, -- [16]
				{
					["visible"] = true,
					["type"] = "string",
					["justify"] = "CENTER",
					["val"] = "Totals",
					["pos"] = 17,
					["Rpoint"] = 447.5306463052305,
					["ComputedW"] = 10.287250272882,
					["disablecolreset"] = 1,
					["lbl"] = "Total Subscriptions",
					["disabledatatype"] = 1,
					["valfoo"] = "GEM3UI_GetZeroValueString",
					["Lpoint"] = 438.7433960323485,
					["tooltip"] = "Total Subscriptions TT",
					["ComputedH"] = 21,
					["disablehedit"] = 1,
					["size"] = 10.287250272882,
				}, -- [17]
				{
					["visible"] = true,
					["colorfooval"] = "min_lvl",
					["Rpoint"] = 471.1168879142019,
					["fontsize"] = 8,
					["ComputedH"] = 21,
					["size"] = 20.58624160897142,
					["disablehedit"] = 1,
					["colorfoo"] = "GEM3UI_GetLevelLimitColor",
					["justify"] = "CENTER",
					["tooltip"] = "Min Level TT",
					["val"] = "min_lvl",
					["type"] = "number",
					["ComputedW"] = 20.58624160897142,
					["sortorder"] = false,
					["Lpoint"] = 452.0306463052305,
					["lbl"] = "Min Level",
					["disabledatatype"] = 1,
					["disablecolreset"] = 1,
					["pos"] = 18,
				}, -- [18]
				{
					["lbl"] = "Deadlineshort",
					["colorfooval"] = "deadline",
					["Rpoint"] = 508.6801944946759,
					["ComputedH"] = 21,
					["size"] = 34.563306580474,
					["disablehedit"] = 1,
					["type"] = "%d%m%y%H%M",
					["justify"] = "LEFT",
					["tooltip"] = "deadlineTT",
					["disablefilter"] = 1,
					["val"] = "deadline",
					["colorfoo"] = "GEM3UI_GetOutdatedColor",
					["ComputedW"] = 34.563306580474,
					["Lpoint"] = 475.6168879142019,
					["disablecolreset"] = 1,
					["sortorder"] = false,
					["visible"] = true,
					["pos"] = 19,
				}, -- [19]
				{
					["lbl"] = "_Channel",
					["type"] = "string",
					["justify"] = "LEFT",
					["Rpoint"] = 569.7835925129914,
					["size"] = 58.1033980183156,
					["val"] = "channel",
					["ComputedH"] = 21,
					["ComputedW"] = 58.1033980183156,
					["pos"] = 20,
					["Lpoint"] = 513.1801944946758,
					["disablehedit"] = 1,
					["disabledatatype"] = 1,
					["visible"] = true,
					["disablecolreset"] = 1,
				}, -- [20]
				{
					["visible"] = true,
					["Rpoint"] = 652.9560976148504,
					["fontsize"] = 6,
					["ComputedH"] = 21,
					["size"] = 80.172505101859,
					["disablehedit"] = 1,
					["type"] = "%d%m%y%H%M",
					["justify"] = "LEFT",
					["tooltip"] = "Last time the event has been updated",
					["disablefilter"] = 1,
					["val"] = "update_time",
					["lbl"] = "_UpdateTime",
					["Lpoint"] = 574.2835925129914,
					["sortorder"] = false,
					["ComputedW"] = 80.172505101859,
					["disablecolreset"] = 1,
					["pos"] = 21,
				}, -- [21]
				{
					["lbl"] = "_Comment",
					["errorfoo"] = "GEM3UI_GridError",
					["justify"] = "LEFT",
					["disablecolreset"] = 1,
					["visible"] = true,
					["Rpoint"] = 717.0021646270964,
					["disablefilter"] = 1,
					["ComputedH"] = 21,
					["disablehedit"] = 1,
					["type"] = "string",
					["size"] = 61.046067012246,
					["Lpoint"] = 657.4560976148504,
					["ComputedW"] = 61.046067012246,
					["disabledatatype"] = 1,
					["val"] = "ev_comment",
					["pos"] = 22,
				}, -- [22]
				{
					["lbl"] = "Max Level",
					["type"] = "number",
					["justify"] = "CENTER",
					["size"] = 16.17241318940919,
					["disablehedit"] = 1,
					["Rpoint"] = 736.1745778165056,
					["ComputedH"] = 21,
					["tooltip"] = "Max Level TT",
					["visible"] = true,
					["val"] = "max_lvl",
					["sortorder"] = false,
					["Lpoint"] = 721.5021646270964,
					["ComputedW"] = 16.17241318940919,
					["disabledatatype"] = 1,
					["disablecolreset"] = 1,
					["pos"] = 23,
				}, -- [23]
			},
		}

GEM3UI_EventsPlayersListGridDefaults = {
   			["DGridParams"] = {
				["inherits"] = "GEM3UI_THEME_Neutral",
				["LineHeight"] = 16,
				["ValueFontSize"] = 6,
				["resetfoo"] = "GEM3UI_ResetPlayersGrid",
				["ColSepWidth"] = 2,
				["DataSource"] = "GEM3UI_EventPlayers",
				["headerheight"] = 16,
				["LabelFontSize"] = 6.5,
				["sortcol"] = {
					-3, -- [1]
					-4, -- [2]
				},
			},
			["GridParams"] = {
				["disableAdvancedCFG"] = 1,
				["parent"] = "GEM3UI_GrideventSubscriptionList",
				["OnEnterFoo"] = "GEM3UI_EventPlayerOnEnter",
				["OnLeaveFoo"] = "GEM3UI_EventPlayerOnLeave",
                ["OnRclickFoo"] = "GEM3UI_GridPlayerMenu",
				["sortcol"] = {
					-3, -- [1]
					-4, -- [2]
				},
			},
			["DHeaders"] = {
				{
					["lbl"] = "#_Invite",
					["valmaxw"] = 13,
					["clickfoo"] = "GEM3UI_InviteButtonOnClick",
					["Rpoint"] = 11.46750891479,
					["fontsize"] = 9,
					["val"] = "name",
					["ComputedH"] = 13,
					["disablesort"] = 1,
					["size"] = 10.46750891479,
					["disablehedit"] = 1,
					["type"] = "custombutton",
					["justify"] = "LEFT",
					["sortorder"] = false,
					["valminw"] = 13,
					["tooltip"] = "InviteThisPlayer",
					["disablefilter"] = 1,
					["visible"] = true,
					["valminh"] = 13,
					["valmaxh"] = 13,
					["valfoo"] = "GEM3UI_MemberGridQuickInviteGetButton",
					["Lpoint"] = 2,
					["disablecolreset"] = 1,
					["ComputedW"] = 13,
					["disabledatatype"] = 1,
					["pos"] = 1,
				}, -- [1]
				{
					["visible"] = true,
					["disablesort"] = 1,
					["Rpoint"] = 17.8812673058189,
					["fontsize"] = 10,
					["pos"] = 2,
					["ComputedH"] = 12,
					["disabledatatype"] = 1,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "texture",
					["justify"] = "LEFT",
					["sortorder"] = false,
					["valminw"] = 35,
					["tooltip"] = "Lead force queue",
					["disablefilter"] = 1,
					["valmaxw"] = 35,
					["valminh"] = 12,
					["valmaxh"] = 12,
					["size"] = 4.4137583910289,
					["Lpoint"] = 14.46750891479,
					["lbl"] = "#_lead_force_queue",
					["ComputedW"] = 35,
					["valfoo"] = "GEM3UI_GetForceQueueIcon",
					["val"] = "lead_force_queue",
				}, -- [2]
				{
					["lbl"] = "Q",
					["valmaxw"] = 20,
					["Rpoint"] = 31.6398870899319,
					["fontsize"] = 9,
					["ComputedH"] = 14,
					["pos"] = 3,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "string",
					["valfoo"] = "GEM3UI_GetQueueString",
					["size"] = 11.758619784113,
					["valminw"] = 20,
					["tooltip"] = "Actual active queue",
					["disabledatatype"] = 1,
					["visible"] = true,
					["valminh"] = 14,
					["valmaxh"] = 14,
					["sortorder"] = false,
					["Lpoint"] = 20.8812673058189,
					["colorfoo"] = "GEM3UI_GetStatusColor",
					["ComputedW"] = 20,
					["justify"] = "CENTER",
					["val"] = "current_queue",
				}, -- [3]
				{
					["lbl"] = "P",
					["valmaxw"] = 24,
					["Rpoint"] = 44.66299718976394,
					["fontsize"] = 9,
					["ComputedH"] = 14,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["colorfoo"] = "GEM3UI_GetStatusColor",
					["justify"] = "CENTER",
					["pos"] = 4,
					["valminw"] = 24,
					["size"] = 11.02311009983203,
					["disabledatatype"] = 1,
					["type"] = "string",
					["valminh"] = 14,
					["valmaxh"] = 14,
					["ComputedW"] = 24,
					["Lpoint"] = 34.6398870899319,
					["errorfoo"] = "GEM3UI_GridError",
					["sortorder"] = false,
					["visible"] = true,
					["val"] = "queue_pos",
				}, -- [4]
				{
					["lbl"] = "R",
					["color"] = {
						0.6980392156862745, -- [1]
						0.6980392156862745, -- [2]
						0.6980392156862745, -- [3]
						1, -- [4]
					},
					["Rpoint"] = 59.15716167242694,
					["fontsize"] = 6,
					["ComputedH"] = 16,
					["size"] = 12.494164482663,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "CENTER",
					["pos"] = 5,
					["visible"] = true,
					["disabledatatype"] = 1,
					["ComputedW"] = 12.494164482663,
					["Lpoint"] = 47.66299718976394,
					["valfoo"] = "GEM3UI_GetQueueString",
					["sortorder"] = false,
					["disablecolreset"] = 1,
					["val"] = "force_queue",
				}, -- [5]
				{
					["visible"] = true,
					["valmaxw"] = 8,
					["Rpoint"] = 66.2951088557309,
					["fontsize"] = 9,
					["ComputedH"] = 16,
					["size"] = 5.137947183303958,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "CENTER",
					["valminw"] = 8,
					["tooltip"] = "Player is linked to this instance",
					["pos"] = 6,
					["lbl"] = "T",
					["disabledatatype"] = 1,
					["Lpoint"] = 62.15716167242694,
					["valfoo"] = "GEM3UI_GetPlayerTaggedToInstance",
					["ComputedW"] = 8,
					["disablecolreset"] = 1,
					["val"] = "name",
				}, -- [6]
				{
					["disablehedit"] = 1,
					["colorfoo"] = "GEM3UI_GetStatusColor",
					["justify"] = "LEFT",
					["size"] = 52.21841017312193,
					["ComputedH"] = 16,
					["Rpoint"] = 120.5135190288528,
					["disabledatatype"] = 1,
					["visible"] = true,
					["lbl"] = "#GS_NAME",
					["type"] = "string",
					["fontsize"] = 8,
					["Lpoint"] = 69.2951088557309,
					["disablecolreset"] = 1,
					["ComputedW"] = 52.21841017312193,
					["pos"] = 7,
					["val"] = "name",
				}, -- [7]
				{
					["visible"] = true,
					["valmaxw"] = 9,
					["Rpoint"] = 127.6514311978899,
					["friendlyfoo"] = "GEM3UI_GetFriendlyRole",
					["ComputedH"] = 9,
					["pos"] = 8,
					["type"] = "texture",
					["valfoo"] = "GEM3UI_GetRoleIcon",
					["size"] = 5.1379121690371,
					["valminw"] = 9,
					["tooltip"] = "Second role",
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["disabledatatype"] = 1,
					["texturecolor"] = {
						1, -- [1]
						1, -- [2]
						1, -- [3]
						0.3799999952316284, -- [4]
					},
					["valminh"] = 9,
					["valmaxh"] = 9,
					["justify"] = "LEFT",
					["Lpoint"] = 123.5135190288528,
					["ComputedW"] = 9,
					["sortorder"] = false,
					["lbl"] = "#_alt_role",
					["val"] = "alt_role",
				}, -- [8]
				{
					["visible"] = true,
					["valmaxw"] = 12,
					["Rpoint"] = 136.2606778638917,
					["friendlyfoo"] = "GEM3UI_GetFriendlyRole",
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["disabledatatype"] = 1,
                    ["ComputedH"] = 12,
					["size"] = 6.6092466660018,
					["type"] = "texture",
					["valfoo"] = "GEM3UI_GetRoleIcon",
					["valminw"] = 12,
					["tooltip"] = "Main role",
					["pos"] = 9,
					["texturecolor"] = {
						1, -- [1]
						1, -- [2]
						1, -- [3]
						1, -- [4]
					},
					["valminh"] = 12,
					["valmaxh"] = 12,
					["justify"] = "LEFT",
					["Lpoint"] = 130.6514311978899,
					["sortorder"] = false,
					["ComputedW"] = 12,
					["lbl"] = "#_Role",
					["val"] = "role",
				}, -- [9]
				{
					["visible"] = true,
					["colorfooval"] = "class",
					["Rpoint"] = 154.4330210247676,
					["fontsize"] = 11,
					["ComputedH"] = 16,
					["size"] = 16.17234316087588,
					["disablehedit"] = 1,
					["colorfoo"] = "GEM3UI_GetClassColor",
					["justify"] = "CENTER",
					["pos"] = 10,
					["disablecolreset"] = 1,
					["disabledatatype"] = 1,
					["lbl"] = "LvL",
					["Lpoint"] = 139.2606778638917,
					["type"] = "string",
					["ComputedW"] = 16.17234316087588,
					["filtertbl"] = {
						[80] = true,
					},
					["val"] = "level",
				}, -- [10]
				{
					["visible"] = true,
					["valmaxw"] = 14,
					["Rpoint"] = 165.2491468862844,
					["friendlyfoo"] = "GEM3UI_GetFriendlyClass",
					["fontsize"] = 10,
					["ComputedH"] = 14,
					["size"] = 8.816125861516801,
					["disablehedit"] = 1,
					["type"] = "texture",
					["justify"] = "RIGHT",
					["valminw"] = 14,
					["pos"] = 11,
					["disablecolreset"] = 1,
					["texturecolor"] = {
						1, -- [1]
						1, -- [2]
						1, -- [3]
						0.699999988079071, -- [4]
					},
					["valminh"] = 14,
					["valmaxh"] = 14,
					["disabledatatype"] = 1,
					["Lpoint"] = 157.4330210247676,
					["lbl"] = "#__Class",
					["ComputedW"] = 14,
					["valfoo"] = "GEM3UI_GetClassIcon",
					["val"] = "class",
				}, -- [11]
				{
					["lbl"] = "C",
					["valmaxw"] = 10,
					["Rpoint"] = 173.8583235237535,
					["pos"] = 12,
					["ComputedH"] = 10,
					["size"] = 6.6091766374691,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "texture",
					["valfoo"] = "GEM3UI_GetCommentIcon",
					["disabledatatype"] = 1,
					["valminw"] = 10,
					["tooltip"] = "Subscription comment",
					["disablefilter"] = 1,
					["justify"] = "CENTER",
					["valminh"] = 10,
					["valmaxh"] = 10,
					["ComputedW"] = 10,
					["Lpoint"] = 168.2491468862844,
					["colorfoo"] = "GEM3UI_GetStatusColor",
					["sortorder"] = false,
					["visible"] = true,
					["val"] = "comment",
				}, -- [12]
				{
					["disablehedit"] = 1,
					["colorfoo"] = "GEM3UI_GetStatusColor",
					["justify"] = "LEFT",
					["size"] = 41.18387413848313,
					["visible"] = true,
					["Rpoint"] = 217.0421976622367,
					["ComputedH"] = 16,
					["lbl"] = "#GS_GUILD",
					["type"] = "string",
					["disabledatatype"] = 1,
					["disablecolreset"] = 1,
					["Lpoint"] = 176.8583235237535,
					["pos"] = 13,
					["ComputedW"] = 41.18387413848313,
					["sortorder"] = false,
					["val"] = "guild",
				}, -- [13]
				{
					["visible"] = true,
					["valmaxw"] = 10,
					["Rpoint"] = 220.5018961387941,
					["ComputedH"] = 10,
					["pos"] = 14,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "texture",
					["justify"] = "CENTER",
					["size"] = 1.4596984765575,
					["valminw"] = 10,
					["tooltip"] = "Subscription Source",
					["disablefilter"] = 1,
					["texturecolor"] = {
						1, -- [1]
						1, -- [2]
						1, -- [3]
						0.9099999666213989, -- [4]
					},
					["valminh"] = 10,
					["valmaxh"] = 10,
					["disabledatatype"] = 1,
					["Lpoint"] = 220.0421976622367,
					["lbl"] = "S",
					["ComputedW"] = 10,
					["valfoo"] = "GEM3UI_GetSourceIcon",
					["val"] = "source",
				}, -- [14]
				{
					["visible"] = true,
					["Rpoint"] = 263.6857702772771,
					["fontsize"] = 6,
					["ComputedH"] = 16,
					["size"] = 41.183874138483,
					["disablehedit"] = 1,
					["type"] = "%default",
					["justify"] = "LEFT",
					["tooltip"] = "Main Time",
					["disablefilter"] = 1,
					["val"] = "main_time",
					["lbl"] = "M Time",
					["Lpoint"] = 223.5018961387941,
					["disablecolreset"] = 1,
					["ComputedW"] = 41.183874138483,
					["colorfoo"] = "GEM3UI_GetStatusColor",
					["pos"] = 15,
				}, -- [15]
				{
					["lbl"] = "I",
					["valmaxw"] = 10,
					["Rpoint"] = 272.2949469147462,
					["friendlyfoo"] = "GEM3UI_GetFriendlyZoneType",
					["ComputedH"] = 10,
					["pos"] = 16,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "texture",
					["justify"] = "CENTER",
					["size"] = 6.6091766374691,
					["valminw"] = 10,
					["tooltip"] = "In instance / Raid / PvP",
					["disabledatatype"] = 1,
					["valminh"] = 10,
					["valmaxh"] = 10,
					["visible"] = true,
					["Lpoint"] = 266.6857702772771,
					["valfoo"] = "GEM3UI_GetZoneIcon",
					["sortorder"] = false,
					["ComputedW"] = 10,
					["val"] = "instance_type",
				}, -- [16]
				{
					["visible"] = true,
					["Rpoint"] = 321.3639489554902,
					["ComputedH"] = 16,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["errorfoo"] = "GEM3UI_GetEmptyOnNil",
					["justify"] = "LEFT",
					["pos"] = 17,
					["size"] = 64.135655868846,
					["disabledatatype"] = 1,
					["type"] = "string",
					["Lpoint"] = 275.2949469147462,
					["lbl"] = "#GS_ZONE",
					["ComputedW"] = 64.135655868846,
					["colorfoo"] = "GEM3UI_GetinFightColor",
					["val"] = "location",
				}, -- [17]
				{
					["visible"] = true,
					["Rpoint"] = 367.4904220593703,
					["ComputedH"] = 16,
					["size"] = 34.170866680376,
					["disablehedit"] = 1,
					["type"] = "%default",
					["justify"] = "LEFT",
					["tooltip"] = "Update Time",
					["disablefilter"] = 1,
					["val"] = "update_time",
					["lbl"] = "U Time",
					["sortorder"] = false,
					["disablecolreset"] = 1,
					["Lpoint"] = 324.3639489554902,
					["colorfoo"] = "GEM3UI_GetStatusColor",
					["ComputedW"] = 34.170866680376,
					["errorfoo"] = "GEM3UI_GetEmptyOnNil",
					["pos"] = 18,
				}, -- [18]
			},
		}
        

GEM3UI_EVENTS_PlayerDefaults = {
			["DGridParams"] = {
				["resetfoo"] = "GEM3UI_ResetEventGrid",
				["LineHeight"] = 65,
   				["ValueFontSize"] = 6,
				["headerheight"] = 20.88505787372714,
				["ColSepWidth"] = 3,
				["LabelFontSize"] = 7,
                ["inherits"] = "GEM3UI_THEME_Neutral",
                ["DataSource"] = "MyEvent",
			},
			["GridParams"] = {
				["sortcol"] = {
					-2, -- [1]
				},
				["OnClickFoo"] = "GEM3UI_GridEventLineOnClick",
				["OnEnterFoo"] = "GEM3UI_GridEventLineOnEnter",
				["OnLeaveFoo"] = "GEM3UI_GridEventLineOnLeave",
                ["OnDclickFoo"] = "GEM3UI_GridEventLineOnDClick",
                ["OnRclickFoo"] = "GEM3UI_GridEventMenu",
                ["disableAdvancedCFG"] = 1,
			},
			["Headers"] = {
				{
					["visible"] = true,
					["valmaxw"] = 30,
					["clickfoo"] = "GEM3UI_GridEventLineopen",
					["Rpoint"] = 26.5,
					["disablecolreset"] = 1,
					["lbl"] = "#_Show Event Details",
					["disablesort"] = 1,
					["ComputedH"] = 30,
					["size"] = 25,
					["disablehedit"] = 1,
					["type"] = "custombutton",
					["justify"] = "LEFT",
					["disabledatatype"] = 1,
					["valminw"] = 30,
					["tooltip"] = "Show Event Details",
					["disablefilter"] = 1,
					["valminh"] = 30,
					["valmaxh"] = 30,
					["valfoo"] = "GEM3UI_GetOpenButtonText",
					["Lpoint"] = 3,
					["sortorder"] = false,
					["ComputedW"] = 30,
					["val"] = "MovixLibID",
					["pos"] = 1,
				}, -- [1]
				{
					["lbl"] = "_Event",
					["Rpoint"] = 505.4425770814816,
					["ComputedH"] = 65,
					["size"] = 475.9425770814816,
					["disablehedit"] = 1,
					["type"] = "custom",
					["justify"] = "LEFT",
					["disablefilter"] = 1,
					["disabledatatype"] = 1,
					["formfoo"] = "GEM3UI_DrawEventHeader",
					["disablecolreset"] = 1,
					["visible"] = true,
					["Lpoint"] = 31,
					["sortorder"] = false,
					["ComputedW"] = 475.9425770814816,
					["val"] = "ev_date",
					["pos"] = 2,
				}, -- [2]
			},
		}

GEM3UI_EVENTS_MinimalDefaults = {
			["DGridParams"] = {
				["resetfoo"] = "GEM3UI_ResetEventGrid",
				["LineHeight"] = 30,
   				["ValueFontSize"] = 8,
				["headerheight"] = 20.88505787372714,
				["LabelFontSize"] = 7,
                ["inherits"] = "GEM3UI_THEME_Neutral",
                ["DataSource"] = "MyEvent",
			},
			["GridParams"] = {
				["sortcol"] = {
					-5, -- [1]
				},
				["OnClickFoo"] = "GEM3UI_GridEventLineOnClick",
                ["OnDclickFoo"] = "GEM3UI_GridEventLineOnDClick",
				["OnEnterFoo"] = "GEM3UI_GridEventLineOnEnter",
				["OnLeaveFoo"] = "GEM3UI_GridEventLineOnLeave",
                ["OnRclickFoo"] = "GEM3UI_GridEventMenu",
                ["disableAdvancedCFG"] = 1,
			},
			["Headers"] = {
                {
				    ["lbl"] = "#_Show Event Details",
					["valmaxw"] = 14,
					["clickfoo"] = "GEM3UI_GridEventLineopen",
					["Rpoint"] = 11.787250272882,
					["val"] = "MovixLibID",
					["visible"] = true,
					["ComputedH"] = 14,
					["sortorder"] = false,
					["size"] = 10.287250272882,
					["disablehedit"] = 1,
					["type"] = "custombutton",
					["valfoo"] = "GEM3UI_GetOpenButtonText",
					["valminw"] = 14,
					["tooltip"] = "Show Event Details",
					["disablefilter"] = 1,
					["justify"] = "LEFT",
					["valminh"] = 14,
					["valmaxh"] = 14,
					["ComputedW"] = 14,
					["Lpoint"] = 3,
					["disablesort"] = 1,
					["disabledatatype"] = 1,
					["disablecolreset"] = 1,
					["pos"] = 1,
				}, -- [1]

                {
					["visible"] = true,
					["valmaxw"] = 20,
					["Rpoint"] = 21.522231802515,
					["ComputedH"] = 20,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "texture",
					["justify"] = "LEFT",
					["valminw"] = 20,
					["pos"] = 2,
					["disablefilter"] = 1,
					["lbl"] = "#_Eventtype Icon",
					["valminh"] = 20,
					["valmaxh"] = 20,
					["sortorder"] = false,
					["Lpoint"] = 3,
					["size"] = 20.022231802515,
					["ComputedW"] = 20,
					["disabledatatype"] = 1,
					["val"] = "EventTexture",
				}, -- [2]
				{
					["visible"] = true,
					["valmaxw"] = 15,
					["colorfooval"] = "EventStatusColor",
					["Rpoint"] = 36.72217140290501,
					["ComputedH"] = 15,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "texture",
					["justify"] = "LEFT",
					["pos"] = 3,
					["valminw"] = 15,
					["disablefilter"] = 1,
					["ComputedW"] = 15,
					["valminh"] = 15,
					["valmaxh"] = 15,
					["size"] = 12.19993960039,
					["Lpoint"] = 26.022231802515,
					["colorfoo"] = "GEM3UI_GetEventStatusColor",
					["disabledatatype"] = 1,
					["lbl"] = "#_Subscription Status",
					["val"] = "StatusTexture",
				}, -- [3]
				{
					["visible"] = true,
					["disablesort"] = 1,
					["Rpoint"] = 61.877699919666,
					["ComputedH"] = 15,
					["pos"] = 4,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "custom",
					["justify"] = "RIGHT",
					["valmaxw"] = 15,
					["valminw"] = 15,
					["tooltip"] = "Allows fast subscription to an event with your default role",
					["disablefilter"] = 1,
					["disabledatatype"] = 1,
					["formfoo"] = "GEM3UI_EventGridQuickSubscribeGetButton",
					["valmaxh"] = 15,
					["size"] = 22.155528516761,
					["Lpoint"] = 41.22217140290501,
					["lbl"] = "#_quick subscribe",
					["ComputedW"] = 15,
					["valminh"] = 15,
					["val"] = "id",
				}, -- [4]
				{
					["lbl"] = "_Date",
					["colorfooval"] = "EventStatusColor",
					["Rpoint"] = 154.588826544042,
					["ComputedH"] = 30,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["colorfoo"] = "GEM3UI_GetEventStatusColor",
					["justify"] = "RIGHT",
					["tooltip"] = "Date the event is scheduled",
					["disablefilter"] = 1,
					["pos"] = 5,
					["size"] = 89.71112662437601,
					["ComputedW"] = 89.71112662437601,
					["type"] = "%default",
					["Lpoint"] = 66.377699919666,
					["sortorder"] = false,
					["visible"] = true,
					["val"] = "ev_date",
				}, -- [5]
				{
					["visible"] = true,
					["valmaxw"] = 20,
					["filtertbl"] = {
						[0] = true,
						[512] = true,
						[5120] = true,
					},
					["Rpoint"] = 182.588826544042,
					["friendlyfoo"] = "GEM3UI_GetTagName",
					["ComputedH"] = 20,
					["size"] = 25,
					["disablehedit"] = 1,
					["type"] = "texture",
					["justify"] = "RIGHT",
					["valminw"] = 20,
					["pos"] = 6,
					["lbl"] = "#_Instance Icon",
					["valminh"] = 20,
					["valmaxh"] = 20,
					["ComputedW"] = 20,
					["Lpoint"] = 159.088826544042,
					["valfoo"] = "GEM3UI_GetTagIcon",
					["disabledatatype"] = 1,
					["disablecolreset"] = 1,
					["val"] = "ev_inst_tag",
				}, -- [6]
				{
					["lbl"] = "_Event",
					["colorfooval"] = "EventStatusColor",
					["Rpoint"] = 308.011086357972,
					["fontsize"] = 9,
					["ComputedH"] = 30,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["colorfoo"] = "GEM3UI_GetEventStatusColor",
					["justify"] = "LEFT",
					["tooltip"] = "Name or description of the event",
					["pos"] = 7,
					["size"] = 122.42225981393,
					["ComputedW"] = 122.42225981393,
					["Lpoint"] = 187.088826544042,
					["type"] = "string",
					["disabledatatype"] = 1,
					["visible"] = true,
					["val"] = "ev_place",
				}, -- [7]
				{
					["visible"] = true,
					["colorfooval"] = "min_lvl",
					["Rpoint"] = 331.744457915213,
					["ComputedH"] = 30,
					["size"] = 20.733371557241,
					["disablehedit"] = 1,
					["type"] = "number",
					["justify"] = "RIGHT",
					["tooltip"] = "Min Level TT",
					["pos"] = 8,
					["lbl"] = "Min Level",
					["ComputedW"] = 20.733371557241,
					["Lpoint"] = 312.511086357972,
					["disablecolreset"] = 1,
					["disabledatatype"] = 1,
					["colorfoo"] = "GEM3UI_GetLevelLimitColor",
					["val"] = "min_lvl",
				}, -- [8]
				{
					["lbl"] = "leader",
					["Rpoint"] = 386.766718166819,
					["ComputedH"] = 30,
					["size"] = 52.022260251606,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "LEFT",
					["pos"] = 9,
					["colorfoo"] = "GEM3UI_GetLeaderStatusColor",
					["disabledatatype"] = 1,
					["errorfoo"] = "GEM3UI_GridError",
					["Lpoint"] = 336.244457915213,
					["disablecolreset"] = 1,
					["ComputedW"] = 52.022260251606,
					["visible"] = true,
					["val"] = "leader",
				}, -- [9]
				{
					["visible"] = true,
					["Rpoint"] = 417.611137128658,
					["ComputedH"] = 30,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "LEFT",
					["tooltip"] = "tt_GEM3UIeventDetailsLimitsFrameLimitHeaderTIT1",
					["pos"] = 10,
					["lbl"] = "Slots",
					["sortorder"] = false,
					["size"] = 27.844418961839,
					["Lpoint"] = 391.266718166819,
					["colorfoo"] = "GEM3UI_GetPlayerCountColor",
					["ComputedW"] = 27.844418961839,
					["disabledatatype"] = 1,
					["val"] = "max_count",
				}, -- [10]
				{
					["lbl"] = "_Comment",
					["type"] = "string",
					["justify"] = "LEFT",
					["Rpoint"] = 503.21107629137,
					["pos"] = 11,
					["disablehedit"] = 1,
					["ComputedW"] = 72.59993916271201,
					["val"] = "ev_comment",
					["visible"] = true,
					["Lpoint"] = 422.111137128658,
					["ComputedH"] = 30,
					["disabledatatype"] = 1,
					["size"] = 72.59993916271201,
					["disablecolreset"] = 1,
				}, -- [11]
			},
    }
        
        

GEM3UI_GridDefaults = {
            ["DGridParams"] = {
				["TEdgeInset"] = 4,
   				["EmptyTexture"] = "interface\\AddOns\\GridLib\\gfx\\questionmark",
                ["TypeTexture"] = "interface\\AddOns\\GridLib\\gfx\\spell-shadow-unacceptable",
				["SliderSize"] = 9,
                ["REdgeInset"] = 4,
				["BEdgeInset"] = 4,
                ["LEdgeInset"] = 4,
				["Mincolwidth"] = 0,
                ["ColSepWidth"] = 3,

            },
            ["GridParams"] = {
                ["disableAdvancedCFG"] = 1,
            },
			["DHeaders"] = {
				{
					["visible"] = true,
					["disablesort"] = 1,
					["clickfoo"] = "GEM3UI_GridEventLineopen",
					["Rpoint"] = 13.787250272882,
					["val"] = "MovixLibID",
					["ComputedH"] = 14,
					["disablecolreset"] = 1,
					["size"] = 10.287250272882,
					["disablehedit"] = 1,
					["type"] = "custombutton",
					["valfoo"] = "GEM3UI_GetOpenButtonText",
					["disabledatatype"] = 1,
					["valminw"] = 14,
					["tooltip"] = "Show Event Details",
					["disablefilter"] = 1,
					["valmaxw"] = 14,
					["valminh"] = 14,
					["valmaxh"] = 14,
					["sortorder"] = false,
					["Lpoint"] = 7,
					["lbl"] = "#_Show Event Details",
					["ComputedW"] = 14,
					["justify"] = "LEFT",
					["pos"] = 1,
				}, -- [1]
				{
					["visible"] = true,
					["valmaxw"] = 15,
					["Rpoint"] = 33.281484784078,
					["ComputedH"] = 15,
					["size"] = 12.494234511196,
					["disablehedit"] = 1,
					["type"] = "texture",
					["justify"] = "LEFT",
					["val"] = "EventTexture",
					["valminw"] = 15,
					["disablecolreset"] = 1,
					["disablefilter"] = 1,
					["texturecolor"] = {
						1, -- [1]
						1, -- [2]
						1, -- [3]
						1, -- [4]
					},
					["valminh"] = 15,
					["valmaxh"] = 15,
					["disabledatatype"] = 1,
					["Lpoint"] = 24.287250272882,
					["lbl"] = "#_Eventtype Icon",
					["ComputedW"] = 15,
					["sortorder"] = false,
					["pos"] = 2,
				}, -- [2]
				{
					["visible"] = true,
					["valmaxw"] = 12,
					["colorfooval"] = "EventStatusColor",
					["Rpoint"] = 46.8908364928804,
					["ComputedH"] = 12,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["colorfoo"] = "GEM3UI_GetEventStatusColor",
					["justify"] = "LEFT",
					["val"] = "StatusTexture",
					["valminw"] = 12,
					["size"] = 6.6093517088024,
					["disablefilter"] = 1,
					["disabledatatype"] = 1,
					["valminh"] = 12,
					["valmaxh"] = 12,
					["lbl"] = "#_Subscription Status",
					["Lpoint"] = 43.781484784078,
					["sortorder"] = false,
					["ComputedW"] = 12,
					["type"] = "texture",
					["pos"] = 3,
				}, -- [3]
				{
					["lbl"] = "#_quick subscribe",
					["valmaxw"] = 14,
					["Rpoint"] = 74.47704308758478,
					["ComputedH"] = 14,
					["size"] = 20.58620659470437,
					["disablehedit"] = 1,
					["type"] = "custom",
					["justify"] = "RIGHT",
					["val"] = "id",
					["valminw"] = 14,
					["tooltip"] = "Allows fast subscription to an event with your default role",
					["disablefilter"] = 1,
					["disablecolreset"] = 1,
					["valminh"] = 14,
					["valmaxh"] = 14,
					["disabledatatype"] = 1,
					["Lpoint"] = 57.3908364928804,
					["formfoo"] = "GEM3UI_EventGridQuickSubscribeGetButton",
					["ComputedW"] = 14,
					["visible"] = true,
					["pos"] = 4,
				}, -- [4]
				{
					["visible"] = true,
					["colorfooval"] = "EventStatusColor",
					["Rpoint"] = 141.7872852871478,
					["fontsize"] = 8,
					["ComputedH"] = 20,
					["disablecolreset"] = 1,
					["colorfoo"] = "GEM3UI_GetEventStatusColor",
					["justify"] = "RIGHT",
					["tooltip"] = "Date the event is scheduled",
					["disablefilter"] = 1,
					["val"] = "ev_date",
					["lbl"] = "_Date",
					["sortorder"] = false,
					["Lpoint"] = 84.97704308758478,
					["type"] = "%d%m%y%ReplWeek%ReplTomorrow%ReplToday%ReplYesterday",
					["ComputedW"] = 60.310242199563,
					["size"] = 60.310242199563,
					["pos"] = 5,
				}, -- [5]
				{
					["visible"] = true,
					["colorfooval"] = "EventStatusColor",
					["Rpoint"] = 189.9712294541638,
					["fontsize"] = 8,
					["ComputedH"] = 20,
					["size"] = 41.183944167016,
					["colorfoo"] = "GEM3UI_GetEventStatusColor",
					["justify"] = "LEFT",
					["tooltip"] = "Time the event is schedules",
					["disablefilter"] = 1,
					["val"] = "ev_date",
					["disablecolreset"] = 1,
					["ComputedW"] = 41.183944167016,
					["Lpoint"] = 152.2872852871478,
					["type"] = "%H%M",
					["sortorder"] = false,
					["lbl"] = "_Time",
					["pos"] = 6,
				}, -- [6]
				{
					["lbl"] = "#_Instance Icon",
					["valmaxw"] = 15,
					["Rpoint"] = 210.2011487209758,
					["friendlyfoo"] = "GEM3UI_GetTagName",
					["ComputedH"] = 15,
					["size"] = 13.229919266812,
					["disablehedit"] = 1,
					["type"] = "texture",
					["justify"] = "LEFT",
					["valminw"] = 15,
					["val"] = "ev_inst_tag",
					["disablecolreset"] = 1,
					["disabledatatype"] = 1,
					["valminh"] = 15,
					["valmaxh"] = 15,
					["visible"] = true,
					["Lpoint"] = 200.4712294541638,
					["sortorder"] = false,
					["ComputedW"] = 15,
					["valfoo"] = "GEM3UI_GetTagIcon",
					["pos"] = 7,
				}, -- [7]
				{
					["visible"] = true,
					["colorfooval"] = "EventStatusColor",
					["Rpoint"] = 317.2358466965958,
					["fontsize"] = 10,
					["ComputedH"] = 20,
					["size"] = 100.03469797562,
					["disablehedit"] = 1,
					["colorfoo"] = "GEM3UI_GetEventStatusColor",
					["justify"] = "LEFT",
					["pos"] = 8,
					["tooltip"] = "Name or description of the event",
					["disabledatatype"] = 1,
					["disablecolreset"] = 1,
					["lbl"] = "_Event",
					["Lpoint"] = 220.7011487209758,
					["type"] = "string",
					["ComputedW"] = 100.03469797562,
					["sortorder"] = false,
					["val"] = "ev_place",
				}, -- [8]
				{
					["visible"] = true,
					["valmaxw"] = 20,
					["Rpoint"] = 329.3737938798998,
					["friendlyfoo"] = "GEM3UI_GetFriendlyAmILeader",
					["ComputedH"] = 20,
					["val"] = "id",
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "texture",
					["valfoo"] = "GEM3UI_IsMyEvent",
					["size"] = 5.137947183304,
					["valminw"] = 20,
					["tooltip"] = "Shows a ! if i am leader of the event",
					["disabledatatype"] = 1,
					["texturecolor"] = {
						1, -- [1]
						1, -- [2]
						1, -- [3]
						0.2699999809265137, -- [4]
					},
					["valminh"] = 20,
					["valmaxh"] = 20,
					["justify"] = "CENTER",
					["Lpoint"] = 327.7358466965958,
					["ComputedW"] = 20,
					["sortorder"] = false,
					["lbl"] = "#_Am i Leader",
					["pos"] = 9,
				}, -- [9]
				{
					["lbl"] = "#_Leader Online",
					["valmaxw"] = 12,
					["Rpoint"] = 338.569002040741,
					["friendlyfoo"] = "GEM3UI_GetFirendlyOnline",
					["fontsize"] = 7,
					["ComputedH"] = 12,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["errorfoo"] = "GEM3UI_GridError",
					["justify"] = "CENTER",
					["pos"] = 10,
					["valminw"] = 12,
					["size"] = 2.1952081608412,
					["disabledatatype"] = 1,
					["visible"] = true,
					["valminh"] = 12,
					["valmaxh"] = 12,
					["ComputedW"] = 12,
					["Lpoint"] = 339.8737938798998,
					["type"] = "texture",
					["sortorder"] = false,
					["valfoo"] = "GEM3UI_GetOnlineIcon",
					["val"] = "leader_connected",
				}, -- [10]
				{
					["visible"] = true,
					["Rpoint"] = 399.994221380844,
					["fontsize"] = 7,
					["ComputedH"] = 20,
					["size"] = 54.425219340103,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "LEFT",
					["pos"] = 11,
					["colorfoo"] = "GEM3UI_GetLeaderStatusColor",
					["disabledatatype"] = 1,
					["disablecolreset"] = 1,
					["ComputedW"] = 54.425219340103,
					["Lpoint"] = 349.069002040741,
					["errorfoo"] = "GEM3UI_GridError",
					["sortorder"] = true,
					["lbl"] = "_Leader",
					["val"] = "leader",
				}, -- [11]
				{
					["lbl"] = "Leader Guild",
					["Rpoint"] = 460.683861008131,
					["fontsize"] = 7,
					["ComputedH"] = 20,
					["size"] = 53.689639627287,
					["disablehedit"] = 1,
					["colorfoo"] = "GEM3UI_GetLeaderStatusColor",
					["justify"] = "LEFT",
					["pos"] = 12,
					["type"] = "string",
					["disabledatatype"] = 1,
					["visible"] = true,
					["disablecolreset"] = 1,
					["Lpoint"] = 410.494221380844,
					["sortorder"] = true,
					["ComputedW"] = 53.689639627287,
					["errorfoo"] = "GEM3UI_GridError",
					["val"] = "leader_guild",
				}, -- [12]
				{
					["lbl"] = "#_Leader Rank",
					["valmaxw"] = 14,
					["Rpoint"] = 474.2929676170674,
					["friendlyfoo"] = "GEM3UI_GetOfficerFriendly",
					["fontsize"] = 7,
					["ComputedH"] = 14,
					["pos"] = 13,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["errorfoo"] = "GEM3UI_GridError",
					["justify"] = "LEFT",
					["size"] = 6.6091066089364,
					["valminw"] = 14,
					["disabledatatype"] = 1,
					["visible"] = true,
					["texturecolor"] = {
						1, -- [1]
						1, -- [2]
						1, -- [3]
						0.3499999940395355, -- [4]
					},
					["valminh"] = 14,
					["valmaxh"] = 14,
					["type"] = "texture",
					["Lpoint"] = 471.183861008131,
					["valfoo"] = "GEM3UI_GetOfficerIcon",
					["ComputedW"] = 14,
					["sortorder"] = true,
					["val"] = "leader_officer",
				}, -- [13]
				{
					["lbl"] = "Leader Guildrank",
					["Rpoint"] = 555.5801697453335,
					["fontsize"] = 7,
					["ComputedH"] = 20,
					["size"] = 74.28720212826602,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "LEFT",
					["pos"] = 14,
					["colorfoo"] = "GEM3UI_GetLeaderStatusColor",
					["disabledatatype"] = 1,
					["visible"] = true,
					["disablecolreset"] = 1,
					["Lpoint"] = 484.7929676170674,
					["ComputedW"] = 74.28720212826602,
					["sortorder"] = true,
					["errorfoo"] = "GEM3UI_GridError",
					["val"] = "leader_rank",
				}, -- [14]
				{
					["lbl"] = "Slots",
					["Rpoint"] = 587.5802397738664,
					["fontsize"] = 7,
					["ComputedH"] = 20,
					["size"] = 25.000070028533,
					["disablehedit"] = 1,
					["colorfoo"] = "GEM3UI_GetPlayerCountColor",
					["justify"] = "CENTER",
					["tooltip"] = "tt_GEM3UIeventDetailsLimitsFrameLimitHeaderTIT1",
					["val"] = "max_count",
					["visible"] = true,
					["disabledatatype"] = 1,
					["sortorder"] = false,
					["Lpoint"] = 566.0801697453335,
					["type"] = "string",
					["ComputedW"] = 25.000070028533,
					["disablecolreset"] = 1,
					["pos"] = 15,
				}, -- [15]
				{
					["visible"] = true,
					["Rpoint"] = 601.1894514256023,
					["ComputedH"] = 20,
					["size"] = 6.6092116517359,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "CENTER",
					["tooltip"] = "tt_GEM3UIeventDetailsLimitsFrameLimitHeaderSUB1",
					["val"] = "sub_count",
					["disablecolreset"] = 1,
					["disabledatatype"] = 1,
					["lbl"] = "_substituteshort",
					["Lpoint"] = 598.0802397738664,
					["ComputedW"] = 6.6092116517359,
					["sortorder"] = false,
					["valfoo"] = "GEM3UI_GetZeroValueString",
					["pos"] = 16,
				}, -- [16]
				{
					["lbl"] = "_replacementshort",
					["Rpoint"] = 617.7452886833946,
					["ComputedH"] = 20,
					["size"] = 9.555837257792334,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "CENTER",
					["tooltip"] = "tt_GEM3UIeventDetailsLimitsFrameLimitHeaderTIT1",
					["val"] = "repl_count",
					["disablecolreset"] = 1,
					["disabledatatype"] = 1,
					["visible"] = true,
					["Lpoint"] = 611.6894514256023,
					["ComputedW"] = 9.555837257792334,
					["sortorder"] = false,
					["valfoo"] = "GEM3UI_GetZeroValueString",
					["pos"] = 17,
				}, -- [17]
				{
					["lbl"] = "_discarshort",
					["Rpoint"] = 632.8256247464959,
					["ComputedH"] = 20,
					["size"] = 8.080336063101299,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "CENTER",
					["tooltip"] = "tt_GEM3UIeventDetailsLimitsFrameLimitHeaderREJ1",
					["val"] = "rej_count",
					["disablecolreset"] = 1,
					["disabledatatype"] = 1,
					["visible"] = true,
					["Lpoint"] = 628.2452886833946,
					["sortorder"] = false,
					["ComputedW"] = 8.080336063101299,
					["valfoo"] = "GEM3UI_GetZeroValueString",
					["pos"] = 18,
				}, -- [18]
				{
					["visible"] = true,
					["color"] = {
						1, -- [1]
						0.07058823529411765, -- [2]
						0.08235294117647059, -- [3]
						1, -- [4]
					},
					["Rpoint"] = 653.7911237261243,
					["ComputedH"] = 20,
					["size"] = 13.96549897962833,
					["disablehedit"] = 1,
					["type"] = "string",
					["valfoo"] = "GEM3UI_GetZeroValueString",
					["tooltip"] = "tt_GEM3UIeventDetailsLimitsFrameLimitHeaderNC1",
					["val"] = "NAcount",
					["disablecolreset"] = 1,
					["disabledatatype"] = 1,
					["Lpoint"] = 643.3256247464959,
					["lbl"] = "_not_comingshort",
					["ComputedW"] = 13.96549897962833,
					["justify"] = "CENTER",
					["pos"] = 19,
				}, -- [19]
				{
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "CENTER",
					["size"] = 10.287250272882,
					["Rpoint"] = 671.0783739990063,
					["tooltip"] = "Total Subscriptions TT",
					["ComputedH"] = 20,
					["visible"] = true,
					["lbl"] = "Total Subscriptions",
					["valfoo"] = "GEM3UI_GetZeroValueString",
					["disabledatatype"] = 1,
					["Lpoint"] = 664.2911237261243,
					["disablecolreset"] = 1,
					["ComputedW"] = 10.287250272882,
					["val"] = "Totals",
					["pos"] = 20,
				}, -- [20]
				{
					["visible"] = true,
					["colorfooval"] = "min_lvl",
					["Rpoint"] = 698.6646156079778,
					["fontsize"] = 8,
					["ComputedH"] = 20,
					["size"] = 20.58624160897142,
					["disablehedit"] = 1,
					["colorfoo"] = "GEM3UI_GetLevelLimitColor",
					["justify"] = "CENTER",
					["tooltip"] = "Min Level TT",
					["val"] = "min_lvl",
					["lbl"] = "Min Level",
					["disabledatatype"] = 1,
					["ComputedW"] = 20.58624160897142,
					["Lpoint"] = 681.5783739990063,
					["type"] = "number",
					["sortorder"] = false,
					["disablecolreset"] = 1,
					["pos"] = 21,
				}, -- [21]
				{
					["lbl"] = "Deadlineshort",
					["colorfooval"] = "deadline",
					["Rpoint"] = 740.2279221884518,
					["ComputedH"] = 20,
					["size"] = 34.563306580474,
					["disablehedit"] = 1,
					["type"] = "%d%m%y%H%M",
					["justify"] = "LEFT",
					["tooltip"] = "deadlineTT",
					["val"] = "deadline",
					["visible"] = true,
					["ComputedW"] = 34.563306580474,
					["Lpoint"] = 709.1646156079778,
					["disablecolreset"] = 1,
					["sortorder"] = false,
					["colorfoo"] = "GEM3UI_GetOutdatedColor",
					["pos"] = 22,
				}, -- [22]
				{
					["lbl"] = "_Channel",
					["type"] = "string",
					["justify"] = "LEFT",
					["disablecolreset"] = 1,
					["tooltip"] = "Channel the event is created in",
					["Rpoint"] = 805.3313202067677,
					["disabledatatype"] = 1,
					["disablehedit"] = 1,
					["visible"] = true,
					["size"] = 58.103398018316,
					["Lpoint"] = 750.7279221884518,
					["val"] = "channel",
					["ComputedH"] = 20,
					["ComputedW"] = 58.103398018316,
					["pos"] = 23,
				}, -- [23]
				{
					["visible"] = true,
					["Rpoint"] = 892.5038253086267,
					["fontsize"] = 6,
					["ComputedH"] = 20,
					["size"] = 80.172505101859,
					["disablehedit"] = 1,
					["type"] = "%d%m%y%H%M",
					["justify"] = "LEFT",
					["tooltip"] = "Last time the event has been updated",
					["disablefilter"] = 1,
					["val"] = "update_time",
					["disablecolreset"] = 1,
					["Lpoint"] = 815.8313202067677,
					["ComputedW"] = 80.172505101859,
					["sortorder"] = false,
					["lbl"] = "_UpdateTime",
					["pos"] = 24,
				}, -- [24]
				{
					["visible"] = true,
					["type"] = "string",
					["justify"] = "LEFT",
					["disablecolreset"] = 1,
					["Rpoint"] = 960.5498923208724,
					["disablefilter"] = 1,
					["lbl"] = "_Comment",
					["disabledatatype"] = 1,
					["disablehedit"] = 1,
					["size"] = 61.04606701224565,
					["Lpoint"] = 903.0038253086267,
					["ComputedW"] = 61.04606701224565,
					["ComputedH"] = 20,
					["val"] = "ev_comment",
					["pos"] = 25,
				}, -- [25]
				{
					["visible"] = true,
					["valmaxw"] = 10,
					["Rpoint"] = 971.9521897628267,
					["friendlyfoo"] = "GEM3UI_GetIsOutdatedFriendly",
					["ComputedH"] = 10,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "texture",
					["valfoo"] = "GEM3UI_GetIsOutdatedIcon",
					["val"] = "outdated",
					["valminw"] = 10,
					["tooltip"] = "shows wether the event is outdated or not",
					["size"] = 4.4022974419544,
					["disabledatatype"] = 1,
					["valminh"] = 10,
					["valmaxh"] = 10,
					["lbl"] = "#_outDated",
					["Lpoint"] = 971.0498923208724,
					["sortorder"] = false,
					["ComputedW"] = 10,
					["justify"] = "CENTER",
					["pos"] = 26,
				}, -- [26]
				{
					["disablehedit"] = 1,
					["type"] = "number",
					["justify"] = "CENTER",
					["size"] = 21.32182132178716,
					["Rpoint"] = 1000.274011084614,
					["tooltip"] = "Max Level TT",
					["ComputedH"] = 20,
					["visible"] = true,
					["lbl"] = "Max Level",
					["disabledatatype"] = 1,
					["disablecolreset"] = 1,
					["Lpoint"] = 982.4521897628267,
					["ComputedW"] = 21.32182132178716,
					["sortorder"] = false,
					["val"] = "max_lvl",
					["pos"] = 27,
				}, -- [27]
				{
					["lbl"] = "#_PlayerOverview",
					["Rpoint"] = 1375.733810227184,
					["ComputedH"] = 65,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "custom",
					["justify"] = "LEFT",
					["val"] = "ev_date",
					["valminw"] = 350,
					["tooltip"] = "event overview in one column",
					["disablefilter"] = 1,
					["size"] = 368.45979914257,
					["valminh"] = 65,
					["disabledatatype"] = 1,
					["visible"] = true,
					["Lpoint"] = 1010.774011084614,
					["formfoo"] = "GEM3UI_DrawEventHeader",
					["ComputedW"] = 368.45979914257,
					["sortorder"] = false,
					["pos"] = 28,
				}, -- [28]
			},
}

GEM3UI_ChannelMembersGridDefaults = {
			["GridParams"] = {
				["OnClickFoo"] = "GEM3UI_MemberOnLClick",
				["OnRclickFoo"] = "GEM3UI_MemberLineMenu",
				["OnLeaveFoo"] = "GEM3UI_MemberLineOnLeave",
				["OnEnterFoo"] = "GEM3UI_MemberLineOnEnter",
                ["parent"] = "GEM3UI_MemberslistTest",
                ["disableAdvancedCFG"] = 1,
			},
			["DGridParams"] = {
                ["inherits"] = "GEM3UI_THEME_Neutral",
                ["resetfoo"] = "GEM3UI_ResetMembersGrid",
                ["headerheight"] = 20.14940813237797,
				["LineHeight"] = 20,
				["LabelFontSize"] = 7,
				["ValueFontSize"] = 7.5,
				["DataSource"] = "GEM3UI_ChannelMembers",
				["ColSepWidth"] = 3,
				["headerheight"] = 15,
			},
			["DHeaders"] = {
				{
					["visible"] = true,
					["valmaxw"] = 13,
					["clickfoo"] = "GEM3UI_InviteButtonOnClick",
					["Rpoint"] = 11.96750891478966,
					["fontsize"] = 9,
					["pos"] = 1,
					["ComputedH"] = 13,
					["size"] = 10.46750891478966,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "custombutton",
					["valfoo"] = "GEM3UI_MemberGridQuickInviteGetButton",
					["disabledatatype"] = 1,
					["valminw"] = 13,
					["tooltip"] = "InviteThisPlayer",
					["disablefilter"] = 1,
					["disablesort"] = 1,
					["valminh"] = 13,
					["valmaxh"] = 13,
					["ComputedW"] = 13,
					["Lpoint"] = 3,
					["justify"] = "LEFT",
					["sortorder"] = false,
					["lbl"] = "#_Invite",
					["val"] = "invite",
				}, -- [1]
				{
					["visible"] = true,
					["valmaxw"] = 13,
					["clickfoo"] = "GEM3UI_SetGemAdminButtonOnClick",
					["Rpoint"] = 22.49248889271606,
					["lbl"] = "#_IsAdmin",
					["fontsize"] = 9,
					["disablesort"] = 1,
					["ComputedH"] = 16,
					["val"] = "name",
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "boolean",
					["valfoo"] = "GEM3UI_isGemAdmin",
					["size"] = 7.5249799779264,
					["valminw"] = 13,
					["tooltip"] = "#_Is Admin",
					["disablefilter"] = 1,
					["htooltipfoo"] = "#_Is Admin",
					["valminh"] = 13,
					["valmaxh"] = 16,
					["ComputedW"] = 13,
					["Lpoint"] = 16.46750891478966,
					["justify"] = "LEFT",
					["disabledatatype"] = 1,
					["sortorder"] = false,
					["pos"] = 2,
				}, -- [2]
				{
					["visible"] = true,
					["valmaxw"] = 20,
					["Rpoint"] = 32.48631475596326,
					["friendlyfoo"] = "GEM3UI_GetSortStatus",
					["pos"] = 3,
					["ComputedW"] = 20,
					["ComputedH"] = 20,
					["disabledatatype"] = 1,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["colorfoo"] = "GEM3UI_GetStatusColor",
					["justify"] = "LEFT",
					["size"] = 6.9938258632472,
					["valminw"] = 20,
					["tooltip"] = "PlayerstatusHeaderTooltip",
					["sortvalfoo"] = "GEM3UI_GetSortStatus",
					["texturecolor"] = {
						1, -- [1]
						1, -- [2]
						1, -- [3]
						0.2299999892711639, -- [4]
					},
					["valminh"] = 20,
					["valmaxh"] = 20,
					["valfoo"] = "GEM3UI_GetStatusIcon",
					["Lpoint"] = 26.99248889271606,
					["lbl"] = "#_StatusIcon",
					["sortorder"] = false,
					["type"] = "texture",
					["val"] = "name",
				}, -- [3]
				{
					["visible"] = true,
					["valmaxw"] = 8,
					["Rpoint"] = 40.91439015234776,
					["ComputedH"] = 8,
					["pos"] = 4,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "texture",
					["valfoo"] = "GEM3UI_GetTimerefIcon",
					["size"] = 5.4280753963845,
					["valminw"] = 8,
					["tooltip"] = "PlayerstatusHeaderTooltip",
					["disablefilter"] = 1,
					["disabledatatype"] = 1,
					["valminh"] = 8,
					["valmaxh"] = 8,
					["lbl"] = "#_StatusIcon",
					["Lpoint"] = 36.98631475596326,
					["ComputedW"] = 8,
					["sortorder"] = false,
					["justify"] = "RIGHT",
					["val"] = "isTimeRef",
				}, -- [4]
				{
					["visible"] = true,
					["valmaxw"] = 10,
					["Rpoint"] = 51.69111750972606,
					["ComputedH"] = 10,
					["pos"] = 5,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "texture",
					["justify"] = "LEFT",
					["size"] = 7.7767273573783,
					["valminw"] = 10,
					["tooltip"] = "OnlineStatusHeaderTooltip",
					["disablefilter"] = 1,
					["disabledatatype"] = 1,
					["valminh"] = 10,
					["valmaxh"] = 10,
					["ComputedW"] = 10,
					["Lpoint"] = 45.41439015234776,
					["lbl"] = "O",
					["sortorder"] = false,
					["valfoo"] = "GEM3UI_GetOnlineIcon",
					["val"] = "connected",
				}, -- [5]
				{
					["lbl"] = "T",
					["color"] = {
						0.8470588235294118, -- [1]
						1, -- [2]
						0.05882352941176471, -- [3]
						1, -- [4]
					},
					["Rpoint"] = 60.26100068585696,
					["friendlyfoo"] = "GEM3UI_GetTagCount",
					["fontsize"] = 6,
					["ComputedH"] = 20,
					["size"] = 5.5698831761309,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "CENTER",
					["pos"] = 6,
					["tooltip"] = "TagsHeaderTooltip",
					["disablecolreset"] = 1,
					["disabledatatype"] = 1,
					["sortorder"] = false,
					["sortvalfoo"] = "GEM3UI_GetTagCount",
					["visible"] = true,
					["Lpoint"] = 56.19111750972606,
					["errorfoo"] = "GEM3UI_GridError",
					["ComputedW"] = 5.5698831761309,
					["valfoo"] = "GEM3UI_GetTagCount",
					["val"] = "tags",
				}, -- [6]
				{
					["visible"] = true,
					["colorfooval"] = "class",
					["Rpoint"] = 141.5436632691667,
					["fontsize"] = 11,
					["ComputedH"] = 20,
					["size"] = 78.28266258330977,
					["disablehedit"] = 1,
					["colorfoo"] = "GEM3UI_GetClassColor",
					["justify"] = "LEFT",
					["tooltip"] = "NameHeaderTooltip",
					["pos"] = 7,
					["disablecolreset"] = 1,
					["disabledatatype"] = 1,
					["type"] = "string",
					["sortorder"] = false,
					["Lpoint"] = 64.76100068585697,
					["lbl"] = "#GS_NAME",
					["ComputedW"] = 78.28266258330977,
					["val"] = "name",
				}, -- [7]
				{
					["lbl"] = "R",
					["valmaxw"] = 16,
					["Rpoint"] = 151.7608142964354,
					["friendlyfoo"] = "GEM3UI_GetFriendlyRole",
					["ComputedH"] = 16,
					["pos"] = 8,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "texture",
					["justify"] = "LEFT",
					["size"] = 7.2171510272687,
					["valminw"] = 16,
					["tooltip"] = "RoleHeaderTooltip",
					["disabledatatype"] = 1,
					["texturecolor"] = {
						1, -- [1]
						1, -- [2]
						1, -- [3]
						0.3799999952316284, -- [4]
					},
					["valminh"] = 16,
					["valmaxh"] = 16,
					["visible"] = true,
					["Lpoint"] = 146.0436632691667,
					["ComputedW"] = 16,
					["sortorder"] = false,
					["valfoo"] = "GEM3UI_GetRoleIcon",
					["val"] = "role",
				}, -- [8]
				{
					["visible"] = true,
					["colorfooval"] = "class",
					["Rpoint"] = 172.9984389586797,
					["fontsize"] = 13,
					["ComputedH"] = 20,
					["size"] = 18.23762466224425,
					["disablehedit"] = 1,
					["type"] = "number",
					["justify"] = "CENTER",
					["tooltip"] = "LevelHeaderTooltip",
					["pos"] = 9,
					["disablecolreset"] = 1,
					["disabledatatype"] = 1,
					["lbl"] = "LvL",
					["colorfoo"] = "GEM3UI_GetClassColor",
					["Lpoint"] = 156.2608142964354,
					["ComputedW"] = 18.23762466224425,
					["sortorder"] = false,
					["val"] = "level",
				}, -- [9]
				{
					["lbl"] = "C",
					["valmaxw"] = 16,
					["Rpoint"] = 183.7751313017913,
					["friendlyfoo"] = "GEM3UI_GetFriendlyClass",
					["ComputedH"] = 16,
					["pos"] = 10,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "texture",
					["valfoo"] = "GEM3UI_GetClassIcon",
					["size"] = 7.7766923431116,
					["valminw"] = 16,
					["tooltip"] = "ClassHeaderTooltip",
					["disabledatatype"] = 1,
					["texturecolor"] = {
						1, -- [1]
						1, -- [2]
						1, -- [3]
						0.699999988079071, -- [4]
					},
					["valminh"] = 16,
					["valmaxh"] = 16,
					["visible"] = true,
					["Lpoint"] = 177.4984389586797,
					["ComputedW"] = 16,
					["sortorder"] = false,
					["justify"] = "RIGHT",
					["val"] = "class",
				}, -- [10]
				{
					["visible"] = true,
					["Rpoint"] = 247.3903850345209,
					["ComputedH"] = 20,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "LEFT",
					["tooltip"] = "GuildHeaderTooltip",
					["pos"] = 11,
					["colorfoo"] = "GEM3UI_GetStatusColor",
					["disabledatatype"] = 1,
					["Lpoint"] = 188.2751313017913,
					["size"] = 60.61525373272967,
					["ComputedW"] = 60.61525373272967,
					["lbl"] = "#GS_GUILD",
					["val"] = "guild",
				}, -- [11]
				{
					["lbl"] = "R",
					["valmaxw"] = 18,
					["Rpoint"] = 258.1672874632321,
					["friendlyfoo"] = "GEM3UI_GetFriendlyOfficer",
					["ComputedH"] = 18,
					["val"] = "officer",
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "texture",
					["valfoo"] = "GEM3UI_GetOfficerIcon",
					["size"] = 7.7769024287112,
					["valminw"] = 18,
					["tooltip"] = "OfficerHeaderTooltip",
					["disabledatatype"] = 1,
					["texturecolor"] = {
						1, -- [1]
						1, -- [2]
						1, -- [3]
						0.2699999809265137, -- [4]
					},
					["valminh"] = 18,
					["valmaxh"] = 18,
					["justify"] = "LEFT",
					["Lpoint"] = 251.8903850345209,
					["sortorder"] = true,
					["ComputedW"] = 18,
					["visible"] = true,
					["pos"] = 12,
				}, -- [12]
				{
					["lbl"] = "#GS_RANK",
					["Rpoint"] = 309.6534569305042,
					["fontsize"] = 8,
					["ComputedH"] = 20,
					["size"] = 48.486169467272,
					["disablehedit"] = 1,
					["colorfoo"] = "GEM3UI_GetStatusColor",
					["justify"] = "LEFT",
					["tooltip"] = "OfficerHeaderTooltip",
					["pos"] = 13,
					["type"] = "string",
					["disabledatatype"] = 1,
					["Lpoint"] = 262.6672874632321,
					["visible"] = true,
					["ComputedW"] = 48.486169467272,
					["disablecolreset"] = 1,
					["val"] = "grank_name",
				}, -- [13]
				{
					["lbl"] = "I",
					["valmaxw"] = 10,
					["Rpoint"] = 316.7521806810025,
					["friendlyfoo"] = "GEM3UI_GetFriendlyZoneType",
					["ComputedH"] = 10,
					["val"] = "instance_type",
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["type"] = "texture",
					["valfoo"] = "GEM3UI_GetZoneIcon",
					["size"] = 4.0987237504984,
					["valminw"] = 10,
					["tooltip"] = "In instance / Raid / PvP",
					["disabledatatype"] = 1,
					["texturecolor"] = {
						1, -- [1]
						1, -- [2]
						1, -- [3]
						0.8, -- [4]
					},
					["valminh"] = 10,
					["valmaxh"] = 10,
					["justify"] = "LEFT",
					["Lpoint"] = 314.1534569305042,
					["sortorder"] = false,
					["ComputedW"] = 10,
					["visible"] = true,
					["pos"] = 14,
				}, -- [14]
				{
					["lbl"] = "#GS_ZONE",
					["colorfoo"] = "GEM3UI_GetinFightColor",
					["justify"] = "LEFT",
					["size"] = 66.91760937906449,
					["disablehedit"] = 1,
					["Rpoint"] = 386.669790060067,
					["ComputedH"] = 20,
					["tooltip"] = "ZoneHeaderTooltip",
					["disabledatatype"] = 1,
					["visible"] = true,
					["type"] = "string",
					["Lpoint"] = 321.2521806810025,
					["disablecolreset"] = 1,
					["ComputedW"] = 66.91760937906449,
					["pos"] = 15,
					["val"] = "location",
				}, -- [15]
				{
					["visible"] = true,
					["Rpoint"] = 434.8088057256006,
					["fontsize"] = 7,
					["ComputedH"] = 20,
					["size"] = 45.13901566553356,
					["disablehedit"] = 1,
					["type"] = "%m%d%y%H%M%ReplWeek%ReplTomorrow%ReplToday%ReplYesterday",
					["justify"] = "CENTER",
					["tooltip"] = "LastseenHeaderTooltip",
					["disablefilter"] = 1,
					["pos"] = 16,
					["lbl"] = "Lastseen",
					["sortorder"] = false,
					["Lpoint"] = 391.169790060067,
					["colorfoo"] = "GEM3UI_GetStatusColor",
					["ComputedW"] = 45.13901566553356,
					["disablecolreset"] = 1,
					["val"] = "lastlog",
				}, -- [16]
				{
					["visible"] = true,
					["Rpoint"] = 456.7171800576542,
					["fontsize"] = 6,
					["ComputedH"] = 20,
					["size"] = 18.90837433205359,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "CENTER",
					["tooltip"] = "CoreHeaderTooltip",
					["pos"] = 17,
					["colorfoo"] = "GEM3UI_GetStatusColor",
					["disabledatatype"] = 1,
					["Lpoint"] = 439.3088057256006,
					["lbl"] = "Core",
					["ComputedW"] = 18.90837433205359,
					["disablecolreset"] = 1,
					["val"] = "version",
				}, -- [17]
				{
					["lbl"] = "UI",
					["Rpoint"] = 479.860892729762,
					["fontsize"] = 6,
					["ComputedH"] = 20,
					["size"] = 20.14371267210776,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "CENTER",
					["tooltip"] = "UIHeaderTooltip",
					["pos"] = 18,
					["colorfoo"] = "GEM3UI_GetStatusColor",
					["disabledatatype"] = 1,
					["Lpoint"] = 461.2171800576542,
					["visible"] = true,
					["ComputedW"] = 20.14371267210776,
					["disablecolreset"] = 1,
					["val"] = "ui_version",
				}, -- [18]
			},
        }

GEM3UI_CFG_ChannellistGridDefaults = {
			["DGridParams"] = {
				["LineHeight"] = 29,
				["inherits"] = "GEM3UI_THEME_Neutral",
				["DataSource"] = "GEM3UI_CFG_Channellist",
				["headerheight"] = 22.35632234215893,
				["ColSepWidth"] = 3,
				["LabelFontSize"] = 8,
				["SliderSize"] = 5,
  			["ValueFontSize"] = 12,
				["resetfoo"] = "GEM3UI_ResetChannelsGrid",
			},
			["GridParams"] = {
				["OnClickFoo"] = "GEM3UI_CFGGridChanSelect",
				["parent"] = "GEM3UI_CFG_Chanlist",
				["disableAdvancedCFG"] = 1,
				["disableAddCol"] = 1,
			},
			["DHeaders"] = {
				{
					["lbl"] = "Auto config",
					["valmaxw"] = 16,
					["Rpoint"] = 51.511460949074,
					["ComputedH"] = 16,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["disablecoldelete"] = 1,
					["justify"] = "CENTER",
					["val"] = "autoconfig",
					["ComputedW"] = 16,
					["tooltip"] = "_ADMIN_ONLY_ThisChannelWillBeconfiguredAutomaticallyForChannelMembers",
					["disablefilter"] = 1,
					["disabledatatype"] = 1,
					["disablesort"] = 1,
					["valmaxh"] = 16,
					["size"] = 50.011460949074,
					["Lpoint"] = 3,
					["type"] = "boolean",
					["sortorder"] = false,
					["visible"] = true,
					["pos"] = 1,
				}, -- [1]
				{
					["visible"] = true,
					["valmaxw"] = 30,
					["clickfoo"] = "GEM3UI_SendChannelConfig",
					["Rpoint"] = 89.81027721383038,
					["ComputedH"] = 20,
					["size"] = 35.29881626475637,
					["type"] = "button",
					["valfoo"] = "GEM3UI_GetValSend",
					["tooltip"] = "_Send_This_Channel_Config",
					["val"] = "name",
					["valmaxh"] = 20,
					["justify"] = "CENTER",
					["Lpoint"] = 56.011460949074,
					["ComputedW"] = 30,
					["lbl"] = "_Send",
					["pos"] = 2,
				}, -- [2]
				{
					["visible"] = true,
					["Rpoint"] = 253.9021880223752,
					["ComputedH"] = 29,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["disablecoldelete"] = 1,
					["justify"] = "LEFT",
					["val"] = "name",
					["sortorder"] = false,
					["disablefilter"] = 1,
					["disabledatatype"] = 1,
					["type"] = "string",
					["size"] = 161.0919108085448,
					["colorfoo"] = "GEM3UI_GuildChannelColor",
					["Lpoint"] = 94.31027721383038,
					["lbl"] = "_ChanName",
					["ComputedW"] = 161.0919108085448,
					["colorfooval"] = "guild",
					["pos"] = 3,
				}, -- [3]
				{
					["lbl"] = "_Password",
					["disablesort"] = 1,
					["Rpoint"] = 333.396409403222,
					["ComputedH"] = 29,
					["val"] = "password",
					["size"] = 76.4942213808468,
					["disablehedit"] = 1,
					["disablecoldelete"] = 1,
					["justify"] = "LEFT",
					["colorfooval"] = "guild",
					["disabledatatype"] = 1,
					["visible"] = true,
					["disablefilter"] = 1,
					["ComputedW"] = 76.4942213808468,
					["disablecolreset"] = 1,
					["colorfoo"] = "GEM3UI_GuildChannelColor",
					["errorfoo"] = "GEM3UI_GridError",
					["Lpoint"] = 258.4021880223752,
					["type"] = "string",
					["sortorder"] = false,
					["color"] = {
						1, -- [1]
						0.09019607843137255, -- [2]
						0.04313725490196078, -- [3]
						1, -- [4]
					},
					["pos"] = 4,
				}, -- [4]
				{
					["visible"] = true,
					["disablesort"] = 1,
					["colorfooval"] = "guild",
					["Rpoint"] = 362.8675688288544,
					["fontsize"] = 10,
					["ComputedH"] = 29,
					["size"] = 26.47115942563237,
					["disablehedit"] = 1,
					["disablecoldelete"] = 1,
					["justify"] = "LEFT",
					["val"] = "alias",
					["errorfoo"] = "GEM3UI_GridError",
					["tooltip"] = "_TheNameShownInFromOfChatLines",
					["disablefilter"] = 1,
					["ComputedW"] = 26.47115942563237,
					["type"] = "string",
					["colorfoo"] = "GEM3UI_GuildChannelColor",
					["disablecolreset"] = 1,
					["Lpoint"] = 337.896409403222,
					["lbl"] = "_Alias",
					["disabledatatype"] = 1,
					["pos"] = 5,
				}, -- [5]
				{
					["lbl"] = "_Slash",
					["disablesort"] = 1,
					["colorfooval"] = "guild",
					["Rpoint"] = 391.6034286558034,
					["fontsize"] = 10,
					["ComputedH"] = 29,
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["disablecoldelete"] = 1,
					["justify"] = "LEFT",
					["val"] = "slash",
					["size"] = 25.73585982694901,
					["tooltip"] = "_UseSlashToChatonThischannel",
					["disablefilter"] = 1,
					["disabledatatype"] = 1,
					["type"] = "string",
					["colorfoo"] = "GEM3UI_GuildChannelColor",
					["errorfoo"] = "GEM3UI_GridError",
					["Lpoint"] = 367.3675688288544,
					["visible"] = true,
					["ComputedW"] = 25.73585982694901,
					["pos"] = 6,
				}, -- [6]
				{
					["visible"] = true,
					["valmaxw"] = 16,
					["Rpoint"] = 429.9022449205602,
					["ComputedH"] = 16,
					["val"] = "name",
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["disablecoldelete"] = 1,
					["justify"] = "CENTER",
					["type"] = "boolean",
					["ComputedW"] = 16,
					["tooltip"] = "_SyncEventsOfThisChannelToBlizzardCalendar",
					["disablefilter"] = 1,
					["size"] = 35.29881626475679,
					["valfoo"] = "GEM3UI_UseBlizCal",
					["valmaxh"] = 16,
					["lbl"] = "bliz_cal",
					["Lpoint"] = 396.1034286558034,
					["clickfoo"] = "GEM3UI_CFGSetChanMustHandleCalGrid",
					["disabledatatype"] = 1,
					["disablesort"] = 1,
					["pos"] = 7,
				}, -- [7]
				{
					["visible"] = true,
					["valmaxw"] = 16,
					["clickfoo"] = "GEM3UI_CFGSetChanDefaultGrid",
					["Rpoint"] = 471.8793799205952,
					["ComputedH"] = 16,
					["val"] = "name",
					["disablecolreset"] = 1,
					["disablehedit"] = 1,
					["disablecoldelete"] = 1,
					["valfoo"] = "GEM3UI_CFGIsChanDefaultGrid",
					["justify"] = "CENTER",
					["ComputedW"] = 16,
					["tooltip"] = "_TheChannelUsedByDefaultInGEM",
					["disablefilter"] = 1,
					["lbl"] = "_Default",
					["valmaxh"] = 16,
					["size"] = 38.977135000035,
					["Lpoint"] = 434.4022449205602,
					["type"] = "boolean",
					["disabledatatype"] = 1,
					["disablesort"] = 1,
					["pos"] = 8,
				}, -- [8]
			},
		}



GEM3UI_GridParamsDefaults = {
 ["GEM3UI_GridDefaults"] = GEM3UI_GridDefaults,
 ["GEM3UI_THEME_Neutral"] = GEM3UI_Gridtheme_Neutral,
 ["GEM3UI_THEME_Horde"] = GEM3UI_Gridtheme_Horde,
 ["GEM3UI_THEME_Alliance"] = GEM3UI_Gridtheme_Alliance,
 ["GEM3UI_EVENTS_Leader"] = GEM3UI_EVENTS_LeaderDefaults,
 ["GEM3UI_EVENTS_Player"] = GEM3UI_EVENTS_PlayerDefaults,
 ["GEM3UI_EVENTS_Minimal"] = GEM3UI_EVENTS_MinimalDefaults,
 ["GEM3UI_EventPlayers"] = GEM3UI_EventsPlayersListGridDefaults,
 ["GEM3UI_ChannelMembers"] = GEM3UI_ChannelMembersGridDefaults,
 ["GEM3UI_CFG_Channellist"] = GEM3UI_CFG_ChannellistGridDefaults
}


GEM3_UI_FAQ_CLISTDefault = {
			["DGridParams"] = {
				["DataSource"] = "GEM3UI_FAQListHeaders",
			},
			["GridParams"] = {
				["SliderSize"] = 6,
				["OnClickFoo"] = "GEM3UI_FAQHeaderCListOnClick",
				["LineHeight"] = 22,
				["parent"] = "GEM3UI_FAQCLIST",
				["disableResets"] = 1,
				["disableAdvancedCFG"] = 1,
				["ColSepWidth"] = 2,
				["disableAddCol"] = 1,
			},
			["DHeaders"] = {
				{
					["lbl"] = "title",
					["type"] = "string",
					["justify"] = "LEFT",
					["pos"] = 1,
					["visible"] = true,
					["size"] = 25,
					["val"] = "title",
				}, -- [1]
			},
			["Headers"] = {
				{
					["visible"] = true,
					["Rpoint"] = 83.37941931164005,
					["ComputedH"] = 22,
					["size"] = 82.37941931164005,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "LEFT",
					["disablecoldelete"] = 1,
					["lbl"] = "Sub Section",
					["disabledatatype"] = 1,
					["disablecolreset"] = 1,
					["Lpoint"] = 2,
					["ComputedW"] = 82.37941931164005,
					["sortorder"] = false,
					["val"] = "title",
					["pos"] = 1,
				}, -- [1]
			},
		}

GEM3_UI_FAQ_PLISTDefault = {
			["DGridParams"] = {
				["DataSource"] = "GEM3_UI_SECTIONS",
			},
			["GridParams"] = {
				["SliderSize"] = -1,
				["OnClickFoo"] = "GEM3UI_FAQHeaderPListOnClick",
				["LineHeight"] = 22,
				["parent"] = "GEM3UI_FAQPLIST",
				["disableResets"] = 1,
				["LabelFontSize"] = 10,
				["ColSepWidth"] = 2,
				["disableAdvancedCFG"] = 1,
				["disableAddCol"] = 1,
				["ValueFontSize"] = 9,
				["sortcol"] = {
				},
			},
			["DHeaders"] = {
				{
					["lbl"] = "name",
					["type"] = "string",
					["justify"] = "LEFT",
					["pos"] = 1,
					["visible"] = true,
					["size"] = 25,
					["val"] = "name",
				}, -- [1]
			},
			["Headers"] = {
				{
					["lbl"] = "Section",
					["Rpoint"] = 89.26433712830078,
					["ComputedH"] = 22,
					["size"] = 88.26433712830078,
					["disablehedit"] = 1,
					["type"] = "string",
					["justify"] = "LEFT",
					["disablecoldelete"] = 1,
					["visible"] = true,
					["disabledatatype"] = 1,
					["disablecolreset"] = 1,
					["Lpoint"] = 2,
					["val"] = "name",
					["sortorder"] = false,
					["ComputedW"] = 88.26433712830078,
					["pos"] = 1,
				}, -- [1]
			},
		}
