-- Members list

function GEM3UI_MembersSortlist(e1, e2)
 returnval = GEM3UIMembers.sortdir or false;
 if GEM3UIMembers.sortfld==nil then GEM3UIMembers.sortfld="name"; end
 if e1 == nil then return returnval; end
 if e2 == nil then return not returnval; end
 local E1, E2, E3;
 if GEM3UIMembers.sortfld=="lvl" then
   E1 = e1.level; E2 = e2.level;
 elseif GEM3UIMembers.sortfld=="name" then
   E1 = e1.name; E2 = e2.name;
 elseif GEM3UIMembers.sortfld=="location" then
   E1 = e1.location; E2 = e2.location;
 end
 if returnval then E3 = E1; E1 = E2; E2 = E3; end -- change sortorder
 
 if E1 == E2 then
  return e1.name > e2.name
 else
  return E1 > E2
 end
end


function GEM3UI_MembersSort(self)
 if self.data == "lvl"      then
  GEM3UIMembers.sortfld="lvl";
 elseif self.data == "location" then
  GEM3UIMembers.sortfld="location";
 elseif self.data == "name"     then
  GEM3UIMembers.sortfld="name";
 end
 self.sortdir = not (self.sortdir or false);
 GEM3UIMembers.sortdir = self.sortdir;
 table.sort(GEM3UI_ChannelMembers, GEM3UI_MembersSortlist);
 --GEM3UI_ChannelMembersScrollUpdate();
end

function GEM3UI_ColumHeaderHighLight(self, flag)
 if flag == true then
  getglobal(self:GetName().."Label"):SetTextColor(0,1,0,1);
 else
  getglobal(self:GetName().."Label"):SetTextColor(0.9,0.85,0.15,1);
 end
end

function GEM3UI_ShowHideOfflineMembers(self)
 GEM3UI_GetChannelMembers();
 --GEM3UI_ChannelMembersScrollUpdate();
 if GEM3UI_MemberslistTest:IsVisible() then
    MovixLib_RefreshGrid(GEM3UI_MemberslistTest, true)
 end
end

function GEM3UI_ShowHideIgnoredMembers(self)
 GEM3UI_GetChannelMembers();
 --GEM3UI_ChannelMembersScrollUpdate();
 if GEM3UI_MemberslistTest:IsVisible() then
    MovixLib_RefreshGrid(GEM3UI_MemberslistTest, true)
 end
end

function GEM3UI_MembersFilterChannelDD(self)
 if GEM3UI_DDTable == nil then
  GEM3UI_DDTable = GA_GetTable();
 end
 table.insert(GEM3UI_DDTable, {   text = GEM3UI_LocalizedStrings["_Channels"],   isTitle = true, textHeight = 12 });
 --table.insert(GEM3UI_ChannelDDTable, {   text = GEM3UI_LocalizedStrings["None"],   isradio = true,   checked = false,   func = function() GEM3UI_EventFilterChannelAllClick(0) end,   closeWhenClicked = true, });
 for i, channel in ipairs(GEM3_QA_Config.channels) do
  if GEM3_PLAY_IsPlayerInChannel(channel.name,UnitName("player")) then
     local tbl = {   text = channel.name,   func = function() GEM3UI_MembersFilterChannelClick(channel.name) end, }
     table.insert(GEM3UI_DDTable, tbl);
  end
 end
 --table.insert(GEM3UI_ChannelDDTable, {   text = GEM3UI_LocalizedStrings["All"],   isradio = true,   checked = false,   func = function() GEM3UI_EventNameFilterOnClickAll(1) end,   closeWhenClicked = true, });
 GEM3UI_SetDDMenu(self, GEM3UI_DDTable)
end


function GEM3UI_MembersFilterChannelClick(value)
 GEM3UI_MembersFilterChannelTextLabel.value = value
 GEM3UI_MembersFilterChannelTextLabel:SetText(value);
 GEM3UI_GetChannelMembers();
 --GEM3UI_ChannelMembersScrollUpdate();
end


function GEM3UI_ChannelMembersOnShow(self)
  if GEM3UI_MembersFilterChannelTextLabel.value ==nil then 
   --for i, channel in ipairs(GEM3_QA_Config.channels) do
    --if GEM3_PLAY_IsPlayerInChannel(channel.name,UnitName("player")) then
      GEM3UI_MembersFilterChannelTextLabel.value = GEM3UI[UnitName("player")].DefaultChannel;
      GEM3UI_MembersFilterChannelTextLabel:SetText(GEM3UI[UnitName("player")].DefaultChannel);
    --end
   --end
  end
 if GEM3UIPlayerPanel.stickedLine ~= nil then 
   GEM3UIPlayerPanel.stickedLine:UnlockHighlight();
 end
 GEM3UI_GetChannelMembers();
 --GEM3UI_ChannelMembersScrollUpdate();
end

function GEM3UI_GetChannelMembers()
 local channamefilter = GEM3UI_MembersFilterChannelTextLabel.value;
 GEM3UI_ConnectedMembers = 0;
 GEM3UI_ignoredMembers =0;
 GEM3UI_totalMembers=0;

 GEM3UI_ChannelMembersCount = 0;
 GEM3UI_ChannelMembers = {};
 
 for i, chan in ipairs(GEM3_QA_Channels) do
  if GEM3_CHAN_IsChannelActive(chan.name) and  channamefilter == chan.name then
   for i, player in pairs(GEM3_QA_Players[chan.name]) do
     local p = MovixLib_TblCpy(player)
     GEM3UI_totalMembers = GEM3UI_totalMembers+1;
     local show = true;
     if GEM3_PLAY_IsPlayerIgnored(player.name) then GEM3UI_ignoredMembers= GEM3UI_ignoredMembers + 1; end
     if player.connected then GEM3UI_ConnectedMembers = GEM3UI_ConnectedMembers + 1; end
         
     if not GEM3UIMembersShowIgnored:GetChecked() and GEM3_PLAY_IsPlayerIgnored(player.name) then
       show = false;
     end
     if not GEM3UIMembersShowOffline:GetChecked() and not player.connected then
        show = false;
     end
     if show then
      GEM3UI_ChannelMembersCount = GEM3UI_ChannelMembersCount + 1;
      p.invite = p.name
      if GEM3UI_PlayerVersions[p.name] then
        p.ui_version = (GEM3UI_PlayerVersions[p.name].MAJOR or "").."."..(GEM3UI_PlayerVersions[p.name].MINOR or "").."."..(GEM3UI_PlayerVersions[p.name].REVISION or ""); 
      else
        p.ui_version = "???"
      end
      table.insert(GEM3UI_ChannelMembers, p)
     end
   end
  end
 end
 
 if GEM3UI.Gridstyle then 
    GEM3UI_FillMembersList()
 else
    table.sort(GEM3UI_ChannelMembers, GEM3UI_MembersSortlist);
 end
end



function GEM3UI_MemberOnLClick(p, row, col, foo)
 local member_name = p.data[row].name
 GEM3UI_ContextFrame="GEM3UIPlayerPanel";
 GEM3UIPlayerPanel.Stickedplname = member_name
end



function GEM3UI_MemberLineOnClick(self, arg1)
 if arg1 == "RightButton" then
  local dd = getglobal("GEM3UIDropDown");
  dd.target = self.index;
  GEM3UI_DropDowninit();
  GEM3UI_MemberLineMenu(self);
  GEM3UI_DDshow(self);
 elseif arg1 == "LeftButton" then
  GEM3UI_ContextFrame="GEM3UIPlayerPanel";
  GEM3UIPlayerPanel.Stickedplname = GEM3UI_ChannelMembers[self.index].name;
  --GEM3UI_ActPanel.GEM3UI_OldPanel = GEM3UI_ActPanel;
  if GEM3UIPlayerPanel.stickedLine ~= nil then 
   GEM3UIPlayerPanel.stickedLine:UnlockHighlight();
  end
  GEM3UIPlayerPanel.stickedLine = self;
  self:LockHighlight();
 end
end

function GEM3UI_MemberLineMenu(...)
 local member_name
 local ls = GEM3UI_LocalizedStrings;
 if GEM3UI.Gridstyle then 
  local p, row, col, foo = select(1,...)
  member_name = p.data[row].name
  MovixLib_DDMenuAddLine({text = PLAYER, isTitle = true, })
  MovixLib_DDMenuAddLine({   text = WHISPER,  func = function() ChatFrameEditBox:Show(); ChatFrameEditBox:Insert("/w "..member_name) end});
  MovixLib_DDMenuAddLine({   text = INVITE,  func = function() InviteUnit(member_name) end});
  if GEM3_PLAY_IsPlayerIgnored(member_name ) == true then 
    MovixLib_DDMenuAddLine({   text = ls["UnIgnore"],  func = function() GEM3_PLAY_UnIgnorePlayer(member_name); GEM3UI_ShowHideIgnoredMembers(); end});
  else
    MovixLib_DDMenuAddLine({   text = ls["Ignore"],  func = function() 
                                 local dialogFrame = StaticPopup_Show("GEM3UI_CONFIRM", GEM3UI_DIALOG_CONFIRM_MEMBER_IGNORE);
                                 if(dialogFrame) then dialogFrame.data = member_name; end
                        end});
  end
  MovixLib_DDMenuAddLine({   text = WHO,  func = function() SendWho(member_name) end});
  MovixLib_DDMenuAddLine({   text = "Send Config",  func = function() SendWho(member_name) end});
 else
  local self = select(1,...)
  member_name = GEM3UI_ChannelMembers[self.index].name;
  GEM3UI_DDAddLine("Whisp", member_name , ls["WhispPlayer"], true, false, GEM3UI_MemberMenuClick);
  GEM3UI_DDAddLine("Invite", member_name , ls["InvitePlayer"], true, false, GEM3UI_MemberMenuClick);
  GEM3UI_DDAddLine("Who", member_name , ls["whoPlayer"], true, false, GEM3UI_MemberMenuClick);
  if GEM3_PLAY_IsPlayerIgnored(member_name ) == true then 
    GEM3UI_DDAddLine("Unignore", member_name , ls["UnIgnore"], true, false, GEM3UI_MemberMenuClick);
  else
    GEM3UI_DDAddLine("Ignore", member_name , ls["Ignore"], true, false, GEM3UI_MemberMenuClick);
  end
 end
end

function GEM3UI_MemberMenuClick(id, value)
 if      id == "Whisp" then ChatFrameEditBox:Show(); ChatFrameEditBox:Insert("/w "..value);
 elseif  id == "Invite"  then InviteUnit(value);
 elseif  id == "Who"  then SendWho(value);
 elseif  id == "Ignore"  then 
   local dialogFrame = StaticPopup_Show("GEM3UI_CONFIRM", GEM3UI_DIALOG_CONFIRM_MEMBER_IGNORE);
   if(dialogFrame) then dialogFrame.data = value; end
 elseif  id == "Unignore"  then GEM3_PLAY_UnIgnorePlayer(value); GEM3UI_ShowHideIgnoredMembers(); 
  GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE", "CLOSE");
  --GEM3UI_-RefreshAll();
 end
end


function GEM3UI_CreateChannelMembersline()
 local framename;
 local parent = getglobal("GEM3UIMembersList");
 local line;
 local i;
 for i=1,GEM3UI_DefaultChannelPlayerLines do
  framename = "GEM3UI_ChannelMemberlineFrame"..i;
  line = CreateFrame("BUTTON", framename, parent, "MemberLineTemplate");
  if i > 1 then
    line:SetPoint("TOPLEFT", getglobal("GEM3UI_ChannelMemberlineFrame"..(i-1)), "BOTTOMLEFT", 0, 0);
  else
    line:SetPoint("TOPLEFT", getglobal("GEM3UIMembersListScroll"), "TOPLEFT", 4, -18);
  end
  line:SetWidth(parent:GetWidth()-10);
  line:SetHeight(14);
  line.classicon = getglobal(framename.."ClassIconTexture");
  --line.classicon = line:CreateTexture(framename.."ClassIcon");
  --line.classicon:SetPoint("TOPLEFT", line, "TOPLEFT", 2, -1);
  --line.classicon:SetHeight(12);
  --line.classicon:SetWidth(12);
  --line.classicon:SetDrawLayer("BACKGROUND");

  line.roleicon = getglobal(framename.."RoleIconTexture");
  --line.roleicon = line:CreateTexture(framename.."RoleIcon");
  --line.roleicon:SetPoint("TOPLEFT", line, "TOPLEFT", 14, -1);
  --line.roleicon:SetHeight(12);
  --line.roleicon:SetWidth(12);
  --line.roleicon:SetDrawLayer("ARTWORK");
  
  line.statusicon = getglobal(framename.."StatusIconTexture");
  --line.statusicon = line:CreateTexture(framename.."StatusIcon");
  --line.statusicon:SetPoint("TOPLEFT", line, "TOPLEFT", 28, -1);
  --line.statusicon:SetHeight(12);
  --line.statusicon:SetWidth(12);
  --line.statusicon:SetDrawLayer("ARTWORK");
  line.statusicon:SetTexture("interface\\AddOns\\GEM3UI\\X");

  line.leadicon = getglobal(framename.."LeadIconTexture");
  --line.leadicon = line:CreateTexture(framename.."LeadIcon");
  --line.leadicon :SetPoint("TOPLEFT", line, "TOPLEFT", 42, 0);
  --line.leadicon :SetHeight(12);
  --line.leadicon :SetWidth(12);
  --line.leadicon :SetDrawLayer("ARTWORK");
  line.leadicon:SetTexture("interface\\groupframe\\ui-group-leadericon");
  
  line:Hide();
  line:RegisterForClicks("LeftButtonUp", "RightButtonUp");
 end
end


function GEM3UI_FillChannelMembersLine(i, index)
 local framename = "GEM3UI_ChannelMemberlineFrame"..i;
 local line = getglobal(framename);
 local lbl,r,g,b,a;
 line.roleicon:SetTexture("");
 line.classicon:SetTexture("");
 line.index = index;
 lbl = getglobal(framename.."PlayerNameLabel");
 if GEM3UI_ChannelMembers[index].connected then 
  r = 0;
  g = 1;
  b = 0;
  a = 1;
 else 
  r = 1;
  g = 1;
  b = 1;
  a = 0.8; 
 end
 local pname = GEM3UI_ChannelMembers[index].name;
 lbl:SetText(pname);
 lbl:SetTextColor(r,g,b,a);
 lbl = getglobal(framename.."PlayerLvLLabel");
 lbl:SetText(GEM3UI_ChannelMembers[index].level);
 lbl:SetTextColor(r,g,b,a);
 lbl = getglobal(framename.."PlayerGuildLabel");
 lbl:SetText(GEM3UI_ChannelMembers[index].location);
 lbl:SetTextColor(r,g,b,a);
 
 local classid = GEM3UI_GetClassIndex(GEM3UI_ChannelMembers[index].class);
 local roleid = GEM3UI_GetRoleIndex(GEM3UI_ChannelMembers[index].role);
 line.roleicon:SetTexture("interface\\icons\\"..GEM3UI_Roles[roleid].icon);
 line.classicon:SetTexture(GEM3UI_Players_Classes[GEM3UI_Classes[classid].gemid].icon);
 
 
 
 line.statusicon:Hide();
 if GEM3_PLAY_IsPlayerIgnored(GEM3UI_ChannelMembers[index].name) then 
  line.statusicon:SetTexture("interface\\AddOns\\GEM3UI\\X");
  line.statusicon:Show(); 
 end
 if GEM3_PLAY_IsPlayerIgnored(GEM3UI_ChannelMembers[index].name) == false and GEM3UI_ChannelMembers[index].isTimeRef then
  line.statusicon:SetTexture("interface\\AddOns\\GEM3UI\\bell");
  line.statusicon:Show(); 
 end
 
 if GEM3UI_ChannelMembers[index].isLeader and GEM3UI_ChannelMembers[index].connected then line.leadicon:Show(); else line.leadicon:Hide(); end
 
 --if GEM3UI_ChannelMembers[index].connected then a = 1; else a=0.4 end
 
 line.classicon:SetAlpha(a);
 line.roleicon:SetAlpha(a);
 
 
 if GEM3UI_ChannelMembersCount > GEM3UI_DefaultChannelPlayerLines then
   line:SetWidth(GEM3UIMembersListScroll:GetWidth());
 else
   line:SetWidth(GEM3UIMembersListScroll:GetWidth()+18);
 end
end

--[[function GEM3UI_ChannelMembersScrollUpdate()
   local line; -- 1 through 5 of our window to scroll
   local lineplusoffset=0; -- an index into our data calculated from the scroll offset
   local cnt = #GEM3UI_ChannelMembers;  

   for line=1,GEM3UI_DefaultChannelPlayerLines do
       getglobal("GEM3UI_ChannelMemberlineFrame"..line):Hide();
   end
   FauxScrollFrame_Update(GEM3UIMembersListScroll,cnt,GEM3UI_DefaultChannelPlayerLines,14);
   for line=1,GEM3UI_DefaultChannelPlayerLines do
     lineplusoffset = line + FauxScrollFrame_GetOffset(GEM3UIMembersListScroll);
     if lineplusoffset < cnt+1 then
       GEM3UI_FillChannelMembersLine(line, lineplusoffset );
       getglobal("GEM3UI_ChannelMemberlineFrame"..line):Show();
     end
   end
   if GEM3UIMembers:IsVisible() then
    GEM3UI_SetStatusMessage(string.format(GEM3UI_LocalizedStrings["_MembersInChannelStatus"], GEM3UI_ConnectedMembers, GEM3UI_ignoredMembers, GEM3UI_totalMembers), 0);
   end
end]]--


function GEM3UI_CreatePlayerTagIcons(self)
 frm = getglobal("GEM3UIPlayerPlayerTag1");
 if frm == nil then return; end
 
 for i=1, 14 do
   frmname = "GEM3UIPlayerPlayerTag"..i;
   local frm = getglobal(frmname);
   if not frm.icontext then
    frm.icontext = frm:CreateFontString(frmname.."T", "OVERLAY", "GameFontNormalSmall"); 
    frm.icontext:SetHeight(10)
    frm.icontext:SetWidth(10)
    frm.icontext:ClearAllPoints()
    frm.icontext:SetPoint("BOTTOMRIGHT", 0, -1)
   end
   frm:EnableMouse();
   frm.icon = getglobal(frmname.."Texture");
   frm.icon:SetAllPoints();
   frm.icon:SetHeight(15);
   frm.icon:SetWidth(15);
   frm.icon:SetDrawLayer("ARTWORK");
   frm:SetScript("OnLeave", GEM3UI_PlayerLineHideTagPopup);
   frm:SetScript("OnEnter", GEM3UI_PlayerLineShowTagPopup);
   frm:SetScript("OnMouseUp", GEM3UI_PlayerLineShowTagPopup);
 end
end

function GEM3UI_DisplayPlayerDetails()
 if not GEM3UIPlayerPanel:IsVisible() then return; end
 local p = GEM3_PLAY_GetPlayerInfos(GEM3UIPlayerPanel.plname, GEM3UI_MembersFilterChannelTextLabel:GetText());
 if p == nil then
    p = GEM3_PLAY_GetPlayerInfos(GEM3UIPlayerPanel.plname);
 end
 local classid = GEM3UI_GetClassIndex(p.class);
 local roleid = GEM3UI_GetRoleIndex(p.role);
--init
 GEM3UIPlayerPlayerNameLabel:SetText("");
 GEM3UIPlayerPlayerGuildLabel:SetText("");
 GEM3UIPlayerClassIconTexture:SetTexture("");
 GEM3UIPlayerRoleIconTexture:SetTexture("");
 GEM3UIPlayerClassTextLabel:SetText("");
 GEM3UIPlayerRoleTextLabel:SetText("");
 GEM3UIPlayerPlayerLevelLabel:SetText("");
 GEM3UIPlayerPlayerVersionLabel:SetText("");
 GEM3UIPlayerPlayerCommentLabel:SetText("");
 GEM3UIPlayerPlayerGuildRankLabel:SetText("");
 GEM3UIPlayerPlayerStatusLabel:SetText("");
 GEM3UIPlayerPlayerLastLogLabel:SetText("");
 GEM3UIPlayerPlayerZoneLabel:SetText("");
 GEM3UI_CreatePlayerTagIcons();
 for i = 1, 14 do
  local frm = getglobal("GEM3UIPlayerPlayerTag"..i);
  --local ico = getglobal("GEM3UIPlayerPlayerTag"..i.."Texture");
  frm.icon:SetTexture("");
  frm.icon:SetAlpha(1);
  frm.icontext:SetText("")
 end

-- fill
 local i = 1;
 local tagAllreadyDisplayed = {};
 for tagid, tag in pairs(p.tags) do
    local tid = tag[GEM3_ACCESS_INST_TAG_NAME];
    if tagAllreadyDisplayed[tid] == nil then
        tagAllreadyDisplayed[tid] = false
    end
    if tag[GEM3_ACCESS_INST_TAG_RESET] > time()+GEM3UI.ServerTimeOffSet and i <= 14 and tagAllreadyDisplayed[tid] == false then
     local frm = getglobal("GEM3UIPlayerPlayerTag"..i);
     if TaggedInstances[tid] and TaggedInstances[tid].icon then
          if string.find(TaggedInstances[tid].icon, "lfgframe") ~= nil then
              frm.icon:SetTexCoord(0,0.8,0,0.72);
          else
              frm.icon:SetTexCoord(0,1,0,1);
          end
     end        
     frm.plname=p.name;
     frm.ev_inst_tag=tid;
     frm.tags = p.tags
     frm.version=p.version
     --id = tag[GEM3_ACCESS_INST_TAG_ID];
     --frm.tagtime = tag[GEM3_ACCESS_INST_TAG_RESET];
     if TaggedInstances[tid] and TaggedInstances[tid].icon then
          tagAllreadyDisplayed[tid] = tag[GEM3_ACCESS_INST_TAG_RESET];
          frm.icon:SetTexture(TaggedInstances[tid].icon);
          if tag[GEM3_ACCESS_INST_TAG_RESET] == 0 and tagAllreadyDisplayed[tid] == 0 then
            frm.icon:SetAlpha(0.5);
          else
            frm.icon:SetAlpha(1);
          end
     end
     i=i+1;
    end
 end

 GEM3UIPlayerPlayerNameLabel:SetText(p.name);
 GEM3UIPlayerPlayerGuildLabel:SetText("<"..p.guild..">");
 
 GEM3UIPlayerClassIconTexture:SetTexture(GEM3UI_Players_Classes[p.class].icon);
 if roleid > 0 then
  GEM3UIPlayerRoleIconTexture:SetTexture("interface\\icons\\"..GEM3UI_Roles[roleid].icon);
 end
 GEM3UIPlayerClassTextLabel:SetText(GEM3UI_Classes[classid].name_loc);
 GEM3UIPlayerRoleTextLabel:SetText(GEM3UI_Roles[roleid].name_loc);
 GEM3UIPlayerPlayerLevelLabel:SetText(p.level);
 GEM3UIPlayerPlayerVersionLabel:SetText(p.version);
 GEM3UIPlayerPlayerCommentLabel:SetText(GEM3UI_LocalizedStrings["_Comment"]..": "..(p.comment or ""));
 GEM3UIPlayerPlayerGuildRankLabel:SetText(p.grank_name);
 if p.officer == 2 then
  GEM3UIPlayerPlayerStatusLabel:SetText(GEM3UI_LocalizedStrings["_GM"]);
 elseif p.officer == 1 then
  GEM3UIPlayerPlayerStatusLabel:SetText(GEM3UI_LocalizedStrings["_Officer"]);
 elseif p.guild == "" then
  GEM3UIPlayerPlayerStatusLabel:SetText(GEM3UI_LocalizedStrings["_Guildless"]);
 else
  GEM3UIPlayerPlayerStatusLabel:SetText(GEM3UI_LocalizedStrings["_GuildMember"]);
 end
 GEM3UIPlayerPlayerLastLogLabel:SetText(GEM3UI_FormatDateString(p.lastlog, true));
 GEM3UIPlayerPlayerZoneLabel:SetText(p.location);
end


function GEM3UI_FillMembersList()

 if not GEM3UI_MemberslistTest:IsVisible() then return end
 if GEM3UI_NewGridinit ~= true then
    MovixLib_GetGridDefaults(GEM3UI_MemberslistTest, "GEM3UI_ChannelMembers", "GEM3UI_ChannelMembers")
    MovixLib_Grid_RegisterColor("GEM3UI_ChannelMembers", "Status color", "GEM3UI_GetStatusColor", nil, "Yellow = Online, White = Offline, Blue = in my raid or party")
    MovixLib_Grid_RegisterColor("GEM3UI_ChannelMembers", "Class color", "GEM3UI_GetClassColor", "class", "")
    MovixLib_Grid_RegisterColor("GEM3UI_ChannelMembers", "In instance / Raid / PvP", "GEM3UI_GetinFightColor", nil, "")
    MovixLib_FillData(GEM3UI_MemberslistTest);
    MovixLib_RefreshGrid(GEM3UI_MemberslistTest, true, nil, true)
    GEM3UI_NewGridinit = true
 else
    MovixLib_FillData(GEM3UI_MemberslistTest)
    MovixLib_RefreshGrid(GEM3UI_MemberslistTest)
 end
 
end

function GEM3UI_ResetMembersGrid()
  --MovixLib_WipeTable(GridLib.Grids["GEM3UI_ChannelMembers"],20)
  --GridLib.Grids["GEM3UI_ChannelMembers"].DGridParams = nil
  --GridLib.Grids["GEM3UI_ChannelMembers"].GridParams = nil
  --GridLib.Grids["GEM3UI_ChannelMembers"].DHeaders = nil
  --GridLib.Grids["GEM3UI_ChannelMembers"].Headers = nil
  --GridLib.Grids["GEM3UI_ChannelMembers"] = nil
  --GEM3UI_MemberslistTest.Headers = nil
  GridLib.Grids["GEM3UI_ChannelMembers"] = MovixLib_TblCpy(GEM3UI_ChannelMembersGridDefaults)
  GridLib.Grids["GEM3UI_ChannelMembers"] = MovixLib_GetGridDefaults(GEM3UI_MemberslistTest, "GEM3UI_ChannelMembers", "GEM3UI_ChannelMembers")
  --table.sort(GridLib.Grids["GEM3UI_ChannelMembers"].Headers, mycolsort);
  GEM3UI_NewGridinit = false
  GEM3UI_FillMembersList()
  --MovixLib_GetGridDefaults(GEM3UI_MemberslistTest, "GEM3UI_ChannelMembers", "GEM3UI_ChannelMembers")
  --MovixLib_Grid_RegisterColor("GEM3UI_ChannelMembers", "Status color", "GEM3UI_GetStatusColor", nil, "Yellow = Online, White = Offline, Blue = in my raid or party")
  --MovixLib_Grid_RegisterColor("GEM3UI_ChannelMembers", "Class color", "GEM3UI_GetClassColor", "class", "")
  --MovixLib_Grid_RegisterColor("GEM3UI_ChannelMembers", "In instance / Raid / PvP", "GEM3UI_GetinFightColor", nil, "")
  --GridLib.Grids["GEM3UI_ChannelMembers"].DGridParams.inherits = GEM3UI.EventGridTheme 
  --MovixLib_RegisterLocale("GEM3UI_ChannelMembers", GEM3UI_LocalizedStrings)
  --MovixLib_FillData(GEM3UI_MemberslistTest);
  --MovixLib_RefreshGrid(GEM3UI_MemberslistTest, true, nil, true)
end




--- GRID RELATED
GEM3UI_Players_Classes = {
        ["DEATHKNIGHT"]    = {color = CLASS_ICON_TCOORDS["DEATH KNIGHT"], icon = "interface\\AddOns\\GEM3UI\\gfx\\dk"},
        ["DRUID"]           = {color = CLASS_ICON_TCOORDS["DRUID"], icon = "interface\\AddOns\\GEM3UI\\gfx\\druid"},
        ["HUNTER"]          = {color = CLASS_ICON_TCOORDS["HUNTER"], icon = "interface\\AddOns\\GEM3UI\\gfx\\hunter"},
        ["MAGE"]            = {color = CLASS_ICON_TCOORDS["MAGE"], icon = "interface\\AddOns\\GEM3UI\\gfx\\mage"},
        ["PALADIN"]         = {color = CLASS_ICON_TCOORDS["PALADIN"], icon = "interface\\AddOns\\GEM3UI\\gfx\\paladin"},
        ["PRIEST"]          = {color = CLASS_ICON_TCOORDS["PRIEST"], icon = "interface\\AddOns\\GEM3UI\\gfx\\priest"},
        ["ROGUE"]           = {color = CLASS_ICON_TCOORDS["ROGUE"], icon = "interface\\AddOns\\GEM3UI\\gfx\\rogue"},
        ["SHAMAN"]          = {color = CLASS_ICON_TCOORDS["SHAMAN"], icon = "interface\\AddOns\\GEM3UI\\gfx\\chaman"},
        ["WARLOCK"]         = {color = CLASS_ICON_TCOORDS["WARLOCK"], icon = "interface\\AddOns\\GEM3UI\\gfx\\warlock"},
        ["WARRIOR"]         = {color = CLASS_ICON_TCOORDS["WARRIOR"], icon = "interface\\AddOns\\GEM3UI\\gfx\\warrior"},
        [0]                 = {color = nil, icon = nil},
    }


function GEM3UI_GetClassColor(val)
 local col = RAID_CLASS_COLORS[val]
 if col then 
  return {col.r, col.g, col.b, 1}
 else
  return nil
 end
end



function GEM3UI_GetClassIcon(class)
 return GEM3UI_Players_Classes[class].icon
end

function GEM3UI_GetRoleIcon(role)
    for k, r in pairs(GEM3UI_Roles) do
     if r.gemid == role then
      return "interface\\icons\\"..r.icon
     end
    end
    return ""
end


function GEM3UI_GetStatusIcon(plname)
    if GEM3_PLAY_IsPlayerIgnored(plname) then
        return "interface\\AddOns\\GEM3UI\\X"
    end
    local p = GEM3_QA_Players[GEM3UI_MembersFilterChannelTextLabel.value][plname]
    if not p then return nil end
    if p.isLeader and p.connected then
        return "interface\\AddOns\\GEM3UI\\gfx\\UI-group-leadericon"
    else
        return nil
    end
end

function GEM3UI_GetSortStatus(plname)
    local p = GEM3_QA_Players[GEM3UI_MembersFilterChannelTextLabel.value][plname]
    if not p then return "4 Offline" end
    if p.isLeader and p.connected then
        return "1 Channel Leader"
    elseif GEM3_PLAY_IsPlayerIgnored(plname) then
        return "2 Ignore"
    elseif p.connected then
        return "3 Connected"
    else
        return "4 Offline"
    end
end


function GEM3UI_GetOfficerIcon(isOfficer)
    if isOfficer == 2 then
        return "interface\\AddOns\\GEM3UI\\gfx\\UI-group-leadericon"
    elseif isOfficer == 1 then
        return "interface\\AddOns\\GEM3UI\\gfx\\UI-group-assistanticon"
    elseif isOfficer == 0 then
        return "interface\\AddOns\\GEM3UI\\gfx\\party"
    else 
        return ""
    end
end

function GEM3UI_GetOfficerFriendly(isOfficer)
    if isOfficer == 2 then
        return MovixLib_GetLocale("Guild Master", "GEM3UI_ChannelMembers")
    elseif isOfficer == 1 then
        return MovixLib_GetLocale("Officer", "GEM3UI_ChannelMembers")
    elseif isOfficer == 0 then
        return MovixLib_GetLocale("Member", "GEM3UI_ChannelMembers")
    else 
        return "?"
    end
end

function GEM3UI_GetIgnoreIcon(isIgnored)
    if isIgnored then
        return "interface\\AddOns\\GEM3UI\\X"
    else
        return ""
    end
end



function GEM3UI_GetTimerefIcon(isTimeref)
    if isTimeref then
        return "interface\\AddOns\\GEM3UI\\bell"
    else
        return ""
    end   
end

function GEM3UI_GetOnlineIcon(connected)
    if connected then
        return "interface\\AddOns\\GEM3UI\\gfx\\online"
    else
        return "interface\\AddOns\\GEM3UI\\gfx\\offline"
    end
end

function GEM3UI_GetFirendlyOnline(connected)
    if connected then
        return MovixLib_GetLocale("Online", "GEM3UI_ChannelMembers")
    else
        return MovixLib_GetLocale("Offline", "GEM3UI_ChannelMembers")
    end
end


function GEM3UI_GetStatusColor(p)
    if GroupAnalyse.Members[p.name] and (GetNumPartyMembers() + GetNumRaidMembers()) > 0 then
        return {0.4,0.3,1,1}
    elseif   p.current_queue == GEM3_SUB_STATE_NOT_COMING then
        return {0.6,0.1,0.1,1}
    elseif p.connected then
        return {0,1,0,1}
    else
        return {1,1,1,1}
    end
end

function GEM3UI_GetZoneIcon(InstanceType)
    if (InstanceType or 0) > 0  then
        return "interface\\AddOns\\GEM3UI\\gfx\\UI-Group-MainAssistIcon"
    else
        return ""
    end
end

function GEM3UI_GetinFightColor(p)
    local pl = GEM3_PLAY_GetPlayerInfos(p.name, p.channel);
    if not pl then
        pl = GEM3_PLAY_GetPlayerInfos(p.name);
    end

    if not pl then return GEM3UI_GetStatusColor(p) end
    if pl then 
        if (pl.instance_type or 0) > 0 then
            return {1,0,0,1}
        else
            return GEM3UI_GetStatusColor(p)
        end
    else
        return nil
    end
end

function GEM3UI_GetInviteText(val)
 return MovixLib_GetLocale("InviteShort", "GEM3UI_ChannelMembers")
end

function GEM3UI_MemberGridQuickInviteGetButton(p, row, f, action, scale)
   --[[scale = scale or 1
   if action == "create" then
    f.button = MovixLib_GetControlObject(f, "custombutton")
    f.button:ClearAllPoints()
    f.button:SetAllPoints()   
    f.button:SetNormalTexture("interface\\AddOns\\GEM3UI\\gfx\\invite")
    f.button:SetPushedTexture("interface\\AddOns\\GEM3UI\\gfx\\invite")
    f.button:SetHighlightTexture("interface\\AddOns\\GEM3UI\\gfx\\invite")
    f.button:SetScript("OnLeave", function (self) GameTooltip:Hide() end)
    f.button:SetScript("OnEnter", function (self) GEM3UI_GameTooltipShow(self, INVITE..self.name, true) end)
    f.button:SetScript("OnClick", function(self) InviteUnit(self.name) end )
    return f
   end
   if action == "release" then
    MovixLib_ReleaseControlObject(f.button)
    f.button = nil
    return
   end
   local pid = row.MovixLibID
   local pl = GEM3UI_ChannelMembers[pid]
   f.button.name = pl.name]]--
   return "interface\\AddOns\\GEM3UI\\gfx\\invite"
end



function GEM3UI_InviteButtonOnClick(val)
    InviteUnit(val)
end

--git = "qslmdkqsdmlfksqmdlfkqmslfkdqsdf\nlkfjdqlkjsdqlskdqjflkqsd\nGEMCC:channame1,password1,alias1,slash1,default1,blizcal1|channame1,password1,alias2,slash2,default2,blizcal2\nGEMADM:name1,name2"


--[[
function GEM3UI_GetGuildInfoVar(varname)
PARAMETERS
varname: string, the name of the var to gather from the guildinfo
RETURN var_array
var_array: array, the array containing the values of the variable

example of the variable format in the guildInfoText for the variable GEMADMIN and 3 players
GEMADMIN:player1#player2#player3
GEM3UI_GetGuildInfoVar("GEMADMIN") will return
{"player1","player2","player3"}     
]]--

function GEM3UI_GetGuildInfoVar(varname)
    local gi = GetGuildInfoText()
    if not GEM3UI_ALLVARSLOADED then
        GEM3UI_SetStatusMessage("Guild data is not loaded, try again later.", 5, false, false)
        GuildRoster()
        return {}
    end
    local gi_lines = {strsplit("\n", gi)}
    local var = nil
    for i, line in ipairs(gi_lines) do
        if not var then var = string.find(line, varname..":") end
        if var and type(var) == "number" then
            var = strtrim(string.sub(line, (strlen(varname)+2)))
            var_array = {strsplit("#", var)}
            return var_array
        end
    end
    return {}
end


--[[
function GEM3UI_IsGuildInfoVarSet(varname, value)
PARAMETERS
varname: string, the name of the var in the guildIfnoText. it will be appended a ":" and then the values array where the values are separated by #
value: string or number, the data that is looked for in the guildinfotext
RETURN result
result: boolean, true if value is present, false if not


example of the variable format in the guildInfoText for the variable GEMADMIN and 3 players
GEMADMIN:player1#player2#player3
GEM3UI_SetGuildInfoVar("GEMADMIN", "player2") will remove player2
GEM3UI_SetGuildInfoVar("GEMADMIN", "player4") will add player4
]]--

function GEM3UI_IsGuildInfoVarSet(varname, value)
    local values = GEM3UI_GetGuildInfoVar(varname)
    if #values == 0 then
        return false; --values 
    end
    
    for _, v in pairs(values) do
        if v == value then
            return true
        end
    end
    return false
end


--[[
function GEM3UI_SetGuildInfoVar(varname, value)
PARAMETERS
varname: string, the name of the var in the guildIfnoText. it will be appended a ":" and then the values array where the values are separated by #
value: string or number, the data tha is added or removed to/from the variable
RETURN result, reason
result: boolean, true if saving was succesfull, else false
reason: if result is false this contains the reson for the failure

example of the variable format in the guildInfoText for the variable GEMADMIN and 3 players
GEMADMIN:player1#player2#player3
GEM3UI_SetGuildInfoVar("GEMADMIN", "player2") will remove player2
GEM3UI_SetGuildInfoVar("GEMADMIN", "player4") will add player4
]]--

GEM3UI_GuildRosterQueue = {}

function GEM3UI_SetGuildInfoVar(varname, value, callback)
    if not CanEditGuildInfo() then
        GEM3UI_SetStatusMessage("You have no rights to do this, You need to be allowed to modify the Guild Info Text", 5, true, true)
        return false, "You have no rights to do this, You need to be allowed to modify the Guild Info Text"
    end
    
    local gi_lines = {strsplit("\n", GetGuildInfoText())}
    local valstr  =""
    local var
    local var_array
    local guild_infotext = ""
    local add_or_remove = true
    for _, line in ipairs(gi_lines) do
        if not var then 
            var = string.find(line, varname) 
        end
        if var and type(var) == "number" then
            var = strtrim(string.sub(line, (strlen(varname)+2)))
            var_array = {strsplit("#", var)}
            for i, v in pairs (var_array) do
                if v == value then
                    if add_or_remove == true then
                        tremove(var_array,i)
                        add_or_remove = false
                    end
                end
            end
        else
            guild_infotext = guild_infotext .. "\n" .. line
        end
    end
    if add_or_remove == true then
            tinsert((var_array or {}), value)
    end
    mydbg(varname .. " \n" .. valstr)
    valstr = varname .. ":" .. GEM3UI_Serialize_GuildInfo_VarValues (var_array)
    
    guild_infotext = guild_infotext .. "\n" .. valstr
    
    if strlen(guild_infotext) > 500 then
        GEM3UI_SetStatusMessage("There is not enough space in the Guild Info Message, please delete some text", 5, true, true)
        return false, "There is not enough space in the Guild Info Message, please delete some text"
    else
        local cmd = {["VAR"] = varname, ["VAL"] = value, ["CMD"] = add_or_remove, ["REFRESH"] = callback}
        local insertit = false
        for i, v in ipairs(GEM3UI_GuildRosterQueue) do
            if v.VAR == varname and v.VAL == value then
                insertit = true
            end
        end
        if (time() - GEM3UI_LastGuildRosterUpdate_Time) < 10 then
            GEM3UI_SetStatusMessage("You must wait 10 seconds between each Modifcation. Your request is queued!\nOpen/Close or Close/open the guild frame to update Data", 5, true, true)
        end 
        if #GEM3UI_GuildRosterQueue > 0 then
            GEM3UI_SetStatusMessage("There is allready administrative task submitted. Your request is queued", 5, true, true)
        else
            --GEM3UIMain:RegisterEvent("GUILD_ROSTER_UPDATE")
        end
        if insertit then
            tinsert(GEM3UI_GuildRosterQueue, cmd)
        end

        SetGuildInfoText(guild_infotext)
        GuildRoster();
    end
    return true
end

function GEM3UI_Serialize_GuildInfo_VarValues (array)
    local sep = ""
    local ret_string = ""
    if type(array) ~= "table" and type(array) ~= "string" then
        return ""
    end
    
    if type(array) == "string"then
        return array
    end
    
    for _, v in pairs(array) do
            ret_string = ret_string .. sep .. v
            sep = "#"
    end
    return ret_string
end

function GEM3UI_isGemAdmin(playername)
    local isadmin = GEM3UI_IsGuildInfoVarSet("GEMADM", playername)
    if isadmin and GEM3UI_ALLVARSLOADED then 
        return true
    end
    
    if CanEditGuildInfo() and GEM3UI_ALLVARSLOADED then
        return isadmin
    else
        return nil;
    end
end 

--[[
Site : www.papy-team.fr

TS : ts.papy-team.fr:53181
mot de passe : wipe

Roster : roster.papyteam.fr
Addons : Curse !! (avec l'aide de Curse Client et si vous pouvez pas faire autrement : WoWmatrix)

GEM core 3.50/gem version2.00 (utilisez uniquement la dernière version svp - DONC SYNC vos addons)
=> canal papyteam MDP jeune alias papy Slash pt
=> canal papysf MDP psf alias psf psf

GEMCC:papyteam,jeune,psf,psf,0,1#papysf,psf,psf,psf
GEMADM:Movixette#Aihla
]]--


function GEM3UI_SetGemAdminButtonOnClick(playername)
   if GEM3UI_ALLVARSLOADED then
    GEM3UI_SetGuildInfoVar("GEMADM", playername, GEM3UI_FillMembersList)
   end 
end



function GEM3UI_GetFriendlyZoneType(InstanceType)
    if (InstanceType or 0) > 0  then
        return "In fight"
    else
        return "Not in fight"
    end
end


function GEM3UI_GetFriendlyClass(class)
 return GEM3UI_CLASS_STRINGS[class]
end

function GEM3UI_GetFriendlyRole(role)
 if role == nil then return "?" end
 for k, r in ipairs(GEM3UI_Roles) do
  if r.gemid == role then
    return r.name_loc
  end
 end
end

function GEM3UI_GetFriendlyOfficer(officer)
  if officer == 2 then
    return "Guild Master"
  elseif officer == 1 then
    return "Officer"
  else
    return "Member"
  end
end

function GEM3UI_GetTagCount(tags)
  local i = 0
  if tags then
    for _, _ in pairs(tags) do
        i = i + 1    
    end
  end
  if i == 0 then
    return nil
  else
    return i
  end
end

function GEM3UI_GridError()
    return ""
end

