--[[
 Guild Event Manager GUI
 -------------------------------------
  Code: Movix - Conseil des Ombres - EU
  LIBS
]]


function GEM3UI_TextFrameScroll(self, arg1)
 if (arg1 == 1) then
   self:ScrollUp();
 else
   self:ScrollDown();
 end
end


-- LOCALIZATION FUNCTION
function MovixLib_Localize(self, str)
  local obj = self;
  if obj == nil then
    return;
 end
  --if type (str) ~= "string" then 
  local objtype = obj:GetObjectType();
  --end
  
  local mobj = "";
  if (objtype == "Frame") then
   mobj = obj:GetName().."Label";
  elseif (objtype == "CheckButton" or objtype == "Button") then
    if type(obj.SetNormalFontObject) == "function" then
  --      local font, size, flags = obj:GetNormalFontObject();
        obj:SetNormalFontObject(GameFontNormalSmall, 10, flags);
    end
   mobj = obj:GetName().."Text";
  else
   mobj = obj:GetName();
  end
  
  --mydbg("MOBJ:"..mobj)
  mobj = getglobal(mobj)
  if mobj == nil then mydbg("MOBJ:"..self:GetName()) end
  
  par = mobj:GetText();
  if string.sub(par,1,1) == "_" then
   if GEM3UI_LocalizedStrings[par] ~= nil then 
     mobj:SetText(GEM3UI_LocalizedStrings[par]);
   end
  elseif str~=nil then
    mobj:SetText(str);
  end
end


function GEM3UI_FormatDateString(datevar, withtime)
 local DateString
 local timeformat = "";
 if withtime then
  timeformat = " "..GEM3UI_TimeFormatString
 end
 if GEM3UI.DateFormat == 1 then 
  DateString = date("%y"..GEM3UI.DateSeparator.."%m"..GEM3UI.DateSeparator.."%d"..timeformat, datevar);
 elseif GEM3UI.DateFormat == 0 then 
  DateString = date("%d"..GEM3UI.DateSeparator.."%m"..GEM3UI.DateSeparator.."%y"..timeformat, datevar);
 elseif GEM3UI.DateFormat == 2 then 
  DateString = date("%m"..GEM3UI.DateSeparator.."%d"..GEM3UI.DateSeparator.."%y"..timeformat, datevar);
 end
 
 if GEM3UI.ShowWeekday == 1 then
 
  DateString = GEM3UI_LocalizedStrings.dayshort[tonumber(date("%w", datevar))].." "..DateString 
 end
 return DateString;
end


-------- HELP & Tooltip ------
function GEM3UI_GameTooltipShow(self, Text, force, title)
    if not GEM3UI.ShowTooltips and force == nil then return; end
	local oname = self:GetName();
    GameTooltip:SetOwner(self, "ANCHOR_LEFT");
	GameTooltip:ClearLines();
	if title == nil then
        GameTooltip:SetText(GEM3UI_LocalizedStrings["_lblTitle"], 1,1,1,1);
    else
        GameTooltip:SetText(title, 1,1,1,1);
    end
	GameTooltip:AddLine(" "); 
    if oname == "GEM3MinimapButton" then 
        if #GEM3UI_newEvents == 1 then
		    GameTooltip:AddLine(GEM3UI_LocalizedStrings["_NewEvent"]); 
            GameTooltip:AddLine(" "); 
	    end
        if #GEM3UI_newEvents > 1 then
		     GameTooltip:AddLine(string.format(GEM3UI_LocalizedStrings["_NewEvents"], #GEM3UI_newEvents)); 
             GameTooltip:AddLine(" "); 
        end
    end
    if Text ~= nil and Text ~= "limitsicon" then
     GameTooltip:AddLine(Text); 
    else
     local i = 1;
     local tt = GEM3UI_LocalizedStrings["tt_"..self:GetName()..i];
     while (tt) do
      GameTooltip:AddLine(tt); 
      i = i + 1;
      tt = GEM3UI_LocalizedStrings["tt_"..self:GetName()..i];
     end
    end
    if Text == "limitsicon" then
     GameTooltip:AddLine(GEM3UI_LocalizedStrings["LimitsTitel"], 1,1,1,1)
     GameTooltip:AddLine(GEM3UI_LocalizedStrings["LimitsRed"], 1,0,0,1)
     GameTooltip:AddLine(GEM3UI_LocalizedStrings["LimitsYellow"], 1,1,0,1)
     GameTooltip:AddLine(GEM3UI_LocalizedStrings["LimitsGreen"], 0,1,0,1)
    end
	GameTooltip:Show(); 
end

function GEM3UI_HideTooltip()
 GameTooltip:Hide();
end


-------- Minimap button ------
function GEM3UI_MinimapButtonClick(self, button, down)
 if button == "LeftButton" then
    GEM3UI_Toggle();
 elseif button == "RightButton" then
    if GEM3_COM_IsSuspended() then
        --GEM3MinimapButtonSwitch:Hide()
        GEM3_COM_Suspend(false)
    else
        --GEM3MinimapButtonSwitch:Show()
        GEM3_COM_Suspend(true)
    end
 else
 end
 GEM3UI_SetFrameTitle() 
end

function GEM3UI_SetFrameTitle()
    local title
    if GEM3UI.WindowState == 0 then
        title =  GEM3UI_LocalizedStrings["_lblTitle"].." V."..GEM3_GetVersion()
    else
        title = "GEM 3"
   end
   GEM3UIMainTitelLabel:SetText(title);
   local alert = GEM3UI_NEEDUPDATE;
   if GEM3_COM_IsSuspended() then
    alert = alert .. " " .. GEM3UI_LocalizedStrings["_suspended"];
   elseif GEM3_COM_IsDisabled() then
    alert = alert .. " " .. GEM3UI_LocalizedStrings["_disabled"];
   end 
   GEM3UIMainAlertLabel:SetText(alert);
end


function GEM3UI_MiniMapIconStartMove(self)
  GEM3MinimapButton:SetScript("OnUpdate", GEM3UI_MiniMapIconDoMove);
end

function GEM3UI_MiniMapIconStopMove(self)
GEM3MinimapButton:SetScript("OnUpdate", nil);
end

function GEM3UI_MiniMapIconDoMove(self)
  	local curX, curY = GetCursorPosition()
    local miniX, miniY = Minimap:GetCenter()
    miniX = miniX * Minimap:GetEffectiveScale()
    miniY = miniY * Minimap:GetEffectiveScale()
    local relX = miniX - curX
   	local relY = miniY - curY
    local angle = math.deg(math.atan2(relY, relX)) + 180
    local distance = (((relX*2) + (relY*2))/2)-(Minimap:GetWidth()/2);
    if IsControlKeyDown() then
     GEM3UI_MinimapButtonReposition(self, nil, distance);
    else
     GEM3UI_MinimapButtonReposition(self, angle);
    end    
end

function GEM3UI_MinimapButtonReposition(self, angle, distance)
	 if (not angle) then angle = GEM3UI.MinimapAngle or 1
	 else GEM3UI.MinimapAngle = angle; end
	 if (not distance) then distance = GEM3UI.MinimapRadius or Minimap:GetWidth()/4
	 else GEM3UI.MinimapRadius = distance; end
     local width,height = Minimap:GetWidth()/2, Minimap:GetHeight()/2
	 width = width+distance
	 height = height+distance
	 local iconX, iconY
	 iconX = width * cos(angle)
	 iconY = height * sin(angle)
	 GEM3MinimapButton:ClearAllPoints()
	 GEM3MinimapButton:SetPoint("CENTER", Minimap, "CENTER", iconX, iconY)
end

function GEM3MinimapButton_Update(self)
    if GEM3UI.ShowMinimapIcon then
    
     if #GEM3UI_newEvents > 0 then 
      GEM3MinimapButtonText:SetText(GEM3UI_newEvents);
     else
      GEM3MinimapButtonText:SetText("");
     end
     
     GEM3MinimapButtonText:SetTextColor(1.0,0.1,0.1);
     GEM3MinimapButtonTexture:SetTexture("interface\\AddOns\\GEM3UI\\gem");
     GEM3MinimapButton:SetAlpha(1);
     GEM3UI_MinimapButtonReposition(self);
     GEM3MinimapButton:Show();
    else
     GEM3MinimapButton:Hide();
    end
end



---- DIALOG POPUP BOX
StaticPopupDialogs["GEM3UI_CONFIRM"] = {
   text = TEXT("%s"),
   button1 = TEXT(OKAY),
   button2 = TEXT(CANCEL),
   hideOnEscape = 1,
   whileDead=1,
   showAlert = 1,
   hasEditBox = 1,
   OnShow = function (self)
      GEMUI_PopUpDialogCancel=nil;
      self.myid = getglobal(self:GetName().."Text"):GetText();
      self.myid = tonumber(self.myid);
      getglobal(self:GetName().."Text"):SetText(GEM3UI_LocalizedStrings[GEM3UI_CONFIRM_DIALOGS[self.myid].label]);
      if GEM3UI_CONFIRM_DIALOGS[self.myid].reason then 
       getglobal(self:GetName().."EditBox"):Show();
       getglobal(self:GetName().."EditBox"):SetText("");
      else
       getglobal(self:GetName().."EditBox"):Hide();
      end
   end,
   
   OnAccept =  function(self, argName)
      local txtframe = getglobal(self:GetName().."EditBox")
      local text = txtframe:GetText();
      ret1, ret2 = pcall(GEM3UI_CONFIRM_DIALOGS[self.myid].foo, argName, text);
      GEMUI_PopUpDialogCancel=false;
   end,
   OnCancel = function (_,reason)
      if reason == "timeout" or reason == "clicked" then
          GEM3UI_PopUpDialogCancel=true;
      end
  end,
  timeout = 0
};

function GEM3UI_Popup(popupcode, data)
 if InCombatLockdown() then
  GEM3MinimapButton:SetScript("OnUpdate", GEM3UI_MiniMapCombatOnwait);  
  table.insert(GEM3UI_Popupdata, {code = popupcode, data = data} )
 else
   local dialogFrame = StaticPopup_Show("GEM3UI_CONFIRM", popupcode);
   if data and dialogFrame then dialogFrame.data = data; end
 end
end

function GEM3UI_MiniMapCombatOnwait()
 if InCombatLockdown() then return; end
 for i, popup in pairs(GEM3UI_Popupdata) do
  if popup.code == GEM3UI_DIALOG_INTERNAL then
  else
   local dialogFrame = StaticPopup_Show("GEM3UI_CONFIRM", popup.code);
   if popup.data and dialogFrame then dialogFrame.data = popup.data; end
  end
  table.remove(GEM3UI_Popupdata, i);
 end
 GEM3MinimapButton:SetScript("OnUpdate", nil);  
end

--- STATUS BAR MESSAGE HANDLING

function GEM3UI_SetStatusMessage(msg, delay, UseUIError, useChat)
 if delay == nil then delay = 5; end
 GEM3UIMainStatusBar.olddelay = GEM3UIMainStatusBar.delay;
 GEM3UIMainStatusBar.delay = delay;
 GEM3UIMainStatusBar.t = time();
 if delay == 0  then
  GEM3UIMainStatusBar:SetScript("OnUpdate", nil);
 else
  GEM3UIMainStatusBar.oldMessage = GEM3UIMainStatusBarTextLabel:GetText();
  GEM3UIMainStatusBar:SetScript("OnUpdate", GEM3UI_SetStatusMessageUpdate);
 end
 if UseUIError then
    UIErrorsFrame:AddMessage("GEM3: "..msg, 1, 0.2, 0.2, 1.0, UIERRORS_HOLD_TIME);
 end
 if useChat then
    DEFAULT_CHAT_FRAME:AddMessage("GEM3UI: "..msg, 1,1,1,1)
 end
 GEM3UIMainStatusBarTextLabel:SetText(msg);
end

function GEM3UI_SetDebugStatus(msg, delay)
 if GEM3UI_DEBUGMODE > 0 then
  if delay == nil then delay = 5; end
  if delay == 0  then
   GEM3UI_DebugStatusBar:SetScript("OnUpdate", nil);
  else
   GEM3UI_DebugStatusBar.oldMessage = GEM3UI_DebugStatusBarTextLabel:GetText();
   GEM3UI_DebugStatusBar:SetScript("OnUpdate", GEM3UI_SetStatusMessageUpdate);
  end
  GEM3UI_DebugStatusBarTextLabel:SetText(msg);
  GEM3UI_DebugStatusBar.olddelay = GEM3UI_DebugStatusBar.delay;
  GEM3UI_DebugStatusBar.delay = delay;
  GEM3UI_DebugStatusBar.t = time();
 end
 GEM3UI_DebugStatusBarTitelLabel:SetText("DEBUG-"..GEM3_QA_Config.debug_flags..":");
end


function GEM3UI_SetStatusMessageUpdate(self)
 if type(self.delay) == "boolean" or self.delay == nil then self.delay = 5; end
 
 if self.delay > 0
  and (time() - self.t) > self.delay then
  getglobal(self:GetName().."TextLabel"):SetText("");
  self:SetScript("OnUpdate", nil);
  if self.olddelay == 0 then
   getglobal(self:GetName().."TextLabel"):SetText(self.oldMessage);
  end
 end
end



---- DropDown

function GEM3UI_DropDowninit(title)
 local i = 1;
 local dd = getglobal("GEM3UIDropDown");
 local scrollit = getglobal("GEM3UIDropDownScroll");
 dd.title=nil;
 dd.title=title;
 dd.strwidth=0;
 if scrollit == nil then
  scrollit = CreateFrame("SCROLLFRAME", "GEM3UIDropDownScroll", dd , "GEM3UIScrollFrameTemplate");
 end
 GEM3UI_CreateDDlines();
 if dd.items ~= nil then
  GA_WipeTable(dd.items,50);
 end
 dd.items = nil;
 dd.items= GA_GetTable();
 dd.target=nil;
 dd.opentime = time();
 GEM3UI_DDScrollUpdate();
end

function GEM3UI_DDAddLine(id, value, label, state, checked, foo)
  local dd = getglobal("GEM3UIDropDown");
  item = GA_GetTable();
  item.id = id;
  item.value=value;
  item.label=label;
  item.state=state;
  item.checked=checked;
  item.foo=foo;
  if (string.len(label) * 7) + 40 > (dd.strwidth or 0) then dd.strwidth = (string.len(label) * 7) + 40; end
  table.insert(dd.items, item);
end


function GEM3UI_DDScrollUpdate()
   local dd = getglobal("GEM3UIDropDown");
   local line; -- 1 through 5 of our window to scroll
   local lineplusoffset=0; -- an index into our data calculated from the scroll offset
   local cnt = #dd.items;
   for line=1,GEM3UI_DefaultDDLines do
       getglobal("GEM3UIDropDownline"..line):Hide();
   end
   FauxScrollFrame_Update(GEM3UIDropDownScroll,cnt,GEM3UI_DefaultDDLines,15);
   for line=1,GEM3UI_DefaultDDLines do
     lineplusoffset = line + FauxScrollFrame_GetOffset(GEM3UIDropDownScroll);
     if lineplusoffset < cnt+1 then
       GEM3UI_fillDDLine(line, lineplusoffset );
       getglobal("GEM3UIDropDownline"..line):Show();
     end
   end
 end


function GEM3UI_fillDDLine(i, index)
 local framename = "GEM3UIDropDownline"..i;
 local dd = getglobal("GEM3UIDropDown");
 local line = getglobal(framename);
 local item = dd.items[index];
 line.dd_index = index;
 getglobal(framename.."Text"):SetText(item.label);
 if item.checked == true then
   getglobal(framename.."Check"):Show();
 else
   getglobal(framename.."Check"):Hide();
 end
  
 if item.state == true then
    line:Enable();
 else
    line:Disable();
 end
 
 if #dd.items > GEM3UI_DefaultDDLines then
   line:SetWidth(GEM3UIDropDownScroll:GetWidth());
 else
   line:SetWidth(GEM3UIDropDownScroll:GetWidth()+18);
 end
end






 function GEM3UI_CreateDDlines()
 local framename;
 local line;
 local i;
 for i=1,GEM3UI_DefaultDDLines do
  framename = "GEM3UIDropDownline"..i;
  line = getglobal(framename);
  if line == nil then
   line = CreateFrame("BUTTON", framename, getglobal("GEM3UIDropDown"), "GEM3UI_DDLine");
  end
  if i > 1 then
    line:SetPoint("TOPLEFT", getglobal("GEM3UIDropDownline"..(i-1)), "BOTTOMLEFT", 0, 0);
  else
    line:SetPoint("TOPLEFT", getglobal("GEM3UIDropDownScroll"), "TOPLEFT", 3, -3);
  end
  line:SetWidth(GEM3UIDropDownScroll:GetWidth()-10);
  line:SetHeight(14);
  line:RegisterForClicks("LeftButtonUp", "RightButtonUp");
  if type(line.SetNormalFontObject) == "function" then
     line:SetNormalFontObject(GameFontNormalSmall, 10, flags);
  end
  local ddc = getglobal(line:GetName().."Check");
  if ggc == nil then
   ddc= line:CreateTexture(line:GetName().."Check");
  end
  ddc:SetPoint("TOPLEFT", 0,0);
  ddc:SetHeight(12);
  ddc:SetWidth(12);
  ddc:SetTexture("interface\\buttons\\ui-checkbox-check");
  ddc:Hide();
  line:Hide();
  local ddt = getglobal(line:GetName().."Text");
  ddt:SetPoint("TOPLEFT", 15,0);
  --ddt:SetWidth(ddt:GetParent():GetWidth()-25);
  line:SetScript("OnClick", GEM3UI_DropDownClick);
 end
end


function GEM3UI_DDshow(self)  -- Contextmenu
  local dd = getglobal("GEM3UIDropDown");
  dd:SetParent(self);
  --GEM3UIMain:SetFrameStrata("BACKGROUND");
  local x, y = GetCursorPosition();
  
 dd:ClearAllPoints();
 dd:SetPoint("BOTTOMLEFT", UIParent, (x)/GEM3UI.Scale, ((y)/GEM3UI.Scale)-dd:GetHeight());
 dd:SetFrameStrata("DIALOG");
 dd:SetFrameLevel(200);
 
 GEM3UI_DD_SetGlobal();
end

function GEM3UI_ShowDD(self, dd) -- DropDown list
 dd:SetParent(self:GetParent());
 dd:ClearAllPoints();
 if GEM3UI_DefaultDDLines > #dd.items then
   dd:SetHeight((#dd.items*14)+10);
 else
   dd:SetHeight((GEM3UI_DefaultDDLines*14)+10);
 end
 dd:SetPoint("TOPRIGHT", self, "BOTTOMRIGHT", 0, 2);
 
 GEM3UI_DD_SetGlobal();
end



function GEM3UI_DD_SetGlobal()
 local dd = getglobal("GEM3UIDropDown");
 dd:SetWidth(dd.strwidth);
 local ddtitle = getglobal(dd:GetName().."Title");
 local ddtitlel = getglobal(dd:GetName().."TitleLine");
 
 if ddtitlel == nil then
  ddtitlel = dd:CreateTexture(dd:GetName().."TitleLine");
  ddtitlel:SetHeight(15);
  ddtitlel:SetPoint("TOPLEFT", dd, 3, -3);
  ddtitlel:SetTexture(0.3,0.3,0.3,1);
  ddtitlel:SetDrawLayer("BACKGROUND");
 end
 if ddtitle == nil then
   ddtitle = dd:CreateFontString(dd:GetName().."Title", "ARTWORK", "GameFontNormal");
   ddtitle:SetPoint("TOPLEFT", dd, 7, -3);
   ddtitle:SetHeight(15);
   ddtitle:SetTextColor(1,1,1,1);
   ddtitle:SetJustifyH("LEFT");
 end 
 ddtitlel:SetWidth(dd:GetWidth()-6);
 ddtitle:SetWidth(dd:GetWidth()-6); 
 local scrollit = getglobal("GEM3UIDropDownScroll");
 local titelheight = 0 ;
 if dd.title ~= nil then
  ddtitle:SetText(dd.title);
  ddtitle:Show();
  ddtitlel:Show();
  scrollit:SetPoint("TOPLEFT", dd, 3, -18);
  scrollit:SetPoint("BOTTOMRIGHT", dd, -27, 3);
  titelheight = 15;
 else
  ddtitle:Hide();
  ddtitlel:Hide();
  scrollit:SetPoint("TOPLEFT", dd, 3, -3);
  scrollit:SetPoint("BOTTOMRIGHT", dd, -27, 3);
 end

 if GEM3UI_DefaultDDLines > #dd.items then
   dd:SetHeight((#dd.items*14)+10+titelheight);
 else
   dd:SetHeight((GEM3UI_DefaultDDLines*14)+10+titelheight);
 end

 if dd:IsVisible() then
  dd:Hide();
 end
 dd:Show();
 dd:Raise();
end




function GEM3UI_DropDownOpenClose(self, foo, arg)
  GEM3UI_DropDowninit();
 local dd = getglobal("GEM3UIDropDown")
 dd.target = self:GetParent():GetName().."TextLabel";
 if dd:IsVisible() then
   dd:Hide();
 else
   pcall(foo, arg);
   GEM3UI_ShowDD(self, dd);
 end
 dd.target = self:GetParent():GetName().."TextLabel";
end


function GEM3UI_DropDownClick (self, button, obj)
  local dd = getglobal("GEM3UIDropDown");
  if dd.target ~= nil then
   local target = getglobal(dd.target);
   if target then
    target:SetText(dd.items[self.dd_index].value);
    target.id=dd.items[self.dd_index].id;
   end
  end
  if dd.items[self.dd_index].foo ~= nil then
   retok, ret1 = pcall(dd.items[self.dd_index].foo ,dd.items[self.dd_index].id, dd.items[self.dd_index].value);
  end
  dd:Hide();
end


function GEM3UI_CloseDD(self)
 local dd = getglobal("GEM3UIDropDown");
 if dd:IsVisible() and (time()-dd.opentime) > 1 then
  dd:Hide();
 end
end


function GEM3UI_HighlightTexture(self, state)
 local tex = getglobal(self:GetName().."Texture");
 local texhl = getglobal(self:GetName().."HLTexture"); 
 if texhl == nil then
  texhl = self:CreateTexture(self:GetName().."HLTexture", "OVERLAY");
  texhl:SetTexture(tex:GetTexture());
  texhl:SetAllPoints();
  texhl:SetBlendMode("ADD");
 end
 if state == "ON" then
  texhl:Show();
  texhl:SetVertexColor(1,0,0, 1);
 else
  texhl:Hide();
  texhl:SetVertexColor(1,1,1, 0);
 end
end


--function GEM3UI_DDAddLine(id, value, label, state, checked, foo)
function GEM3UI_SetDDMenu(target, table)
 if target == nil then 
  --if type(target) ~= "string" then target = target:GetName(); end
 --else
  target = "cursor";
 end
 MovixLib_DDMenuAddLine({text = " ", disabled = true}, nil, table)
 MovixLib_DDMenuAddLine({text = CLOSE , func = function () GEM3UI_DDMenuFrame:Hide() end}, nil, table)   
 EasyMenu(table, GEM3UI_DDMenuFrame, target, 0,0, "MENU", 5);
  GEM3UI_DDTable = GA_ReleaseTable(table);
end


-- HANDLE ESC KEY for EditBoxes to release Focus
function GEM3UI_ESCpressed(self)
    self:ClearFocus();
end


-- SCROLL FRAMES

function GEM3UIScrollFrame_OnScroll(self, arg1)
  if self:GetName() == "GEM3UIDayEventScrollList" then 
    FauxScrollFrame_OnVerticalScroll(self, arg1, 14, GEM3UI_DayEventListScrollUpdate);
  end
end

function GEM3UIScrollFrame_OnMouseWheel(self, delta)
  if self:GetName() == "GEM3UIDayEventList" then
    GEM3UI_ScrollFrameOnMouseWheel(self, delta);
  end
end

function GEM3UIScrollFrame_Update(self)
 if self:GetName() == "GEM3UIDayEventList" then
  GEM3UI_DayEventListScrollUpdate();
 end
end


function GEM3UI_ScrollFrameOnMouseWheel(self, value, scrollBar)
	if self:GetName() == "GEM3UIMainEventScrollList" then return; end
    scrollBar = scrollBar or getglobal(self:GetName() .. "ScrollBar");
	if ( value > 0 ) then
		scrollBar:SetValue(scrollBar:GetValue() - 14);
	else
		scrollBar:SetValue(scrollBar:GetValue() + 14);
	end
end

----- misc
function GEM3UI_GetClassIndex(class)
 for i, class_str in ipairs(GEM3UI_Classes) do
  if class_str.gemid == class then return i; end
 end
 return false
end

function GEM3UI_GetRoleIndex(role)
 for i, role_str in ipairs(GEM3UI_Roles) do
  if role_str.gemid == role then return i; end
 end
 return 0;
end




function GEM3UI_IsPlayerOnline(chan, pl)
 --mydbg("GEM3UI_IsPlayerOnline:"..pl.." chan :"..chan);
 if pl == nil then return false; end
 if UnitIsConnected(pl) == 1 then return true; end
 local plinfo = GEM3_PLAY_GetPlayerInfos(pl, chan);
 if plinfo ~= nil then
  if plinfo.connected == true then return true; end
 end
 return false;
end
 

function GEM3UI_TblCpy(tab)
  if(type(tab) ~= "table")
  then
    return nil;
  end
  local newtab = GA_GetTable();
  for n,v in pairs(tab)
  do
    if(type(v) == "table") -- recurs dup
    then
      newtab[n] = GEM3UI_TblCpy(v);
    else
      newtab[n] = v;
    end
  end
  return newtab;
end


---- TOOLBAR


--[[
function GEM3UI_CreateToolBar(tbname, parent)
 local tb = getglobal(tbname);
 if tb==nil then
  tb = parent:CreateFrame("FRAME", tbname);
 end
 tb.buttons={};
 return tb;
end

function GEM3UI_RefreshToolBar(self, tb)
 if tb==nil then tb = self; end
 if tb == nil then return; end
 if tb.buttons = nil then return; end
 local i = 0;
 for i, button in pairs(tb.buttons) do
  i = i+1;
  local but = getglobal(tb:GetName().."but"..i);
  if but == nil then
   but = CreateFrame("BUTTON", tb:GetName().."but"..i, tb, "ToolbarButtonTemplate");
  end
  
  button.name = but:GetName();
  but:SetScript("OnClick", button.OnClick);
  but:SetScript("OnEnter", button.OnEnter);
  but:SetScript("OnLeave", button.OnLeave);
  GEM3UI_DrawButtonShadow(but, but.State);
  local bicon = getglobal(but:GetName().."Icon");
  bicon:SetTexture(but.texture);
  but:SetHeight(tb:GetHeight());
  but:SetWidth(but:GetHeight());
  
  if button.visible then 
   but:Show();
  else
   but:Hide();
  end
  if button.active then 
   but:SetAlpha(1);
  else
   but:SetAlpha(0.5);
  end
 end
end


function GEM3UI_AddToolbarButton(tb, texture, text, tt, state, active, visible, OnEnter, OnLeave, OnClick)
 local but = GA_GetTable();
 but.active = active;
 but.visible = visible;
 but.Onenter=OnEnter;
 but.OnLeave=OnLeave;
 but.OnClick=OnClick;
 but.texture=texture;
 but.text=text
 but.tooltip=tt;
 but.State=state;
 table.insert(tb.buttons, but);
end

]]--


function GEM3UI_DrawButtonShadow(but, state)
   local b;
   local prefix = but:GetName();
   bt = getglobal(prefix.."1");
   if bt == nil then 
    bt = but:CreateTexture("$parent1");
    bl = but:CreateTexture("$parent2");
    bb = but:CreateTexture("$parent3");
    br = but:CreateTexture("$parent4");
    
    bicon = but:CreateTexture("$parentIcon");
    bicon:SetTexture(1,0,1,0.7);
    bicon:SetPoint("TOPLEFT", but, "TOPLEFT", 1, -1);
    bicon:SetPoint("BOTTOMRIGHT", but, "BOTTOMRIGHT", -1, 1);
    
    bt:SetPoint("TOPLEFT", but, "TOPLEFT", 0, 0);
    bt:SetPoint("BOTTOMRIGHT", but, "TOPRIGHT", 0, -1);
    bl:SetPoint("TOPLEFT", but, "TOPLEFT", 0, 0);
    bl:SetPoint("BOTTOMRIGHT", but, "BOTTOMLEFT", 1, 0);
    br:SetPoint("TOPLEFT", but, "TOPRIGHT", -1, 0);
    br:SetPoint("BOTTOMRIGHT", but, "BOTTOMRIGHT", 0, 0);
    bb:SetPoint("TOPLEFT", but, "BOTTOMLEFT", 0, 1);
    bb:SetPoint("BOTTOMRIGHT", but, "BOTTOMRIGHT", 0, 0);
    
   else
    bt = getglobal(prefix.."1");
    bl = getglobal(prefix.."2");
    bb = getglobal(prefix.."3");
    br = getglobal(prefix.."4");
    bicon = getglobal(prefix.."Icon");
   end

   if state then
    bt:SetTexture(0.5,0.5,0.5,1);
    bl:SetTexture(0.5,0.5,0.5,1);
    bb:SetTexture(1,1,1,1);
    br:SetTexture(1,1,1,1);
    --but:SetTextColor(1,1,1,0);
    bicon:SetAlpha(1);
   else
    bt:SetTexture(1,1,1,1);
    bl:SetTexture(1,1,1,1);
    bb:SetTexture(0.5,0.5,0.5,1);
    br:SetTexture(0.5,0.5,0.5,1);
    --but:SetTextColor(1,1,1,1);
    bicon:SetAlpha(0.5);
   end
end



------ Temporaly added code from the grid lib
--[[
if(not MovixLib) then
  MovixLib = {};
  MovixLib.DateSeperator = ".";
  MovixLib.TimeSeperator = ":";
  MovixLib.version = 0.1 
  MovixLib.Grids = {}
end
MovixLib_DDMenuFrame = CreateFrame("FRAME", "MovixLib_DDMenuFrame", nil, "UIDropDownMenuTemplate");
MovixLib.Tables = {};

--------------- Table recycling functions ---------------

-- wipe table content
function MovixLib_WipeTable(t1,recurseCount)
  if(type(t1) ~= "table")
  then
    if(t1 == nil)
    then
      return MovixLib_GetTable();
    end
    return t1;
  end

  for k,v in pairs(t1)
  do
    if(recurseCount and (recurseCount > 0) and (type(v) == "table")) -- Recurse release table
    then
      MovixLib_ReleaseTable(v,recurseCount-1);
    end
    t1[k] = nil;
  end

  return t1;
end

function MovixLib_GetTable()
  local recTable;
  if(#MovixLib.Tables >= 1)
  then
    recTable = tremove(MovixLib.Tables);
  else
    recTable = {};
  end
  return recTable;
end

-- Definitly free table for next garbage collection
function MovixLib_ReleaseTable(t1,recurseCount)
  if(type(t1) ~= "table")
  then
    return;
  end
  
  for k,v in pairs(t1)
  do
    if(recurseCount and (recurseCount > 0) and (type(v) == "table")) -- Recurse release table
    then
      MovixLib_ReleaseTable(v,recurseCount-1);
    end
    t1[k] = nil;
  end
  
  tinsert(MovixLib.Tables,t1);
  return nil;
end

function MovixLib_TblCpy(tab)
  if(type(tab) ~= "table")
  then
    return nil;
  end
  local newtab = MovixLib_GetTable();
  for n,v in pairs(tab)
  do
    if(type(v) == "table") -- recurs dup
    then
      newtab[n] = MovixLib_TblCpy(v);
    else
      newtab[n] = v;
    end
  end
  return newtab;
end


]]--


function GEM3_UI_CreateFAQFrame()
    local font = "Fonts\\FRIZQT__.TTF"
    if not GEM3UIHelp.FAQF  then
        GEM3UIHelp.FAQF =  MovixLib_UIFrames.Createsimple(GEM3UIHelp, "GEM3 FAQ" ,527 , 150)
    end
    local FAQF = GEM3UIHelp.FAQF
    FAQF:SetBackdrop({bgFile = "Interface/CharacterFrame/UI-Party-Background", 
                    edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                    tile = true, tileSize = 16, edgeSize = 16, 
                    insets = { left = 4, right = 4, top = 4, bottom = 4 }});
   FAQF:SetBackdropColor(0, 0, 0, 1) 
   FAQF:Raise()
   FAQF:ClearAllPoints()
   FAQF:SetParent(GEM3UIHelp)
   FAQF:SetPoint("TOPLEFT", 10, -170)
   FAQF:SetPoint("BOTTOMRIGHT", -10, 45)
   FAQF.PinupButton:Hide()

   local f = FAQF.Content
   
   
   if not f.plist then 
    f.plist = CreateFrame("Frame", "GEM3UI_FAQPLIST", f); 
    f.plist:ClearAllPoints()
    f.plist:SetPoint("TOPLEFT", 5,-5)
    f.plist:SetWidth(100)
    f.plist:SetHeight(165)
    f.plist:SetBackdrop({bgFile = "Interface/CharacterFrame/UI-Party-Background", 
                    edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                    tile = true, tileSize = 16, edgeSize = 16, 
                    insets = { left = 4, right = 4, top = 4, bottom = 4 }});
    --f.plist:SetBackdropBorderColor(1, 0, 0, 1) 
   end
   
   if not f.clist then 
    f.clist = CreateFrame("Frame", "GEM3UI_FAQCLIST", f); 
    f.clist:ClearAllPoints()
    f.clist:SetPoint("TOPLEFT", f.plist, "TOPRIGHT", 0,0)
    f.clist:SetWidth(100)
    f.clist:SetHeight(165)
    f.clist:SetBackdrop({bgFile = "Interface/CharacterFrame/UI-Party-Background", 
                    edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                    tile = true, tileSize = 16, edgeSize = 16, 
                    insets = { left = 4, right = 4, top = 4, bottom = 4 }});
    --f.clist:SetBackdropBorderColor(1, 0, 0, 1) 
   end
   
   if not f.text then
    f.text = GEM3UI_FAQText
    f.text:SetParent(f)
    f.text:ClearAllPoints()
    f.text:SetPoint("TOPLEFT", f.clist, "TOPRIGHT", 5, 0)
    f.text:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", -5, 5)
    f.text:SetInsertMode("TOP")
    f.text:SetJustifyH("LEFT")
    f.text:SetFont(font, 8.5);
    f.text:Clear()
   end

   if not f.morestr then 
    f.morestr = MovixLib_GetControlObject(f, "string"); 
    f.morestr:ClearAllPoints()
    f.morestr:SetPoint("BOTTOMRIGHT", f.text, "BOTTOMRIGHT", 0,0)
    f.morestr:SetJustifyH("RIGHT")
    f.morestr:SetWidth(120)
    f.morestr:SetHeight(-20)
    f.morestr:SetText("Scroll for more...")
    f.morestr:SetFont(font, 7);
   end
   f.morestr:Hide()
   f:Show()
   if not GridLib.Grids.GEM3_UI_FAQ_CLIST then
     GridLib.Grids.GEM3_UI_FAQ_CLIST = MovixLib_TblCpy(GEM3_UI_FAQ_CLISTDefault)
   end
   if not GridLib.Grids.GEM3_UI_FAQ_PLIST then
     GridLib.Grids.GEM3_UI_FAQ_PLIST = MovixLib_TblCpy(GEM3_UI_FAQ_PLISTDefault)
   end

   
   
   MovixLib_GetGridDefaults(f.plist, "GEM3_UI_FAQ_PLIST", "GEM3_UI_SECTIONS")
   MovixLib_FillData(f.plist);
   MovixLib_RefreshGrid(f.plist, true, nil, true)
   
   GEM3UI_FAQListHeaders = {} -- GEM3UI_getFAQTbl(GEM3_UI_CHANGELOG, "Version ")
   MovixLib_GetGridDefaults(f.clist, "GEM3_UI_FAQ_CLIST", "GEM3UI_FAQListHeaders")
   MovixLib_FillData(f.clist);
   MovixLib_RefreshGrid(f.clist, true, nil, true)
   GEM3UI_FAQText:Show()
end

function GEM3UI_FAQHeaderPListOnClick(p, row, col)
   if string.find(string.lower(p.data[row].name), "changelog") then
    GEM3UI_FAQListHeaders = GEM3UI_getFAQTbl(p.data[row].content, "Version ")
   else
    GEM3UI_FAQListHeaders = GEM3UI_getFAQTbl(p.data[row].content)
   end
   MovixLib_FillData(GEM3UIHelp.FAQF.Content.clist);
   MovixLib_RefreshGrid(GEM3UIHelp.FAQF.Content.clist, true) 
end

function GEM3UI_FAQHeaderCListOnClick(p, row, col)
   local ts = GEM3UI_FAQText
   local f = GEM3UIHelp.FAQF.Content
   ts:Clear()
   local t = GEM3UI_getFAQTbl(p.data[row].content)
   local prefix = ""
   if string.find(string.lower(p.data[row].title), "version ") then
    prefix = "- "
   end
   for i, l in ipairs (t) do
      local lines = l.content
      for n=0, #lines do
         local msg = lines[#lines-n]
         if msg then
            ts:AddMessage(prefix..msg)
         else
            ts:AddMessage(msg)
         end
      end
      ts:AddMessage("\n|cffffffff"..l.title.."|cffffff00")
   end
   ts:ScrollToBottom()
   if ts:GetNumLinesDisplayed() < ts:GetNumMessages() then
    f.morestr:Show()
   else
    f.morestr:Hide()
   end
end

function GEM3UI_SortFAQ_A(l1, l2)
   return l1.title < l2.title
end

function GEM3UI_SortFAQ_D(l1, l2)
   return l1.title > l2.title
end

function GEM3UI_getFAQTbl(source, titleprefix)
    titleprefix = titleprefix or ""
    local tbl = {}
    for i, l in pairs(source) do
        table.insert(tbl, {title = titleprefix..i, content = l})
    end
    if tittleprefix then 
        table.sort(tbl, GEM3UI_SortFAQ_A)
    else
        table.sort(tbl, GEM3UI_SortFAQ_D)
    end
    return tbl
end

function GEM3UI_FAQ_register(name, source)
    table.insert(GEM3_UI_SECTIONS, {name = name, content = source})
end

function GEM3UI_ShowLatestChangelog()
 --GEM3UI_ShowCoreChangeLog = true
 --GEM3UI_ShowUIChangeLog = true
 		 
 if (not GEM3UI_ShowCoreChangeLog) and (not GEM3UI_ShowUIChangeLog) then tdbg("damn") return end
 tdbg("TEST")
 local font = "Fonts\\FRIZQT__.TTF"
 local ts = GEM3UI_FAQText
 local core_MSG = nil

 local corever = GEM3_GetVersion()
 if GEM3UI_ShowCoreChangeLog then
    if GEM3_CORE_CHANGELOG[corever] then
     core_MSG = GEM3_CORE_CHANGELOG[corever]
    end
 end   
 
 local UI_MSG = nil
 
 local uiver = (GEM3UI_MAJOR or 0).."."..(GEM3UI_MINOR or 0)..(GEM3UI_REVISION or 0)
 if GEM3UI_ShowUIChangeLog then
    if GEM3_UI_CHANGELOG[uiver] then
        UI_MSG = GEM3_UI_CHANGELOG[uiver]
    end
 end

 local f = nil
 if core_MSG or UI_MSG then
 
    local FAQF = MovixLib_UIFrames.Createsimple("GEM3UIMain", "GEM3 Latest Changelog" ,500 , 350)
    FAQF:SetBackdrop({bgFile = "Interface/CharacterFrame/UI-Party-Background", 
                    edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                    tile = true, tileSize = 16, edgeSize = 16, 
                    insets = { left = 4, right = 4, top = 4, bottom = 4 }});
    FAQF:SetBackdropColor(0, 0, 0, 0.9) 
    FAQF:ClearAllPoints()

    FAQF:SetPoint("CENTER", 0, 0)
    --FAQF:SetFrameStrata("DIALOG")
    FAQF:Raise()
    FAQF:SetScript("OnHide", function (self) GEM3UI_FAQText:Hide() end )
    
    f = FAQF.Content
   
    ts:SetParent(f)
    ts:ClearAllPoints()

    ts:SetPoint("TOPLEFT", f, "TOPLEFT", 5, -5)
    ts:SetWidth(490)
    ts:SetHeight(300)
    ts:SetInsertMode("TOP")
    ts:SetJustifyH("LEFT")
    ts:SetFont(font, 8.5);

    if not f.morestr then 
     f.morestr = MovixLib_GetControlObject(f, "string"); 
     f.morestr:ClearAllPoints()
     f.morestr:SetPoint("BOTTOMRIGHT", ts, "BOTTOMRIGHT", 0,0)
     f.morestr:SetJustifyH("RIGHT")
     f.morestr:SetWidth(120)
     f.morestr:SetHeight(-20)
     f.morestr:SetText("Scroll for more...")
     f.morestr:SetFont(font, 7);
    end
    f.morestr:Hide()
    f:Show()
    FAQF:Show()
 end
 GEM3UI_FAQText:Clear()
 if core_MSG then
    local t = GEM3UI_getFAQTbl(core_MSG)
    for i, l in ipairs (t) do
      local lines = l.content
      for n=0, #lines do
         local msg = lines[#lines-n]
         if msg then
            ts:AddMessage("- "..msg)
         else
            ts:AddMessage(msg)
         end
      end
      ts:AddMessage("\n|cffffffff"..l.title.."|cffffff00")
    end
    ts:AddMessage("\n|cffff5500".."GEM3 Core Changelog version " ..corever.."|cffffff00")
 end
 
 if UI_MSG then
    local t = GEM3UI_getFAQTbl(UI_MSG)
    for i, l in ipairs (t) do
      local lines = l.content
      for n=0, #lines do 
         local msg = lines[#lines-n]
         if msg then
            ts:AddMessage("- "..msg)
         else
            ts:AddMessage(msg)
         end
      end
      ts:AddMessage("\n|cffffffff"..l.title.."|cffffff00")
    end
    ts:AddMessage("\n|cffff5500".."GEM3UI Changelog version "..uiver.."|cffffff00")
 end 
 if core_MSG or UI_MSG then
    ts:ScrollToBottom()
    ts:Show()
    if ts:GetNumLinesDisplayed() < ts:GetNumMessages() then
        f.morestr:Show()
    else
        f.morestr:Hide()
    end
    
 end
 GEM3UI_ShowCoreChangeLog = nil
 GEM3UI_ShowUIChangeLog = nil
end
