--[[
 Guild Event Manager GUI
 -------------------------------------
  Code: Movix - Conseil des Ombres - EU
  Main  
]]

GEM3UI_Addon = LibStub("AceAddon-3.0"):NewAddon("GEM3UI_Addon","AceComm-3.0","AceSerializer-3.0");
GEM3UI_ALLVARSLOADED = false
GEM3UI_LastGuildRosterUpdate_Time = time();

function GEM3UI_Reset(self)
 if GEM3UI_ResetCoreDB:GetChecked() then
  GEM3_Reset_Events()
 end
 if GEM3UI_ResetCoreCFG:GetChecked() then
    GEM3_Reset_Config()
 end
 
 
 if GEM3UI_ResetTemplates:GetChecked() then
  GEM3UI.Templates = nil;
 end
 
 if GEM3UI_ResetUI:GetChecked() then
  GEM3UI = nil;
 end
 
 if GEM3UI_ResetGrids:GetChecked() then
  for gid, g in pairs (GridLib.Grids) do
    if string.find(gid, "GEM3UI") then
        GridLib.Grids[gid].DHeaders = nil
        GridLib.Grids[gid].DGridParams = nil
        GridLib.Grids[gid].Headers = nil
        GridLib.Grids[gid].GridParams = nil
        GridLib.Grids[gid] = nil
    end
  end
 end
 
 ReloadUI();
end


function GEM3UI_GridFirstRunMessage()
   local f = MovixLib_UIFrames.Createsimple(GEM3UIMain, "GEM 3.25-UI1.9",300 , 200)
   f:SetBackdrop({bgFile = "Interface/CharacterFrame/UI-Party-Background", 
         edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
         tile = true, tileSize = 16, edgeSize = 16, 
         insets = { left = 4, right = 4, top = 4, bottom = 4 }});
   f:SetBackdropColor(0, 0, 0, 0.5) 
   f:ClearAllPoints()
   f:SetPoint("CENTER", 0, 0)
   f.msg = MovixLib_GetControlObject(f.Content, "string")
   f.msg:SetText(GEM3UI_LocalizedStrings["_FirstGridRun"])
   f.msg:SetJustifyH("CENTER")
   f.msg:SetJustifyV("MIDDLE")
   f.msg:SetPoint("TOPLEFT", 10 ,0)
   f.msg:SetPoint("BOTTOMRIGHT", -10 ,30)
   f.but = MovixLib_GetControlObject(f.Content, "button")
   f.but:SetPoint("TOPLEFT", f.Content, "BOTTOMLEFT", 100, 30)
   f.but:SetPoint("BOTTOMRIGHT", f.Content, "BOTTOMRIGHT", -100, 10)
   f.but:SetText("OK")
   f.but:SetScript("OnClick",
      function(self, button) 
         local f = self:GetParent():GetParent()
         f:Hide()
      end
   )
   f:SetScript("OnHide",
      function(self) 
         local f = self
         MovixLib_ReleaseControlObject(f.msg)
         MovixLib_ReleaseControlObject(f.but)
         f.msg = nil
         f.but = nil
         GEM3UI.FirstGridRun = true
      end
   )
   f:Show()
   f:Raise()
end

--- INITIALIZATION

function  GEM3UI_Init()
 local plname = UnitName("player"); 
 
 if GEM3UI                     == nil then GEM3UI = {}; 
 else
  if (GEM3UI.VersionMajor or GEM3UI_MAJOR)..(GEM3UI.VersionMinor or GEM3UI_MINOR)..(GEM3UI.Revision or GEM3UI_REVISION) < "151" then
  -- evenlist options
   GEM3UI.ShowLevelCol = 1
   GEM3UI.ShowTagiconCol = 1
   GEM3UI.ShowLeaderCol = 1
   GEM3UI.ShowLeaderIconCol = 1
   GEM3UI.ShowSubsCol = 1
   GEM3UI.ShowLimitsIconCol = 1
   GEM3UI.ShowEventIconCol = 1
  end
  if (GEM3UI.VersionMajor or GEM3UI_MAJOR)..(GEM3UI.VersionMinor or GEM3UI_MINOR)..(GEM3UI.Revision or GEM3UI_REVISION) < "190" then
  -- evenlist options
    for gid, g in pairs (GridLib.Grids) do
        if string.find(gid, "GEM3UI") then
         GridLib.Grids[gid] = nil
        end
    end
    GEM3UI.EventGridView = "GEM3UI_EVENTS_Minimal"
    GEM3UI.EventGridTheme  = "GEM3UI_THEME_Neutral"
    
  end
  if (GEM3UI.VersionMajor or GEM3UI_MAJOR)..(GEM3UI.VersionMinor or GEM3UI_MINOR)..(GEM3UI.Revision or GEM3UI_REVISION) == "193" then
    GridLib.Grids["GEM3UI_EVENTS_Minimal"] = nil
  end
  
  if (GEM3UI.VersionMajor or GEM3UI_MAJOR)..(GEM3UI.VersionMinor or GEM3UI_MINOR)..(GEM3UI.Revision or GEM3UI_REVISION) < "196" then
    GridLib.Grids["GEM3UI_EventPlayers"] = nil
  end
 end
 
-- GridLib.Grids["GEM3UI_EventPlayers"] = nil
 
 -- upon version 2.0 old gridstyle is no more available
 GEM3UI.Gridstyle = true
 

 GEM3UI_PlayerVersions = {};
 if GEM3UI_chans == nil then   GEM3UI_chans = {} end

------ READING SV
    
--- CORE VERSION HANDLING
 if GEM3UI.CoreVersion ~= GEM3_GetVersion() then
    GEM3UI_ShowCoreChangeLog = true
    GEM3UI.CoreVersion = GEM3_GetVersion()
 end   

--- REVISION RELEASE CHANGE INIT 
 if GEM3UI.Revision ~= GEM3UI_REVISION then 
   GEM3UI.Revision     = GEM3UI_REVISION;
   GEM3UI_ShowUIChangeLog = true
 end

--- MINOR RELEASE CHANGE INIT 
 if GEM3UI.VersionMinor ~= GEM3UI_MINOR then 
   if GEM3UI.VersionMinor or 0 < 3 then
    GEM3UI={};
   end
   GEM3UI.VersionMinor = GEM3UI_MINOR;
   GEM3UI.Revision     = GEM3UI_REVISION;
   GEM3UI_ShowUIChangeLog = true
 end

--- MAJOR RELEASE CHANGE INIT
 if GEM3UI.VersionMajor ~= GEM3UI_MAJOR then
  GEM3UI={};
  GEM3UI.VersionMajor = GEM3UI_MAJOR;
  GEM3UI.VersionMinor = GEM3UI_MINOR;
  GEM3UI.Revision     = GEM3UI_REVISION;
  GEM3UI_ShowUIChangeLog = true
 end

 

--- FIRST RUN INIT
 if GEM3UI.Firstrun               == nil then
   GEM3UI.ShowLevelCol = 1
   GEM3UI.ShowTagiconCol = 1
   GEM3UI.ShowLeaderCol = 1
   GEM3UI.ShowLeaderIconCol = 1
   GEM3UI.ShowSubsCol = 1
   GEM3UI.ShowLimitsIconCol = 1
   GEM3UI.ShowEventIconCol = 1

   GEM3UI.ShowTooltips = true;
   GEM3UI.ShowMinimapIcon = true;
   GEM3UI.AutoSubscribe = false;
   GEM3UI.ShowTooltips = true;
   GEM3UI.NotifySound = false;
   GEM3UI.NotifySubs = false;
   GEM3UI.NotifyNew = true;
   GEM3UI.NotifyOwn = true;
   GEM3UI.NotifyEdit = false;
   GEM3UI.NotifyDateChange = false;
   GEM3UI.NotifyKickBan = flase;
   GEM3UIRUNCFGWIZ = true;
   GEM3UI.WindowState = 0
   GEM3UI.Firstrun = "DONE1"
   GEM3UI.EventGridView = "GEM3UI_EVENTS_Minimal"
   GEM3UI.Gridstyle = true
 end

 
 GEM3UI.InvitePeriod = 15;
--- GENERAL INITS
 if GEM3UI.Templates           == nil then GEM3UI.Templates = {};             end
 if GEM3UI[plname]             == nil then GEM3UI[plname]  = {};              end

 if GEM3UI.InvitePeriod        == nil then GEM3UI.InvitePeriod = 3*60;        end

 if GEM3UI.VersionMajor        == nil then GEM3UI.VersionMajor = GEM3UI_MAJOR;end
 if GEM3UI.VersionMinor        == nil then GEM3UI.VersionMinor = GEM3UI_MINOR;end
 if GEM3UI.Revision            == nil then GEM3UI.Revision     = GEM3UI_REVISION;end

-- GRID RELATED
 if GEM3UI.EventGridView       == nil then GEM3UI.EventGridView = "GEM3UI_EVENTS_Minimal" end
 if GEM3UI.EventGridTheme      == nil then GEM3UI.EventGridTheme  = "GEM3UI_THEME_Neutral" end
 if GEM3UI.Gridstyle           == nil then GEM3UI.Gridstyle = true end
 --MovixLib_DebugLevel = false

 if GEM3UI.eventLimitsWidth    == nil then GEM3UI.eventLimitsWidth = 130 end
-- Main FRAME an Minimap Icon settings
 if GEM3UI.Scale               == nil then GEM3UI.Scale = 1;                  end
 if GEM3UI.WindowState         == nil then GEM3UI.WindowState = 0;            end --0 = full, 1 = half, 2 = small     
 if GEM3UI.MinimapRadius       == nil then GEM3UI.MinimapRadius = Minimap:GetWidth()/4; end
 if GEM3UI.MinimapAngle        == nil then GEM3UI.MinimapAngle = 180;         end
 if GEM3UI.MinimapIcon         == nil then GEM3UI.MinimapIcon = "Spell_Nature_TimeStop"; end
 if GEM3UI.WindowPosX          == nil then GEM3UI.WindowPosX = (GetScreenWidth()*UIParent:GetEffectiveScale()/2)+(GEM3UI_MainWidth/2); end
 if GEM3UI.WindowPosY          == nil then GEM3UI.WindowPosY = (GetScreenHeight()*UIParent:GetEffectiveScale()/2)+(GEM3UI_MainHeight/2); end
-- Calendar and Date settings
 if GEM3UI.FirstWeekday        == nil then GEM3UI.FirstWeekday = 1;           end -- true = lundi, false = dimanche
-- if GEM3UI.FirstWeekday == false then GEM3UI_FirstWeekday = 0; else GEM3UI_FirstWeekday = 1; end
 if GEM3UI.DateFormat          == nil then -- 0= d/m/y, 1 = y/m/d, 2 = m/d/y
  if GetLocale() == "frFR" or GetLocale() == "deDE" or GetLocale() == "esES" then GEM3UI.DateFormat = 0
  elseif GetLocale() == "enUS" then GEM3UI.DateFormat = 2
  else GEM3UI.DateFormat = 1 end
 end 
 if GEM3UI.ShowWeekday         == nil then GEM3UI.ShowWeekday = 0             end
 if GEM3UI.TimeFormat          == nil then GEM3UI.TimeFormat = 0;          end -- true= 24h, false = 12h
 if GEM3UI.DateSeparator       == nil then GEM3UI.DateSeparator = "/";
  if GetLocale() == "deDE" then GEM3UI.DateSeparator = "."
  else GEM3UI.DateSeparator = "/" end
 end
 if GEM3UI.CalCol              == nil then GEM3UI.CalCol = GEM3UI_calcol;     end
 if GEM3UI.DayCol              == nil then GEM3UI.DayCol = GEM3UI_daycol;     end
 if GEM3UI.CalText             == nil then GEM3UI.CalText = GEM3UI_caltext;   end

-- General settings
 if GEM3UI.ServerTimeOffSet    == nil then GEM3UI.ServerTimeOffSet = 0;       end
 if GEM3UI.DefaultHour         == nil then GEM3UI.DefaultHour = 20;           end
 if GEM3UI.DefaultMinute       == nil then GEM3UI.DefaultMinute = 30;         end
 if GEM3UI.DefaultDuration     == nil then GEM3UI.DefaultDuration = 60*60*3;  end
 if GEM3UI.ArchiveBeforeDelete == nil then GEM3UI.ArchiveBeforeDelete = false end

-- Player specific settings
 if GEM3UI[plname].OnlyMyChannels == nil then GEM3UI[plname].OnlyMyChannels = false; end

-- Eventype filtering
 if GEM3UI[plname].EvenTypeFilters == nil then GEM3UI[plname].EvenTypeFilters = {};             end
 for evtypeid, evtype in pairs (GEM3UI_LocalizedStrings.EventTypes) do
  if 
   GEM3UI[plname].EvenTypeFilters[evtypeid] == nil then GEM3UI[plname].EvenTypeFilters[evtypeid] = true;
   evtype.state = true;
  else
   evtype.state = GEM3UI[plname].EvenTypeFilters[evtypeid];
  end
 end


 
 -- GRID RELATED
 GEM3UI_Init_Chanlist()
 -- init
 if GridLib == nil then
    GridLib = {}
 end
 if GridLib.Grids == nil then
    GridLib.Grids = {}
 end
  -- copy defaults if grid configs are not present
 for gid, def in pairs (GEM3UI_GridParamsDefaults) do
    if not GridLib.Grids[gid] then
       GridLib.Grids[gid] = MovixLib_TblCpy(def)
    end
    -- special treatment for Eventlist, i do not remember why, got to check this
    if gid ~= "GEM3UI_GridDefaults" and not strfind(gid, "GEM3UI_THEME_") then
       if gid ~= "GEM3UI_EventPlayers" and gid ~= "GEM3UI_ChannelMembers" and gid ~= "GEM3UI_CFG_Channellist" then
        GridLib.Grids[gid].DHeaders = MovixLib_TblCpy(GEM3UI_GridDefaults.DHeaders)
       end
       --GEM3UI.EventGridTheme = GridLib.Grids[gid].DGridParams.inherits
    end

 end
 for gid, g in pairs(GridLib.Grids) do
    if strfind(gid, "GEM3UI_") then
       MovixLib_RegisterLocale(gid, GEM3UI_LocalizedStrings)
    end
 end
-- replace field EV_subtype by ev_inst_type
 for gid, g in pairs(GridLib.Grids) do
    if strfind(gid, "GEM3UI_") then
       if GridLib.Grids[gid].DHeaders ~= nil then
           for fname, fcfg in ipairs (GridLib.Grids[gid].DHeaders) do
                if fcfg.val == "ev_subtype" then
                    GridLib.Grids[gid].DHeaders[fname].val = "ev_inst_tag"
                end
           end 
        end
        if GridLib.Grids[gid].Headers ~= nil then
            for fname, fcfg in ipairs (GridLib.Grids[gid].Headers) do
                if fcfg.val == "ev_subtype" then
                    GridLib.Grids[gid].Headers[fname].val = "ev_inst_tag"
                end
            end
        end
    end
 end



----- INIT RUNTIME VARS

GEM3_EVTYPE_INSTTYPE_INSTTAG_MATCHING[GEM3_EVT_TYPE_GUILD_EVENT][GEM3UI_INST_TYPE_GUILD] = { GEM3_INST_TAG_NONE, GEM3UI_INST_TAG_GUILD_OFFMETTING, GEM3UI_INST_TAG_GUILD_SOCIAL,
GEM3UI_INST_TAG_GUILD_BIRTHDAY, GEM3UI_INST_TAG_GUILD_QUEST5,GEM3UI_INST_TAG_GUILD_QUEST10, GEM3UI_INST_TAG_GUILD_DAILYQUEST, GEM3UI_INST_TAG_GUILD_DAILYHERO,
 }

GEM3_EVTYPE_INSTTYPE_INSTTAG_MATCHING[GEM3_EVT_TYPE_INSTANCE5_BC][GEM3_INST_TYPE_PARTY] = { GEM3_INST_TAG_NONE,
 GEM3UI_INST_TAG_BC5_HELLFIRERAMP,GEM3UI_INST_TAG_BC5_BLOODFUM,GEM3UI_INST_TAG_BC5_SLAVEPENS,GEM3UI_INST_TAG_BC5_UNDERBOG,GEM3UI_INST_TAG_BC5_MANATOMB,
GEM3UI_INST_TAG_BC5_CRYPT,GEM3UI_INST_TAG_BC5_SETHEK,GEM3UI_INST_TAG_BC5_STEAMVAULT,GEM3UI_INST_TAG_BC5_SHADOWLAB,GEM3UI_INST_TAG_BC5_MECHENAR,
GEM3UI_INST_TAG_BC5_BOTANICA,GEM3UI_INST_TAG_BC5_ARCATRAZ,GEM3UI_INST_TAG_BC5_SHATHALL,GEM3UI_INST_TAG_BC5_COT1,GEM3UI_INST_TAG_BC5_COT2,
 }
GEM3_EVTYPE_INSTTYPE_INSTTAG_MATCHING[GEM3_EVT_TYPE_INSTANCE5_BC][GEM3_INST_TYPE_PARTY_HEROIC] = { GEM3_INST_TAG_NONE,
GEM3UI_INST_TAG_BC5_HELLFIRERAMP,GEM3UI_INST_TAG_BC5_BLOODFUM,GEM3UI_INST_TAG_BC5_SLAVEPENS,GEM3UI_INST_TAG_BC5_UNDERBOG,GEM3UI_INST_TAG_BC5_MANATOMB,
GEM3UI_INST_TAG_BC5_CRYPT,GEM3UI_INST_TAG_BC5_SETHEK,GEM3UI_INST_TAG_BC5_STEAMVAULT,GEM3UI_INST_TAG_BC5_SHADOWLAB,GEM3UI_INST_TAG_BC5_MECHENAR,
GEM3UI_INST_TAG_BC5_BOTANICA,GEM3UI_INST_TAG_BC5_ARCATRAZ,GEM3UI_INST_TAG_BC5_SHATHALL,GEM3UI_INST_TAG_BC5_COT1,GEM3UI_INST_TAG_BC5_COT2,
 }


GEM3_EVTYPE_INSTTYPE_INSTTAG_MATCHING[GEM3_EVT_TYPE_INSTANCE5_WOTLK][GEM3_INST_TYPE_PARTY] = { GEM3_INST_TAG_NONE, 
GEM3UI_INST_TAG_WOTLK5_UK,GEM3UI_INST_TAG_WOTLK5_NEXUS,GEM3UI_INST_TAG_WOTLK5_AN,GEM3UI_INST_TAG_WOTLK5_AK,GEM3UI_INST_TAG_WOTLK5_DTK,GEM3UI_INST_TAG_WOTLK5_VH,
GEM3UI_INST_TAG_WOTLK5_GUN,GEM3UI_INST_TAG_WOTLK5_COT_S,GEM3UI_INST_TAG_WOTLK5_HOS,GEM3UI_INST_TAG_WOTLK5_UP,GEM3UI_INST_TAG_WOTLK5_OCULUS,GEM3UI_INST_TAG_WOTLK5_HOL,
 }
GEM3_EVTYPE_INSTTYPE_INSTTAG_MATCHING[GEM3_EVT_TYPE_INSTANCE5_WOTLK][GEM3_INST_TYPE_PARTY_HEROIC] = { GEM3_INST_TAG_NONE,  
GEM3UI_INST_TAG_WOTLK5_UK,GEM3UI_INST_TAG_WOTLK5_NEXUS,GEM3UI_INST_TAG_WOTLK5_AN,GEM3UI_INST_TAG_WOTLK5_AK,GEM3UI_INST_TAG_WOTLK5_DTK,GEM3UI_INST_TAG_WOTLK5_VH,
GEM3UI_INST_TAG_WOTLK5_GUN,GEM3UI_INST_TAG_WOTLK5_COT_S,GEM3UI_INST_TAG_WOTLK5_HOS,GEM3UI_INST_TAG_WOTLK5_UP,GEM3UI_INST_TAG_WOTLK5_OCULUS,GEM3UI_INST_TAG_WOTLK5_HOL,
 }

GEM3_EVTYPE_INSTTYPE_INSTTAG_MATCHING[GEM3_EVT_TYPE_PVP][GEM3_INST_TYPE_BG] = { GEM3_INST_TAG_NONE, GEM3UI_INST_TAG_PVP_RAID, GEM3UI_INST_TAG_PVP_ALTE, GEM3UI_INST_TAG_PVP_ARATHI, 
GEM3UI_INST_TAG_PVP_WARSONG, GEM3UI_INST_TAG_PVP_EOTS, GEM3UI_INST_TAG_PVP_IOC,  GEM3UI_INST_TAG_PVP_SOA,
 }
GEM3_EVTYPE_INSTTYPE_INSTTAG_MATCHING[GEM3_EVT_TYPE_PVP][GEM3_INST_TYPE_ARENA] = { GEM3_INST_TAG_NONE,  GEM3UI_INST_TAG_PVP_2V2, GEM3UI_INST_TAG_PVP_3V3, GEM3UI_INST_TAG_PVP_5V5,
 }



 GEM3UI_NEEDUPDATE = "";

 if GEM3UI.DateFormat == 1 then 
  MovixLib_DefaultDateStrings = string.gsub(MovixLib_DefaultDateStrings, "%%d%%m%%y", "%%y%%m%%d")
  MovixLib_DefaultDateStrings = string.gsub(MovixLib_DefaultDateStrings, "%%m%%d%%y", "%%y%%m%%d")
  GEM3UI_ModifyGridDateStrings("%%d%%m%%y", "%%y%%m%%d")
  GEM3UI_ModifyGridDateStrings("%%m%%d%%y", "%%y%%m%%d")
  GEM3UI_DateFormatString = "%y"..GEM3UI.DateSeparator.."%m"..GEM3UI.DateSeparator.."%d";
 elseif GEM3UI.DateFormat == 0 then 
  MovixLib_DefaultDateStrings = string.gsub(MovixLib_DefaultDateStrings, "%%m%%d%%y", "%%d%%m%%y")
  MovixLib_DefaultDateStrings = string.gsub(MovixLib_DefaultDateStrings, "%%y%%m%%d", "%%d%%m%%y")
  GEM3UI_ModifyGridDateStrings("%%m%%d%%y", "%%d%%m%%y")
  GEM3UI_ModifyGridDateStrings("%%y%%m%%d", "%%d%%m%%y")
  GEM3UI_DateFormatString = "%d"..GEM3UI.DateSeparator.."%m"..GEM3UI.DateSeparator.."%y";
 elseif GEM3UI.DateFormat == 2 then 
  MovixLib_DefaultDateStrings = string.gsub(MovixLib_DefaultDateStrings, "%%d%%m%%y", "%%m%%d%%y")
  MovixLib_DefaultDateStrings = string.gsub(MovixLib_DefaultDateStrings, "%%y%%m%%d", "%%m%%d%%y")
  GEM3UI_ModifyGridDateStrings("%%d%%m%%y", "%%m%%d%%y")
  GEM3UI_ModifyGridDateStrings("%%y%%m%%d", "%%m%%d%%y")
  GEM3UI_DateFormatString = "%m"..GEM3UI.DateSeparator.."%d"..GEM3UI.DateSeparator.."%y";
 end
 if GEM3UI.ShowWeekday == 1 then
    GEM3UI_DateFormatString = "%a "..GEM3UI_DateFormatString;
    if not string.find(MovixLib_DefaultDateStrings, "%%wday") and not string.find(MovixLib_DefaultDateStrings, "%%default") and string.find(MovixLib_DefaultDateStrings, "%%d") then
        MovixLib_DefaultDateStrings = "%wday"..MovixLib_DefaultDateStrings
    end
    GEM3UI_ModifyGridDateStrings("", "%%wday")
 else
    if string.find(MovixLib_DefaultDateStrings, "%%wday") then
        MovixLib_DefaultDateStrings = string.gsub(MovixLib_DefaultDateStrings,"%%wday", "")
    end
    GEM3UI_ModifyGridDateStrings("%%wday", "")
 end
 if GEM3UI.TimeFormat == 1 then 
  GEM3UI_ModifyGridDateStrings("%%H", "%%I")
  GEM3UI_TimeFormatString = "%I:%M %p";
 else
  GEM3UI_ModifyGridDateStrings("%%I", "%%H")
  GEM3UI_TimeFormatString = "%H:%M";
 end
 
 GEM3UICFG_tabid = 1;
  
 GEM3UI_calcol = GEM3UI.CalCol;
 GEM3UI_daycol = GEM3UI.DayCol;
 GEM3UI_caltext = GEM3UI.CalText;
 
 --GEM3_NewEvents = 0;
 
----- FINISH INITIALIZING 
 GEM3UI_ContextFrame="GEM3UIDay";

 if GEM3UI[plname].DefaultRole == nil then
     GEM3UI[plname].DefaultRole = GEM3_QA_Config.role
 end
 if GEM3UI[plname].DefaultAltRole == nil then
     GEM3UI[plname].DefaultAltRole = GEM3_QA_Config.role
 end

 if GEM3UI.BlockWhispers then
    ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", GEM3UI_GlobalChatFilter); 
 end
 
 if GEM3UI.ChannelFilter == nil then GEM3UI.ChannelFilter = {}; end
 for i, channel in ipairs(GEM3_QA_Config.channels) do
  if GEM3_PLAY_IsPlayerInChannel(channel.name,UnitName("player")) then
    if GEM3UI.ChannelFilter[channel.name] == nil then GEM3UI.ChannelFilter[channel.name] = true; end
    if GEM3UI[UnitName("player")].DefaultChannel == nil then GEM3UI[UnitName("player")].DefaultChannel = channel.name; end
  end
  GEM3UI_EventChannelFilters[channel.name] = GEM3UI.ChannelFilter[channel.name];
 end
 GEM3UI_EventChannelFilterTextLabel:SetText(GEM3UI_LocalizedStrings["_Channels"]);

 GEM3UI_DDMenuFrame = CreateFrame("FRAME", "GEM3UI_DDMenuFrame", nil, "UIDropDownMenuTemplate");

 --if GEM3UI.UseServerTime then
  --GEM3UI_EventlistDateColumnHeaderLabel:SetText(GEM3UI_LocalizedStrings["_Date"] .. " ("..GEM3UI_LocalizedStrings["_server"]..")");
 --else
--  GEM3UI_EventlistDateColumnHeaderLabel:SetText(GEM3UI_LocalizedStrings["_Date"] .. " ("..GEM3UI_LocalizedStrings["_local"]..")");
 --end

--- Version Checking
 GEM3UI_HIGHEST_MAJOR = GEM3UI_MAJOR;
 GEM3UI_HIGHEST_MINOR = GEM3UI_MINOR;
 GEM3UI_HIGHEST_REV = GEM3UI_REVISION;

 GEM3UI_PlayerVersions[plname] = {MAJOR = GEM3UI_MAJOR, MINOR = GEM3UI_MINOR, REVISION = GEM3UI_REVISION,
                                               HMAJOR = GEM3UI_MAJOR, HMINOR = GEM3UI_MINOR, HREVISION = GEM3UI_REVISION}; 

 GEM3UI_LoadCFGPage();
 GEM3UIMain:SetScript("OnSizeChanged", GEM3UI_Resizing);
 GEM3UI_RegisterPlugin();
 GroupAnalyse.RegisterForEvents(GEM3UI_InviteProcess);


 if GEM3UIMain:IsVisible() then 
  GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE", "CLOSE");
 end
 GEM3_PLAY_RegisterCustomDataCallback(GEM3UI_custom_out,GEM3UI_custom_in);
 
 GEM3UI_Addon:RegisterComm("GEM3UI",GEM3UI_OnGetMessage);
 
 -- Init Minimap
 
 if GEM3_COM_IsDisabled() then
        GEM3MinimapButtonSwitch:Show()
 else
        GEM3MinimapButtonSwitch:Hide()
 end
 
 
 -- read settings out of GuildInfo
 -- GEMCC:channame1,password1,alias1,slash1,default1,blizcal1|channame1,password1,alias2,slash2,default2,blizcal2| -- list of channels to configure
 -- GEMADM:name1,name2 -- list of the gem admins
 -- GEMDC:sortplugin -- Sets the default sortplugin
 local gc = GEM3UI_GetGuildInfoVar("GEMC")
 gc = gc[1]
 
 local gp = GEM3UI_GetGuildInfoVar("GEMP")
 gp = gp[1]
 
 local ga = GEM3UI_GetGuildInfoVar("GEMA")
 ga = ga[1]
 
 local gs = GEM3UI_GetGuildInfoVar("GEM/")
 gs = gs[1]
 
 local ds = GEM3UI_GetGuildInfoVar("GEMS")
 ds = ds[1]
 
 local dc = GEM3UI_GetGuildInfoVar("GEMDC")
 dc = dc[1]
 
 local gcc = GEM3UI_GetGuildInfoVar("GEMCC")

 if ds then
    local sortplugin = GEM3_SORT_GetPlugin(ds); -- WARNING, plugins are not registered yet, so it will return nil everytime !!
    if(sortplugin and GEM3UI.DefaultSorting ~= sortplugin.Name) then
        DEFAULT_CHAT_FRAME:AddMessage("GEM3UI AUTO CONFIG DEFAULT SORTING: "..sortplugin.Name, 1,1,1,1)
        GEM3UI.DefaultSorting = sortplugin.Name
    end
 end

 chanexists = false
 for i, chan in ipairs(GEM3_QA_Channels) do
   if chan.name == dc then
    chanexists = true
   end
 end

 if dc and GEM3UI[UnitName("player")].DefaultChannel ~= dc and chanexists then
    DEFAULT_CHAT_FRAME:AddMessage("GEM3UI AUTO CONFIG DEFAULT CHANNEL: "..dc, 1,1,1,1)
    GEM3UI[UnitName("player")].DefaultChannel = dc
 end
 
 local chanexists = false
 for i, chan in ipairs(GEM3_QA_Channels) do
   if chan.name == gc then
    chanexists = true
   end
 end
 
 if gc and not chanexists then
    DEFAULT_CHAT_FRAME:AddMessage("GEM3UI AUTO CONFIG CHAN (S): "..gc, 1,1,1,1)
    local result = GEM3_CHAN_AddChannel(gc, (gp or ""), (ga or ""), (gs or ""));
    if result then
        GEM3UI_SetStatusMessage(string.format(GEM3UI_LocalizedStrings["_ChanneladdedSuccess"], GEM3UI_CFGChanEditName:GetText()), 5, false, true);
    else
        GEM3UI_SetStatusMessage(string.format(GEM3UI_LocalizedStrings["_ChanneladdedFailed"], GEM3UI_CFGChanEditName:GetText()), 5, false, true);
    end
  end
  
  for _, l in pairs(gcc) do
        chanexists = false
        local ccfg = {strsplit(",", l)}
        mydbg(ccfg[1])
        for i, chan in pairs(GEM3_QA_Channels) do
            if chan.name == ccfg[1] then
                chanexists = true
            end
        end
        if not chanexists then
            DEFAULT_CHAT_FRAME:AddMessage("GEM3UI AUTO CONFIG CHAN (M): "..ccfg[1], 1,1,1,1)
            local result = GEM3_CHAN_AddChannel(ccfg[1], (ccfg[2] or ""), (ccfg[3] or ""), (ccfg[4] or ""));
            if result then
                GEM3UI_SetStatusMessage(string.format(GEM3UI_LocalizedStrings["_ChanneladdedSuccess"], ccfg[1]), 5, false, true);
            else
                GEM3UI_SetStatusMessage(string.format(GEM3UI_LocalizedStrings["_ChanneladdedFailed"], ccfg[1]), 5, false, true);
            end
            
        end
        
        if ccfg[5] == "1" and (chanexists or result) then
            GEM3_CAL_EnableCalendar(ccfg[1])
            DEFAULT_CHAT_FRAME:AddMessage("GEM3UI AUTO CONFIG USE BLIZCAL FOR CHANNEL: "..ccfg[1], 1,1,1,1)
        end
        
        if ccfg[6] == "1" and (chanexists or result) and GEM3UI[UnitName("player")].DefaultChannel ~= ccfg[1] then
            GEM3UI[UnitName("player")].DefaultChannel = ccfg[1]
            DEFAULT_CHAT_FRAME:AddMessage("GEM3UI AUTO CONFIG DEFAULT CHANNEL: "..ccfg[1], 1,1,1,1)
        end
  end
end


function GEM3UI_OnGetMessage(prefix,Msgs,distribution,target)
 if target == UnitName("player") then
  return; -- do not preccess my own message
 end
 if prefix == "pushedCFG" then
    result, configArray= GEM3UI_Addon:Deserialize(Msgs);
    for k,v in pairs(configArray) do
        GEM3UI[k] = v;
    end
 end
end

function GEM3UI_SendConfig(chan, target, configArray)
 local msg = GEM3UI_Addon:Serialize(configArray)
 if chan then
  GEM3UI_Addon:SendCommMessage("pushedConfig",msg,chan);
 end
end


function GEM3UI_custom_in(channel,playerInfos,customDataInfos)
  local mydata = customDataInfos["UI"];
  local color = {1,0.1,0};
  if(mydata)
  then
    local recievedver = (mydata.major or "").."."..(mydata.minor or "").."."..(mydata.rev or "")
    local myver = (GEM3UI_HIGHEST_MAJOR or "").."."..(GEM3UI_HIGHEST_MINOR or "").."."..(GEM3UI_HIGHEST_REV or "")
    if GEM3UI_PlayerVersions == nil then 
       GEM3UI_PlayerVersions = {};
    end
    GEM3UI_PlayerVersions[playerInfos.name] = {MAJOR = mydata.major, MINOR = mydata.minor, REVISION = mydata.rev,
                                               HMAJOR = mydata.hmajor, HMINOR = mydata.hminor, HREVISION = mydata.hrev}; 
    
    if recievedver > (GEM3UI_HIGHEST_MAJOR or "").."."..(GEM3UI_HIGHEST_MINOR or "").."."..(GEM3UI_HIGHEST_REV or "") then
        if GEM3UI_HIGHEST_MAJOR < mydata.major then
         DEFAULT_CHAT_FRAME:AddMessage(GEM3UI_LocalizedStrings["YouHaveAnIncompatibleVersion"], unpack(color));
        else
         DEFAULT_CHAT_FRAME:AddMessage(GEM3UI_LocalizedStrings["YouHaveAnOutdatedVersion"], unpack(color));
        end
        GEM3UI_HIGHEST_MAJOR = mydata.major
        GEM3UI_HIGHEST_MINOR = mydata.minor
        GEM3UI_HIGHEST_REV = mydata.rev
        
        DEFAULT_CHAT_FRAME:AddMessage(string.format(GEM3UI_LocalizedStrings["PlayerKnowNewerVersion"], playerInfos.name, channel, recievedver), unpack(color));
    end
  end
end

function GEM3UI_custom_out(channel,playerInfos,customDataInfos)
  local mydata = {};
  mydata.hmajor = (GEM3UI_HIGHEST_MAJOR or GEM3UI_MAJOR);
  mydata.hminor = (GEM3UI_HIGHEST_MINOR or GEM3UI_MINOR);
  mydata.hrev   = (GEM3UI_HIGHEST_REV or GEM3UI_REVISION);
  mydata.major = (GEM3UI_MAJOR);
  mydata.minor = (GEM3UI_MINOR);
  mydata.rev   = (GEM3UI_REVISION);
  GEM3UI_PlayerVersions[UnitName("player")] = {MAJOR = GEM3UI_MAJOR, MINOR = GEM3UI_MINOR, REVISION = GEM3UI_REVISION,
                                               HMAJOR = GEM3UI_MAJOR, HMINOR = GEM3UI_MINOR, HREVISION = GEM3UI_REVISION}; 
  customDataInfos["UI"] = mydata;
end

function GEM3UI_SelectGridStyle(self)
    --local scrollit = getglobal("GEM3UIMainEventScrollList");
    --local expline = getglobal("GEM3UI_lineFrame"..GEM3UI_expandedLine); 
    --if self then GEM3UI.Gridstyle = GEM3UI_SetNewGrid:GetChecked() or false end
    --if GEM3UI_EventDetailsStandAloneFrame then GEM3UI_EventDetailsStandAloneFrame:Hide() end
    --if expline ~= nil then
      --  GEM3UI_ExpandEventLine(expline, true);
    --end   
    if GEM3UI.Gridstyle then 
        GEM3UI_GridViewSelect:Show()
        GEM3UI_MemberslistTest:Show()
        GEM3UI_EventGrid:Show()
--        GEM3UI_HideShowEventlines(false)
        GEM3UI_GrideventSubscriptionList:Show()
        GEM3UIeventDetailsLimitsFrame:SetPoint("TOPLEFT", 280, -32)
        if GEM3UI_MemberslistTest:IsVisible() then 
            MovixLib_RefreshGrid(GEM3UI_MemberslistTest, true)
        end
    end
    GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE")
end


-- FUNCTION LINKED TO SLASH COMMAND /GEMUI
function GEM3UI_show(arg1)
 if arg1 == "" then GEM3UIMain:Show(); end
 if arg1 == "reset" then
  if GEM3UIMain:IsVisible() then GEM3UIMain:Hide(); end
  GEM3UIReset:Show()
 end 
end


-- FRAME EVENT HANDLER

function GEM3UI_MainOnShow(self)
   GEM3_NewEvents = 0;
   GEM3MinimapButton_Update();
   GEM3UIMain:SetScale(GEM3UI.Scale);
   gemuipopulate();
   GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE");
   local cal = getglobal("GEM3UICalendar");
   GEM3UI_today = date ("*t");
   if (GEM3UICalendar:IsVisible()) then
    MovixLibCreateCalendar(cal, GEM3UI_today.month, GEM3UI_today.year);
    GEM3UI_HilightDay(self, cal.SELDAY, cal);
   end
   if (GEM3UIMainMainPanel:IsVisible()) and not GEM3UI.Gridstyle then
    GEM3UI_EventListScrollUpdate();
   end
   GEM3UI_CalHighlightSubstDays();
   
      
   GEM3UIMain:ClearAllPoints();
   GEM3UIMain:SetPoint("TOPRIGHT", UIParent, "BOTTOMLEFT", GEM3UI.WindowPosX, GEM3UI.WindowPosY);
   GEM3UIMain:SetWidth(GEM3UI_MainWidth);
   GEM3UIMain:SetHeight(GEM3UI_MainHeight);
   
   local state = GEM3UI.WindowState;
   for i=self.state+1,state do
    GEM3UI_Collapse(self);
   end
   if GEM3UIRecoverFrame:IsVisible() then
    self:Hide();
   end
   
   GEM3UI_SetFrameTitle()
   
   if getglobal("GEM3UIEventListToolbar"):IsVisible() then 
    GEM3UI_BuildToolBar();
   end
--   if GEM3UI.FirstGridRun == nil then
  --      GEM3UI_GridFirstRunMessage()
    --end
   GEM3UI_ShowLatestChangelog()
end

function GEM3UI_MainStartMoving(self)
 self:StartMoving();
end

function GEM3UI_MainStopMoving(self)
local fr = GEM3UIeventDetails;
 self:StopMovingOrSizing();
 GEM3UI.WindowPosX = GEM3UIMain:GetRight();
 GEM3UI.WindowPosY = GEM3UIMain:GetTop();
 GEM3UIMain:ClearAllPoints();
 GEM3UIMain:SetPoint("TOPRIGHT", UIParent, "BOTTOMLEFT", GEM3UI.WindowPosX, GEM3UI.WindowPosY);
end



function GEM3UI_Toggle()
  if (GEM3UIMain:IsVisible()) then
    GEM3UIMain:Hide();
  else
    GEM3UIMain:Show();
  end
end





-- Global UI refresh function 

function GEM3UI_RefreshView(reason, ...)
 if GEM3UI_InitTerminated ~= true then return; end
 
 if GEM3UI.Gridstyle then 
    local close, line, event
    if reason == "GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE" then
      close, line, event = select(1,...)
      if close then
        getglobal("GEM3UIEventSubs"):Hide();
      end
    end
    if GEM3UI_EventGrid:IsVisible() then 
        gemuipopulate()
        GEM3UI_EventGridFill(close)
    end
    if GEM3UI_SelectedEvent then
        GEM3UI_EventLinePopulate(GEM3UI_SelectedEvent);
    end
 else
  if not GEM3UIMain:IsVisible() then return end
  if reason == nil then return; end
  local expline = getglobal("GEM3UI_lineFrame"..GEM3UI_expandedLine); 
  if reason == "GEM3UI_REFRESH_CLOSEONLY" then
   if expline ~= nil then
     GEM3UI_ExpandEventLine(expline, true);
   end
   return
  end
--- Evenlist visible
  if GEM3UIMainMainPanelEventListMain:IsVisible() then
   local expline = getglobal("GEM3UI_lineFrame"..GEM3UI_expandedLine); 
   mydbg("Eventlist visible");
   if reason == "GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE" then
      local close, line, event = select(1,...)
      if expline ~= nil then
       if close == "CLOSE" and (line == "SELF" or line == nil) then
         if MyEvent[expline.ev_index].id == event.id then
          gemuipopulate();
          GEM3UI_DisplayDaydetails();
--          GEM3UI_EventListScrollUpdate();
          GEM3UI_ExpandEventLine(expline, true);

         end
       end
       GEM3UI_EventLinePopulate(expline);
      else
--        gemuipopulate();
--        GEM3UI_EventListScrollUpdate();
      end
  else
    if not GEM3UI_ShowArchive:GetChecked() and not GEM3UI_ShowTemplates:GetChecked() then
      for i=1,GEM3UI_DefaultLines do
          local line = getglobal("GEM3UI_lineFrame"..i)
          if line:IsVisible() then
            mydbg("line visible");
          
            local ev = GEM3UI_EventSource[MyEvent[line.ev_index].id]
            
            if reason == "GEM3UI_REFRESH_EVENT_UPDATE" then
             mydbg("Event update");
             local id = select (1,...);
             if ev.id == id then
              gemuipopulate();
--              GEM3UI_fillLine(i, line.ev_index);
              mydbg("Event update : "..id);
             end
            end

            if reason == "GEM3UI_REFRESH_LEADERS" then
             mydbg("Leader update");
             local leader = select (1,...);
             if ev.leader == leader then
--              GEM3UI_fillLine(i, line.ev_index);
              mydbg("Leader update : "..leader);
             end
            end --- refresh Leader or Event update
            
            if expline ~= nil then
               mydbg("Event open");
--               GEM3UI_EventLinePopulate(expline);
               GEM3UI_SubsFromRefresh()
               GEM3UI_EventDetailsShow()
--               GEM3UI_EventMembersListScrollUpdate();
             end
          end --- if line visible
       end --- Line loop
    end -- Archive or template
   end --- reason == GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE
  end --- Evenlist visible
 end
 if (reason == "GEM3UI_REFRESH_EVENT_UPDATE" 
 or reason == "GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE")
 then
   local cal = getglobal("GEM3UICalendar");
   MovixLibCreateCalendar(cal, cal.amonth.month, cal.amonth.year);
   GEM3UI_CalHighlightSubstDays();
   GEM3UI_DisplayDaydetails();
 end
 if getglobal("GEM3UIEventListToolbar"):IsVisible() then 
  GEM3UI_BuildToolBar();
 end
 
 if GEM3UIEventSubs:IsVisible() and GEM3UIEventSubs.userIsEditing ~= true then
  GEM3UI_EventDetailsShow();
 end
 local es = getglobal("GEM3UIEventSubs");
 if es:IsVisible() then
    es:Hide();
    es:Show();
 end


 
end -- function GEM3UI_RefreshView




-- FUNCTION ON FRAME LOAD
function GEM3UI_UIOnLoad(self)
  GEM3UI = {};
  GEM3UIMain:RegisterEvent("GUILD_ROSTER_UPDATE")
  GEM3UICalendar:ClearAllPoints();
  GEM3UICalendar:SetPoint("TOPRIGHT", GEM3UIMain, "TOPRIGHT", -8, -50);
  GEM3UIPlayerDetails:ClearAllPoints();
  GEM3UIPlayerDetails:SetPoint("BOTTOMRIGHT", GEM3UIMain, "BOTTOMRIGHT", -8, 10);
  GEM3UIEventSubs:ClearAllPoints();
  GEM3UIEventSubs:SetPoint("BOTTOMRIGHT", GEM3UIMain, "BOTTOMRIGHT", -8, 10);
  GEM3UIDay:ClearAllPoints();
  GEM3UIDay:SetPoint("BOTTOMRIGHT", GEM3UIMain, "BOTTOMRIGHT", -8, 10);
  GEM3UIPlayerPanel:ClearAllPoints();
  GEM3UIPlayerPanel:SetPoint("BOTTOMRIGHT", GEM3UIMain, "BOTTOMRIGHT", -8, 10);
  GEM3UIMainFrameButtons:ClearAllPoints();
  GEM3UIMainFrameButtons:SetPoint("TOPRIGHT", GEM3UIMain, "TOPRIGHT", -8, -6);
   
  GEM3UIMain:ClearAllPoints();
  GEM3UIMain:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", GEM3UI.WindowPosX, GEM3UI.WindowPosY);
  
  local gemuiver = GEM3UI_MAJOR.."."..GEM3UI_MINOR..GEM3UI_REVISION;
  SLASH_GEM3UI1 = "/GEM";
  SLASH_GEM3UI2 = "/GEM3";
  SlashCmdList["GEM3UI"] = GEM3UI_show;
  DEFAULT_CHAT_FRAME:AddMessage(string.format(GEM3UI_LocalizedStrings["GEM3UILOADED"],gemuiver), 0.9, 0.80, 0.10);
  DEFAULT_CHAT_FRAME:AddMessage(GEM3UI_LocalizedStrings["GEM3UIRESET"], 0.9, 0.80, 0.10);
  
end
  
if GEM3_GetVersion == nil then
 GEM3_GetVersion = function ()
  return "3.003";
 end
end

function GEM3UI_OnEvent(self, event, ...)
 arg1 = select (1, ...);
 local msg = ""
 local msg2 = ""
 if event == "GUILD_ROSTER_UPDATE" then
    GEM3UI_ALLVARSLOADED = true
    GEM3UI_LastGuildRosterUpdate_Time = time();
    mydbg("Main OnEvent -> GuildRosterUpdate")
    if #GEM3UI_GuildRosterQueue > 0 then
        mydbg("Elements in queue")
        for i, v in ipairs(GEM3UI_GuildRosterQueue) do
            msg = ""
            msg2 = ""
            local is_in_GI =  GEM3UI_IsGuildInfoVarSet(v.VAR, v.VAL)
            if is_in_GI then mydbg("IS IN GI") else mydbg("IS NOT IN GI") end
            if v.CMD then mydbg("ADD") else mydbg("REMOVE") end
            if is_in_GI and v.CMD then
                tremove(GEM3UI_GuildRosterQueue, i)
                msg = v.VAL .. " added to " .. v.VAR .. " and saved in the GuildInfoText"
                if v.VAR == "GEMADM" then
                    msg2 = v.VAL .. " is now GEM admin"
                end
            elseif not is_in_GI and not v.CMD  then
                tremove(GEM3UI_GuildRosterQueue, i)
                msg = v.VAL .. " deleted from " .. v.VAR .. " and saved in the GuildInfoText"
                if v.VAR == "GEMADM" then
                    msg2 = v.VAL .. " has been removed from GEM admins"
                end
            end
            v.REFRESH();
            GEM3UI_SetStatusMessage(msg, 5, false, true)
            --if strlen(msg2) > 0 then SendChatMessage(msg2, "GUILD") end
        end
    else
        --GEM3UIMain:UnregisterEvent("GUILD_ROSTER_UPDATE")
    end
    GEM3UI_FillMembersList()
 end
end

function GEM3UI_OnCoreVarsLoaded()
    local gemuiver = GEM3UI_MAJOR.."."..GEM3UI_MINOR..GEM3UI_REVISION;
    if GEM3_GetVersion() < GEM3UI_MINCOREVERSION then
     DEFAULT_CHAT_FRAME:AddMessage(string.format(GEM3UI_LocalizedStrings["COREINCOMPATIBLE"],GEM3_GetVersion(),gemuiver), 0.9, 0.1, 0.10);
     return;
    end
    GEM3UI_FAQ_register("FAQ Core", GEM3_CORE_FAQ)
	GEM3UI_FAQ_register("Changelog Core", GEM3_CORE_CHANGELOG)
 

   local scrollit;
   local cal;
   GEM3UI_Init();
   GEM3UI_InitConfigFrame();
   GEM3UIMain:RegisterForDrag("LeftButton");
   GEM3MinimapButton:RegisterForDrag("RightButton");
   tinsert(UISpecialFrames,GEM3UIMain:GetName());
   --tinsert(UISpecialFrames,GEM3UIAddExternal:GetName());

   GEM3UI_CreateSizer();
   
   gemuipopulate();
--[[   scrollit = getglobal("GEM3UIMainEventScrollList");
   if scrollit == nil then
       scrollit = CreateFrame("SCROLLFRAME", "GEM3UIMainEventScrollList", getglobal("GEM3UIMainMainPanelEventListMain"), "GEM3UIScrollFrameTemplate");
   end
   scrollit:SetPoint("TOPLEFT", getglobal("GEM3UIMainMainPanelEventListMain") ,"TOPLEFT", 0, -49)
   scrollit:SetPoint("BOTTOMRIGHT", getglobal("GEM3UIMainMainPanelEventListMain") ,"BOTTOMRIGHT", -27, 4)
   createuiline();]]--
   GEM3UI_SelectGridStyle(false)

--[[]   scrollit = getglobal("GEM3UIMembersListScroll");
   if scrollit == nil then
    scrollit = CreateFrame("SCROLLFRAME", "GEM3UIMembersListScroll", getglobal("GEM3UIMembersList"), "GEM3UIScrollFrameTemplate");
   end
   scrollit:SetPoint("TOPLEFT", getglobal("GEM3UIMembersList") ,"TOPLEFT", 0, -4)
   scrollit:SetPoint("BOTTOMRIGHT", getglobal("GEM3UIMembersList") ,"BOTTOMRIGHT", -27, 4)
   GEM3UI_CreateChannelMembersline();]]--
   
   scrollit = getglobal("GEM3UIDayEventScrollList");
   if scrollit == nil then
    scrollit = CreateFrame("SCROLLFRAME", "GEM3UIDayEventScrollList", getglobal("GEM3UIDay"), "GEM3UIScrollFrameTemplate");
   end
   scrollit :SetPoint("TOPLEFT", getglobal("GEM3UIDay") ,"TOPLEFT", 4, -82);
   scrollit :SetPoint("BOTTOMRIGHT", getglobal("GEM3UIDay") ,"BOTTOMRIGHT", -27, 75);
   createDayEventline();

   --[[scrollit = getglobal("GEM3UI_eventSubscriptionListScroll");
   if scrollit == nil then
    scrollit = CreateFrame("SCROLLFRAME", "GEM3UI_eventSubscriptionListScroll", getglobal("GEM3UI_eventSubscriptionList") , "GEM3UIScrollFrameTemplate");
   end
   scrollit:SetPoint("TOPLEFT", getglobal("GEM3UI_eventSubscriptionList"), 3, -16);
   scrollit:SetPoint("BOTTOMRIGHT", getglobal("GEM3UI_eventSubscriptionList"), -27, 28);
   createplayersline();
   
   scrollit = getglobal("GEM3UI_CFGChanlistScroll");
   if scrollit == nil then
    scrollit = CreateFrame("SCROLLFRAME", "GEM3UI_CFGChanlistScroll", getglobal("GEM3UI_CFGChanlist") , "GEM3UIScrollFrameTemplate");
   end
   scrollit:SetPoint("TOPLEFT", getglobal("GEM3UI_CFGChanlist"), 3, -20);
   scrollit:SetPoint("BOTTOMRIGHT", getglobal("GEM3UI_CFGChanlist"), -27, 28);
   createChannelline();
   ]]--
   GEM3UI_today = date ("*t");
   GEM3UIDay.d = GEM3UI_today;
   cal = getglobal("GEM3UICalendar");
   cal.amonth = date ("*t", time({["year"] = GEM3UI_today.year, ["month"] = GEM3UI_today.month, ["day"] = 1, }));
   cal.SELDAY = GEM3UI_today;
   cal.amonth = MovixLibMonthDaycount(cal.amonth);
   cal.amonth = MovixLibSetWday(cal.amonth);

   GEM3UIMain.state = 0;
   GEM3UI_InitTerminated = true;
   
--  end
  
  if GEM3UIRUNCFGWIZ == true then
   GEM3UI_MainTabClick(nil, 4);
   GEM3UIMain:Show();
   GEM3UI.ShowMinimapIcon = true;
   GEM3UIRUNCFGWIZ = false; 
  end
  GEM3MinimapButton_Update(nil);
  GEM3UI_MinimapButtonReposition(nil);
  
  GEM3UI_SelectEventGridView(GEM3UI.EventGridView)
  GEM3UI_GetChannelMembers();
end

function GEM3UI_CreateSizer()
   
   local Sizer = getglobal("GEM3UIMainSizer");
   if Sizer == nil then
    Sizer = CreateFrame("FRAME", "GEM3UIMainSizer", GEM3UIMain);
   end
   Sizer:SetPoint("TOPLEFT", GEM3UIMain, "BOTTOMRIGHT", -18,18);
   Sizer:EnableMouse();
   Sizer:SetWidth(18);
   Sizer:SetHeight(18);
   Sizer:SetBackdrop({   bgFile = "interface\\AddOns\\GEM3UI\\ResizeGrip", edgeFile ="", tile= false, tileSize=0, edgeSize=0, insets = { left=0, right=0, top=0, bottom=0}});
   Sizer:SetScript("OnMouseDown", GEM3UI_ResizingMD); 
   Sizer:SetScript("OnMouseUp", GEM3UI_ResizingMU);
   
end


function GEM3UI_DayDetailsHide(self)
 local expline = getglobal("GEM3UI_lineFrame"..GEM3UI_expandedLine);
 if expline ~= nil then
  GEM3UI_ExpandEventLine(expline, true);
 end
 self:GetParent():Hide();
end


function GEM3UI_DayEventClick(obj)
 GEM3UI_ContextFrame="GEM3UIDay";
 GEM3UIEventSubs.ev_index = GEM3UI_DayEvents[obj.index];
 GEM3UIEventSubs.evt = GEM3UI_EventSource[MyEvent[GEM3UI_DayEvents[obj.index]].id];
 GEM3UIEventSubs.form=true;
 GEM3UIEventSubs:Show();
 
end

function GEM3UI_DayEventLineHighLight(obj)
GEM3UIDayEVCommentLabel:SetText(MyEvent[GEM3UI_DayEvents[obj.index]].ev_comment);
GEM3UI_SetDebugStatus(string.format("EVENTLINE: %s - EVENTID: %s", GEM3UI_DayEvents[obj.index], MyEvent[GEM3UI_DayEvents[obj.index]].id),0);
end

function GEM3UI_DayEventLineOut(obj)
GEM3UIDayEVCommentLabel:SetText("");
end



-- GEM3UI_ContextFrame="GEM3UIEventSubs";
-- GEM3UI_ContextFrame="GEM3UIDay";
-- GEM3UI_ContextFrame="GEM3UIPlayerPanel";

function GEM3UI_DetailPanelOnShow(self)
 if GEM3UI_MovingOrSizing == true then return; end
 
 if GEM3UI_ActPanel == nil then 
  GEM3UI_ActPanel = getglobal("GEM3UIDay");
 end
 
 if GEM3UI_ActPanel:GetName() ~= self:GetName() then
  self.GEM3UI_OldPanel = GEM3UI_ActPanel;
  GEM3UI_ActPanel = self;
  self.GEM3UI_OldPanel:Hide();
 end
 
 if GEM3UI_ActPanel.GEM3UI_OldPanel == nil then 
   GEM3UI_ActPanel.GEM3UI_OldPanel = GEM3UI_ActPanel;
 end

 if GEM3UI_expandedLine == 0 then
   getglobal("GEM3UIDay").GEM3UI_OldPanel = getglobal("GEM3UIDay");
 end

 if self:GetName() == "GEM3UIEventSubs" then
   GEM3UI_EventDetailsShow();
 end
 
 if self:GetName() == "GEM3UIDay" then
  --GEM3UIEventSubs.userIsEditing = nil;
  GEM3UI_DisplayDaydetails();
 end
 
 if self:GetName() == "GEM3UIPlayerPanel" then
  --GEM3UIEventSubs.userIsEditing = nil;
  GEM3UI_DisplayPlayerDetails();
 end
 
end

function GEM3UI_DetailPanelOnHide(self)
 if GEM3UI_MovingOrSizing == true then return; end
 --if GEM3UIPlayerPanel.Stickedplname ~= nil then GEM3UIPlayerPanel.Stickedplname = nil; end
 
 if GEM3UI_ActPanel:GetName() == self:GetName() then
  GEM3UI_ActPanel = self.GEM3UI_OldPanel;
  self.GEM3UI_OldPanel:Show();
  --getglobal(GEM3UI_ContextFrame):Show();
 end
end




function GEM3UI_MemberLineOnEnter(...)
 local member_name
 if GEM3UI.Gridstyle then 
  local p, row, col, foo = select(1,...)
  member_name = p.data[row].name
 else
  local self = select(1,...)
  member_name = GEM3UI_ChannelMembers[self.index].name;
 end
 GEM3UIPlayerPanel.plname = member_name
 if not GEM3UIPlayerPanel:IsVisible() then 
  GEM3UIPlayerPanel:Show();
 end
 GEM3UI_DisplayPlayerDetails();
end

function GEM3UI_MemberLineOnLeave(self)
 if GEM3UIPlayerPanel.Stickedplname == nil then
  GEM3UI_DisplayPlayerDetails();--GEM3UIPlayerPanel:Hide();
 else
  GEM3UIPlayerPanel.plname = GEM3UIPlayerPanel.Stickedplname;
  GEM3UI_DisplayPlayerDetails();
 end
end


-- Main frame expand / collapse functions
function GEM3UI_Collapse(self)
  GEM3UI.WindowState = 0;
  if (GEM3UIMainMainPanel:IsVisible()) then
   GEM3UI.WindowState = 1;
   GEM3UIMainMainPanel:Hide();
   GEM3UIMain:SetWidth(GEM3UIMain:GetWidth() - GEM3UIMainMainPanel:GetWidth());
   GEM3UIMainFrameButtonsExpand:Enable();
  else
   if (GEM3UICalendar:IsVisible()) then
    GEM3UI.WindowState = 2;
    GEM3UICalendar:Hide();
    GEM3UIMain:SetHeight(GEM3UIMain:GetHeight() - GEM3UICalendar:GetHeight());
    GEM3UIMainFrameButtonsCollapse:Disable();
    GEM3UIMainFrameButtonsExpand:Enable();
   end
  end
  GEM3UI_ShowTemplates:SetChecked(false);
  GEM3UI_ShowArchive:SetChecked(false);
  GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE", "CLOSE");
  --GEM3UI_-RefreshAll();
  GEM3UIMainStatusBar:Hide();
  GEM3UIMain.state = GEM3UI.WindowState;
  GEM3UI_SetToolbarPosition();
end

function GEM3UI_Expand(self)
  GEM3UI.WindowState = 2;
  if (not GEM3UIMainMainPanel:IsVisible()) then
   if (not GEM3UICalendar:IsVisible()) then
    GEM3UI.WindowState = 1;
    GEM3UICalendar:Show();
    GEM3UIMain:SetHeight(GEM3UIMain:GetHeight() + GEM3UICalendar:GetHeight());
    GEM3UIMainFrameButtonsCollapse:Enable();
    GEM3UIMainFrameButtonsExpand:Enable();
   else
    GEM3UI.WindowState = 0
    GEM3UIMainMainPanel:Show();
    GEM3UIMainStatusBar:Show();
    if GEM3_QA_Config.debug > 0 then
     GEM3UI_DebugStatusBar:Show();
    end
    GEM3UIMainFrameButtonsExpand:Disable();
    GEM3UIMainFrameButtonsCollapse:Enable();
   
    GEM3UIMain:SetWidth(GEM3UIMain:GetWidth() + GEM3UIMainMainPanel:GetWidth());
   end
  end
  GEM3UIMain.state = GEM3UI.WindowState;
  GEM3UI_SetToolbarPosition();
end



--- Main Frame scaling
function GEM3UI_MainFrameHideShowcontent(state)
  if state == "HIDE" then 
   GEM3UI_MovingOrSizing=true;
  else
   GEM3UI_MovingOrSizing=false;
  end

  --GEM3UI_HideShow(GEM3UIMainMainPanel,state);
  --GEM3UI_HideShow(GEM3UICalendar,state);
  --GEM3UI_HideShow(GEM3UIPlayerDetails,state);
  --GEM3UI_HideShow(GEM3UIEventSubs,state);
  --GEM3UI_HideShow(GEM3UIDay,state);
  --GEM3UI_HideShow(GEM3UIPlayerPanel,state);
  --GEM3UI_HideShow(GEM3UIMainStatusBar,state);
  --GEM3UI_HideShow(GEM3UI_DebugStatusBar,state);
end

function GEM3UI_HideShow(frm, state)
 if state == "HIDE" then
  frm.oldstate=frm:IsVisible();
  frm:Hide();
 else
  if frm.oldstate then
   frm:Show();
  end
 end
end


function GEM3UI_ResizingMD()  -- MouseDown
  GEM3UI_MainFrameHideShowcontent("HIDE");
  GEM3UI_Resizing(2);
end

function GEM3UI_ResizingMU() -- MouseUp
 GEM3UI_Resizing(1);
 GEM3UI.WindowPosX = GEM3UIMain:GetRight();
 GEM3UI.WindowPosY = GEM3UIMain:GetTop();
 GEM3UIMain:ClearAllPoints();
 GEM3UIMain:SetPoint("TOPRIGHT", UIParent, "BOTTOMLEFT", GEM3UI.WindowPosX, GEM3UI.WindowPosY);
 GEM3UI_MainFrameHideShowcontent("SHOW");
end

function GEM3UI_Resizing(state)
 if state == nil then  state = 0; end 
 if state == 0 and GEM3UI_IsSizing == true then -- draging
   GEM3UIMain:SetHeight(GEM3UIMain:GetWidth()/GEM3UI_FrameRatio);
 elseif state== 1 then -- stopdragging
  GEM3UIMain:StopMovingOrSizing();
  GEM3UI.Scale = GEM3UIMain:GetWidth()/GEM3UI_MainWidth*GEM3UI_OldScale ;
  GEM3UIMain:SetHeight(GEM3UI_MainHeight );
  GEM3UIMain:SetWidth(GEM3UI_MainWidth);
  if GEM3UI.Scale > 1.4 then GEM3UI.Scale = 1.4; end
  if GEM3UI.Scale < 0.5 then GEM3UI.Scale = 0.5; end
  GEM3UIMain:SetScale(GEM3UI.Scale);
  GEM3UI_IsSizing = false;
  local kids = { GEM3UIMain:GetChildren() };
  for _, child in ipairs(kids) do
   if (child:GetName() ~= "GEM3UIMainSizer" and child.wasvisible == true) then
     child:Show();
   end
  end
 elseif state == 2 then -- startdragging
  GEM3UI_IsSizing = true;
  GEM3UI_MainHeight = GEM3UIMain:GetHeight()
  GEM3UI_MainWidth = GEM3UIMain:GetWidth();
  GEM3UI_FrameRatio = GEM3UI_MainWidth/GEM3UI_MainHeight;
  GEM3UI_OldScale =  GEM3UI.Scale;
  GEM3UIMain:StartSizing("BOTTOMRIGHT");
  local kids = { GEM3UIMain:GetChildren() };
  for _, child in ipairs(kids) do
   if (child:GetName() ~= "GEM3UIMainSizer" and child:IsVisible() == true) then
     child:Hide();
     child.wasvisible = true;
   end
  end
 end
 GEM3UIMainStatusBar:ClearAllPoints()
 GEM3UIMainStatusBar:SetPoint("TOPLEFT", GEM3UIMain, "BOTTOMLEFT", 0 ,3);
 GEM3UIMainStatusBar:SetWidth(GEM3UIMain:GetWidth());
 GEM3UIMainStatusBar:SetHeight(25);
 if GEM3_QA_Config.debug > 0 then
  GEM3UI_DebugStatusBar:ClearAllPoints()
  GEM3UI_DebugStatusBar:SetWidth(GEM3UIMain:GetWidth());
  if GEM3UI.WindowState == 0 then
    GEM3UI_DebugStatusBar:SetPoint("TOPLEFT", GEM3UIMainStatusBar, "BOTTOMLEFT", 0 ,3);
    GEM3UI_DebugStatusBar:SetHeight(25);
    GEM3UI_DebugStatusBarText:SetPoint("TOPLEFT", 101,-4);
    GEM3UI_DebugStatusBarText:SetWidth(443);
    GEM3UI_DebugStatusBarText:SetHeight(15)
    GEM3UIMainDelayDBG:SetPoint("TOPLEFT", 540,-4);
    
  else
    GEM3UI_DebugStatusBar:SetPoint("TOPLEFT", GEM3UIMainStatusBar, "BOTTOMLEFT", 0 ,25);
    GEM3UI_DebugStatusBar:SetHeight(100);
    GEM3UI_DebugStatusBarText:SetPoint("TOPLEFT", 3,-20);
    GEM3UI_DebugStatusBarText:SetWidth(GEM3UIMainStatusBar:GetWidth()-8);
    GEM3UI_DebugStatusBarText:SetHeight(60)
    GEM3UIMainDelayDBG:SetPoint("TOPLEFT", 3,-80);
  end
 end
 --[[if GEM3UI.WindowState == 0 then
   GEM3UIMainTitelLabel:SetText(GEM3UI_LocalizedStrings["_lblTitle"].." V."..GEM3_GetVersion());
   GEM3UIMainAlertLabel:SetText(GEM3UI_NEEDUPDATE);
 else
  GEM3UIMainTitelLabel:SetText("GEM 3");
  GEM3UIMainAlertLabel:SetText("");

 end]]--
  GEM3UI_SetFrameTitle()
 GEM3UI_SetToolbarPosition();
end

-- TAB Handling
function GEM3UI_MainTabClick(self, tabid)
 if tabid ~= nil or self == nil then
  GEM3UI_tabid = tabid;
  obj = getglobal("GEM3UIMainMainPanelTab"..tabid);
 else
  GEM3UI_tabid = string.sub(self:GetName(),23)*1;
  obj = self;
 end
 if GEM3UI_tabid ~= 2 then
  GEM3UICreate.ev_id = nil;
 end
 local tab;
 local tabtexture;
 local tabedFrames = {
  [1] = "GEM3UIMainMainPanelEventListMain",
  [2] = "GEM3UICreate",
  [3] = "GEM3UIMembers",
  [4] = "GEM3UIOptions",
  [5] = "GEM3UIDebug",
  [6] = "GEM3UIHelp",
  [7] = "GEM3UIPlugins",
 };
 for i=1,#tabedFrames do
   tabtexture = getglobal("GEM3UIMainMainPanelTab"..i.."Texture");
   tab = getglobal(tabedFrames[i]);
   if tabtexture:GetDrawLayer() == "ARTWORK" then
     tabtexture:SetDrawLayer("BACKGROUND");
     tabtexture:SetTexCoord(0, 1, 0.26, 0.5);
     tab:Hide();
   end
   if i == GEM3UI_tabid then
     tabtexture:SetDrawLayer("ARTWORK");
     tabtexture:SetTexCoord(0, 1, 0, 0.25);
     tab:SetParent(obj:GetParent());
     tab:SetPoint("TOPLEFT", 3,-30);
     tab:Show();
   end
 end
end


function GEM3UI_HelpTabShow(self)
GEM3UI_HELP_CORETITELLabel:SetText(GEM3UI_LocalizedStrings["_lblTitle"].." "..GEM3UI_LocalizedStrings["_core"].." "..GEM3UI_LocalizedStrings["_version"].." "..GEM3_GetVersion());
GEM3UI_HELP_UITITELLabel:SetText(GEM3UI_LocalizedStrings["_lblTitle"].." "..GEM3UI_LocalizedStrings["_ui"].." "..GEM3UI_LocalizedStrings["_version"].." "..GEM3UI_MAJOR.."."..GEM3UI_MINOR..GEM3UI_REVISION);
end



-- CALENDAR FUNCTIONS
function GEM3UI_CalHighlightSubstDays()
  if GEM3UI_ShowTemplates:GetChecked() then return; end
    local i;
    for i in pairs(MyEvent) do
    local ev=GEM3UI_EventSource[MyEvent[i].id];
    if ev then
     if GEM3_SUB_GetSubscribedInfos(ev.id, UnitName("Player")) then
      local day = date("*t", ev.ev_date);
       GEM3UI_ChangeDaySetColor(getglobal("GEM3UICalendar"), day, GEM3UI_COLOR_CAL_WITHSUBSCRIBEDEVENT);
      end
     end
   end
end


function GEM3UI_NextDay()
 local parent = getglobal("GEM3UICalendar");
 parent.SELDAY = MovixLibMonthDaycount(parent.SELDAY);
 if parent.SELDAY.day == parent.SELDAY.monthdaycount then
  if parent.SELDAY.month == 12 then
    parent.SELDAY.day = 1;
    parent.SELDAY.month = 1;
    parent.SELDAY.year = parent.SELDAY.year + 1
  else
    parent.SELDAY.day = 1;
    parent.SELDAY.month = parent.SELDAY.month + 1;
  end
 else
  parent.SELDAY.day = parent.SELDAY.day + 1;
 end
 parent.SELDAY = date ("*t", time({["year"] = parent.SELDAY.year, ["month"] = parent.SELDAY.month, ["day"] = parent.SELDAY.day, }));
 GEM3UIDay.d = parent.SELDAY;
 GEM3UIDay:Show();
 GEM3UI_DisplayDaydetails();
 MovixLibCreateCalendar(parent, parent.SELDAY.month, parent.SELDAY.year);
 GEM3UI_HilightDay(parent, parent.SELDAY, parent);
end

function GEM3UI_PrevDay()
 local parent = getglobal("GEM3UICalendar");
 if parent.SELDAY.day == 1 then
  if parent.SELDAY.month == 1 then
    parent.SELDAY.day = 31;
    parent.SELDAY.month = 12;
    parent.SELDAY.year = parent.SELDAY.year - 1
  else
    parent.SELDAY.day = 1;
    parent.SELDAY.month = parent.SELDAY.month - 1;
    parent.SELDAY = MovixLibMonthDaycount(parent.SELDAY);
    parent.SELDAY.day = parent.SELDAY.monthdaycount;
  end
 else
  parent.SELDAY.day = parent.SELDAY.day - 1;
 end
 parent.SELDAY = date ("*t", time({["year"] = parent.SELDAY.year, ["month"] = parent.SELDAY.month, ["day"] = parent.SELDAY.day, }));
 GEM3UIDay.d = parent.SELDAY;
 GEM3UIDay:Show();
 GEM3UI_DisplayDaydetails();
 MovixLibCreateCalendar(parent, parent.SELDAY.month, parent.SELDAY.year);
 GEM3UI_HilightDay(parent, parent.SELDAY, parent);
end


function GEM3UI_GetDateShow(self, target)
  GEM3UI_DatePickTarget = target;
  local datepick = getglobal("GEM3UI_DatePicker");
  if datepick == nil then 
   datepick = CreateFrame("FRAME", "GEM3UI_DatePicker", GEM3UIMain);
   datepick:SetFrameStrata("TOOLTIP");
   datepick:SetFrameLevel(10);
   datepick:SetWidth(170) -- Set these to whatever height/width is needed 
   datepick:SetHeight(170) -- for your Texture
   datepick:SetBackdrop( { 
    bgFile = "interface\\raidframe\\ui-raidframe-groupbg", 
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, 
    insets = { left = 3, right = 3, top = 3, bottom = 3 }
    });
    datepick:SetBackdropColor(0,0,0,1);
    datepick:SetScale(0.79);
  else
   if datepick:IsVisible() then
    datepick:Hide();
    return;
   end
  end
  datepick:SetPoint("TOPLEFT", self:GetParent(), "BOTTOMLEFT", 0,3);
  local id = 5;
  if target == "date" then id = 5; else id = 10; end
  local d = getglobal("GEM3EDITBOX"..id);
  local m = getglobal("GEM3EDITBOX"..id+1);
  local y = getglobal("GEM3EDITBOX"..id+2);
  
  if string.len(y:GetText()) == 2 then 
   y:SetText("20"..y:GetText());
  elseif string.len(y:GetText()) < 2 then
   y:SetText(GEM3UI_today.year);
  end
  
  if string.len(m:GetText()) == 0 then 
   m:SetText(GEM3UI_today.month);
  end
  
  if string.len(d:GetText()) == 0 then 
   d:SetText(GEM3UI_today.day);
  end
  
  datepick.SELDAY = date ("*t", time({["year"] = y:GetText(), ["month"] = m:GetText(), ["day"] = d:GetText(), }));

  datepick.amonth= date ("*t", time({["year"] = y:GetText(), ["month"] = m:GetText(), ["day"] = 1, }));
  datepick.amonth = MovixLibMonthDaycount(datepick.amonth);
  datepick.amonth = MovixLibSetWday(datepick.amonth);
  MovixLibCreateCalendar(datepick, datepick.SELDAY.month, datepick.SELDAY.year, GEM3UI_GetDate);
  datepick:Show();
end

function GEM3UI_GetDate(self)
    local pickdate = GEM3UI_DayClicked (self);
    if pickdate ~= 0 then 
      pickdate = date("*t", pickdate);
      local d = getglobal("GEM3EDITBOX5");
      local m = getglobal("GEM3EDITBOX6");
      local y = getglobal("GEM3EDITBOX7");
      local h = getglobal("GEM3EDITBOX8");
      local mi = getglobal("GEM3EDITBOX9");
      if GEM3UI_DatePickTarget == "deadline" then
       d = getglobal("GEM3EDITBOX10");
       m = getglobal("GEM3EDITBOX11");
       y = getglobal("GEM3EDITBOX12");
       h = getglobal("GEM3EDITBOX13");
       mi = getglobal("GEM3EDITBOX14");
      elseif GEM3UI_DatePickTarget == "end" then
       d = getglobal("GEM3EDITBOX15");
       m = getglobal("GEM3EDITBOX16");
       y = getglobal("GEM3EDITBOX17");
       h = getglobal("GEM3EDITBOX18");
       mi = getglobal("GEM3EDITBOX19");
      end
       d:SetText(string.format("%02d", pickdate.day));
       m:SetText(string.format("%02d", pickdate.month));
       y:SetText(pickdate.year);       
       if string.len(h:GetText()) == 0 then h:SetText("20"); end
       if string.len(mi:GetText()) == 0 then mi:SetText("00"); end
    end
    GEM3UI_DatePicker:Hide();
    
end 

function GEM3UI_DayHasEvent(d)
 local daystart = time({["year"] = d.year, ["month"] = d.month, ["day"] = d.day, ["hour"] = 0; ["minute"] = 0; ["sec"] = 0;}); ---(60*60);
 local daystop = daystart+(60*60*24); --time({["year"] = d.year, ["month"] = d.month, ["day"] = d.day, ["hour"] = 23; ["minute"] = 59; ["sec"] = 59;});
 for i in pairs(MyEvent) do
  if (MyEvent[i].ev_date >= daystart and MyEvent[i].ev_date <= daystop) then
   return true
  end
 end
 return false;
end



    



--- DIALOG BOXES


function GEM3UI_DialogIgnoreMember(value)
   GEM3_PLAY_IgnorePlayer(value);
   GEM3UI_ShowHideIgnoredMembers();
   --GEM3UI_-RefreshAll();
   GEM3UI_SetStatusMessage(string.format(GEM3UI_LocalizedStrings["_memberhasbeenignored"], value));
end

function GEM3UI_DialogIgnoreEvent(value)
 GEM3_EVT_IgnoreEvent(value);
 local ev = GEM3UI_EventSource[value];
 GEM3UI_SetStatusMessage(string.format(GEM3UI_LocalizedStrings["_eventhasbeenignored"], ev.ev_place, ev.id, ev.leader));
end

function GEM3UI_DialogCloseEvent(value, reason)
 GEM3_EVT_CloseEvent(value, reason);
 local ev = GEM3UI_EventSource[value];
 GEM3UI_SetStatusMessage(string.format(GEM3UI_LocalizedStrings["_eventhasbeenclosed"], ev.ev_place, ev.id, ev.leader));
end
 






-- DD inits
function GEM3UI_DropDownClasses()
 GEM3UI_DropDowninit("Classes"); 
 --local dd = getglobal("GEM3UIDropDown");
 --local t;
 local i=0;
 --local r;
 for i in pairs(GEM3UI_Classes) do
    GEM3UI_DDAddLine(GEM3UI_Classes[i].gemid, GEM3UI_Classes[i].name_loc, GEM3UI_Classes[i].name_loc, true, false, GEM3UI_DropDownClassesClick);
 end
end

function GEM3UI_DropDownClassesClick()
 GEM3UI_ExternalAddClassChanged();
end

function GEM3UI_FillDropDownPlayers()
 GEM3UI_DropDowninit("My Rerolls");
 --local dd = getglobal("GEM3UIDropDown");
 --local ddl;
 --local ddt;
 local i=0;
 --local p;
 local rerolls = GEM3_PLAY_GetMyRerolls();
 for p in pairs(rerolls) do
  i = i+1;
  local player = rerolls[p];
  GEM3UI_DDAddLine(player.name, player.name, player.name, GEM3_IsMyReroll(player.name), false, GEM3UI_SubsFromRefresh);
 end
 GA_ReleaseTable(rerolls,0)
end

function GEM3UI_FillSortDD() 
 GEM3UI_DropDowninit("Sorttype");
 local nameret;
 for name in pairs(GEM3_SORT_Plugins) do
   if name == GEM3UI.DefaultSorting then
    nameret=name;
   end
   GEM3UI_DDAddLine(GEM3_SORT_GetSortType(name), name, name, true,false, nil);
 end
 return nameret;
end
      

function GEM3UI_DefaultDropDownAltRoles(class)
 GEM3UI_DropDownRoles(nil, GEM3UI_CFGDefaultAltRole);
 --GEM3UI_DropDownRoles(class, GEM3UI[UnitName("player")].DefaultRole);
end


function GEM3UI_DefaultDropDownRoles(class)
 GEM3UI_DropDownRoles(nil, GEM3UI_CFGDefaultRole);
 --GEM3UI_DropDownRoles(class, GEM3UI[UnitName("player")].DefaultRole);
end

function GEM3UI_SubsDropDownRoles()
 GEM3UI_DropDownRoles(nil, nil);
end

function GEM3UI_CFGDefaultAltRole(id)
 GEM3UI[UnitName("player")].DefaultAltRole = id;
 --GEM3_QA_Config.role = id;
 GEM3UI_ConfigDefaultAltRoleTextLabel:SetText(GEM3UI_Roles[GEM3UI_GetRoleIndex(id)].name_loc);
end

function GEM3UI_CFGDefaultRole(id)
 GEM3UI[UnitName("player")].DefaultRole = id;
 --GEM3_QA_Config.role = id;
 GEM3UI_ConfigDefaultRoleTextLabel:SetText(GEM3UI_Roles[GEM3UI_GetRoleIndex(id)].name_loc);
end

function GEM3UI_DropDownRoles(class, foo)
 GEM3UI_DropDowninit("Roles");
 local i = 0;
 local t, allowedroles, selectedplayer;
 if class ~= nil then
  allowedroles = GEM3_PLAY_GetAllowedRoles(GEM3UI_CLASS_STRINGS[class]);
 else
  if GEM3UIEventSubsForm:IsVisible() then
   local pl = GEM3_PLAY_GetPlayerInfos(GEM3UI_ActualPlayerTextLabel:GetText());
   allowedroles = GEM3_PLAY_GetAllowedRoles(pl.class);
  else
   class, classEN = UnitClass("player");
   allowedroles = GEM3_PLAY_GetAllowedRoles(classEN);
  end
 end
 
 for r=1, 5 do
  if (bit.band(allowedroles, GEM3UI_Roles[r].gemid) ~= 0) and GEM3UI_Roles[r].gemid ~=6 then
   i = i+1;
   if (bit.band(GEM3UI_Roles[4].gemid, GEM3UI_Roles[r].gemid) ~= 0) then
     t= GEM3UI_Roles[4].name_loc.." "..GEM3UI_Roles[r].name_loc;
   else
     t=GEM3UI_Roles[r].name_loc;
   end
   GEM3UI_DDAddLine(GEM3UI_Roles[r].gemid, t, t, true, false, foo);
  end
 end
end



function GEM3UI_MainHide(self)
 GEM3UI_MainWidth = GEM3UIMain:GetWidth();
 GEM3UI_MainHeight = GEM3UIMain:GetHeight();
 GEM3UIFirstRunHelp:Hide();
 GEM3UIFirstRunHelp:SetScript("OnUpdate", nil);
 GEM3UIRUNCFGWIZ = false;
 if GEM3UI.Firstrun == "DONE1" then
    GEM3UI.WindowState = 1;
    GEM3UI.Firstrun = "DONE";
 end
end



function GEM3UI_BuildToolBar()
 --GEM3UI_SetToolbarPosition();
 local tb = getglobal("GEM3UIEventListToolbar");
 local i = 1;
 local but = getglobal(tb:GetName().."but"..i);
 while but do
  but:Hide();
  i = i + 1;
  but = getglobal(tb:GetName().."but"..i);
 end
 
 i = 1;
 for ev_type, count in pairs (GEM3UI_EventTypePresent) do
  
  if (GEM3_QA_Config.debug > 0 and ev_type < 20)
     or ev_type == 0 or ev_type >= 20 
  then
    GEM3UI_CreateButton(but, tb, i, ev_type, count);
    i = i + 1; 
  end
 end
end


function GEM3UI_CreateButton(but, tb, i, ev_type, count)
 local but = getglobal(tb:GetName().."but"..i);
   if but == nil then
    but = CreateFrame("BUTTON", tb:GetName().."but"..i, tb, "ToolbarButtonTemplate");
   end
   but:SetWidth(19);
   but:SetHeight(19);

   if type(but.SetNormalFontObject) == "function" then
     but:SetNormalFontObject(GameFontNormalSmall, 10, flags);
   end


   if GEM3UI_LocalizedStrings.EventTypes[ev_type].state==true then
     GEM3UI_DrawButtonShadow(but, true);
     local bicon = getglobal(but:GetName().."Icon");
     bicon:SetTexture(GEM3UI_LocalizedStrings.EventTypes[ev_type].tbip);
   else
     GEM3UI_DrawButtonShadow(but, false);
     local bicon = getglobal(but:GetName().."Icon");
     bicon:SetTexture(GEM3UI_LocalizedStrings.EventTypes[ev_type].tbin);
   end
   if tb:GetHeight() == 40 then
    if i == 1 then
     but:SetPoint("TOPLEFT", tb, "TOPLEFT", 2,0);
    elseif (i > 1 and i < 9) or i > 9 then
     but:SetPoint("TOPLEFT", getglobal(tb:GetName().."but"..i-1), "TOPRIGHT", 1,0);
    elseif i == 9 then
     but:SetPoint("TOPLEFT", tb, "TOPLEFT", 2,-19);
    end
   else
    if i == 1 then
     but:SetPoint("TOPLEFT", tb, "TOPLEFT", 0,-6);
    else
     but:SetPoint("TOPLEFT", getglobal(tb:GetName().."but"..i-1), "TOPRIGHT", 2,0);
    end
   end
   but:SetScript("OnLeave", GEM3UI_HideTooltip);
   but:SetScript("OnEnter", GEM3UI_ToolbarTooltipShow);
   but:SetText(count);
   but.index=ev_type
   but:Show();
end





function GEM3UI_ToolbarTooltipShow(self)
 local t = string.format(GEM3UI_LocalizedStrings["EventTypesToolbarButtonsTooltip"],GEM3UI_LocalizedStrings.EventTypes[self.index].longtext);
 GEM3UI_GameTooltipShow(self, t);
end



function GEM3UI_ToolBarButtonClick(self)
 local tex;
 local plname = UnitName("player"); 
 if GEM3UI_LocalizedStrings.EventTypes[self.index].state then
  GEM3UI_LocalizedStrings.EventTypes[self.index].state = false;
  GEM3UI[plname].EvenTypeFilters[self.index] = false;
  GEM3UI_DrawButtonShadow(self, false);
 else
  GEM3UI_DrawButtonShadow(self, true);
  GEM3UI_LocalizedStrings.EventTypes[self.index].state=true;
  GEM3UI[plname].EvenTypeFilters[self.index] = true;
 end
 GEM3UI_SelectedEvent = nil
 local es = getglobal("GEM3UIEventSubs");
 es:Hide();

 --GEM3UI_-RefreshAll(GEM3UI_REFRESH_CLOSE_OPEN_EVENTLINE);
 GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE", "CLOSE");
end





function GEM3UI_SetToolbarPosition()
if GEM3UIMain.state == 0 then 
   GEM3UIEventListToolbar:SetParent(GEM3UIMainMainPanelEventListMain);
   GEM3UIEventListToolbar:ClearAllPoints();
   GEM3UIEventListToolbar:SetPoint("TOPLEFT",GEM3UIMainMainPanelEventListMain, "TOPLEFT", 14, -4);
   GEM3UIEventListToolbar:SetWidth(390);
   GEM3UIEventListToolbar:SetHeight(30);
else
   GEM3UIEventListToolbar:SetParent(GEM3UIDay);
   GEM3UIEventListToolbar:ClearAllPoints();
   GEM3UIEventListToolbar:SetPoint("TOPLEFT", GEM3UIDay, "TOPLEFT", 3, -41);
   GEM3UIEventListToolbar:SetWidth(220);
   GEM3UIEventListToolbar:SetHeight(40);
end
GEM3UIEventListToolbar:Show();
GEM3UI_BuildToolBar()
end


function GEM3UI_RegisterPlugin(name)
 local tabobj = getglobal("GEM3UIMainMainPanelTab7");
 local tabobjlbl = getglobal("GEM3UIMainMainPanelTab7Text");
 if name ~= nil then
  table.insert(GEM3UI_PluginList, name);
 end
 if #GEM3UI_PluginList > 0 then
  tabobj:Show();
  tabobjlbl:Show();
 else
   tabobj:Hide();
   tabobjlbl:Hide();
 end
end



GEM3UI_DIALOG_INTERNAL = 0
GEM3UI_DIALOG_CONFIRM_EVENT_IGNORE = 1;
GEM3UI_DIALOG_CONFIRM_MEMBER_IGNORE = 2;
GEM3UI_DIALOG_CONFIRM_EVENT_CLOSE = 3;
GEM3UI_DIALOG_CONFIRM_UNSUBSCRIBE = 4;
GEM3UI_DIALOG_CONFIRM_PLAYER_KICK = 5;
GEM3UI_DIALOG_CONFIRM_PLAYER_BAN = 6;
GEM3UI_DIALOG_CONFIRM_EVENT_RECOVER = 7;
GEM3UI_DIALOG_CONFIRM_EVENT_RECOVER_REJECT = 8;
GEM3UI_DIALOG_CONFIRM_EVENT_RECOVER_DELETE = 9;
GEM3UI_DIALOG_CONFIRM_EVENT_DELETE = 10;
GEM3UI_DIALOG_CONFIRM_EVENTARCHIVE_DELETE = 11;
GEM3UI_DIALOG_CONFIRM_CANCEL_EVENT_EDIT = 12;
GEM3UI_DIALOG_CONFIRM_SETTIMEREF = 13;
GEM3UI_DIALOG_CONFIRM_SETTIMEREFCONFLICT = 14;
GEM3UI_DIALOG_CONFIRM_NOOBTIMEREFCONFLICT = 15;
GEM3UI_DIALOG_CONFIRM_UPGRADENEEDED = 16;


GEM3UI_CONFIRM_DIALOGS = {
   [GEM3UI_DIALOG_CONFIRM_EVENT_IGNORE]  = {label = "_ConfirmEventIgnore", reason=false, foo= GEM3UI_DialogIgnoreEvent},
   [GEM3UI_DIALOG_CONFIRM_MEMBER_IGNORE] = {label = "_ConfirmMemberIgnore",reason=false,  foo= GEM3UI_DialogIgnoreMember},
   [GEM3UI_DIALOG_CONFIRM_EVENT_CLOSE]   = {label = "_ConfirmEventClose", reason=true, foo= GEM3UI_DialogCloseEvent},
   [GEM3UI_DIALOG_CONFIRM_UNSUBSCRIBE]   = {label = "_ConfirmEventUnsubscribe", reason=true, foo= GEM3UI_DialogUnsubscribeEvent},
   [GEM3UI_DIALOG_CONFIRM_PLAYER_KICK]   = {label = "_ConfirmPlayerKick", reason=true, foo= GEM3UI_ProccedPlayerKick},
   [GEM3UI_DIALOG_CONFIRM_PLAYER_BAN]   = {label = "_ConfirmPlayerBan", reason=true, foo= GEM3UI_ProccedPlayerBan},
   [GEM3UI_DIALOG_CONFIRM_EVENT_RECOVER]   = {label = "_ConfirmEventRecover", reason=false, foo= GEM3UI_ProceedEventRecover},
   [GEM3UI_DIALOG_CONFIRM_EVENT_RECOVER_REJECT]   = {label = "_ConfirmEventRecoverReject", reason=false, foo= GEM3UI_ProceedEventRecoverReject},
   [GEM3UI_DIALOG_CONFIRM_EVENT_RECOVER_DELETE]   = {label = "_ConfirmEventRecoverDelete", reason=false, foo= GEM3UI_ProceedEventRecoverDelete},
   [GEM3UI_DIALOG_CONFIRM_EVENTARCHIVE_DELETE]   = {label = "_ConfirmEventArchiveDelete", reason=false, foo= GEM3UI_EventDeleteArchive},
   [GEM3UI_DIALOG_CONFIRM_EVENT_DELETE]   = {label = "_ConfirmEventDelete", reason=false, foo= GEM3UI_EventDelete},
   [GEM3UI_DIALOG_CONFIRM_CANCEL_EVENT_EDIT]   = {label = "_ConfirmCancelEventEdit", reason=false, foo= GEM3UI_CancelCreate},
   [GEM3UI_DIALOG_CONFIRM_SETTIMEREF]   = {label = "_ConfirmSetTimeRef", reason=false, foo= GEM3UI_SetTimeRef},
   [GEM3UI_DIALOG_CONFIRM_SETTIMEREFCONFLICT]   = {label = "_ConfirmTimeRefConflict", reason=false, foo= nil},
   [GEM3UI_DIALOG_CONFIRM_NOOBTIMEREFCONFLICT]   = {label = "_ConfirmIncorrectTimeSettings", reason=false, foo= nil},
   [GEM3UI_DIALOG_CONFIRM_UPGRADENEEDED]   = {label = "_ConfirmUpgradeNeeded", reason=false, foo= nil},
}

