﻿-- File containing critical localized strings

local loc = GetLocale();

if(loc == "enUS")
then
  -- Instance names
  GEM3_LOC_INSTANCE_NAMES = {
   ["Zul'Gurub"] = GEM3_INST_TAG_ZG, -- Unsure
   ["Molten Core"] = GEM3_INST_TAG_MC,
   ["Ruins of Ahn'Qiraj"] = GEM3_INST_TAG_AQ20, -- Unsure
   ["Ahn'Qiraj Temple"] = GEM3_INST_TAG_AQ40,
   ["Blackwing Lair"] = GEM3_INST_TAG_BWL, -- Unsure
   ["Onyxia's Lair"] = GEM3_INST_TAG_ONY, -- Unsure
   ["Karazhan"] = GEM3_INST_TAG_KARA,
   ["Zul'Aman"] = GEM3_INST_TAG_ZA,
   ["Gruul's Lair"] = GEM3_INST_TAG_GRUUL,
   ["Magtheridon's Lair"] = GEM3_INST_TAG_MAGTH,
   ["Coilfang: Serpentshrine Cavern"] = GEM3_INST_TAG_SSC,
   ["Tempest Keep"] = GEM3_INST_TAG_EYE,
   ["The Battle for Mount Hyjal"] = GEM3_INST_TAG_HYJAL,
   ["Black Temple"] = GEM3_INST_TAG_BT,
   ["The Sunwell"] = GEM3_INST_TAG_SWP,
   -- Wotlk
   ["Naxxramas"] = GEM3_INST_TAG_NAXXRAMAS,
   ["The Obsidian Sanctum"] = GEM3_INST_TAG_CHAMBEROFASPECTS,
   ["The Eye of Eternity"] = GEM3_INST_TAG_EYEOFETERNITY, -- Unsure
   ["Vault of Archavon"] = GEM3_INST_TAG_WINTERGRASP,
   ["Ulduar"] = GEM3_INST_TAG_ULDUAR,
   ["Trial of the Crusader"] = GEM3_INST_TAG_TRIAL_CRUSADER,
   ["Icecrown Citadel"] = GEM3_INST_TAG_ICC,
  };

  -- Zone names
  GEM3_LOC_ZONE_NAMES = {
   -- Capitals
   ["Dalaran"] = GEM3_ZONE_DALARAN,
   ["Orgrimmar"] = GEM3_ZONE_ORGRIMMAR,
   ["Thunder Bluff"] = GEM3_ZONE_THUNDERBLUFF,
   ["Undercity"] = GEM3_ZONE_UNDERCITY,
   ["Silvermoon City"] = GEM3_ZONE_SILVERMOON,
   ["Ironforge"] = GEM3_ZONE_IRONFORGE,
   ["Stormwind City"] = GEM3_ZONE_STORMWIND,
   ["Darnassus"] = GEM3_ZONE_DARNASSUS,
   ["The Exodar"] = GEM3_ZONE_EXODAR,
   ["Shattrath City"] = GEM3_ZONE_SHATTRATH,
   -- LK Outside
   ["Borean Tundra"] = GEM3_ZONE_BOREAN_TUNDRA,
   ["Crystalsong Forest"] = GEM3_ZONE_CRYSTALSONG_FOREST,
   ["Dalaran"] = GEM3_ZONE_DALARAN,
   ["Dragonblight"] = GEM3_ZONE_DRAGONBLIGHT,
   ["Grizzly Hills"] = GEM3_ZONE_GRIZZLY_HILLS,
   ["Howling Fjord"] = GEM3_ZONE_HOWLING_FJORD,
   ["Icecrown"] = GEM3_ZONE_ICECROWN,
   ["Sholazar Basin"] = GEM3_ZONE_SHOLAZAR_BASIN,
   ["The Storm Peaks"] = GEM3_ZONE_THE_STORM_PEAKS,
   ["Wintergrasp"] = GEM3_ZONE_WINTERGRASP,
   ["Zul'Drak"] = GEM3_ZONE_ZUL_DRAK,
   ["Hrothgar's Landing"] = GEM3_ZONE_HROTHGAR_LANDING,
   -- LK Instances
   ["Vault of Archavon"] = GEM3_ZONE_ARCHAVON,
   ["Naxxramas"] = GEM3_ZONE_NAXXRAMAS,
   ["The Obsidian Sanctum"] = GEM3_ZONE_CHAMBEROFASPECTS,
   ["The Eye of Eternity"] = GEM3_ZONE_EYEOFETERNITY,
   ["Utgarde Keep"] = GEM3_ZONE_UTGARDE_KEEP,
   ["Utgarde Pinnacle"] = GEM3_ZONE_UTGARDE_PINNACLE,
   ["Drak'Tharon Keep"] = GEM3_ZONE_DRAK_THARON,
   ["Gundrak"] = GEM3_ZONE_GUNDRAK,
   ["Halls of Lightning"] = GEM3_ZONE_HALLS_LIGHTNING,
   ["Halls of Stone"] = GEM3_ZONE_HALLS_STONE,
   ["Azjol-Nerub"] = GEM3_ZONE_AZJOL_NERUB,
   ["Ahn'kahet: The Old Kingdom"] = GEM3_ZONE_AHN_KAHET,
   ["The Violet Hold"] = GEM3_ZONE_VIOLET_HOLD,
   ["The Oculus"] = GEM3_ZONE_OCULUS,
   ["The Nexus"] = GEM3_ZONE_NEXUS,
   ["The Culling of Stratholme"] = GEM3_ZONE_CULLING_STRATHOLME,
   ["Ulduar"] = GEM3_ZONE_ULDUAR,
   ["Trial of the Champion"] = GEM3_ZONE_TRIAL_CHAMPION,
   ["Trial of the Crusader"] = GEM3_ZONE_TRIAL_CRUSADER,
   ["The Forge of Souls"] = GEM3_ZONE_ICC_FORGE_OF_SOULS,
   ["Pit of Saron"] = GEM3_ZONE_ICC_PIT_OF_SARON,
   ["Halls of Reflection"] = GEM3_ZONE_ICC_HALLS_OF_REFLECTION,
   ["Icecrown Citadel"] = GEM3_ZONE_ICC_RAID,
  };

elseif(loc == "frFR")
then
  -- Instance names
  GEM3_LOC_INSTANCE_NAMES = {
    ["Cœur du Magma"] = GEM3_INST_TAG_MC,
    ["Karazhan"] = GEM3_INST_TAG_KARA,
    ["Zul'Aman"] = GEM3_INST_TAG_ZA,
    ["Le repaire de Gruul"] = GEM3_INST_TAG_GRUUL,
    ["Repaire de Magtheridon"] = GEM3_INST_TAG_MAGTH,
    ["Glissecroc : caverne du sanctuaire du Serpent"] = GEM3_INST_TAG_SSC,
    ["Donjon de la Tempête"] = GEM3_INST_TAG_EYE,
    ["La bataille du mont Hyjal"] = GEM3_INST_TAG_HYJAL,
    ["Temple noir"] = GEM3_INST_TAG_BT,
    -- Wotlk
    ["Naxxramas"] = GEM3_INST_TAG_NAXXRAMAS,
    ["Le sanctum Obsidien"] = GEM3_INST_TAG_CHAMBEROFASPECTS,
    ["L'Œil de l'éternité"] = GEM3_INST_TAG_EYEOFETERNITY,
    ["Caveau d'Archavon"] = GEM3_INST_TAG_WINTERGRASP,
    ["Ulduar"] = GEM3_INST_TAG_ULDUAR,
    ["L'épreuve du croisé"] = GEM3_INST_TAG_TRIAL_CRUSADER,
    ["Citadelle de la Couronne de glace"] = GEM3_INST_TAG_ICC,
  };

  -- Zone names
  GEM3_LOC_ZONE_NAMES = {
   -- Capitals
   ["Dalaran"] = GEM3_ZONE_DALARAN,
   ["Orgrimmar"] = GEM3_ZONE_ORGRIMMAR,
   ["Les Pitons du Tonnerre"] = GEM3_ZONE_THUNDERBLUFF,
   ["Fossoyeuse"] = GEM3_ZONE_UNDERCITY,
   ["Lune-d'argent"] = GEM3_ZONE_SILVERMOON,
--~    [""] = GEM3_ZONE_IRONFORGE,
--~    [""] = GEM3_ZONE_STORMWIND,
--~    [""] = GEM3_ZONE_DARNASSUS,
--~    [""] = GEM3_ZONE_EXODAR,
   ["Shattrath"] = GEM3_ZONE_SHATTRATH,
   -- LK Outside
   ["Toundra Boréenne"] = GEM3_ZONE_BOREAN_TUNDRA,
   ["Forêt du Chant de cristal"] = GEM3_ZONE_CRYSTALSONG_FOREST,
   ["Dalaran"] = GEM3_ZONE_DALARAN,
   ["Désolation des dragons"] = GEM3_ZONE_DRAGONBLIGHT,
   ["Les Grisonnes"] = GEM3_ZONE_GRIZZLY_HILLS,
   ["Fjord Hurlant"] = GEM3_ZONE_HOWLING_FJORD,
   ["La Couronne de glace"] = GEM3_ZONE_ICECROWN,
   ["Bassin de Sholazar"] = GEM3_ZONE_SHOLAZAR_BASIN,
   ["Les pics Foudroyés"] = GEM3_ZONE_THE_STORM_PEAKS,
   ["Joug-d'hiver"] = GEM3_ZONE_WINTERGRASP,
   ["Zul'Drak"] = GEM3_ZONE_ZUL_DRAK,
   --["Hrothgar's Landing"] = GEM3_ZONE_HROTHGAR_LANDING,
   -- LK Instances
   ["Caveau d'Archavon"] = GEM3_ZONE_ARCHAVON,
   ["Naxxramas"] = GEM3_ZONE_NAXXRAMAS,
   ["Le sanctum Obsidien"] = GEM3_ZONE_CHAMBEROFASPECTS,
   ["L'Œil de l'éternité"] = GEM3_ZONE_EYEOFETERNITY,
   ["Donjon d'Utgarde"] = GEM3_ZONE_UTGARDE_KEEP,
   ["Cime d'Utgarde"] = GEM3_ZONE_UTGARDE_PINNACLE,
   ["Donjon de Drak'Tharon"] = GEM3_ZONE_DRAK_THARON,
   ["Gundrak"] = GEM3_ZONE_GUNDRAK,
   ["Les salles de Foudre"] = GEM3_ZONE_HALLS_LIGHTNING,
   ["Les salles de Pierre"] = GEM3_ZONE_HALLS_STONE,
   ["Azjol-Nérub"] = GEM3_ZONE_AZJOL_NERUB,
   ["Ahn'kahet : l'Ancien royaume"] = GEM3_ZONE_AHN_KAHET,
   ["Le fort Pourpre"] = GEM3_ZONE_VIOLET_HOLD,
   ["L'Oculus"] = GEM3_ZONE_OCULUS,
   ["Le Nexus"] = GEM3_ZONE_NEXUS,
   ["L'Épuration de Stratholme"] = GEM3_ZONE_CULLING_STRATHOLME,
   ["Ulduar"] = GEM3_ZONE_ULDUAR,
   ["L'épreuve du champion"] = GEM3_ZONE_TRIAL_CHAMPION,
   ["L'épreuve du croisé"] = GEM3_ZONE_TRIAL_CRUSADER,
   --["The Forge of Souls"] = GEM3_ZONE_ICC_FORGE_OF_SOULS,
   --["Pit of Saron"] = GEM3_ZONE_ICC_PIT_OF_SARON,
   --["Halls of Reflection"] = GEM3_ZONE_ICC_HALLS_OF_REFLECTION,
   ["Citadelle de la Couronne de glace"] = GEM3_ZONE_ICC_RAID,
  };

elseif(loc == "deDE")
then
  -- Instance names
  GEM3_LOC_INSTANCE_NAMES = {
    ["Geschmolzener Kern"] = GEM3_INST_TAG_MC,

    ["Karazhan"] = GEM3_INST_TAG_KARA,
    ["Zul'Aman"] = GEM3_INST_TAG_ZA,
    ["Gruuls Unterschlupf"] = GEM3_INST_TAG_GRUUL,
    ["Magtheridons Kammer"] = GEM3_INST_TAG_MAGTH,
    ["Echsenkessel: Höhle des Schlangenschreins"] = GEM3_INST_TAG_SSC,
    ["Festung der Stürme"] = GEM3_INST_TAG_EYE,
    ["Die Schlacht um den Berg Hyjal"] = GEM3_INST_TAG_HYJAL,
    ["Der Schwarze Tempel"] = GEM3_INST_TAG_BT,
    -- Wotlk
    ["Naxxramas"] = GEM3_INST_TAG_NAXXRAMAS, -- Unsure
    ["Das Obsidiansanktum"] = GEM3_INST_TAG_CHAMBEROFASPECTS,
    --["The Eye of Eternity"] = GEM3_INST_TAG_EYEOFETERNITY, -- Unsure
    ["Schlacht um Tausendwinter"] = GEM3_INST_TAG_WINTERGRASP,
    ["Ulduar"] = GEM3_INST_TAG_ULDUAR, -- Unsure
  };

  -- Zone names
  GEM3_LOC_ZONE_NAMES = {
   -- Capitals
--~    [""] = GEM3_ZONE_DALARAN,
--~    [""] = GEM3_ZONE_ORGRIMMAR,
--~    [""] = GEM3_ZONE_THUNDERBLUFF,
--~    [""] = GEM3_ZONE_UNDERCITY,
--~    [""] = GEM3_ZONE_SILVERMOON,
--~    [""] = GEM3_ZONE_IRONFORGE,
--~    [""] = GEM3_ZONE_STORMWIND,
--~    [""] = GEM3_ZONE_DARNASSUS,
--~    [""] = GEM3_ZONE_EXODAR,
--~    [""] = GEM3_ZONE_SHATTRATH,
   -- LK Outside
   ["Boreanische Tundra"] = GEM3_ZONE_BOREAN_TUNDRA,
   ["Kristallsangwald"] = GEM3_ZONE_CRYSTALSONG_FOREST,
   ["Dalaran"] = GEM3_ZONE_DALARAN,
   ["Drachenöde"] = GEM3_ZONE_DRAGONBLIGHT,
   ["Grizzlyhügel"] = GEM3_ZONE_GRIZZLY_HILLS,
   ["Der heulende Fjord"] = GEM3_ZONE_HOWLING_FJORD,
   ["Eiskrone"] = GEM3_ZONE_ICECROWN,
   ["Sholazarbecken"] = GEM3_ZONE_SHOLAZAR_BASIN,
   ["Die Sturmgipfel"] = GEM3_ZONE_THE_STORM_PEAKS,
   ["Tausendwintersee"] = GEM3_ZONE_WINTERGRASP,
   ["Zul'Drak"] = GEM3_ZONE_ZUL_DRAK,
   --["Hrothgar's Landing"] = GEM3_ZONE_HROTHGAR_LANDING,
   -- LK Instances
   ["Burg Utgarde"] = GEM3_ZONE_UTGARDE_KEEP,
   ["Turm Utgarde"] = GEM3_ZONE_UTGARDE_PINNACLE,
   ["Feste Drak'Tharon"] = GEM3_ZONE_DRAK_THARON,
   ["Gundrak"] = GEM3_ZONE_GUNDRAK,
   ["Die Hallen der Blitze"] = GEM3_ZONE_HALLS_LIGHTNING,
   ["Die Hallen des Steins"] = GEM3_ZONE_HALLS_STONE,
   ["Azjol-Nerub"] = GEM3_ZONE_AZJOL_NERUB,
   ["Ahn'kahet: Das Alte Königreich"] = GEM3_ZONE_AHN_KAHET,
   ["Die Violette Festung"] = GEM3_ZONE_VIOLET_HOLD,
   ["Der Oculus"] = GEM3_ZONE_OCULUS,
   ["Der Nexus"] = GEM3_ZONE_NEXUS,
   ["Das Ausmerzen von Stratholme"] = GEM3_ZONE_CULLING_STRATHOLME,
   ["Ulduar"] = GEM3_ZONE_ULDUAR, -- Unsure
  };

elseif(loc == "esES")
then
  -- Instance names
  GEM3_LOC_INSTANCE_NAMES = {
  };

  -- Zone names
  GEM3_LOC_ZONE_NAMES = {
  };

elseif(loc == "esMX")
then
  -- Instance names
  GEM3_LOC_INSTANCE_NAMES = {
  };

  -- Zone names
  GEM3_LOC_ZONE_NAMES = {
  };

elseif(loc == "koKR")
then
  -- Instance names
  GEM3_LOC_INSTANCE_NAMES = {
  };

  -- Zone names
  GEM3_LOC_ZONE_NAMES = {
  };

elseif(loc == "zhCN")
then
  -- Instance names
  GEM3_LOC_INSTANCE_NAMES = {
  };

  -- Zone names
  GEM3_LOC_ZONE_NAMES = {
  };

elseif(loc == "zhTW")
then
  -- Instance names
  GEM3_LOC_INSTANCE_NAMES = {
  };

  -- Zone names
  GEM3_LOC_ZONE_NAMES = {
  };

elseif(loc == "ruRU")
then
  -- Instance names
  GEM3_LOC_INSTANCE_NAMES = {
  };

  -- Zone names
  GEM3_LOC_ZONE_NAMES = {
  };

else
  -- Instance names
  GEM3_LOC_INSTANCE_NAMES = {
  };

  -- Zone names
  GEM3_LOC_ZONE_NAMES = {
  };

end
