MovixLib_DebugLevel = false
if(not GridLib) then
  GridLib = {};
  GridLib.DateSeperator = ".";
  GridLib.TimeSeperator = ":";
  GridLib.version = 1 
end

if GridLib.DataSources == nil then GridLib.DataSources = {} end

if not GridLib.Grids then GridLib.Grids = {} end

MovixLib_DDMenuFrame = CreateFrame("FRAME", "MovixLib_DDMenuFrame", nil, "UIDropDownMenuTemplate");

MovixLib_Tables = {};

MovixLib_controls  = {};
MovixLib_controls.used = {
 ["string"] = {},
 ["texture"] = {},
 ["boolean"] = {},
 ["button"] = {},
-- ["table"] = {},
 ["custom"] = {},
 }
MovixLib_controls.free = {
 ["string"] = {},
 ["texture"] = {},
 ["boolean"] = {},
 ["button"] = {},
-- ["table"] = {},
 ["custom"] = {},
 }


function MovixLib_FrameEditGrids_OnLoad(self)
 self:RegisterEvent("VARIABLES_LOADED")
end

function MovixLib_FrameEditGrids_OnShow(self)
    --MovixLib_GridUI_CreateFillGridsList()
    if self.gridid then
     MovixLib_LoadGridConfig(self.gridid)
    end
    --MovixLib_GridUI_CreateDatasourceList()
end

function MovixLib_FrameEditGrids_OnEvent (self, event, ...)
 if event == "VARIABLES_LOADED" then 
  --MovixLib_GridUI_CreateFillGridsList()
 end
end


function MovixLib_GridListsContextMenuShow(p, row, col)
 local data = p.data[row].name
 MovixLib_GridListsContextMenu(data, MovixLib_GridDelete)
end

function MovixLib_GridDelete(data)
 if not data then return end
  GridLib.Grids[data] = nil
  MovixLib_GridUI_BuildGridsList()
  MovixLib_GridUI_FillGridsList()
end


function MovixLib_DatasourceListsContextMenuShow(p, row, col)
 local data = p.data[row].name
 MovixLib_GridListsContextMenu(data, MovixLib_DatasourceDelete)
end

function MovixLib_DatasourceDelete(data)
 if not data then return end
  GridLib.DataSources[data] = nil
  MovixLib_GridUI_FillDatasourceList()
end



function MovixLib_GridUI_BuildGridsList()
    MovixLib_ReleaseTable(MovixLib_Grid.Gridlist)
    MovixLib_Grid.Gridlist = MovixLib_GetTable()
    for index, gridstruct in pairs (GridLib.Grids) do
        table.insert(MovixLib_Grid.Gridlist ,{name = index})
    end
end

function MovixLib_GridUI_FillGridsList()
    local parent = getglobal("MovixLib_Frame_Gridslist");
    MovixLib_FillData(parent);
    MovixLib_RefreshGrid(parent, true, true)
end

function MovixLib_GridUI_CreateFillGridsList()
    local parent = getglobal("MovixLib_Frame_Gridslist");
    MovixLib_GridUI_BuildGridsList()
    parent.gridid = "MovixLib_Frame_Gridslist"
    if not GridLib.Grids["MovixLib_Frame_Gridslist"] then
        GridLib.Grids["MovixLib_Frame_Gridslist"] = MovixLib_TblCpy(GM_Grids["MovixLib_Frame_Gridslist"])
    end
    MovixLib_GetGridDefaults(parent, "MovixLib_Frame_Gridslist", "MovixLib_Grid.Gridlist")
    parent.GridParams.OnClickFoo = "MovixLib_LoadGridDef"
    parent.GridParams.OnRclickFoo = "MovixLib_GridListsContextMenuShow"
    MovixLib_GridUI_FillGridsList()
end


function MovixLib_GridUI_FillDatasourceList()
    local parent = getglobal("MovixLib_Frame_Datasourcelist");
    MovixLib_FillData(parent);
    MovixLib_RefreshGrid(parent, true, true)
end

function MovixLib_GridUI_CreateDatasourceList()
    local parent = getglobal("MovixLib_Frame_Datasourcelist");
    parent.gridid = "MovixLib_Frame_Datasourcelist"
    MovixLib_GetGridDefaults(parent, parent.gridid, "GridLib.DataSources")
    parent.GridParams.OnClickFoo = "MovixLib_PreviewDataSource"
    parent.GridParams.OnRclickFoo = "MovixLib_DatasourceListsContextMenuShow"
    MovixLib_GridUI_FillDatasourceList()
end

function MovixLib_AddDataSource(name)
    if not GridLib.DataSources[name] then
     GridLib.DataSources[name] = {name = name}
    end
    MovixLib_GridUI_FillDatasourceList()
end

function MovixLib_PreviewDataSource(p, row, col)
  local name = p.data[row].name
  local parent = getglobal("MovixLib_Grid_OptionsFrameGrid");
  MovixLib_GetGridDefaults(parent, name, name)
  MovixLib_FillData(parent);
  MovixLib_RefreshGrid(parent, true, true)
end

function MovixLib_GetDataSource(name)
  foo = loadstring("return " .. name)
  local datasource = foo();
  if type(datasource) == "table" then
    return datasource
  elseif type(datasource) == "function" then
    return datasource()
  else
   return nil
  end
end

function MovixLib_Grid_Options_CreateHeadersFromSource(self)
--    local headers = MovixLib_Grid_CreateHeadersFromData(getglobal(self:GetParent():GetName().."DataSource")):GetText())
end

function MovixLib_LoadGridDef(p, row, col)
 local name = p.data[row].name
 MovixLib_LoadGridConfig(name)
end

function MovixLib_LoadGridConfig(name)
 MovixLib_GridConfigNameLabel:SetText(name)
 --local parent = GridLib.Grids[name].GridParams.parent
 --MovixLib_GetGridDefaults(parent, name)
 --MovixLib_FillData(parent);
 --MovixLib_RefreshGrid(parent, true, true)
 --MovixLib_GridUI_GridParams.GridName = name
 MovixLib_GridUI_GridParams.Grid = GridLib.Grids[name]
 --MovixLib_GridConfigPreviewLabelLabel:SetText("GridID = "..(name or "NIL").." - Datasource = "..(GridLib.Grids[name].GridParams.DataSource or "NIL"))
 if MovixLib_GridUI_GridParams.activebutton then
    MovixLib_GridUI_GridParams_OnPanelButtonClick(MovixLib_GridUI_GridParams.activebutton)
 else
    MovixLib_GridUI_GridParams_OnPanelButtonClick()
 end
 
end


function MovixLib_GridUI_CopyGridTo_OnShow(self)
 MovixLib_GridUI_CopyGridResetName(self)
 MovixLib_GridUI_CopyGridTo_Refresh(self)
end

function MovixLib_GridUI_CopyGridResetName(self)
 if MovixLib_GridUI_CopyGridToDestinationName:GetText() == "" then
    if MovixLib_GridUI_CopyGridToAsDefault:GetChecked() then
        MovixLib_GridUI_CopyGridToNameSourceLabel:SetText("Defaults")
    elseif MovixLib_GridUI_CopyGridToAsGrid:GetChecked() then
        MovixLib_GridUI_CopyGridToDestinationName:SetText("NewGrid")
        MovixLib_GridUI_CopyGridToNameSourceLabel:SetText("Grid name")
    else
        MovixLib_GridUI_CopyGridToDestinationName:SetText("NewVar")
        MovixLib_GridUI_CopyGridToNameSourceLabel:SetText("Var name")
    end
 end
 MovixLib_GridUI_CopyGridTo_Refresh(self)
end

function MovixLib_GridUI_CopyGridTo_Refresh(self)
    local destination = MovixLib_GridUI_CopyGridToDestinationName:GetText() or MovixLib_GridUI_GridParams.GridName
    local default_flag = "";
    MovixLib_GridUI_CopyGridToDestinationName:SetText(destination)
    
    if self:GetName() == "MovixLib_GridUI_CopyGridToAsGrid" then
        MovixLib_GridUI_CopyGridToAsVar:SetChecked(false)
    elseif self:GetName() == "MovixLib_GridUI_CopyGridToAsVar" then
        MovixLib_GridUI_CopyGridToAsGrid:SetChecked(false)
    elseif self:GetName() == "MovixLib_GridUI_CopyGridToAsDefault" then
        if MovixLib_GridUI_CopyGridToAsDefault:GetChecked() then
--            default_flag = "  ( as Defaults)" 
        end
    end
    
    if MovixLib_GridUI_CopyGridToAsGrid:GetChecked() then
      destination = "GridLib.Grids['"..destination.."']"
    end
    destination = destination .. default_flag
    MovixLib_GridUI_CopyGridToDestinationPreviewLabel:SetText(destination)
end

function MovixLib_GridUI_CopyGridToSave_OnClick(self, button)
    local parent = self:GetParent();
    local destination = MovixLib_GridUI_CopyGridToDestinationPreviewLabel:GetText()
    local kids = { parent:GetChildren() };
    for _, child in ipairs(kids) do
      if child.source then
        if child:GetChecked() then
            if MovixLib_GridUI_CopyGridToAsGrid:GetChecked() then
                local dest = MovixLib_GridUI_CopyGridToDestinationName:GetText()
                if GridLib.Grids[dest] == nil then
                    GridLib.Grids[dest] = MovixLib_GetTable()
                end
                GridLib.Grids[dest][child.source] = MovixLib_TblCpy(MovixLib_GridUI_GridParams.Grid[child.source])
            else           
                local destfoo = assert(loadstring([[
                    return
                    function(section, var)
                        if not ]] ..destination.. [[ then ]] ..destination.. [[ = MovixLib_GetTable(); end; 
                        ]] ..destination.. [[['section'] = var; return ]]..destination..[[;
                     end
                  ]]
                ))
                local func  = destfoo()
                func(child.source, MovixLib_TblCpy(GridLib.Grids[MovixLib_GridUI_GridParams.GridName]))
            end
        end
      end
    end
    MovixLib_GridUI_FillDatasourceList()
    MovixLib_FillData(MovixLib_Frame_Gridslist);
    MovixLib_RefreshGrid(MovixLib_Frame_Gridslist, true, true)
end

function MovixLib_GridUI_CopyGridToSave_OnClick___TEST(self, button)
    local parent = self:GetParent();
    local kids = { parent:GetChildren() };
    for _, child in ipairs(kids) do
      if child.source then
        if child:GetChecked() then
            local savepanel = getglobal("MovixLib_GridUI_GridParams_OptionPanel_"..child.source)
            MovixLib_Frame_Gridoptions_Save(savepanel, MovixLib_GridUI_CopyGridToAsDefault:GetChecked(), MovixLib_GridUI_CopyGridToDestinationPreviewLabel:GetText())
        end
      end
    end
    MovixLib_GridUI_FillDatasourceList()
end



function MovixLib_Grid_CopyGridTo_OnClick(self)
 MovixLib_GridUI_CopyGridTo:SetParent(UIParent)
 MovixLib_GridUI_CopyGridTo:ClearAllPoints()
 MovixLib_GridUI_CopyGridTo:SetWidth(495)
 MovixLib_GridUI_CopyGridTo:SetHeight(204)
 MovixLib_GridUI_CopyGridTo:SetPoint("CENTER")
 MovixLib_GridUI_CopyGridToCopyTitleLabel:SetText(MovixLib_GridUI_GridParams.GridName)
 MovixLib_GridUI_CopyGridTo.Grid = MovixLib_GridUI_GridParams.Grid
 MovixLib_GridUI_CopyGridTo:Show()
end

function MovixLib_GridUI_GridParams_OnPanelButtonClick(self)
    if self == nil then
        self = MovixLib_GridUI_GridParams_selectPanel_Grid
    end
    local parent = self:GetParent()
    if parent.activepanel ~= nil then
        parent.activepanel:Hide()
    end
    if parent.activebutton then
        parent.activebutton:SetButtonState("PUSHED", false)
        parent.activebutton:UnlockHighlight()
    end
    self:SetButtonState("NORMAL", false)
    self:LockHighlight()
    parent.activebutton = self
    parent.panel = self.source
    if self.source == "grid" then
        parent.activepanel = MovixLib_GridUI_GridParams_OptionPanel_grid
        MovixLib_GridUI_GridParams_OptionPanel.GridParams = MovixLib_GridUI_GridParams.Grid.GridParams
        MovixLib_GridUI_GridParams_OptionPanel.DGridParams = MovixLib_GridUI_GridParams.Grid.DGridParams
    elseif self.source == "column" then
        parent.activepanel = MovixLib_GridUI_GridParams_OptionPanel_column
        MovixLib_GridUI_GridParams_OptionPanel.Headers = MovixLib_GridUI_GridParams.Grid.Headers
    elseif self.source == "rights" then
        parent.activepanel = MovixLib_GridUI_GridParams_OptionPanel_rights
        MovixLib_GridUI_GridParams_OptionPanel.Headers = MovixLib_GridUI_GridParams.Grid.Headers
        MovixLib_GridUI_GridParams_OptionPanel.GridParams = MovixLib_GridUI_GridParams.Grid.GridParams
    elseif self.source == "line" then
        parent.activepanel = MovixLib_GridUI_GridParams_OptionPanel_line
        MovixLib_GridUI_GridParams_OptionPanel.GridParams = MovixLib_GridUI_GridParams.Grid.GridParams
        MovixLib_GridUI_GridParams_OptionPanel.Headers = MovixLib_GridUI_GridParams.Grid.Headers
    elseif self.source == "colors" then
        parent.activepanel = MovixLib_GridUI_GridParams_OptionPanel_colors
        MovixLib_GridUI_GridParams_OptionPanel.Headers = MovixLib_GridUI_GridParams.Grid.Headers
    elseif self.source == "data" then
        parent.activepanel = MovixLib_GridUI_GridParams_OptionPanel_data
        MovixLib_GridUI_GridParams_OptionPanel.DataGrid = MovixLib_GridUI_GridParams.Grid.DataGrid
    elseif self.source == "filters" then
        parent.activepanel = MovixLib_GridUI_GridParams_OptionPanel_filters
        MovixLib_GridUI_GridParams_OptionPanel.Headers = MovixLib_GridUI_GridParams.Grid.Headers
    elseif self.source == "functions" then
        parent.activepanel = MovixLib_GridUI_GridParams_OptionPanel_functions
        MovixLib_GridUI_GridParams_OptionPanel.Headers = MovixLib_GridUI_GridParams.Grid.Headers
    end
    MovixLib_GridConfigPanelLabel:SetText("Options : "..self.source)
    parent.activepanel:Show()    
end

function MovixLib_Frame_Gridoptions_Refresh(self)
    local kids = { self:GetChildren() };
    for _, child in ipairs(kids) do
      if child.field then
       child:Hide()
       child:Show()
      end
    end
end

function MovixLib_Frame_Gridoptions_Grid_Onshow(self)
    self.GridParams = MovixLib_GridUI_GridParams_OptionPanel.GridParams
    self.DGridParams = MovixLib_GridUI_GridParams_OptionPanel.DGridParams
    MovixLib_Frame_Gridoptions_Refresh(self)
    self:SetAllPoints()
end

function MovixLib_Frame_Gridoptions_Line_Onshow(self)
    self.GridParams = MovixLib_GridUI_GridParams_OptionPanel.GridParams
    self.Headers = MovixLib_GridUI_GridParams_OptionPanel.Headers
    MovixLib_Frame_Gridoptions_Refresh(self)
    self:SetAllPoints()
end


function MovixLib_Frame_Gridoptions_Save(self, asdefault, destination)
    local dest = self
    if destination then
     local destfoo = assert(loadstring("return "..destination..";"))
     dest = destfoo()
     if dest == nil then
      local destfoo = assert(loadstring("return function(var) "..destination.." = var; return "..destination.."; end"))
      local func  = destfoo()
      dest = func(MovixLib_GetTable())
      dest.GridParams = MovixLib_GetGridParamsDefaults()
     else
        tdbg("MUST DO OVERWRITE PROTECTION")
     end
    end
    local kids = { self:GetChildren() };
    for _, child in ipairs(kids) do
      if child.field then
       if child.GetChecked then
        local val = child:GetChecked()
        if not dest[child.datasource] then 
            dest[child.datasource] = MovixLib_GetTable()
        end
        dest[child.datasource][child.field] = val

       elseif child.GetText then
        local val = child:GetText()
        if not dest[child.datasource] then 
            dest[child.datasource] = MovixLib_GetTable()
        end
        if not val or val == "" then
            dest[child.datasource][child.field] = nil
        elseif tonumber(val) then
            dest[child.datasource][child.field] = tonumber(val)
        else
            dest[child.datasource][child.field] = val
        end
       end
      end
    end
    local GridParams = MovixLib_GridUI_GridParams_OptionPanel.GridParams
    if not destination then
     MovixLib_RefreshGrid(getglobal(GridParams.parent), true, false)
    end
end



function MovixLib_Frame_Gridoptions_OnSave(self, button)
 local parent = self:GetParent()
 MovixLib_Frame_Gridoptions_Save(parent.activepanel)
end


function MovixLib_Frame_Gridoptions_Rights_Onshow(self)
    local Headers = MovixLib_GridUI_GridParams_OptionPanel.Headers
    MovixLib_GridEdit_ColumnList = {}
    for colid, column in ipairs (Headers) do
     MovixLib_GridEdit_ColumnList[colid] = {id = colid, name = column.lbl}
    end
    
    local parent = MovixLib_GridUI_GridParams_OptionPanel_rights_List
    parent.gridid = "MovixLib_GridUI_GridParams_OptionPanel_column_List"
    MovixLib_GetGridDefaults(parent, parent.gridid, "MovixLib_GridEdit_ColumnList")
    
    parent.GridParams.OnClickFoo = "MovixLib_GridEdit_rights_OnSelect"
    MovixLib_FillData(parent);
    MovixLib_RefreshGrid(parent, true, true)
    
    self.GridParams = MovixLib_GridUI_GridParams_OptionPanel.GridParams
    self:SetAllPoints()
    MovixLib_Frame_Gridoptions_Refresh(self)
end


function MovixLib_Frame_Gridoptions_Column_Onshow(self)
    local Headers = MovixLib_GridUI_GridParams_OptionPanel.Headers
    self:SetAllPoints()
    MovixLib_GridEdit_ColumnList = {}
    for colid, column in ipairs (Headers) do
     MovixLib_GridEdit_ColumnList[colid] = {id = colid, name = column.lbl}
    end
    
    local parent = MovixLib_GridUI_GridParams_OptionPanel_column_List
    parent.gridid = "MovixLib_GridUI_GridParams_OptionPanel_column_List"
    MovixLib_GetGridDefaults(parent, parent.gridid, "MovixLib_GridEdit_ColumnList")
    
    parent.GridParams.OnClickFoo = "MovixLib_GridEdit_column_OnSelect"
    MovixLib_FillData(parent);
    MovixLib_RefreshGrid(parent, true, true)

end

function MovixLib_GridEdit_column_OnSelect(p, row, col)
    local Headers = MovixLib_GridUI_GridParams_OptionPanel.Headers
    --local Gridparams = MovixLib_GridUI_GridParams_OptionPanel.Gridparams
    MovixLib_GridUI_GridParams_OptionPanel_column.column = Headers[p.data[row].id]
    MovixLib_Frame_Gridoptions_Refresh(MovixLib_GridUI_GridParams_OptionPanel_column)
end

function MovixLib_GridEdit_rights_OnSelect(p, row, col)
    local Headers = MovixLib_GridUI_GridParams_OptionPanel.Headers
    local GridParams = MovixLib_GridUI_GridParams_OptionPanel.GridParams
    MovixLib_GridUI_GridParams_OptionPanel_rights.rights = Headers[p.data[row].id]
    MovixLib_Frame_Gridoptions_Refresh(MovixLib_GridUI_GridParams_OptionPanel_rights)
end

function Movixlib_GetColumnParam(gridid, col, param)
 local G = GridLib.Grids[gridid]
 local colid = col.pos
 local inherits = nil
 if G and G.Headers and G.Headers[colid] then -- IF individual params defined
        if G.Headers[colid][param] then -- if this param exists
            return G.Headers[colid][param]
        end
 end
 if G and G.DHeaders then -- IF individual params defined
    for cid, c in ipairs(G.DHeaders) do
        if c.lbl == col.lbl then -- if this param exists
            return c[param]
        end
    end
 end

 if G and G.DGridParams then -- IF default params defined
        inherits = G.DGridParams.inherits
 end
 if inherits then
    return Movixlib_GetColumnParam(inherits, col, param)
 else
    local h = MovixLib_Grid_CreateHeadersFromData(Movixlib_GetGridParam(gridid, "DataSource"))
    return h[param]
 end
end

function Movixlib_GetGridParam(gridid, param)
    local G = GridLib.Grids[gridid]
    if not G then return Movixlib_Default_GridParams[param] end
    local inherits = nil
    if G.GridParams then -- IF individual params defined
        if G.GridParams[param] then -- if this param exists
            return G.GridParams[param]
        end
    end
    if G.DGridParams then -- IF default params defined
        inherits = G.DGridParams.inherits
        if G.DGridParams[param] then -- if this param exists
            return G.DGridParams[param]
        end
    end
    if inherits then -- IF Inherits defined look there
        return Movixlib_GetGridParam(inherits, param)
    else -- else if nothing found get defaults
        return Movixlib_Default_GridParams[param]
    end
end


function MovixLib_GetGridParamsDefaults()
    return MovixLib_TblCpy(Movixlib_Default_GridParams)
end


function MovixLib_GetGridDefaults(parent, name, datasource, inherits, defaults)
   if not name then name = parent.gridid end
   if not name then error ("Grid name not defined") end
   parent.gridid = name
   if not GridLib.Grids[name] then
    GridLib.Grids[name] = MovixLib_GetTable()
   end
   
   --[[parent.Headers= nil
   parent.DHeaders= nil
   parent.GridParams = nil
   parent.DGridParams = nil
   parent.ComputedLineHeight = nil
   parent.linecount = nil
   parent.offset=0
   parent.columns = nil 
   parent.HeaderLine = nil
   if parent.lines then 
        for k, gl in pairs(parent.lines) do 
            for ind, ctrl in pairs(gl.cols) do
                MovixLib_ReleaseControlObject(ctrl:GetName())
                gl.cols[ind]:Hide()
                gl.cols[ind] = nil
            end
            gl.lineoptions = nil
            gl.parent = nil
            gl.cols = nil
            gl.OddEven = nil
            parent.lines[k]:Hide()
            parent.lines[k] = nil
            
        end
        parent.lines= nil
   end]]--

   
   local G = GridLib.Grids[name]
   
   
   -- Grid default Params
   
   
   
   if G.DGridParams == nil then
    G.DGridParams = MovixLib_GetTable()

    if inherits then
        G.DGridParams.inherits = inherits
    else
        G.DGridParams = MovixLib_TblCpy(Movixlib_Default_GridParams)
    end
   end
   
   if datasource then G.DGridParams.DataSource = datasource end
   
   parent.DGridParams = G.DGridParams

   -- Grid Current Params
   if G.GridParams == nil then
    G.GridParams = MovixLib_GetTable();
   end
   parent.GridParams = G.GridParams 
   parent.GridParams.parent = parent:GetName() 
   
   -- Grid Default Headers
   if not G.DHeaders then
    if inherits then
        G.DHeaders = GridLib.Grids[inherits].Headers or GridLib.Grids[inherits].DHeaders
    end
    if not G.DHeaders then
        G.DHeaders = MovixLib_Grid_CreateHeadersFromData(G.DGridParams.DataSource or G.GridParams.DataSource)
    end
   end
   parent.DHeaders = G.DHeaders
   
   -- Grid current Headers
   if not G.Headers then
     G.Headers = MovixLib_TblCpy(G.DHeaders)
   end
   parent.Headers = G.Headers

   return G
end   

function MovixLib_ModifyDateString(datestr, new_datestr)
        if datestr == "%default" then 
            datestr = MovixLib_DefaultDateStrings
        end
        if not string.find(datestr, "%",1, true) then
         datestr = ""
        end
        local scoltype = string.gsub(new_datestr, "%%", "%%%%")
        --tdbg("new_datestr : "..new_datestr)
        local strmoreplace = nil;
        -- search replacements
        -- Month switch
        if (new_datestr == "%m" or new_datestr == "%lmonth") and string.find(datestr, "%smo", 1, true) then
            strmoreplace = "%%smo"
        elseif (new_datestr == "%smo" or new_datestr == "%lmonth") and string.find(datestr, "%m", 1, true) then
            strmoreplace = "%%m"
        elseif (new_datestr == "%m" or new_datestr == "%smo") and string.find(datestr, "%lmonth", 1, true) then
            strmoreplace = "%%lmonth"
        -- Year switch
        elseif new_datestr == "%y" and string.find(datestr, "%Y", 1, true) then
         strmoreplace = "%%Y"
        elseif new_datestr == "%Y" and string.find(datestr, "%y", 1, true) then
         strmoreplace = "%%y"
        --wday switch
        elseif new_datestr == "%A" and string.find(datestr, "%wday", 1, true) then
            strmoreplace = "%%wday"
        elseif new_datestr == "%wday" and string.find(datestr, "%A", 1, true) then
            strmoreplace = "%%A"
        -- 24h / 12h swtich
        elseif new_datestr == "%H" and string.find(datestr, "%I", 1, true) then
            strmoreplace = "%%I"
        elseif new_datestr == "%I" and string.find(datestr, "%H", 1, true) then
            strmoreplace = "%%H"
        end
    
        if new_datestr ~= (strmoreplace or new_datestr) then
            datestr = string.gsub(datestr, strmoreplace, scoltype) 
            --MovixLib_RefreshGrid(p);
            return datestr
        end
        
        
        if string.find(datestr, "%%") or string.len(datestr or "") == 0  then
            -- escape pattern
            -- if present then remove
            if string.find(datestr, new_datestr,1 ,true) then
                datestr = string.gsub(datestr, scoltype, "")
                if new_datestr == "%H" then
                -- if hour removed, remove minutes and seconds also
                    if string.find (datestr, "%M", 1, true) then
                        datestr = string.gsub(datestr, "%%M", "")
                    end
                    if string.find (datestr, "%S", 1, true) then
                        datestr = string.gsub(datestr, "%%S", "")
                    end
                end
                
                if string.find (new_datestr, "%A", 1, true)
                or string.find (new_datestr, "%wday", 1, true)
                or string.find (new_datestr, "%ReplWeek", 1, true)
                or string.find (new_datestr, "%ReplTomorrow", 1, true)
                or string.find (new_datestr, "%ReplToday", 1, true)
                or string.find (new_datestr, "%ReplYesterday", 1, true)
                then
                  datestr = string.gsub(datestr, scoltype, "")
                end
                
                if new_datestr == "%I" then
                -- if hour removed, remove minutes and seconds also
                    if string.find (datestr, "%M", 1, true) then
                        datestr = string.gsub(datestr, "%%M", "")
                    end
                    if string.find (datestr, "%S", 1, true) then
                        datestr = string.gsub(datestr, "%%S", "")
                    end
                end
                
                if new_datestr == "%M" then
                -- if minutes removed, remove seconds also
                    if string.find (datestr, "%S", 1, true) then
                        datestr = string.gsub(datestr, "%%S", "")
                    end
                end   
       
                if (string.len(datestr) or 0) == 0 then
                -- If not date / time format left, set to default
                    datestr = MovixLib_Default_Timeformat;
                end
            else
            -- if not present then add it
                
                if string.find (new_datestr, "%A", 1, true)
                or string.find (new_datestr, "%wday", 1, true)
                or string.find (new_datestr, "%ReplWeek", 1, true)
                or string.find (new_datestr, "%ReplTomorrow", 1, true)
                or string.find (new_datestr, "%ReplToday", 1, true)
                or string.find (new_datestr, "%ReplYesterday", 1, true)
                then
                  datestr = datestr .. new_datestr
                end
                
                
                
                if string.find (new_datestr, "%H", 1, true) or string.find (new_datestr, "%I", 1, true) then
                  datestr = datestr .. new_datestr
                end
                
                if new_datestr == "%M" then
                -- if minutes addes
                    if not (string.find (datestr, "%H", 1, true) or string.find (datestr, "%I", 1, true)) then
                    -- add hours if not present
                        datestr = datestr.."%H"..new_datestr
                    else
                    --append minutes to hours
                     if string.find (datestr, "%I", 1, true) then
                        datestr = string.gsub(datestr, "I", "I"..scoltype)
                     else
                        datestr = string.gsub(datestr, "H", "H"..scoltype)
                     end
                    end
                end
                
                if new_datestr == "%S" then
                -- if seccondes added
                    if not string.find (datestr, "%H", 1, true) then
                    -- add hours and minutes if not present
                        datestr = datestr.."%H%M"..new_datestr
                    elseif not string.find (datestr, "%M", 1, true) then
                    -- add minutes if not prensent
                        datestr = string.gsub(datestr, "H", "H%%M"..scoltype)
                    else 
                    -- apprend to %H:%M
                        datestr = string.gsub(datestr, "H%%M", "H%%M"..scoltype)
                    end
                end
                
                if new_datestr == "%d" or new_datestr == "%m" or new_datestr == "%y" or new_datestr == "%Y" or new_datestr == "%smo" or new_datestr == "%lmonth" then
                -- if date item added
                    local Dpos = nil
                    local dpos = string.find (datestr, "%d", 1, true)
                    local ypos = string.find (datestr, "%y", 1, true)
                    if ypos == nil then ypos = string.find (datestr, "%Y", 1, true) end
                    local mpos = string.find (datestr, "%m", 1, true)
                    if mpos == nil then mpos = string.find (datestr, "%smo", 1, true) end
                    if mpos == nil then mpos = string.find (datestr, "%lmonth", 1, true) end
                    
                    if dpos then
                      if (ypos or 0 ) > dpos then dpos = nil end
                      if dpos and (mpos or 0 ) > dpos then dpos = nil end
                    end
                    
                    if mpos then
                     if (dpos or 0 ) > mpos then mpos = nil end
                     if mpos and (ypos or 0 ) > mpos then mpos = nil end
                    end
                    
                    if ypos then
                     if (ypos or 0 ) > ypos then ypos = nil end
                     if ypos and (dpos or 0 ) > ypos then ypos = nil end
                    end
                    if dpos then Dpos = "%%d" end
                    if ypos then 
                     if string.find (datestr, "%y", 1, true) then
                      Dpos = "%%y"
                     elseif string.find (datestr, "%Y", 1, true) then
                      Dpos = "%%Y"
                     end
                    end
                    if mpos then
                        if string.find (datestr, "%m", 1, true) then
                            Dpos = "%%m"
                        elseif string.find (datestr, "%smo", 1, true) then
                            Dpos = "%%smo"
                        elseif string.find (datestr, "%lmonth", 1, true) then
                            Dpos = "%%lmonth"
                        end
                    end
                    if Dpos then
                     datestr = string.gsub(datestr, Dpos, Dpos..scoltype)
                    else
                     datestr = datestr..new_datestr
                    end 
                end
                
            end
        else 
        -- append datestring or other format
            datestr = new_datestr
        end
    return datestr
end


function Movixlib_GetDateFormated(f, d)
 if type(d) ~= "number" then return d end
 local s = nil;
 local formatstring = "";
 local specialdate = nil;
 if f == "%default" then 
    f = MovixLib_DefaultDateStrings
 end
 local pos = string.find( f, "%", 1, true);
 while (pos) do
  local nextfspos = string.find(f, "%", pos+1, true)
  local nextfs = nil;
  local len
  s = " ";
  if nextfspos then
   nextfs = string.sub(f, nextfspos, nextfspos+1)
  end
  local fstring = string.sub(f, pos, ((nextfspos or 0) -1) );
  
  if nextfs and (fstring == "%d" or fstring == "%m" or fstring == "%y" or fstring == "%Y") then
    if nextfs == "%d" or nextfs == "%m" or nextfs == "%y" or nextfs == "%Y" then
     s = GridLib.DateSeperator;
    end
  end
  
  if (fstring == "%I"  or fstring == "%H" or fstring == "%M" or fstring == "%S") then
    local timesuffix = "";
    if nextfs and nextfs == "%I" or nextfs == "%H" or nextfs == "%M" or nextfs == "%S" then
     s = GridLib.TimeSeperator;
    else
     if string.find(f, "%I", 1, true) then 
      timesuffix = " %p";
     end
   end
   
   fstring = fstring .. timesuffix
  end 
  
  if string.find(f, "%ReplToday", 1, true) and not specialdate then
   if date("%d%m%y", time()) == date("%d%m%y", d) then
    formatstring = formatstring .. MovixLib_DateStrings.specialdays["today"] .. " "
    specialdate = true
   end
  end
  if string.find(f, "%ReplTomorrow", 1, true) and not specialdate  then
   if date("%d%m%y", time()+(1*MovixLib_OneDaySeconds)) == date("%d%m%y", d) then
    formatstring = formatstring .. MovixLib_DateStrings.specialdays["tomorrow"] .. " "
    specialdate = true
   end
  end
 if string.find(f, "%ReplYesterday", 1, true) and not specialdate then
   if date("%d%m%y", time()-(1*MovixLib_OneDaySeconds)) == date("%d%m%y", d) then
    formatstring = formatstring .. MovixLib_DateStrings.specialdays["yesterday"] .. " "
    specialdate = true
   end
  end
  
  if string.find(f, "%ReplWeek", 1, true) and not specialdate then
   for i=1, 6 do
    if date("%d%m%y", time()+(i*MovixLib_OneDaySeconds)) == date("%d%m%y", d) then
     formatstring = formatstring .. MovixLib_DateStrings["day"][tonumber(date("%w", d))] .. " "
     specialdate = true
    end
   end
  end
  
  if not specialdate then
   if fstring == "%wday" then
    formatstring = formatstring .. MovixLib_DateStrings["dayshort"][tonumber(date("%w", d))] .. s
   elseif fstring == "%A" then
    formatstring = formatstring .. MovixLib_DateStrings["day"][tonumber(date("%w", d))] .. s
   elseif fstring == "%smo" then
    formatstring = formatstring .. MovixLib_DateStrings["monthshort"][tonumber(date("%m", d))] .. s
   elseif fstring == "%lmonth" then
    formatstring = formatstring .. MovixLib_DateStrings["month"][tonumber(date("%m", d))] .. s
   else
    if  not (fstring == "%ReplTomorrow" or fstring == "%ReplToday" or fstring == "%ReplYesterday" or fstring == "%ReplWeek") then
     formatstring = formatstring .. date(fstring, d) .. s;
    end
   end
  else
    if  not (fstring == "%ReplTomorrow" or fstring == "%ReplToday" or fstring == "%ReplYesterday" or fstring == "%ReplWeek") 
    and not (    fstring == "%A" or fstring == "%wday" 
              or fstring == "%m" or fstring == "%smo" or fstring == "%lmonth"
              or fstring == "%d"
              or fstring == "%y" or fstring == "%Y"
            )
    then
     formatstring = formatstring .. date(fstring, d) .. s;
    end
  end
  pos = string.find( f, "%", pos+1, true );
 end
 
 return formatstring;
end

-- line format handling
function MovixLib_NewLineOptions (grid, index, ltype, height, maxh, minh, colors, valfoo, formfoo, clickfoo, dclickfoo, enterfoo, leavefoo)
 l = MovixLib_GetTable();
 l.index     = index
 l.ltype      = ltype or MovixLib_LineTypes_DATA
 l.height    = height or grid.GridParams.LineHeight or MovixLib_Grid.LineHeight
 --l.maxh      = maxh
 --l.minh      = minh
 -- TODO : l.visible   = NUMBER           -- column visible or not
 -- TODO : l.colors    = ARRAY            -- of color tables colors
 -- NEEDED ?? : valfoo    = FUNC             -- function valfoo(self, val, GRIDPARENT.cols[colpos]) that returns the cellvalue as a string or number or nil
 -- TODO : formfoo   = FUNC             -- function formfoo(self, val, GRIDPARENT.cols[colpos]) that returns a frame displaying the cell content or editcontrol as a frame (for cell type CUSTOM)
 -- TODO : clickfoo  = FUNC             -- function clickfoo(self, val, GRIDPARENT.cols[colpos]) that is triggered by wowAPI "OnClick"
 -- TODO : dclickfoo = FUNC             -- function dclickfoo(self, val, GRIDPARENT.cols[colpos])that is triggered by wowAPI "OnDoubleClick"
 -- TODO : enterfoo  = FUNC             -- function enterfoo(self, val, GRIDPARENT.cols[colpos])that is triggered by wowAPI "OnEnter"
 -- TODO : leavefoo  = FUNC             -- function leavefoo(self, val, GRIDPARENT.cols[colpos])that is triggered by wowAPI "OnLeave"
 return l
end


-- Col format handling

function MovixLib_NewCellOptions (valname, val, valtype, rights, pos, lbl, size, justify, visible, color, valfoo, formfoo, clickfoo, dclickfoo, enterfoo, leavefoo)
 local o = MovixLib_GetTable();
-- REQUIERED PARAMS
 -- in right structure true = allow edit value,  false = do not allow edit value
 o.val = valname

 -- in right structure true = change type,  false = do not allow change type
 local vtype = type(val)
 if vtype == "table" then vtype = "string" end
 o.type = (valtype or vtype)

-- OPTIONAL PARAMS
 -- no meaning in rights structure
 --                   MovixLib_NewCellOptions (valname, val,  valtype, rights, pos,  lbl,   size, justify, visible, colors)
 o.rights = rights
 
 -- in right structure true = allow column pos change,  false = do not allow column pos change
 o.pos = pos
 
 -- in right structure true = allow columnlabel rename,  false = do not allow columnlabel rename
 o.lbl = (lbl or valname or "Newcol")
 
 -- in right structure true = allow column resize,  false = do not allow column resize
 o.size = size or 50
 -- in right structure true = allow column justifying,  false = do not allow column pos justifying
 if not justify then
  if type(val) == "string" then justify="LEFT";
  elseif type(val) == "number" then justify="RIGHT";
  else justify="CENTER"; 
  end
 end 
 o.justify = justify
 
 -- in right structure -1 = do not allow column remove or add,  0 = allow all, n>0 allow add but n references to the column must stay
 if visible == nil then visible = true end
 o.visible = visible
 
 -- in right structure true = allow column color change,  false = do not allow column color change
 o.color =  color
 
 -- no meaning in rights structure
 o.valfoo = valfoo
 o.formfoo = formfoo
 o.clickfoo = clickfoo
 o.dclickfoo = dclickfoo
 o.enterfoo = enterfoo
 o.leavefoo = leavefoo
 
 return o;
end

function MovixLib_GetCellOption (o, option)
 if o == nil then return cel end
 return o[option]
end


function MovixLib_SetCellOption (o, option, value)
 if o == nil then return cel end
 o[option] = value
end


--------------- Table recycling functions ---------------

-- wipe table content
function MovixLib_WipeTable(t1,recurseCount)
  if(type(t1) ~= "table")
  then
    if(t1 == nil)
    then
      return MovixLib_GetTable();
    end
    return t1;
  end

  for k,v in pairs(t1)
  do
    if(recurseCount and (recurseCount > 0) and (type(v) == "table")) -- Recurse release table
    then
      MovixLib_ReleaseTable(v,recurseCount-1);
    end
    t1[k] = nil;
  end

  return t1;
end

function MovixLib_GetTable()
  local recTable;
  if(#MovixLib_Tables >= 1)
  then
    recTable = tremove(MovixLib_Tables);
  else
    recTable = {};
  end
  return recTable;
end

-- Definitly free table for next garbage collection
function MovixLib_ReleaseTable(t1,recurseCount)
  if(type(t1) ~= "table")
  then
    return;
  end
  
  for k,v in pairs(t1)
  do
    if(recurseCount and (recurseCount > 0) and (type(v) == "table")) -- Recurse release table
    then
      MovixLib_ReleaseTable(v,recurseCount-1);
    end
    t1[k] = nil;
  end
  
  tinsert(MovixLib_Tables,t1);
  return nil;
end

function MovixLib_TblCpy(tab)
  if(type(tab) ~= "table")
  then
    return nil;
  end
  local newtab = MovixLib_GetTable();
  for n,v in pairs(tab)
  do
    if(type(v) == "table") -- recurs dup
    then
      newtab[n] = MovixLib_TblCpy(v);
    else
      newtab[n] = v;
    end
  end
  return newtab;
end


-- Dropdown menus
function MovixLib_SetDDMenu(target, tbl)
   if target == nil then 
      target = "cursor";
   end
   if tbl == nil then
      tbl = MovixLib_DDTable
   end
   MovixLib_DDMenuAddLine({text = " ", disabled = true}, nil, tbl)
   MovixLib_DDMenuAddLine({text = CLOSE , func = function () MovixLib_DDMenuFrame:Hide() end}, nil, tbl)   
   MovixLib_DDMenuFrame:Show()
   EasyMenu(tbl, MovixLib_DDMenuFrame, target, 0,0, "MENU", 15);
end


function MovixLib_DDMenuAddLine(line, submenu, tbl)
 if tbl == nil then
  if MovixLib_DDTable == nil then
   MovixLib_DDTable = MovixLib_GetTable();
  end
 tbl = MovixLib_DDTable 
 end
 if submenu then
  for i, menuline in ipairs(tbl) do
   if menuline.menuList then
    MovixLib_DDMenuAddLine(line, submenu, menuline.menuList)
   end
   if menuline.value == submenu then
    if not menuline.menuList then
     menuline.menuList = MovixLib_GetTable();
    end
    table.insert(menuline.menuList, line)
   end
  end
 else
  table.insert(tbl, line)
 end
end


-- recycling grid controls
function MovixLib_GetControl(parent, ctype, colpos, formfoo)
    local control = nil;
    if ctype == "string" or ctype == "number" or string.find(ctype, "%", 1, true) then
     ctype = "string"
    end
    if ctype == "custom" then
        control = MovixLib_GetControlObject(parent:GetName(), ctype, nil, nil, formfoo)
    else
        control = MovixLib_GetControlObject(parent:GetName(), ctype)
    end
    control.hid = colpos
    return control;
end

function aMovixLib_ReleaseControl(control)
 if control == nil then return; end
 control = getglobal(control)
 if control == nil then return; end
 local ctype = control.ctype;
 if type(control) == "table" and (not ctype) then
  for ind, ctrl in pairs(control) do
   --MovixLib_ReleaseControlObject(ctrl)
  end
 else
  --MovixLib_ReleaseControlObject(control)
 end

end


function tdbg(...)
 if not MovixLib_DebugLevel then return end
 local msg = "";
 
 local num = select("#", ...)
 for i=1, num do
  txt = select(i, ...)
  if type(txt) == "nil" or type(txt) == "string" or type(txt) == "number" then
    msg = msg..(txt or "NIL")
  elseif type(txt) == "table" then
   msg = msg.."TYPE:"..type(txt)
   GEM3_PrintTable(txt)
  else
    msg = msg.."TYPE:"..type(txt)
  end
 end
 DEFAULT_CHAT_FRAME:AddMessage(msg, 1,1,1);
end

function MovixLib_ChatMessage(...)
 local msg = "";
 local num = select("#", ...)
 for i=1, num do
  txt = select(i, ...)
  if type(txt) == "nil" or type(txt) == "string" or type(txt) == "number" then
    msg = msg..(txt or "NIL")
  elseif type(txt) == "table" then
   msg = msg.."TYPE:"..type(txt)
   GEM3_PrintTable(txt)
  else
    msg = msg.."TYPE:"..type(txt)
  end
 end
 DEFAULT_CHAT_FRAME:AddMessage(msg, 1,1,1);
end


function MovixLib_RefreshGrid(parent, rebuild, resetfilters, init)
    if parent:IsVisible() or init then
        MovixLib_DrawHeaders(parent, rebuild, resetfilters);
        MovixLib_DrawGrid(parent, rebuild)
    end
end

function MovixLib_GridSetNewColPos(frame, col, old, new)
    --tdbg("OLD: ", old, " NEW: ", new)
    --for ind, sortcol in ipairs(frame.GridParams.sortcol or {}) do
        --if old == math.abs(sortcol) then
          --  frame.GridParams.sortcol[ind] = sortcol/math.abs(sortcol) * new
        --end
    --end
    col.pos = new
    frame.GridParams.sortcol = nil
end


function MovixLib_GetFilterText(col, val)
    local filtertext = "";
    if col.friendlyfoo then
        filtertext = MovixLib_GetTransformedValue(val, col.friendlyfoo, col.type)
    else
        filtertext = MovixLib_GetTransformedValue(val, col.valfoo, col.type)
    end
    if type(filtertext) == "boolean" then
        if filtertext == true then
            filtertext = "TRUE"
        else
            filtertext = "FALSE"
        end
    end
    if type(filtertext) == "nil" then
     filtertext = "NIL"
    end
    return filtertext;
end


function MovixLib_GetLineHeight(p)
   local h = Movixlib_GetGridParam(p.gridid, "LineHeight")
   local maxheight = h;
   local w;
   local j = 0;
   for colid, col in ipairs(p.Headers) do
        h = Movixlib_GetGridParam(p.gridid, "LineHeight")
        j = j + 1;
--        h = p.GridParams.LineHeight
        w = col.size
        -- if explicit size information is given take it
        if col.valw then w = col.valw end
        if col.valh then h = col.valh end
        -- if minimal size information is given and actual sire smaller then adjust
        if col.valminw and col.valminw > w then w = col.valminw end
        if col.valminh and col.valminh > h then h = col.valminh end
        -- if maximal size information is given and actual sire smaller then adjust
        if col.valmaxw and col.valmaxw < w then w = col.valmaxw end
        if col.valmaxh and col.valmaxh < h then h = col.valmaxh end
        -- if cell is taller than actual line height, change line height
        --col.ComputedH = h;
        col.ComputedW = w;
        col.ComputedH = h
        if maxheight < h then
         maxheight = h
        end
    end
    return maxheight;
end

function MovixLib_FormatRowCells(line)
   local j = 0;
   local p = line.parent;
   for colid, col in ipairs(p.Headers) do
        j = j + 1;
        colframe = line.cols[j]
        
        colframe:SetWidth(col.ComputedW)
        colframe:SetHeight(col.ComputedH)
        local hdif = line.lineoptions.height-col.ComputedH
        
        if string.upper(col.justify) == "CENTER" then
            colframe:SetPoint("TOPLEFT", col.Lpoint+((col.Rpoint-col.Lpoint)/2)-(col.ComputedW/2), (hdif/-2))
        
        elseif string.upper(col.justify) == "LEFT" then
            colframe:SetPoint("TOPLEFT", col.Lpoint, (hdif/-2))
        
        elseif string.upper(col.justify) == "RIGHT" then
            colframe:SetPoint("TOPLEFT", col.Rpoint - col.ComputedW, (hdif/-2))
        end
    end
end

function MovixLib_GetTransformedValue(val, foo_to_call, valtype)
 if foo_to_call then
    if foo_to_call ==  "Movixlib_GetDateFormated" then
        return Movixlib_GetDateFormated(valtype, val)
    else
        local foo = loadstring([[
                            return
                            function (val)
                                return ]] .. foo_to_call .. [[(val)
                            end
                         ]]
                        )
        func = foo();
        return func(val)
    end
 else
    return val
 end
end

function MovixLib_GetSortingValue(val, foo_to_call)
  local foo = loadstring([[
                            return
                            function (val)
                                return ]] .. foo_to_call .. [[(val)
                            end
                         ]]
                        )
    func = foo();
    return func(val)
end


function MovixLib_GetColorByFoo(colorfoo, val, row)
 local color = nil;
 if not val then val = row end
 if colorfoo then
    local foo = loadstring([[
                            return
                            function (val, CMD)
                                return ]] .. colorfoo .. [[(val, CMD)
                            end
                         ]]
                        )
    func = foo();
    color = func(val, "GET_COLOR")
 end
 return color
end


function MovixLib_SetFontStringParams(p, row, colframe, col, val)
  local dfontsize = Movixlib_GetGridParam(p.gridid, "ValueFontSize")
  local fontsize = dfontsize 
  if col.fontsize then
     fontsize = col.fontsize or dfontsize
  end

  if col.type == "button" then
        colframe:SetNormalFontObject(MovixLib_VerySmallFont);
  else
    colframe:SetJustifyH(col.justify);
    colframe:SetJustifyV("MIDDLE");
    local dcolor = Movixlib_GetGridParam(p.gridid, "DefaultTextColor")
    local color = dcolor
    if col.colorfoo then
        if col.colorfooval then
            color = MovixLib_GetColorByFoo(col.colorfoo, row[(col.colorfooval)]) or col.color or dcolor
        else
            color = MovixLib_GetColorByFoo(col.colorfoo, nil, row) or col.color or dcolor
        end
    else
      color = col.color or dcolor
    end
    colframe:SetTextColor(unpack (color))

    if type(colframe.SetNormalFontObject) == "function" then
        local font, size, flags = colframe:GetNormalFontObject();
        colframe:SetNormalFontObject(font, fontsize);
    else
        local font, size, flags = colframe:GetFont();
        colframe:SetFont(font, fontsize);
    end
  end
end

function MovixLib_SetTextureParams(p, colframe, col, row)
    local val = row[col.colorfooval]
    local dcolor = col.texturecolor 
          or col.colorfoo 
          or col.color
          or Movixlib_GetGridParam(p.gridid, "DefaultTextureColor") 
          or Movixlib_GetGridParam(p.gridid, "DefaultTextColor")
          
    if type (dcolor) == "string" then
      if val then  
        color = MovixLib_GetColorByFoo(dcolor, val)
      else
        color = MovixLib_GetColorByFoo(dcolor, nil, row)
      end
    elseif type (dcolor) == "table" then
      color = dcolor
    end
    colframe:SetVertexColor(unpack (color or {1,1,1,1}))
end

function MovixLib_ButtonPrepare(self)
  self:SetNormalFontObject("GameFontNormalSmall")
end

function MovixLib_Editbox_OnEnter(self)
end

function MovixLib_Editbox_OnLeave(self)
end

function MovixLib_Editbox_OnEscapePressed(self)
 self:ClearFocus()
end

function MovixLib_Editbox_OnEnterPressed(self)
 self:ClearFocus()
end

function MovixLib_Editbox_OnValueChanged(self)
end

function MovixLib_Editbox_OnShow(self)
 MovixLib_Editbox_LoadValue(self)
end

function MovixLib_Editbox_OnHide(self)
 --tdbg("H I D E ->", self:GetName())
end

function MovixLib_Editbox_Onload(self, datasource, field)
  local parent = self:GetParent()
  self.datasource = datasource
  self.field = field
end

function MovixLib_Editbox_LoadValue(self)
 local parent = self:GetParent()
 self:SetScript("OnEscapePressed", MovixLib_Editbox_OnEscapePressed)
 self:SetScript("OnEnterPressed", MovixLib_Editbox_OnEnterPressed)
 local datasource = parent[self.datasource]
  if datasource and self.field then
    if datasource[self.field] then
        self:SetText(datasource[self.field])
    else
        self:SetText("")
    end
  end
 
end

function MovixLib_Editbox_SaveValue(self)
 local parent = self:GetParent()
 local datasource = parent[self.datasource]
 if datasource and self.field then
    datasource[self.field] = self:GetText()
 end
end

--- checkbox
function MovixLib_Checkbox_OnShow(self)
 MovixLib_Checkbox_LoadValue(self)
end

function MovixLib_Checkbox_OnHide(self)
 --tdbg("H I D E ->", self:GetName())
end

function MovixLib_Checkbox_Onload(self, datasource, field)
  local parent = self:GetParent()
  self.datasource = datasource
  self.field = field
end

function MovixLib_Checkbox_LoadValue(self)
 local parent = self:GetParent()
 local datasource = parent[self.datasource]
  if datasource and self.field then
    if datasource[self.field] then
        self:SetChecked(datasource[self.field])
    else
        self:SetChecked(false)
    end
  end
 
end

function MovixLib_Checkbox_SaveValue(self)
 local parent = self:GetParent()
 local datasource = parent[self.datasource]
 if datasource and self.field then
    datasource[self.field] = self:GetChecked()
 end
end


--- localisation

function MovixLib_RegisterLocale(gridid, local_strings)
    if not GridLiblocalisation then
        GridLiblocalisation = {}
    end
    GridLiblocalisation[gridid] = local_strings
end

function MovixLib_GetLocale(string, gridid)
    if gridid then
        if GridLiblocalisation[gridid] and GridLiblocalisation[gridid][string] then
                return GridLiblocalisation[gridid][string]
        elseif MovixLib_LocalizedStrings[string] then
            return MovixLib_LocalizedStrings[string]
        else
            return string
        end
    else
        return MovixLib_LocalizedStrings[string] or string
    end
end




--- COLOR handling

function MovixLib_Grid_RegisterColor(gridid, name, foo, val, tooltip)
  if GridLib.Grids[gridid] then
        if not GridLib.Grids[gridid].DGridParams then
            GridLib.Grids[gridid].DGridParams = MovixLib_GetTable()
        end
  else
    GridLib.Grids[gridid] = MovixLib_GetTable()
    GridLib.Grids[gridid].DGridParams = MovixLib_GetTable()
  end
   
  if not GridLib.Grids[gridid].DGridParams.Colors then
   GridLib.Grids[gridid].DGridParams.Colors = MovixLib_GetTable()
  end
  
  if GridLib.Grids[gridid].DGridParams.Colors[name] then
    GridLib.Grids[gridid].DGridParams.Colors[name].name = name
    GridLib.Grids[gridid].DGridParams.Colors[name].foo = foo
    GridLib.Grids[gridid].DGridParams.Colors[name].colval = val
    GridLib.Grids[gridid].DGridParams.Colors[name].tooltip=tooltip
  else
    GridLib.Grids[gridid].DGridParams.Colors[name] = {name = name, foo = foo, colval = val, tooltip=tooltip}
  end
end
