local bor = bit.bor
local band = bit.band
local tinsert = table.insert
local tremove= table.remove
local tsort= table.sort
local sfind = string.find
local sformat = string.format
local strsub = string.sub
local strfind = string.find
local strlen = string.len

function GEM3UI_EventNameFilterDD(self)
 local flton = false;
 local fltoff = false;
 if GEM3UI_EventNameFilters == nil then
  GEM3UI_EventNameFilters = GA_GetTable();
 end
 
 for i, evt in pairs(GEM3UI_EventSource) do
  if not GEM3UI[UnitName("Player")].OnlyMyChannels or (GEM3UI[UnitName("Player")].OnlyMyChannels and GEM3_PLAY_IsPlayerInChannel(evt.channel,UnitName("player"))) then
   if GEM3UI_EventNameFilters[evt.ev_place] == nil then
    if GEM3UI_EventChannelFilters[evt.channel] == true then
     GEM3UI_EventNameFilters[evt.ev_place] = true;
    end
   else 
    if GEM3UI_EventChannelFilters[evt.channel] ~= true then
     GEM3UI_EventNameFilters[evt.ev_place] = nil;
    end
   end
   if GEM3UI_EventNameFilters[evt.ev_place] == true then
    flton = true;
   else
    fltoff=true;
   end
  end
 end
 local title = GEM3UI_LocalizedStrings["_EventNameFilterActivated"];
 if not fltoff then title = GEM3UI_LocalizedStrings["_EventAll"]; end
 if GEM3UI_DDTable == nil then
  GEM3UI_DDTable = GA_GetTable();
 end
 tinsert(GEM3UI_DDTable, {   text = GEM3UI_LocalizedStrings["_EventNameFilter"],   isTitle = true, textHeight = 12 });
 tinsert(GEM3UI_DDTable, {   text = GEM3UI_LocalizedStrings["None"],   isradio = true,   checked = not flton,   func = function() GEM3UI_EventNameFilterOnClickAll(false) end, });
 for i, evtflt in pairs(GEM3UI_EventNameFilters) do
  local tbl = {   text = i,   isradio = true,   checked = evtflt,   func = function() GEM3UI_EventNameFilterOnClick(i) end, }
  tinsert(GEM3UI_DDTable, tbl);
 end
 tinsert(GEM3UI_DDTable, {   text = GEM3UI_LocalizedStrings["All"],   isradio = true,   checked = not fltoff,   func = function() GEM3UI_EventNameFilterOnClickAll(true) end,});
 GEM3UI_SetDDMenu(self,GEM3UI_DDTable)
end


function GEM3UI_EventNameFilterOnClick(evtfltid)
 GEM3UI_EventNameFilters[evtfltid] = not GEM3UI_EventNameFilters[evtfltid] ;
 local isfiltered = false;
 for i, evtflt in pairs(GEM3UI_EventNameFilters) do
   if evtflt == false then
    isfiltered = true; 
   end
 end
 
 if isfiltered then
  GEM3UI_EventNameFilterTextLabel:SetText(GEM3UI_LocalizedStrings["_EventNameFilterActivated"]);
 else
  GEM3UI_EventNameFilterTextLabel:SetText(GEM3UI_LocalizedStrings["_EventAll"]);
 end
 GEM3UI_RefreshView("GEM3UI_REFRESH_CLOSEONLY");
 GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE", "CLOSE");
end


function GEM3UI_EventNameFilterOnClickAll(flag)
 for i, evtflt in pairs(GEM3UI_EventNameFilters) do
   GEM3UI_EventNameFilters[i]=flag;
 end
 if flag then 
  GEM3UI_EventNameFilterTextLabel:SetText(GEM3UI_LocalizedStrings["_EventAll"]);
 else
  GEM3UI_EventNameFilterTextLabel:SetText(GEM3UI_LocalizedStrings["_EventNameFilterActivated"]);
 end
 --GEM3UI_-RefreshAll(GEM3UI_REFRESH_CLOSE_OPEN_EVENTLINE);
 --GEM3UI_EventListScrollUpdate();
 GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE", "CLOSE");
end


function GEM3UI_EventsSort(self)
 if self.data == "date"      then
  GEM3UIMain.sortfld="date";
 elseif self.data == "ev_place" then
  GEM3UIMain.sortfld="ev_place";
 elseif self.data == "leader"     then
  GEM3UIMain.sortfld="leader";
 end
 self.sortdir = not (self.sortdir or false);
 GEM3UIMain.sortdir = self.sortdir;
 tsort(MyEvent, GEM3UI_SortEvList);
 --GEM3UI_EventListScrollUpdate();
end


function GEM3UI_SortEvList(e1, e2)
 local returnval = GEM3UIMain.sortdir or false;
 if GEM3UIMain.sortfld==nil then GEM3UIMain.sortfld="date"; end
 if e1 == nil then return returnval; end
 if e2 == nil then return not returnval; end
 local E1, E2, E3;
 if GEM3UIMain.sortfld=="date" then
   E1 = e1.ev_date; E2 = e2.ev_date;
 elseif GEM3UIMain.sortfld=="ev_place" then
   E1 = string.upper(e1.ev_place); E2 = string.upper(e2.ev_place);
 elseif GEM3UIMain.sortfld=="leader" then
   E1 = e1.leader; E2 = e2.leader;
 end
 if returnval then E3 = E1; E1 = E2; E2 = E3; end -- change sortorder
  
 if E1 == E2 then
   return e1.cnt < e2.cnt;
 else
  return E1 < E2
 end 
end

function GEM3UI_ToggleArchive(self)
 GA_ReleaseTable(GEM3UI_EventNameFilters);
 GEM3UI_EventNameFilters = nil;
 GEM3UI_RefreshView("GEM3UI_REFRESH_CLOSEONLY");
 if GEM3UI_ShowTemplates:GetChecked() then GEM3UI_ShowTemplates:SetChecked(false); end
 GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE", "CLOSE");
 GEM3UI_BuildToolBar();
end

function GEM3UI_DoNothing ()
end

function GEM3UI_ToggleTemplates(self)
 GA_ReleaseTable(GEM3UI_EventNameFilters);
 GEM3UI_EventNameFilters = nil;
 GEM3UI_RefreshView("GEM3UI_REFRESH_CLOSEONLY");
 if GEM3UI_ShowArchive:GetChecked() then GEM3UI_ShowArchive:SetChecked(false); end
 GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE", "CLOSE");
 GEM3UI_BuildToolBar();
end

local sfind = string.find
local sformat = string.format
local strsub = string.sub
local strfind = string.find
local strlen = string.len

function GEM3UI_GridViewSelectDD(self)
 local ls = GEM3UI_LocalizedStrings;
 MovixLib_DDTable = MovixLib_ReleaseTable(MovixLib_DDTable, 10);
 MovixLib_DDMenuAddLine({text = (ls["Themes"] or "Themes"), isTitle = true, })
 for gk, g in pairs (GridLib.Grids) do
    local pref = strsub(gk, 1, 13)
    if pref == "GEM3UI_THEME_" then
        local name = strsub(gk, 14)
        local lname = ls[name] or name
        local namett = ls[name.."tt"] or name
        local isactive = GridLib.Grids[GEM3UI.EventGridView].DGridParams.inherits == gk
        MovixLib_DDMenuAddLine({   text = lname,
                                   func = function() GEM3UI_SelectEventGridTheme(gk) end,
--                                   hasArrow = true,
--                                   value = "T"..gk,
                                   tooltipTitle=lname,
                                   tooltipText=namett,
                                   isRadio = true,
                                   checked = isactive,
                                   });
        --MovixLib_DDMenuAddLine({   text = "Edit "..lname, func = function() GEM3UI_EditEventGridTheme(gk) end,}, "T"..gk)
        --MovixLib_DDMenuAddLine({   text = ls["Delete"],  func = function() GEM3UI_DeleteEventGridView(gk) end}, "T"..gk);
    end
 end
 --MovixLib_DDMenuAddLine({   text = (ls["New theme"] or "New theme"),  func = function() MovixLib_EditStringValue(self, "NewViewName", GEM3UI_NewEventGridTheme) end});
 MovixLib_DDMenuAddLine({text = " ", disabled = true})
 MovixLib_DDMenuAddLine({text = (ls["Existing Views"] or "Existing Views"), isTitle = true, })
 for gk, g in pairs (GridLib.Grids) do
    local pref = strsub(gk, 1, 14)
    if pref == "GEM3UI_EVENTS_" then
        local vname = strsub(gk, 15)
        local vlname = ls[vname] or vname
        local vlnamett = ls[vname.."tt"] or vname
        local isactive = (GEM3UI.EventGridView == gk)
        if vname == "Leader" or vname == "Player" or vname == "Minimal" then
            MovixLib_DDMenuAddLine({   text = vlname,
                                   func = function() GEM3UI_SelectEventGridView(gk) end,
                                   isRadio = true,
                                   checked = isactive,
                                   tooltipTitle=vlname,
                                   tooltipText=vlnamett,
                                   });
        else
            MovixLib_DDMenuAddLine({   text = vlname,
                                   func = function() GEM3UI_SelectEventGridView(gk) end,
                                   hasArrow = true,
                                   value = "V"..gk,
                                   isRadio = true,
                                   checked = isactive,

                                   });
            MovixLib_DDMenuAddLine({   text = ls["Delete"],  func = function() GEM3UI_DeleteEventGridView(gk) end}, "V"..gk);
        end
    end
 end
 local new=ls["Create new view"] or "Create new view"
 local newtt=ls["Create new viewtt"] or "Create new view grid as a copy of the current one"
 MovixLib_DDMenuAddLine({   text = (ls["New View"] or "New View"),  
                            tooltipTitle=new,
                            tooltipText=newtt,
                            func = function() MovixLib_EditStringValue(self, "NewViewName", GEM3UI_NewEventGridView) 
                            end
                        });
 MovixLib_SetDDMenu(self)
end

function GEM3UI_NewEventGridTheme(obj, vname)
    GEM3UI_SelectEventGridView(GridLib.Grids[GEM3UI.EventGridView].DGridParams.inherits)
    GEM3UI_NewEventGridView(obj, vname)
end

function GEM3UI_NewEventGridView(obj, vname)
    local pref = ""
    if strfind(GEM3UI.EventGridView, "GEM3UI_THEME_") then
        if vname == "Neutral" or vname == "Alliance" or vname == "Horde" then
                    message(MovixLib_GetLocale("This is a reserved theme name", "GEM3UI_EVENTS_Minimal"))
                    return
        end
        pref = "GEM3UI_THEME_"
    else
        if vname == "Leader" or vname == "Player" or vname == "Minimal" then
                    message(MovixLib_GetLocale("This is a reserved grid name", "GEM3UI_EVENTS_Minimal"))
                    return
        end
        pref = "GEM3UI_EVENTS_"
    end
    if GridLib.Grids[pref..vname] then
        message(MovixLib_GetLocale("Name already exists", "GEM3UI_EVENTS_Minimal"))
    else
        GridLib.Grids[pref..vname] = MovixLib_TblCpy(GridLib.Grids[GEM3UI.EventGridView])
        MovixLib_RegisterLocale(pref..vname, GEM3UI_LocalizedStrings)
        GEM3UI_SelectEventGridView(pref..vname)
    end
end

function GEM3UI_DeleteEventGridView(vname) 
    if not vname then vname = GEM3UI.EventGridView end
    local name = ""
    if strfind(GEM3UI.EventGridView, "GEM3UI_THEME_") then
        name = strsub(vname, 14)
        if name == "Neutral" or name == "Alliance" or name == "Horde" then
                    message(MovixLib_GetLocale("You cannot delete the default themes", "GEM3UI_EVENTS_Minimal"))
                    return
        end
        GEM3UI_SelectEventGridTheme("GEM3UI_THEME_Neutral")
    else
        name = strsub(vname, 15)
        if name == "Leader" or name == "Player" or name == "Minimal" then
                    message(MovixLib_GetLocale("You cannot delete the default views", "GEM3UI_EVENTS_Minimal"))
                    return
        end
    end
    GEM3UI_SelectEventGridView("GEM3UI_EVENTS_Player")
    GridLib.Grids[vname] = nil
    MovixLib_DDMenuFrame:Hide();
end

function GEM3UI_SelectEventGridTheme(theme)
    GEM3UI.EventGridTheme = theme
    for gid, g in pairs (GridLib.Grids) do
        if strfind(gid, "GEM3UI_") then
            if not (gid == "GEM3UI_GridDefaults" or strfind(gid, "_THEME_")) then
                g.DGridParams.inherits = theme
            end
        end
    end
    MovixLib_RefreshGrid(GEM3UI_EventGrid, true, nil, true)
end


function GEM3UI_EditEventGridTheme(name)
    GEM3UI_SelectEventGridView(name)
end

function GEM3UI_SelectEventGridView(vname)
    local lvname = vname
    if strfind(vname, "GEM3UI_EVENTS_") then
        vname = strsub(vname, 15)
    else
        vname = strsub(vname, 14)
    end
    GEM3UI.EventGridView = lvname
    GEM3UI_GridViewSelectTextLabel:SetText((GEM3UI_LocalizedStrings[vname] or vname))
    GridLib.Grids[GEM3UI.EventGridView] = MovixLib_GetGridDefaults(GEM3UI_EventGrid, GEM3UI.EventGridView, "MyEvent")
    MovixLib_Grid_RegisterColor(GEM3UI.EventGridView, "Event status color", "GEM3UI_GetEventStatusColor", "EventStatusColor", "")
    MovixLib_Grid_RegisterColor(GEM3UI.EventGridView, "Leader status color", "GEM3UI_GetLeaderStatusColor", nil, "Yellow = Online, White = Offline")
    MovixLib_FillData(GEM3UI_EventGrid);
    MovixLib_RefreshGrid(GEM3UI_EventGrid, true, nil, true)
end


function GEM3UI_ResetEventGrid()
  MovixLib_WipeTable(GridLib.Grids[GEM3UI.EventGridView], 20)
  GridLib.Grids[GEM3UI.EventGridView] = nil
  GridLib.Grids[GEM3UI.EventGridView] = MovixLib_TblCpy(GEM3UI_GridParamsDefaults[GEM3UI.EventGridView] or GEM3UI_GridParamsDefaults["GEM3UI_EVENTS_Minimal"])
  MovixLib_WipeTable(GridLib.Grids[GEM3UI.EventGridView].DHeaders, 20)
  GridLib.Grids[GEM3UI.EventGridView].DHeaders = MovixLib_TblCpy(GEM3UI_GridDefaults.DHeaders)
  GridLib.Grids[GEM3UI.EventGridView].DGridParams.inherits = GEM3UI.EventGridTheme
  GEM3UI_SelectEventGridView(GEM3UI.EventGridView)
end


function GEM3UI_ResetPlayersGrid()
  MovixLib_WipeTable(GridLib.Grids["GEM3UI_EventPlayers"].Headers)
  GridLib.Grids["GEM3UI_EventPlayers"] = MovixLib_TblCpy(GEM3UI_EventsPlayersListGridDefaults)
  if not GEM3UI_EventPlayers then GEM3UI_EventPlayers= GA_GetTable(); end
  MovixLib_GetGridDefaults(GEM3UI_GrideventSubscriptionList, "GEM3UI_EventPlayers", "GEM3UI_EventPlayers")
  MovixLib_Grid_RegisterColor("GEM3UI_EventPlayers", "Player Status color", "GEM3UI_GetStatusColor", nil, "Yellow = Online, White = Offline, Blue = in my raid or party")
  MovixLib_Grid_RegisterColor("GEM3UI_EventPlayers", "Class color", "GEM3UI_GetClassColor", "class", "")
  MovixLib_FillData(GEM3UI_GrideventSubscriptionList);
  MovixLib_RefreshGrid(GEM3UI_GrideventSubscriptionList, true, nil, true)
end


function GEM3UI_EventFilterChannelDD(self)
 if GEM3UI_DDTable == nil then
  GEM3UI_DDTable = GA_GetTable();
 end
 tinsert(GEM3UI_DDTable, {   text = GEM3UI_LocalizedStrings["_Channels"],   isTitle = true, textHeight = 12 });
 --table.insert(GEM3UI_ChannelDDTable, {   text = GEM3UI_LocalizedStrings["None"],   isradio = true,   checked = false,   func = function() GEM3UI_EventFilterChannelAllClick(0) end,   closeWhenClicked = true, });
 local chans = GA_GetTable();
 for name,config in pairs(GEM3_Config[GEM3_Realm]) do 
  if (GEM3UI[UnitName("player")].OnlyMyChannels and name == UnitName("player")) or not GEM3UI[UnitName("player")].OnlyMyChannels then
   for i, chan in ipairs(config.channels) do
    if not chans[chan.name] then 
     local tbl = {   text = chan.name,   isradio = true,   checked = GEM3UI_EventChannelFilters[chan.name],   func = function() GEM3UI_EventFilterChannelClick(chan.name,GEM3UI_EventChannelFilters[chan.name]) end, }
     tinsert(GEM3UI_DDTable, tbl);
     chans[chan.name] = true;
    end
   end
  end
 end
 --table.insert(GEM3UI_ChannelDDTable, {   text = GEM3UI_LocalizedStrings["All"],   isradio = true,   checked = false,   func = function() GEM3UI_EventNameFilterOnClickAll(1) end,   closeWhenClicked = true, });
 GEM3UI_SetDDMenu(self, GEM3UI_DDTable)
 GA_ReleaseTable(chans, 10);
end

function GEM3UI_EventFilterChannelAllClick(index, value)
 if index == 0 then value = false; else value = true; end
 for channame, val in pairs (GEM3UI_EventChannelFilters) do
  GEM3UI_EventChannelFilters[channame] = value;
 end
 GEM3UI.ChannelFilter = GEM3UI_EventChannelFilters;
 GEM3UI_RefreshView("GEM3UI_REFRESH_CLOSEONLY");
 GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE", "CLOSE");
end


function GEM3UI_EventFilterChannelClick(index, value)
 if GEM3UI_EventChannelFilters[index] then
  GEM3UI_EventChannelFilters[index] = false
 else
  GEM3UI_EventChannelFilters[index] = true
 end
 GEM3UI.ChannelFilter = GEM3UI_EventChannelFilters;
 GEM3UI_RefreshView("GEM3UI_REFRESH_CLOSEONLY");
 GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE", "CLOSE");
end


function gemuipopulate()
 local subs = nil;
 GEM3UI_totalEvents = 0;
 GEM3UI_closedEvents =0;
 GEM3UI_ignoredEvents =0;
 GEM3UI_subsEvents = 0;
 GEM3UI_eventcount = 0 ;
 MyEvent = {};
 GEM3UI_EventTypePresent = {};

 if GEM3UI_EventNameFilters == nil then
  GEM3UI_EventNameFilters = GA_GetTable();
 end
 local showchannel
--- initialize the source of elements to display in the eventlist 
 if GEM3_QA_Events ~= nil then
  if GEM3UI_ShowArchive:GetChecked() then
   GEM3UI_EventSource = GEM3_QA_Events.archived; 
  elseif GEM3UI_ShowTemplates:GetChecked() then
   GEM3UI_EventSource = GEM3UI.Templates; 
  else
   GEM3UI_EventSource = GEM3_QA_Events.events; 
   subs = GEM3_QA_Events.subscribed;
  end
 else
  GEM3UI_EventSource = nil;
 end
--- If Eventlist has to be populated
 if GEM3UI_EventSource ~= nil then
  for ev_id, ev in pairs(GEM3UI_EventSource) do
   
   if not GEM3UI[UnitName("Player")].OnlyMyChannels 
      or (GEM3UI[UnitName("Player")].OnlyMyChannels 
          and GEM3_PLAY_IsPlayerInChannel(ev.channel,UnitName("player"))
         )
      or GEM3UI_ShowTemplates:GetChecked()
   then
    
    
    if GEM3UI_EventTypePresent[ev.ev_type] then
     GEM3UI_EventTypePresent[ev.ev_type] = GEM3UI_EventTypePresent[ev.ev_type] +1;
    else
     GEM3UI_EventTypePresent[ev.ev_type] = 1;
    end
    
    
    local showtype = false;
    for evtypeid, evtype in pairs (GEM3UI_LocalizedStrings.EventTypes) do
     if evtypeid == ev.ev_type and evtype.state == true then
        if ev.ev_type >=20 or ev.ev_type == GEM3_EVT_TYPE_NONE then
         showtype = true;
        elseif GEM3_QA_Config.debug > 0 and ev.ev_type <20 then
         showtype = true;
        end
     end
    end
    
    local showplace = true;
    if GEM3UI_EventNameFilters[ev.ev_place] ~= nil then
       showplace = GEM3UI_EventNameFilters[ev.ev_place];
     end
    
    if not (GEM3UI_EventChannelFilters[ev.channel] or false) and not (GEM3UI_ShowArchive:GetChecked() or GEM3UI_ShowTemplates:GetChecked()) then
     showchannel=false;
    else
     showchannel=true;
    end
        
    if showtype == true and showplace ~= false and showchannel then
    GEM3UI_totalEvents = GEM3UI_totalEvents +1;
    GEM3UI_eventcount = GEM3UI_eventcount +1;

     MyEvent[GEM3UI_eventcount] = {
      ["cnt"] = GEM3UI_eventcount,
      ["id"] = ev_id,
      ["ev_type"] = ev.ev_type,
      ["channel"] = ev.channel,
      ["leader"] = ev.leader,
      ["ev_date"] = (ev.ev_date+(GEM3UI.ServerTimeOffSet*60*60)),
      ["deadline"] = (ev.deadline+(GEM3UI.ServerTimeOffSet*60*60)),
      ["ev_place"] = ev.ev_place,
      ["ev_inst_tag"] = ev.ev_inst_tag,
      ["ev_comment"] = ev.ev_comment,
      ["update_time"] = ((ev.update_time or 0) +(GEM3UI.ServerTimeOffSet*60*60)),
      ["max_count"] = (ev.tit_count or "NIL").."/"..(ev.max_count or "NIL"),
      ["tit_count"] = (ev.tit_count or "NIL"),
      ["max"] = (ev.max_count or "NIL"),
      ["min_lvl"] = ev.min_lvl,
      ["max_lvl"] = ev.max_lvl,
      ["sub_count"] = ev.sub_count or 0,
      ["repl_count"] = ev.repl_count or 0,
      ["rej_count"] = ev.rej_count or 0,
      ["outDated"] = false,
      ["ignored"] = false,
      ["closed_comment"] = ev.closed_comment,
      };
      
      local pl = GEM3_PLAY_GetPlayerInfos(ev.leader, ev.channel);
      if not pl then
        pl = GEM3_PLAY_GetPlayerInfos(ev.leader);
      end
	  if pl then 
		MyEvent[GEM3UI_eventcount]["leader_connected"] = pl.connected
		MyEvent[GEM3UI_eventcount]["leader_rank"] = pl.grank_name
		MyEvent[GEM3UI_eventcount]["leader_officer"] = pl.officer
		MyEvent[GEM3UI_eventcount]["leader_guild"] = pl.guild
	  end

      
      
      MyEvent[GEM3UI_eventcount]["NAcount"] = 0;      
      if not GEM3UI_ShowArchive:GetChecked() and not GEM3UI_ShowTemplates:GetChecked() then
       local nacount = GEM3_CMD_GetNonAckedSubscriptions(ev.id);
       if nacount then
        MyEvent[GEM3UI_eventcount]["NAcount"] = #nacount;
       end
       GA_ReleaseTable(nacount,10);
      end
      
      local count = 0;
      for _,infos in pairs(ev.players) do
       if infos.current_queue == GEM3_SUB_STATE_TITULAR then
        count = count + 1
       end 
      end
      MyEvent[GEM3UI_eventcount]["Totals"]  = count;
      
      if  pl and subs then
       if subs[ev_id] ~= nil then
        local rerolls = GEM3_PLAY_GetMyRerolls();
        for i, pl in ipairs(rerolls) do
         if GEM3_SUB_GetSubscribedInfos(ev_id, pl.name) then 
            GEM3UI_subsEvents = GEM3UI_subsEvents +1;
         end
        end
        GA_ReleaseTable(rerolls,0);
       end
      end
      
      if ev.deadline < time() then
       MyEvent[GEM3UI_eventcount]["outdated"] = true;
      end
      if ev.ev_date < time() then
       MyEvent[GEM3UI_eventcount]["passed"] = true;
      end

      if GEM3_EVT_IsEventIgnored(ev.id) then
       MyEvent[GEM3UI_eventcount]["ignored"] = true;
       GEM3UI_ignoredEvents =GEM3UI_ignoredEvents +1;
      end
      if ev.closed_comment ~= nil then
       GEM3UI_closedEvents = GEM3UI_closedEvents +1;
       MyEvent[GEM3UI_eventcount]["closed"] = true;
      end
      MyEvent[GEM3UI_eventcount]["EventTexture"] = GEM3UI_GetEventStatusTexture(ev_id)
      MyEvent[GEM3UI_eventcount]["StatusTexture"] = GEM3UI_GetEventStatus(ev_id)
      MyEvent[GEM3UI_eventcount]["EventTypeName"] = GEM3UI_GetEventStatusTexture(ev_id, "ASTEXT")
      MyEvent[GEM3UI_eventcount]["EventStatusName"] = GEM3UI_GetEventStatus(ev_id, "ASTEXT")
      MyEvent[GEM3UI_eventcount]["EventStatusColor"] = GEM3UI_GetEventStatus(ev_id, "GET_COLOR")
      
     end
   end
  end
  if not GEM3UI.Gridstyle then 
    tsort(MyEvent, GEM3UI_SortEvList);
  end
 end
 GEM3UI_SetStatusMessage(sformat(GEM3UI_LocalizedStrings["_EventsStatus"], GEM3UI_totalEvents , GEM3UI_closedEvents, GEM3UI_subsEvents, GEM3UI_ignoredEvents), 0);
end


function GEM3UI_QueueSelectCBClick(self)
  local cb = self:GetName();
  local state = self:GetChecked();
  GEM3UIeventDetailsAsRepCB:SetChecked(false);
  GEM3UIeventDetailsAsNCCB:SetChecked(false);
  self:SetChecked(state);
end


function GEM3UI_EventlistOnShow(self)
  gemuipopulate();
  --if not GEM3UI.Gridstyle then
    --GEM3UI_EventListScrollUpdate();
    --GEM3UI_IsEventExpanded()
  --end
end


function GEM3UI_IsEventExpanded()
 --mydbg("GEM3UI_IsEventExpanded");
 if GEM3UI_expandedLine > 0 then
  local line = getglobal("GEM3UI_lineFrame"..GEM3UI_expandedLine);
  --line:SetBackdropColor(0.5,0.5,0.5,0.8);
  line:LockHighlight();
  if MyEvent[line.ev_index] ~= nil then
   GEM3UIeventDetails.evt = GEM3UI_EventSource[MyEvent[line.ev_index].id]
   GEM3UIEventSubs.evt = GEM3UIeventDetails.evt;
   GEM3UI_EventLinePopulate(); 
   GEM3UI_EventDetailOnShow();
   GEM3UI_EventDetailsShow();
  end
 end
end

function GEM3UI_FillPlayerDetails(p_id)
local p = GEM3UI_EventPlayers[p_id];
local f = "GEM3UIPlayerDetails";
local classid = GEM3UI_GetClassIndex(p.class);
local roleid = GEM3UI_GetRoleIndex(p.role or 1);
local altroleid = GEM3UI_GetRoleIndex(p.alt_role);

--init
getglobal(f.."NameLabel"):SetText("");
getglobal(f.."GuildLabel"):SetText("");
getglobal(f.."LvLLabel"):SetText("");
getglobal(f.."ClassLabel"):SetText("");
getglobal(f.."RoleLabel"):SetText("");
getglobal(f.."QueueLabel"):SetText("");
getglobal(f.."PosLabel"):SetText("");
getglobal(f.."Update_dateLabel"):SetText("");
getglobal(f.."Update_timeLabel"):SetText("");
getglobal(f.."TagRstDateLabel"):SetText("");
getglobal(f.."TagRstTimeLabel"):SetText("");
getglobal(f.."CommentLabel"):SetText("");
getglobal(f.."ClassIconTexture"):SetTexture("");
getglobal(f.."RoleIconTexture"):SetTexture("");
getglobal(f.."AltRoleIconTexture"):SetTexture("");

-- fill
getglobal(f.."NameLabel"):SetText(p.name);
getglobal(f.."GuildLabel"):SetText("<"..p.guild..">");
getglobal(f.."LvLLabel"):SetText(p.level);
getglobal(f.."ClassLabel"):SetText(GEM3UI_Classes[classid].name_loc);
getglobal(f.."RoleLabel"):SetText(GEM3UI_Roles[roleid].name_loc);
if altroleid > 0 then
 getglobal(f.."RoleLabel"):SetText(getglobal(f.."RoleLabel"):GetText().." ("..GEM3UI_Roles[altroleid].name_loc..")");
end

local pfq = "";
if p.lead_force_queue ~= GEM3_SUB_FORCE_QUEUE_NONE then
 pfq = "(F) ";
end

if p.current_queue ~= nil then
  getglobal(f.."QueueLabel"):SetText(pfq..GEM3UI_Queues[p.current_queue].name);
  getglobal(f.."PosLabel"):SetText(pfq..(p.queue_pos or "?"));
elseif p.current_queue == GEM3_SUB_STATE_NOT_COMING then
  getglobal(f.."QueueLabel"):SetText(GEM3UI_LocalizedStrings["_not_comingshort"]);
  getglobal(f.."PosLabel"):SetText("");
else 
  getglobal(f.."QueueLabel"):SetText(GEM3UI_LocalizedStrings["_not_acknedshort"]);
  getglobal(f.."PosLabel"):SetText("");
end
getglobal(f.."Update_dateLabel"):SetText(GEM3UI_FormatDateString(p.main_time));
getglobal(f.."Update_timeLabel"):SetText(date(GEM3UI_TimeFormatString, p.main_time));

 local pl = GEM3_PLAY_GetPlayerInfos(p.name, GEM3UIeventDetails.evt.channel);
 if not pl then
  pl = GEM3_PLAY_GetPlayerInfos(p.name);
 end
 local tid = 0
 if pl ~= nil then
    for i, tag in pairs (TaggedInstances) do
        if GEM3UIeventDetails.evt.ev_inst_tag == i then
            for k, t in ipairs(pl.tags) do
                if i ==  t[GEM3_ACCESS_INST_TAG_NAME] then
                    tid = k
                end
            end
        end
    end
    if pl.tags[tid] ~= nil then
        if pl.tags[tid][GEM3_ACCESS_INST_TAG_RESET] > GEM3UIeventDetails.evt.ev_date+GEM3UI.ServerTimeOffSet then
            local rsttime = pl.tags[tid][GEM3_ACCESS_INST_TAG_RESET];
            getglobal(f.."TagRstDateLabel"):SetText(GEM3UI_FormatDateString(rsttime));
            getglobal(f.."TagRstTimeLabel"):SetText(date(GEM3UI_TimeFormatString,rsttime));
        end
    end
 end

 local commentadd = "";
 if strsub(p.source, 1,1) == GEM3_SUB_SOURCE_EXTERNAL then
  commentadd = " "..GEM3UI_LocalizedStrings["_AddedExternalby"]..strsub(p.source, 2);
 end
 mydbg(p.source.." "..commentadd);

getglobal(f.."CommentLabel"):SetText(p.comment..commentadd);
getglobal(f.."ClassIconTexture"):SetTexture(GEM3UI_Players_Classes[p.class].icon);
getglobal(f.."RoleIconTexture"):SetTexture("interface\\icons\\"..GEM3UI_Roles[roleid].icon);
if altroleid > 0 then
 getglobal(f.."AltRoleIconTexture"):SetTexture("interface\\icons\\"..GEM3UI_Roles[altroleid].icon);
end

local classlinep = getglobal("GEM3UI_EventDetailsLimitsFrame"..GEM3UI_Classes[classid].gemid.."Uline");
local rolelinep = getglobal("GEM3UI_EventDetailsLimitsFrame"..GEM3UI_Roles[roleid].name.."Uline");

local parent = getglobal("GEM3UIeventDetailsLimitsFrame");
local classline = getglobal("GEM3UI_EventDetailsClassLimitsHL");
if classline == nil then
    classline  = parent:CreateTexture("GEM3UI_EventDetailsClassLimitsHL");
    classline:SetHeight(15);
    classline:SetWidth(parent:GetWidth()-10);
    classline:SetDrawLayer("BORDER");
    classline:SetTexture(0.4,0.4,0.4,0.4);
end
classline:SetPoint("TOPLEFT", parent.Classline[classid].lb, "TOPLEFT", 0, 0);


classline:Show();
local roleline = getglobal("GEM3UI_EventDetailsRoleLimitsHL");
if roleline == nil then
    roleline = parent:CreateTexture("GEM3UI_EventDetailsRoleLimitsHL");
    roleline:SetHeight(15);
    roleline:SetWidth(parent:GetWidth()-10);
    roleline:SetDrawLayer("BORDER");
    roleline:SetTexture(0.4,0.4,0.4,0.4);
end
if roleid == nil or roleid == 0 then
    roleid = 1;
end
roleline:SetPoint("TOPLEFT", parent.Roleline[roleid].lb, "TOPLEFT",0,0);
roleline:Show();

end


function GEM3UI_PlayerLineHighLight(line)
  GEM3UI_FillPlayerDetails(line.player_index);
  GEM3UIPlayerDetails:Show();
  GEM3UI_PlayerLineShowTagPopup(line);
end




function GEM3UI_PlayerLineOut(line)
  --local p = GEM3UI_EventPlayers[line.player_index];
  --local classid = GEM3UI_GetClassIndex(p.class);
  --local roleid = GEM3UI_GetRoleIndex(p.role);
  local classline = getglobal("GEM3UI_EventDetailsClassLimitsHL");
  local roleline = getglobal("GEM3UI_EventDetailsRoleLimitsHL");
  roleline:Hide();
  classline:Hide();
  GEM3UIPlayerDetails:Hide();
  GEM3UI_PlayerLineHideTagPopup();
end


function GEM3UI_PlayerLineLoad(obj)
 GEM3UI_EventLineLoad(obj);
end

function GEM3UI_EventLineLoad(line)
  local bgFile, GEMedgeFile, GEMinsets = line:GetBackdrop();
  --line:SetBackdrop({   bgFile = "interface\\buttons\\bluegrad64",   edgeFile = GEMedgeFile,   insets = GEMinsets   }  );
  --line:SetBackdropColor(0.5,0.5,0.5,0);
end



function GEM3UI_LineButtonClick(self)
 GEM3UI_ExpandEventLine(self:GetParent(), "true");
end


function GEM3UI_EventLineOnDoubleClick(self)
 if GEM3UI_ShowTemplates:GetChecked() then
  if IsControlKeyDown() then
   GEM3UI_DeleteTemplate(MyEvent[self.ev_index].id);
  else
   GEM3UI_CreateNewFromTemplate(MyEvent[self.ev_index].id);
  end
 end
end

function GEM3UI_EventLineOnClick(self, arg1)
 if arg1 == "RightButton" then
  local dd = getglobal("GEM3UIDropDown");
  GEM3UI_EventLineMenu(self)
  --GEM3UI_DDshow(self);
 elseif arg1 == "LeftButton" then
  GEM3UI_SelectedEvent = MyEvent[self.ev_index].id
  if getglobal(self:GetName().."ExpandButton"):IsVisible() then
   GEM3UI_ExpandEventLine(self, "true");
   GEM3UI_ContextFrame="GEM3UIEventSubs";
  end
 end
end


function GEM3UI_PlayerLineOnClick()
 if arg1 == "RightButton" then
  --local dd = getglobal("GEM3UIDropDown");
  --dd.id  =   getglobal("GEM3UI_lineFrame"..GEM3UI_expandedLine).ev_index;
  --dd.target = this.player_index;
  --local plname = GEM3UI_EventPlayers[this.player_index].name;
  --GEM3UI_DropDowninit(plname);
  GEM3UI_PlayerLineMenu(this, getglobal("GEM3UI_lineFrame"..GEM3UI_expandedLine).ev_index);
  --GEM3UI_DDshow(self);
 end
end

function GEM3UI_PlayerLineMenu(obj, ev_id)
 local isleader = nil;
 local isassist = nil;
 local isnotofficer = true;
 if GEM3_IsMyReroll(MyEvent[ev_id].leader) then
  isleader = true;
  isnotofficer =false;
 end
 local plid = obj.player_index;
 local pl = GEM3UI_EventPlayers[plid];
 local plname = pl.name
 if not GEM3UI_ShowTemplates:GetChecked() and not GEM3UI_ShowArchive:GetChecked() then
  if GEM3_EVT_IsAssistant(MyEvent[ev_id].id,UnitName("player")) then
   isassist = true;
   isnotofficer =false;
  end
 end
 
 local ls = GEM3UI_LocalizedStrings;
 
 if GEM3UI_DDTable == nil then
  GEM3UI_DDTable = GA_GetTable();
 end
 tinsert(GEM3UI_DDTable, {   text = plname,   isTitle = true, textHeight = 12 });
 if GEM3UI_ShowTemplates:GetChecked() then
  tinsert(GEM3UI_DDTable, {   text = ls["Delete"],  func = function() GEM3UI_PlayerMenuClick("Delete", plid) end,});
 else
  tinsert(GEM3UI_DDTable, {   text = ls["AssistPlayer"],  disabled = not isleader , func = function() GEM3UI_PlayerMenuClick("Assist", plid) end,});
  tinsert(GEM3UI_DDTable, {   text = ls["Queues"],   isTitle = true, textHeight = 12 });
  tinsert(GEM3UI_DDTable, {   text = ls["ForceNonePlayer"],  disabled = isnotofficer or pl.lead_force_queue == GEM3_SUB_FORCE_QUEUE_NONE, func = function() GEM3UI_PlayerMenuClick("ForceNone", plid) end,});
  tinsert(GEM3UI_DDTable, {   text = ls["ForceTPlayer"],  disabled = isnotofficer or pl.lead_force_queue == GEM3_SUB_FORCE_QUEUE_TITULAR, func = function() GEM3UI_PlayerMenuClick("ForceT", plid) end,});
  tinsert(GEM3UI_DDTable, {   text = ls["ForceSPlayer"],  disabled = isnotofficer or pl.lead_force_queue == GEM3_SUB_FORCE_QUEUE_SUBSTITUTE, func = function() GEM3UI_PlayerMenuClick("ForceS", plid) end,});
  tinsert(GEM3UI_DDTable, {   text = ls["ForceRPlayer"],  disabled = isnotofficer or pl.lead_force_queue == GEM3_SUB_FORCE_QUEUE_REPLACEMENT, func = function() GEM3UI_PlayerMenuClick("ForceR", plid) end,});
  tinsert(GEM3UI_DDTable, {   text = ls["ForceNCPlayer"], disabled = isnotofficer or pl.lead_force_queue == GEM3_SUB_FORCE_QUEUE_NOT_COMING, func = function() GEM3UI_PlayerMenuClick("ForceNC", plid) end,});
  tinsert(GEM3UI_DDTable, {   text = ls["KickPlayer"],  disabled = isnotofficer, func = function() GEM3UI_PlayerMenuClick("Kick", plid) end,});
  tinsert(GEM3UI_DDTable, {   text = ls["BanPlayer"],  disabled = isnotofficer, func = function() GEM3UI_PlayerMenuClick("Ban", plid) end,});
  --table.insert(GEM3UI_DDTable, {   text = ls["UnBanPlayer"],  disabled = not (isofficer and isleader and GEM3_SUB_IsPlayerBanned(MyEvent[ev_id].id,GEM3UI_EventPlayers[plid].name)) , func = function() GEM3UI_PlayerMenuClick("UnBan", plid) end,});
  tinsert(GEM3UI_DDTable, {   text = ls["Ignore"],  disabled = isnotofficer, func = function() GEM3UI_PlayerMenuClick("Ignore", plid) end,});
 end
 tinsert(GEM3UI_DDTable, {   text = "Action",   isTitle = true, textHeight = 12 });
 tinsert(GEM3UI_DDTable, {   text = ls["WhispPlayer"],  func = function() GEM3UI_PlayerMenuClick("Whisp", plid) end,});
 tinsert(GEM3UI_DDTable, {   text = ls["InvitePlayer"],  func = function() GEM3UI_PlayerMenuClick("Invite", plid) end,});
 tinsert(GEM3UI_DDTable, {   text = ls["whoPlayer"],  func = function() GEM3UI_PlayerMenuClick("Who", plid) end,});
 
 GEM3UI_SetDDMenu(nil,GEM3UI_DDTable)
end

function GEM3UI_GridPlayerMenu(p, row, col)
  local ls = GEM3UI_LocalizedStrings;
  local pl = p.data[row];
  local ev_id = pl.evid
  local ev = GEM3UI_EventSource[ev_id]
  local plname = pl.name
  local isleader = nil;
  local isassist = nil;
  local isnotofficer = true;
  
  if not GEM3UI_ShowTemplates:GetChecked() and not GEM3UI_ShowArchive:GetChecked() then
   if GEM3_IsMyReroll(ev.leader) then
    isleader = true;
    isnotofficer =false;
   end

   if GEM3_EVT_IsAssistant(ev.id,UnitName("player")) then
    tdbg("I AM ASSIST")
    isassist = true;
    isnotofficer =false;
   end
  end
 
 local mainRole = ev.players[plname].role
 local secondaryRole = ev.players[plname].alt_role
 
 local ls = GEM3UI_LocalizedStrings;
 MovixLib_DDMenuAddLine({text = PLAYER.. " " .. plname .. " GEM Action", isTitle = true,  textHeight=14})

 if GEM3UI_ShowTemplates:GetChecked() then
  MovixLib_DDMenuAddLine({   text = ls["Delete"],  func = function() GEM3UI_PlayerMenuClick("Delete", plid) end});
 else
  MovixLib_DDMenuAddLine({   text = ls["AssistPlayer"],  disabled = not isleader, func = function() GEM3_EVT_SetAssistant(ev.id,plname);  GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_UPDATE", ev.id) end});
  MovixLib_DDMenuAddLine({   text = ls["Queues"],   hasArrow = true, disabled = isnotofficer, value = "FQ" });
  MovixLib_DDMenuAddLine({   text = ls["ForceNonePlayer"],  disabled = isnotofficer or pl.lead_force_queue == GEM3_SUB_FORCE_QUEUE_NONE, func = function() GEM3_SUB_ForceQueueForPlayer(ev.id,plname,GEM3_SUB_FORCE_QUEUE_NONE) end,}, "FQ");
  MovixLib_DDMenuAddLine({   text = ls["ForceTPlayer"],  disabled = isnotofficer or pl.lead_force_queue == GEM3_SUB_FORCE_QUEUE_TITULAR, func = function() GEM3_SUB_ForceQueueForPlayer(ev.id,plname,GEM3_SUB_FORCE_QUEUE_TITULAR) end,}, "FQ");
  MovixLib_DDMenuAddLine({   text = ls["ForceSPlayer"],  disabled = isnotofficer or pl.lead_force_queue == GEM3_SUB_FORCE_QUEUE_SUBSTITUTE, func = function() GEM3_SUB_ForceQueueForPlayer(ev.id,plname,GEM3_SUB_FORCE_QUEUE_SUBSTITUTE) end,}, "FQ");
  MovixLib_DDMenuAddLine({   text = ls["ForceRPlayer"],  disabled = isnotofficer or pl.lead_force_queue == GEM3_SUB_FORCE_QUEUE_REPLACEMENT, func = function() GEM3_SUB_ForceQueueForPlayer(ev.id,plname,GEM3_SUB_FORCE_QUEUE_REPLACEMENT) end,}, "FQ");
  MovixLib_DDMenuAddLine({   text = ls["ForceNCPlayer"], disabled = isnotofficer or pl.lead_force_queue == GEM3_SUB_FORCE_QUEUE_NOT_COMING, func = function() GEM3_SUB_ForceQueueForPlayer(ev.id,plname,GEM3_SUB_FORCE_QUEUE_NOT_COMING) end,}, "FQ");
 
--[[  MovixLib_DDMenuAddLine({   text = ls["Roles"],   isTitle = true, textHeight = 12 });
  MovixLib_DDMenuAddLine({   text = ls["ForceTank"],  disabled = isnotofficer, func = function() GEM3_SUB_ForceRoleForPlayer(ev.id,plname,GEM3_ROLE_TANK) end,});
  MovixLib_DDMenuAddLine({   text = ls["ForceHeal"],  disabled = isnotofficer, func = function() GEM3_SUB_ForceRoleForPlayer(ev.id,plname,GEM3_ROLE_HEAL) end,});
  MovixLib_DDMenuAddLine({   text = ls["ForceCDPS"],  disabled = isnotofficer, func = function() GEM3_SUB_ForceRoleForPlayer(ev.id,plname,GEM3_ROLE_CDPS) end,});
  MovixLib_DDMenuAddLine({   text = ls["ForceRDPS"],  disabled = isnotofficer, func = function() GEM3_SUB_ForceRoleForPlayer(ev.id,plname,GEM3_ROLE_RDPS) end,});
    ]]--
  MovixLib_DDMenuAddLine({   text = "Main Roles", disabled = isnotofficer, hasArrow = true, value = "FMR" });
  MovixLib_DDMenuAddLine({   text = "ForceTank",  disabled = isnotofficer, func = function() GEM3_SUB_ForceRoleForPlayer(ev.id,plname,GEM3_ROLE_TANK, secondaryRole) end,}, "FMR");
  MovixLib_DDMenuAddLine({   text = "ForceHeal",  disabled = isnotofficer, func = function() GEM3_SUB_ForceRoleForPlayer(ev.id,plname,GEM3_ROLE_HEAL, secondaryRole) end,}, "FMR");
  MovixLib_DDMenuAddLine({   text = "ForceCDPS",  disabled = isnotofficer, func = function() GEM3_SUB_ForceRoleForPlayer(ev.id,plname,GEM3_ROLE_CDPS, secondaryRole) end,}, "FMR");
  MovixLib_DDMenuAddLine({   text = "ForceRDPS",  disabled = isnotofficer, func = function() GEM3_SUB_ForceRoleForPlayer(ev.id,plname,GEM3_ROLE_RDPS, secondaryRole) end,}, "FMR");

  MovixLib_DDMenuAddLine({   text = "Secondary Roles", disabled = isnotofficer, hasArrow = true, value = "FSR" });
  MovixLib_DDMenuAddLine({   text = "ForceTank",  disabled = isnotofficer, func = function() GEM3_SUB_ForceRoleForPlayer(ev.id,plname,mainRole,GEM3_ROLE_TANK) end,}, "FSR");
  MovixLib_DDMenuAddLine({   text = "ForceHeal",  disabled = isnotofficer, func = function() GEM3_SUB_ForceRoleForPlayer(ev.id,plname,mainRole,GEM3_ROLE_HEAL) end,}, "FSR");
  MovixLib_DDMenuAddLine({   text = "ForceCDPS",  disabled = isnotofficer, func = function() GEM3_SUB_ForceRoleForPlayer(ev.id,plname,mainRole,GEM3_ROLE_CDPS) end,}, "FSR");
  MovixLib_DDMenuAddLine({   text = "ForceRDPS",  disabled = isnotofficer, func = function() GEM3_SUB_ForceRoleForPlayer(ev.id,plname,mainRole,GEM3_ROLE_RDPS) end,}, "FSR");


  MovixLib_DDMenuAddLine({   text = ls["KickPlayer"],  disabled = isnotofficer, func = function() GEM3UI_Popup(GEM3UI_DIALOG_CONFIRM_PLAYER_KICK, {evtid = ev.id, pl = plname}) end,});
  MovixLib_DDMenuAddLine({   text = ls["BanPlayer"],  disabled = isnotofficer, func = function() GEM3UI_Popup(GEM3UI_DIALOG_CONFIRM_PLAYER_BAN, {evtid = ev.id, pl = plname}) end,});
  MovixLib_DDMenuAddLine({   text = ls["Ignore"],  disabled = isnotofficer, func = function() GEM3UI_Popup(GEM3UI_DIALOG_CONFIRM_MEMBER_IGNORE, plname) end,});
  
 end
 MovixLib_DDMenuAddLine({   text = "Action",   isTitle = true });
 MovixLib_DDMenuAddLine({   text = WHISPER,  func = function() ChatFrameEditBox:Show(); ChatFrameEditBox:Insert("/w "..plname) end});
 MovixLib_DDMenuAddLine({   text = INVITE,  func = function() InviteUnit(plname) end});
 MovixLib_DDMenuAddLine({   text = WHO,  func = function() SendWho(plname) end});
end



function GEM3UI_PlayerMenuClick(id, value)
 local ev_id = MyEvent[getglobal("GEM3UI_lineFrame"..GEM3UI_expandedLine).ev_index].id;
 local evt = GEM3UI_EventSource[ev_id];
 local plname = GEM3UI_EventPlayers[value].name;
 if      id == "Assist"   then GEM3_EVT_SetAssistant(evt.id,plname);  GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_UPDATE", evt.id);
 --elseif  id == "Leader"   then GEM3_EVT_SetLeader(evt.id,plname);
 elseif  id == "ForceNone" then GEM3_SUB_ForceQueueForPlayer(evt.id,plname,GEM3_SUB_FORCE_QUEUE_NONE);
 elseif  id == "ForceR"   then GEM3_SUB_ForceQueueForPlayer(evt.id,plname,GEM3_SUB_FORCE_QUEUE_REPLACEMENT);
 elseif  id == "ForceNC"  then GEM3_SUB_ForceQueueForPlayer(evt.id,plname,GEM3_SUB_FORCE_QUEUE_NOT_COMING);
 elseif  id == "ForceS"   then GEM3_SUB_ForceQueueForPlayer(evt.id,plname,GEM3_SUB_FORCE_QUEUE_SUBSTITUTE);
 elseif  id == "ForceT"   then GEM3_SUB_ForceQueueForPlayer(evt.id,plname,GEM3_SUB_FORCE_QUEUE_TITULAR);
 elseif  id == "Kick"     then GEM3UI_Popup(GEM3UI_DIALOG_CONFIRM_PLAYER_KICK, {evtid = evt.id, pl = plname});
 elseif  id == "Ban"      then GEM3UI_Popup(GEM3UI_DIALOG_CONFIRM_PLAYER_BAN, {evtid = evt.id, pl = plname});
 elseif  id == "UnBan"    then GEM3UI_Popup(GEM3UI_DIALOG_CONFIRM_PLAYER_BAN, {evtid = evt.id, pl = plname});
 elseif  id == "Ignore"   then GEM3UI_Popup(GEM3UI_DIALOG_CONFIRM_MEMBER_IGNORE, plname);
 elseif  id == "Whisp"    then ChatFrameEditBox:Show(); ChatFrameEditBox:Insert("/w "..plname);
 elseif  id == "Invite"   then InviteUnit(plname);
 elseif  id == "Who"      then SendWho(plname);
 elseif  id == "Delete"   then evt.players[plname]=nil
 end
 GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE", nil);
end


function GEM3UI_ProccedPlayerKick(dta, reason)
  GEM3_EVT_KickFromEvent(dta.evtid, dta.pl,reason);
  GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_UPDATE", dta.evtid);
  --GEM3UI_-RefreshAll();
end

function GEM3UI_ProccedPlayerBan(dta, reason)
  GEM3_EVT_BanFromEvent(dta.evtid, dta.pl,reason);
  GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_UPDATE", dta.evtid);
  --GEM3UI_-RefreshAll();
end

function GEM3UI_ProccedPlayerUnban(dta)
  GEM3_EVT_unBanFromEvent(dta.evtid, dta.pl);
  GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_UPDATE", dta.evtid);
  --GEM3UI_-RefreshAll();
end


function GEM3UI_GridEventMenu(p, row, col)
  GEM3UI_EventMenu(p.data[row])
end

function GEM3UI_DetailsEventMenu(ev)
    MovixLib_DDTable = MovixLib_ReleaseTable(MovixLib_DDTable, 10);
    GEM3UI_EventMenu(ev)
    MovixLib_SetDDMenu()
end

function GEM3UI_EventMenu(ev)
 local isleader = GEM3_IsMyReroll(ev.leader);
 local archive = GEM3UI_ShowArchive:GetChecked();
 local templates = GEM3UI_ShowTemplates:GetChecked();
 local ls = GEM3UI_LocalizedStrings;
 local evid = ev.id;
 
 MovixLib_DDMenuAddLine({text = ev.ev_place, isTitle = true, })
 if not archive and not templates then
    MovixLib_DDMenuAddLine({   text = ls["Modify"],  disabled = not isleader, func = function() GEM3UI_EventMenuClick("Modify", evid) end});
    MovixLib_DDMenuAddLine({   text = ls["Archive"],  func = function() GEM3UI_EventMenuClick("Archive", evid) end});
    if ev.closed == true then
        MovixLib_DDMenuAddLine({   text = ls["Open"],  disabled = not isleader, func = function() GEM3UI_EventMenuClick("Open", evid) end});
    else
        MovixLib_DDMenuAddLine({   text = ls["Close"],  disabled = not isleader, func = function() GEM3UI_EventMenuClick("Close", evid) end});
    end
    MovixLib_DDMenuAddLine({   text = ls["Delete"],  disabled = not isleader, func = function() GEM3UI_EventMenuClick("Delete", evid) end});
    if ev.ignored == true then
        MovixLib_DDMenuAddLine({   text = ls["Unignore"], func = function() GEM3UI_EventMenuClick("Unignore", evid) end});
    else
        MovixLib_DDMenuAddLine({   text = ls["Ignore"],  func = function() GEM3UI_EventMenuClick("Ignore", evid) end});
    end
    MovixLib_DDMenuAddLine({   text = ls["CopyasTemplate"],  func = function() GEM3UI_EventMenuClick("CopyasTemplate", evid) end});
 end
 if archive then
     MovixLib_DDMenuAddLine({   text = ls["Delete"],  func = function() GEM3UI_EventMenuClick("DeleteArchive", evid) end});
 end
 if templates then
  MovixLib_DDMenuAddLine({   text = ls["CreateNew"],  func = function() GEM3UI_EventMenuClick("CreateFromTemplate", evid) end});
  MovixLib_DDMenuAddLine({   text = ls["Delete"],  func = function() GEM3UI_EventMenuClick("DeleteTemplate", evid) end});
 end
end


function GEM3UI_EventLineMenu(obj)
 local isleader = GEM3_IsMyReroll(MyEvent[obj.ev_index].leader);
 local archive = GEM3UI_ShowArchive:GetChecked();
 local templates = GEM3UI_ShowTemplates:GetChecked();
 local ls = GEM3UI_LocalizedStrings;

 if GEM3UI_DDTable == nil then
  GEM3UI_DDTable = GA_GetTable();
 end
 tinsert(GEM3UI_DDTable, {   text = MyEvent[obj.ev_index].ev_place,   isTitle = true, textHeight = 12 });
 local evid = MyEvent[obj.ev_index].id;
 if not archive and not templates then
  tinsert(GEM3UI_DDTable, {   text = ls["Modify"],  disabled = not isleader , func = function() GEM3UI_EventMenuClick("Modify", evid) end,});
  tinsert(GEM3UI_DDTable, {   text = ls["Archive"],  func = function() GEM3UI_EventMenuClick("Archive", evid) end,});
  if MyEvent[obj.ev_index].closed == true then
    tinsert(GEM3UI_DDTable, {   text = ls["Open"],  disabled = not isleader , func = function() GEM3UI_EventMenuClick("Open", evid) end,});
  else
    tinsert(GEM3UI_DDTable, {   text = ls["Close"],  disabled = not isleader , func = function() GEM3UI_EventMenuClick("Close", evid) end,});
  end
  tinsert(GEM3UI_DDTable, {   text = ls["Delete"],  disabled = not isleader , func = function() GEM3UI_EventMenuClick("Delete", evid) end,});
  if MyEvent[obj.ev_index].ignored == true then
    tinsert(GEM3UI_DDTable, {   text = ls["Unignore"],  disabled = not isleader , func = function() GEM3UI_EventMenuClick("Unignore", evid) end,});
  else
    tinsert(GEM3UI_DDTable, {   text = ls["Ignore"],  func = function() GEM3UI_EventMenuClick("Ignore", evid) end,});
  end
  tinsert(GEM3UI_DDTable, {   text = ls["CopyasTemplate"],  func = function() GEM3UI_EventMenuClick("CopyasTemplate", evid) end,});
 end
 if archive then
   tinsert(GEM3UI_DDTable, {   text = ls["Delete"],  disabled = not isleader , func = function() GEM3UI_EventMenuClick("DeleteArchive", evid) end,});
 end
 if templates then
  tinsert(GEM3UI_DDTable, {   text = ls["CreateNew"],  func = function() GEM3UI_EventMenuClick("CreateFromTemplate", evid) end,});
  tinsert(GEM3UI_DDTable, {   text = ls["Delete"],  func = function() GEM3UI_EventMenuClick("DeleteTemplate", evid) end,});
 end
  GEM3UI_SetDDMenu(nil,GEM3UI_DDTable)
end

function GEM3UI_EventLineOnEnter(self)
   mydbg("GEM3UI_EventlineOnenter");
   mydbg(self:GetName());
   local es = getglobal("GEM3UIEventSubs");
   if GEM3UI_expandedLine == 0 then
     es.ev_index = self.ev_index;
     es.evt= GEM3UI_EventSource[MyEvent[self.ev_index].id];
     es.form=false;
     if es:IsVisible() then
      es:Hide();
     end
     es:Show();
     if GEM3UI_SET_EVTCHANGE_TBL(es.evt, GEM3UI_EVENT_CHANGE_VIEWED) then
      GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_UPDATE", es.evt.id);
     end
   end
   GEM3UI_SetDebugStatus(sformat("EVENTLINE: %s, EVENT ID : %s ", self.ev_index, MyEvent[self.ev_index].id ),0);
end


function GEM3UI_EventLineOnLeave(self)
   local es = getglobal("GEM3UIEventSubs");
   if GEM3UI_expandedLine == 0 then
     es:Hide();
   end
   es.form=true;
end

function GEM3UI_EventMenuClick(id, value)
 if      id == "Delete" then GEM3UI_Popup(GEM3UI_DIALOG_CONFIRM_EVENT_DELETE,value); 
 elseif  id == "DeleteArchive"  then GEM3UI_Popup(GEM3UI_DIALOG_CONFIRM_EVENTARCHIVE_DELETE, value); 
 elseif  id == "Modify"  then GEM3UI_EventEdit(value);
 elseif  id == "Archive"  then GEM3_EVT_ArchiveEvent(value);
 elseif  id == "Close"  then GEM3UI_Popup(GEM3UI_DIALOG_CONFIRM_EVENT_CLOSE, value); 
 elseif  id == "Open"  then GEM3_EVT_UnCloseEvent(value); GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_UPDATE", value);
 elseif  id == "Ignore"  then GEM3UI_Popup(GEM3UI_DIALOG_CONFIRM_EVENT_IGNORE, value); 
 elseif  id == "Unignore"  then GEM3_EVT_UnIgnoreEvent(value); GEM3_EVT_UnCloseEvent(value); GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_UPDATE", value);
 elseif  id == "Expand"  then GEM3_EVT_CloseEvent(value);
 elseif  id == "Collapse"  then GEM3UI_EventClose(value);
 elseif  id == "CreateFromTemplate"  then GEM3UI_CreateNewFromTemplate(value);
 elseif  id == "DeleteTemplate"  then GEM3UI_DeleteTemplate(value);
 elseif  id == "CopyasTemplate"  then GEM3UI_CreateModifyEvent(nil, nil, true, GEM3UI_EventSource[value]);
 
 end
end


function GEM3UI_DeleteTemplate(value)
 tremove(GEM3UI.Templates, value);
 --GEM3UI_-RefreshAll();
 GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE", "CLOSE");
end



function GEM3UI_EventDelete(id)
 local expline = getglobal("GEM3UI_lineFrame"..GEM3UI_expandedLine);
 if expline ~= nil then
  if expline.ev_index == id then
   GEM3UI_ExpandEventLine(expline, true);
  end
 end
 if GEM3UI.ArchiveBeforeDelete then
   GEM3_EVT_ArchiveEvent(id);
 end
 GEM3_EVT_DeleteEvent(id);
 GEM3UI_SetStatusMessage(sformat("EVENT: %s DELETED", id),2);
 GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE", "CLOSE");
end


function GEM3UI_EventDeleteArchive(id)
 local expline = getglobal("GEM3UI_lineFrame"..GEM3UI_expandedLine);
 if expline ~= nil then
  GEM3UI_ExpandEventLine(expline, true);
 end
 GEM3_EVT_DeleteArchivedEvent(id);
 GEM3UI_SetStatusMessage(sformat("EVENT Archive: %s DELETED", id),2);
 --GEM3UI_-RefreshAll();
 GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE", "CLOSE");
end



function GEM3UI_ExpandEventLine(line, eventlistupdate)
 local lineid = strsub(line:GetName(),17)*1;
 local isleader = false;
 local es = getglobal("GEM3UIEventSubs");
 if getglobal(line:GetName().."ExpandButton"):IsEnabled() == false then return; end
 if line.ignored == true and GEM3UI_expandedLine ~= lineid and isleader== false then return; end
 if MyEvent[line.ev_index] == nil then return; end
 local lineheader = getglobal(line:GetName().."HeadLineBG");
 if UnitName("player") == MyEvent[line.ev_index].leader then
  isleader = true;
 end
 if GEM3UI_expandedLine == lineid then
   line:SetHeight(GEM3UI_DefaultLineHeight);
   if GEM3UI_lines <= GEM3UI_DefaultLines then
    GEM3UIMainEventScrollList:SetVerticalScroll(0);
   end
   GEM3UIEventSubs:Hide();
   GEM3UI_lines = GEM3UI_DefaultLines;
   GEM3UI_expandedLine= 0;
   getglobal(line:GetName().."ExpandButton"):SetText("+");
   GEM3UIeventDetails:Hide();
   GEM3UIMainEventScrollList:SetVerticalScroll(1);
   GEM3UI_SetDebugStatus(sformat("EVENT: %s COLLAPSED", MyEvent[line.ev_index].id),0);
   --line:SetBackdropColor(0.5,0.5,0.5,0);
   line:UnlockHighlight();
   lineheader:Hide();
   line.expanded = false;
   --line:SetHighlightTexture("interface\\buttons\\ui-listbox-highlight2");
 else
   if GEM3UI_expandedLine ~= 0 then
     local expline = getglobal("GEM3UI_lineFrame"..GEM3UI_expandedLine);
     GEM3UI_ExpandEventLine(expline, false);
     GEM3UIEventSubs:Hide();
     getglobal(expline:GetName().."HeadLineBG"):Hide();
   end
   GEM3UI_lines = GEM3UI_DefaultLines-GEM3UI_DefaultLineExpandedMultiplicator+1;
   local scrollup =  lineid + GEM3UI_DefaultLineExpandedMultiplicator-GEM3UI_DefaultLines;
   if scrollup > 0 then
    GEM3UIMainEventScrollList:SetVerticalScroll(GEM3UIMainEventScrollList:GetVerticalScroll()+(GEM3UI_DefaultLineHeight*scrollup));
    lineid = lineid - scrollup;
   end
   GEM3UI_expandedLine = lineid;
   line = getglobal("GEM3UI_lineFrame"..lineid);
   
   lineheader = getglobal(line:GetName().."HeadLineBG");
   line:SetHeight(GEM3UI_DefaultLineExpandedMultiplicator*GEM3UI_DefaultLineHeight);
   getglobal(line:GetName().."ExpandButton"):SetText("-");
   GEM3UIeventDetails.evt = GEM3UI_EventSource[MyEvent[line.ev_index].id];
   GEM3UIeventDetails.recover = false;
   GEM3UIeventDetails:Show();
   GEM3UIeventDetails:SetParent(line);
   GEM3UIeventDetails:SetPoint("TOPLEFT", line ,"TOPLEFT", 1, -17);
   GEM3UIeventDetails:SetPoint("BOTTOMRIGHT", line ,"BOTTOMRIGHT", -1, 1);
   GEM3UI_Scrollpos = GEM3UIMainEventScrollList:GetVerticalScroll();
   es:Hide();
   es.ev_index = line.ev_index;
   es.form=true;
   es:Show();
   --line:SetBackdropColor(0.5,0.5,0.5,1);
   --line:SetHighlightTexture("interface\\dialogframe\\ui-dialogbox-gold-background");
   line.expanded = true;
   lineheader:Show();
   line:LockHighlight();
   GEM3UI_SetDebugStatus(sformat("EVENT: %s EXPANDED", MyEvent[line.ev_index].id),0);
 end
 
 --if eventlistupdate == "true" then 
   --GEM3UI_EventListScrollUpdate(); 
 --end
end

function GEM3UI_Subscribe(self, button)
 GEM3UIEventSubs.userIsEditing = nil
 local ev_id = GEM3UIEventSubs.evt.id;
 local player = GEM3_PLAY_GetPlayerInfos(GEM3UI_ActualPlayerTextLabel:GetText(), GEM3UIEventSubs.evt.channel);
 if not player then
  player = GEM3_PLAY_GetPlayerInfos(GEM3UI_ActualPlayerTextLabel:GetText());
 end
 
 local force_queue = GEM3_SUB_FORCE_QUEUE_NONE;
 if GEM3UIeventDetailsAsRepCB:GetChecked() then 
  force_queue = GEM3_SUB_FORCE_QUEUE_REPLACEMENT;
 elseif GEM3UIeventDetailsAsNCCB:GetChecked() then 
  force_queue = GEM3_SUB_FORCE_QUEUE_NOT_COMING;
 end
 local subs, reason  = GEM3_SUB_Subscribe(
                    ev_id,
                    GEM3UI_ActualPlayerTextLabel.id,
                    player.guild,
                    player.level,
                    player.class,
                    GEM3UI_ActualRoleTextLabel.id,
                    GEM3UI_SUB_Comment:GetText(),
                    force_queue,
                    GEM3UI_AlternateRoleTextLabel.id or GEM3_ROLE_UNKNOWN);
 if subs then
  PlaySound("PVPENTERQUEUE");
 else
  PlaySound("igQuestFailed");
 end                    
 --GEM3UI_-RefreshAll();
 GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_UPDATE", ev_id);
 GEM3UI_SubsFromRefresh();
 GEM3UI_SetStatusMessage(reason);
 GEM3UI_CheckSubsEdit();
end

function GEM3UI_ModifySubscribe()
 local ev_id = GEM3UIEventSubs.evt.id;
 GEM3UIEventSubs.userIsEditing = nil
 local subs = GEM3_SUB_GetSubscribedInfos(ev_id, GEM3UI_ActualPlayerTextLabel.id);
 
 local force_queue = GEM3_SUB_FORCE_QUEUE_NONE;
 if GEM3UIeventDetailsAsRepCB:GetChecked() then 
  force_queue = GEM3_SUB_FORCE_QUEUE_REPLACEMENT;
 elseif GEM3UIeventDetailsAsNCCB:GetChecked() then 
  force_queue = GEM3_SUB_FORCE_QUEUE_NOT_COMING;
 end
 
 local ret, reason  = GEM3_SUB_SubscribeUpdate(
       ev_id,
       subs.name,
       subs.guild,
       subs.level,
       subs.class,
       GEM3UI_ActualRoleTextLabel.id,
       GEM3UI_SUB_Comment:GetText(),
       force_queue,
       GEM3UI_AlternateRoleTextLabel.id or GEM3_ROLE_UNKNOWN);
 if ret then
  PlaySound("PVPENTERQUEUE");
 else
  PlaySound("igQuestFailed");
 end
 --GEM3UI_-RefreshAll();
 GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_UPDATE", ev_id);
 GEM3UI_SubsFromRefresh();
 GEM3UI_SetStatusMessage(reason);
 GEM3UI_CheckSubsEdit();
end


function GEM3UI_UnSubscribe(self)
 
 local ev_id = GEM3UIEventSubs.evt.id;
 local player = GEM3_PLAY_GetPlayerInfos(GEM3UI_ActualPlayerTextLabel.id, GEM3UIEventSubs.evt.channel);
 if not player then
  player = GEM3_PLAY_GetPlayerInfos(GEM3UI_ActualPlayerTextLabel:GetText());
 end
 GEM3UIEventSubs.userIsEditing = nil
 subs, reason  = GEM3_SUB_SubscribeUpdate(
                    ev_id,
                    GEM3UI_ActualPlayerTextLabel.id,
                    player.guild,
                    player.level,
                    player.class,
                    GEM3UI_ActualRoleTextLabel.id,
                    GEM3UI_SUB_Comment:GetText(),
                    GEM3_SUB_FORCE_QUEUE_NOT_COMING,
                    GEM3UI_AlternateRoleTextLabel.id or GEM3_ROLE_UNKNOWN);
 --GEM3UI_-RefreshAll();
 GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_UPDATE", ev_id);
 GEM3UI_SubsFromRefresh();
 GEM3UI_SetStatusMessage(reason);
 GEM3UI_CheckSubsEdit();
end

function GEM3UI_CheckSubsEdit(self)
    mydbg("CHECK EDIT") 
 -- if not GEM3UIEventSubs.ev_id then return; end

 --GEM3UIEventSubs.userIsEditing = nil;
 GEM3UIEventSubs.comment = nil;
 GEM3UIEventSubs.role = nil
 GEM3UIEventSubs.alt_role = nil;
 GEM3UIEventSubs.state = nil; 
 GEM3UIEventSubs.player = nil;
 local s = GEM3_SUB_GetSubscribedInfos(GEM3UIEventSubs.ev_id, GEM3UI_ActualPlayerTextLabel:GetText())
 if s == nil then s = { comment = "", role = GEM3UI[UnitName("player")].DefaultRole, alt_role = GEM3UI[UnitName("player")].DefaultAltRole, state = GEM3_SUB_STATE_TITULAR}; end
 state = GEM3_SUB_STATE_TITULAR;
 if GEM3UIeventDetailsAsRepCB:GetChecked() then state = GEM3_SUB_STATE_REPLACEMENT end
 if GEM3UIeventDetailsAsNCCB:GetChecked() then state = GEM3_SUB_STATE_NOT_COMING end
 
 if s.comment  ~= GEM3UI_SUB_Comment:GetText()
    or s.alt_role ~= (GEM3UI_AlternateRoleTextLabel.id or GEM3_ROLE_UNKNOWN)
    or s.role     ~= (GEM3UI_ActualRoleTextLabel.id or GEM3_ROLE_UNKNOWN)
    or s.state    ~= state
 then 
        mydbg("SAVING")
   GEM3UIEventSubs.player = GEM3UI_ActualPlayerTextLabel:GetText();
   GEM3UIEventSubs.userIsEditing = true;
   GEM3UIEventSubs.comment = GEM3UI_SUB_Comment:GetText();
   GEM3UIEventSubs.role = (GEM3UI_ActualRoleTextLabel.id or GEM3_ROLE_UNKNOWN)
   GEM3UIEventSubs.alt_role = (GEM3UI_AlternateRoleTextLabel.id or GEM3_ROLE_UNKNOWN);
   GEM3UIEventSubs.state = state; 
 end
end


function GEM3UI_DisplayDaydetails()
 local parent = getglobal("GEM3UIDay");
 local prevbut = getglobal(parent:GetName().."prevbut");
 if prevbut == nil then
  prevbut = CreateFrame("BUTTON", parent:GetName().."prevbut", parent, "PrevButtonTemplate");
  prevbut:SetPoint("TOPLEFT", parent, 5, -5);
  prevbut:SetWidth(16);
  prevbut:SetHeight(16);
  prevbut:SetText("<");
  prevbut:SetScript("OnClick", GEM3UI_PrevDay);
 end
 local nextbut = getglobal(parent:GetName().."nextbut");
 if nextbut == nil then
  nextbut= CreateFrame("BUTTON", parent:GetName().."nextbut", parent, "NextButtonTemplate");
  nextbut:SetPoint("TOPLEFT", parent, 148, -5);
  nextbut:SetWidth(16);
  nextbut:SetHeight(16);
  nextbut:SetText(">");
  nextbut:SetScript("OnClick", GEM3UI_NextDay);
 end
 local m = GEM3UIDay.d;
 local i = 0;
 GEM3UI_DayEvents = {};
 GEM3UI_DayEventCount = 0;
 for i in pairs(MyEvent) do 
  local db = time({["year"] = m.year, ["month"] = m.month, ["day"] = m.day, ["hour"] = 0, ["min"] = 0});
  local de = time({["year"] = m.year, ["month"] = m.month, ["day"] = m.day, ["hour"] = 23, ["min"] = 59});
  if MyEvent[i].ev_date > db and MyEvent[i].ev_date < de then
    GEM3UI_DayEventCount = GEM3UI_DayEventCount +1;
    GEM3UI_DayEvents[GEM3UI_DayEventCount]=i;
  end
 end
 GEM3UI_DayEventListScrollUpdate();
 
 GEM3UIDayDayLabel:SetText(GEM3UI_LocalizedStrings.day[m.wday-1].." "..m.day);
 GEM3UIDayDayMonthYearLabel:SetText(GEM3UI_LocalizedStrings.month[m.month].." "..m.year);
end


function GEM3UI_HighlightEventList(d, lock) 
 --[[for i=1, GEM3UI_DefaultLines do
  local line = getglobal("GEM3UI_lineFrame"..i);
  if lock == true then
   if line:IsVisible() then
    if d <= MyEvent[line.ev_index].ev_date and (d+60*60*24) >= MyEvent[line.ev_index].ev_date then
     line:LockHighlight();
    end
   end
  else
   line:UnlockHighlight();
  end
 end]]--
end


function GEM3UI_EventDetailsShow(id)


  if GEM3UIEventSubs.userIsEditing == true then return end

 local ev = GEM3UIEventSubs.evt;
 local es = getglobal("GEM3UIEventSubs");
 local now = time();
 GEM3UI_eventSubscriptionListInvite:Disable();
 GEM3UI_eventSubscriptionListAddMember:Disable();
 if ev.leader == UnitName("player") or GEM3_EVT_IsAssistant(ev.id,UnitName("player"))
  then
   if not GEM3UI_EventIsGroupFull(ev) 
      and (GEM3UI_GroupingForEvent == nil or GEM3UI_GroupingForEvent == ev.id)
      and date("%m%d%Y", ev.ev_date) == date("%m%d%Y", now) 
   then
    GEM3UI_eventSubscriptionListInvite:Enable();
   end
   GEM3UI_eventSubscriptionListAddMember:Enable();
  end
 
 local evico = getglobal ("GEM3UIEventSubsEventIcon");
 if evico == nil then
   evico = GEM3UIEventSubs:CreateTexture("GEM3UIEventSubsEventIcon");
   evico:SetPoint("TOPLEFT", GEM3UIEventSubs, "TOPLEFT", 7, -6);
   evico:SetWidth(20);
   evico:SetHeight(20);
   evico:SetDrawLayer("ARTWORK");
   evico:Show();
 end
 evico:SetTexture(GEM3UI_LocalizedStrings.EventTypes[ev.ev_type].tbin);
  
 local evdelimiter = getglobal ("GEM3UIEventSubsEventDelimiter1");
 if evdelimiter == nil then
   evdelimiter = GEM3UIEventSubs:CreateTexture("GEM3UIEventSubsEventDelimiter1");
   evdelimiter:SetPoint("TOPLEFT", GEM3UIEventSubs, "TOPLEFT", 3, -3);
   evdelimiter:SetWidth(GEM3UIEventSubs:GetWidth()-6);
   evdelimiter:SetHeight(24);
   evdelimiter:Show();
   evdelimiter:SetDrawLayer("BACKGROUND");
   evdelimiter:SetTexture(0.4,0.4,0.4,1);
 end
 local evdelimiter = getglobal ("GEM3UIEventSubsEventDelimiter2");
 if evdelimiter == nil then
   evdelimiter = GEM3UIEventSubs:CreateTexture("GEM3UIEventSubsEventDelimiter2");
   evdelimiter:SetPoint("TOPLEFT", GEM3UIEventSubsEv_NameLabel, "BOTTOMLEFT", -5, -1);
   evdelimiter:SetWidth(GEM3UIEventSubs:GetWidth()-6);
   evdelimiter:SetHeight(1);
   evdelimiter:Show();
   evdelimiter:SetDrawLayer("BACKGROUND");
   evdelimiter:SetTexture(0.5,0.5,0.5,1);
 end
 local evdelimiter = getglobal ("GEM3UIEventSubsEventDelimiter3");
 if evdelimiter == nil then
   evdelimiter = GEM3UIEventSubs:CreateTexture("GEM3UIEventSubsEventDelimiter3");
   evdelimiter:SetPoint("TOPLEFT", GEM3UIEventSubsEv_CommentLabel, "BOTTOMLEFT", -5, -1);
   evdelimiter:SetWidth(GEM3UIEventSubs:GetWidth()-6);
   evdelimiter:SetHeight(1);
   evdelimiter:Show();
   evdelimiter:SetDrawLayer("BACKGROUND");
   evdelimiter:SetTexture(0.5,0.5,0.5,1);
 end

 
 
 if GEM3UI_ShowTemplates:GetChecked() then
  GEM3UIEventSubsEv_NameLabel:SetText(ev.ev_place);
  GEM3UIEventSubsLeaderLabel:SetText(UnitName("player"));
  GEM3UIEventSubsEv_SubsLabel:SetText("");
  GEM3UIEventSubsEvDateLabel:SetText("");
  GEM3UIEventSubsEv_CommentLabel:SetText(GEM3UI_LocalizedStrings["_Comment"]..": ");
  GEM3UIEventSubsMessageTextLabel:SetText("");
 else
  GEM3UIEventSubsEv_NameLabel:SetText(ev.ev_place);
  GEM3UIEventSubsLeaderLabel:SetText(ev.leader);
  GEM3UIEventSubsEv_SubsLabel:SetText((ev.tit_count or "nil").."/"..(ev.max_count or "nil").."("..(ev.repl_count or "nil")..")/["..(ev.sub_count or "nil").."]");
  --local datestr = GEM3UI_LocalizedStrings["dayshort"][date("*t", ev.ev_date+(GEM3UI.ServerTimeOffSet*60*60)).wday-1];
  local datestr = GEM3UI_FormatDateString(ev.ev_date+(GEM3UI.ServerTimeOffSet*60*60), true);
  GEM3UIEventSubsEvDateLabel:SetText(datestr);
  GEM3UIEventSubsEv_CommentLabel:SetText(GEM3UI_LocalizedStrings["_Comment"]..": "..ev.ev_comment);
  es.ev_id = ev.id;
  if ev.deadline == nil then ev.deadline = ev.ev_date; end
 end

 local playerison, rerollison = GEM3_CHAN_IsChannelConfiguredForAnyReroll(ev.channel);

 GEM3UIEventSubsForm:Hide();
 GEM3UIEventSubsMessage:Show();
 if GEM3UI_ShowArchive:GetChecked() then
  GEM3UIEventSubsMessageTextLabel:SetText(GEM3UI_LocalizedStrings["cannotsubsarchived"]);
 elseif GEM3UI_ShowTemplates:GetChecked() then
  GEM3UIEventSubsMessageTextLabel:SetText(GEM3UI_LocalizedStrings["cannotsubstemplate"]);
 elseif (now>ev.deadline or now>ev.ev_date) then
   GEM3UIEventSubsMessageTextLabel:SetText(GEM3UI_LocalizedStrings["cannotsubspassed"]);
 elseif  ev.closed_comment ~= nil then
  if ev.closed_comment == "Ignored" then
   GEM3UIEventSubsMessageTextLabel:SetText(GEM3UI_LocalizedStrings["cannotsubsignored"]);
  else
   GEM3UIEventSubsMessageTextLabel:SetText(sformat(GEM3UI_LocalizedStrings["cannotsubsclosed"],ev.closed_comment));
  end
 elseif GEM3_EVT_IsEventIgnored(ev.id) then
  GEM3UIEventSubsMessageTextLabel:SetText(GEM3UI_LocalizedStrings["cannotsubsignored"]); 
 elseif not rerollison then
  GEM3UIEventSubsMessageTextLabel:SetText(GEM3UI_LocalizedStrings["cannotsubsotherchan"]);
 else
  GEM3UIEventSubsMessageTextLabel:SetText("");
 end

 if GEM3UIEventSubsMessageTextLabel:GetText() == nil then 
   GEM3UIEventSubsForm:Show();
   GEM3UIEventSubsMessage:Hide();
   --if GEM3UIEventSubs.userIsEditing == nil then
    GEM3UI_SubsFromRefresh();
   --end
 else
   GEM3UIEventSubsForm:Hide();
   GEM3UIEventSubsMessage:Show();
 end
end

function GEM3UI_SubsFromRefresh(id)
 --GEM3UI_CheckSubsEdit();
 -- if ID == nil then
 if (GEM3UIEventSubs.userIsEditing == true) and (id == nil) then return; end
 local ev;
 -- error("refresh");
  mydbg(debugstack())
 --GEM3UIEventSubsFormCancelButton:Disable();
 GEM3UIEventSubsFormSubscribeButton:Disable();
 GEM3UIeventDetailsAsRepCB:SetChecked(false);
 GEM3UIeventDetailsAsNCCB:SetChecked(false);
 GEM3UI_SUB_Comment:SetText("");
 GEM3UIEventSubsFormSubscribeButton:SetScript("OnClick", GEM3UI_Subscribe);
 GEM3UIEventSubsFormSubscribeButton:SetText(GEM3UI_LocalizedStrings["_Subscribe"]);
 ev = GEM3UI_EventSource[GEM3UIEventSubs.ev_id];
 if ev == nil then return; end
 
 GEM3UI_AlternateRoleTextLabel.id= GEM3_ROLE_UNKNOWN;
 GEM3UI_AlternateRoleTextLabel.value = GEM3_ROLE_UNKNOWN;
 GEM3UI_AlternateRoleTextLabel:SetText(GEM3UI_Roles[GEM3UI_GetRoleIndex(GEM3_ROLE_UNKNOWN)].name_loc);
 
 if id == nil then 
   GEM3UI_ActualPlayerTextLabel:SetText(GEM3UIEventSubs.player or UnitName("player"));
   GEM3UI_ActualPlayerTextLabel.id = GEM3UIEventSubs.player or UnitName("player");
   GEM3UI_ActualPlayerTextLabel.value =  GEM3UIEventSubs.player or UnitName("player");
  
   GEM3UI_ActualRoleTextLabel.id = GEM3UIEventSubs.role or GEM3UI[UnitName("player")].DefaultRole;
   GEM3UI_ActualRoleTextLabel.value = GEM3UIEventSubs.role or GEM3UI[UnitName("player")].DefaultRole;
   GEM3UI_ActualRoleTextLabel:SetText(GEM3UI_Roles[GEM3UI_GetRoleIndex(GEM3UIEventSubs.role or GEM3UI[UnitName("player")].DefaultRole)].name_loc);
   
   GEM3UI_AlternateRoleTextLabel.id = GEM3UIEventSubs.alt_role or GEM3UI[UnitName("player")].DefaultAltRole;
   GEM3UI_AlternateRoleTextLabel.value = GEM3UIEventSubs.alt_role or GEM3UI[UnitName("player")].DefaultAltRole;
   GEM3UI_AlternateRoleTextLabel:SetText(GEM3UI_Roles[GEM3UI_GetRoleIndex(GEM3UIEventSubs.alt_role or GEM3UI[UnitName("player")].DefaultAltRole)].name_loc);
   local rerolls =  GEM3_PLAY_GetMyRerolls();
   --for pl_index, pl_struct in ipairs(rerolls) do
    local plsub = GEM3_SUB_GetSubscribedInfos(ev.id) --, UnitName("player"));
    if plsub then
     GEM3UI_ActualPlayerTextLabel:SetText(plsub.name);
     GEM3UI_ActualPlayerTextLabel.id=plsub.name;
     GEM3UI_ActualPlayerTextLabel.value=plsub.name;
     GEM3UI_ActualRoleTextLabel.id = plsub.role;
     GEM3UI_ActualRoleTextLabel.value = plsub.role;
     GEM3UI_ActualRoleTextLabel:SetText(GEM3UI_Roles[GEM3UI_GetRoleIndex(plsub.role)].name_loc);
     
     GEM3UI_AlternateRoleTextLabel.id= plsub.alt_role;
     GEM3UI_AlternateRoleTextLabel.value = plsub.alt_role;
     GEM3UI_AlternateRoleTextLabel:SetText(GEM3UI_Roles[GEM3UI_GetRoleIndex(plsub.alt_role)].name_loc);

     if plsub.state == 3 then GEM3UIeventDetailsAsRepCB:SetChecked(true); end
     if plsub.state == 4 then GEM3UIeventDetailsAsNCCB:SetChecked(true); end
     GEM3UI_SUB_Comment:SetText(plsub.comment);
     GEM3UIEventSubsFormSubscribeButton:SetText(GEM3UI_LocalizedStrings["_Update"]);
     GEM3UIEventSubsFormSubscribeButton:SetScript("OnClick", GEM3UI_ModifySubscribe);
     GEM3UIEventSubsFormSubscribeButton:Enable();
     --GEM3UIEventSubsFormCancelButton:Enable();
     --GEM3UIEventSubsFormCancelButton:SetScript("OnClick", GEM3UI_UnSubscribe);
    end
   --end
   GEM3UIEventSubsFormSubscribeButton:Enable();
   GA_ReleaseTable(rerolls,0);
 else
   local plsub = GEM3_SUB_GetSubscribedInfos(ev.id,GEM3UI_ActualPlayerTextLabel:GetText());
   if plsub then
     GEM3UIEventSubsFormSubscribeButton:SetText(GEM3UI_LocalizedStrings["_Update"]);
     GEM3UIEventSubsFormSubscribeButton:SetScript("OnClick", GEM3UI_ModifySubscribe);
     GEM3UIEventSubsFormSubscribeButton:Enable();
     --GEM3UIEventSubsFormCancelButton:Enable();
     --GEM3UIEventSubsFormCancelButton:SetScript("OnClick", GEM3UI_UnSubscribe);
     
     GEM3UI_ActualRoleTextLabel.id = GEM3UIEventSubs.role or plsub.role;
     GEM3UI_ActualRoleTextLabel.value = GEM3UIEventSubs.role or plsub.role;
     GEM3UI_ActualRoleTextLabel:SetText(GEM3UI_Roles[GEM3UI_GetRoleIndex(GEM3UIEventSubs.role or plsub.role)].name_loc);
     
     GEM3UI_AlternateRoleTextLabel.id= GEM3UIEventSubs.alt_role or plsub.alt_role;
     GEM3UI_AlternateRoleTextLabel.value = GEM3UIEventSubs.alt_role or plsub.alt_role;
     GEM3UI_AlternateRoleTextLabel:SetText(GEM3UI_Roles[GEM3UI_GetRoleIndex(GEM3UIEventSubs.alt_role or plsub.alt_role)].name_loc);
     if GEM3UIEventSubs.state then
        if GEM3UIEventSubs.state  == 3 then GEM3UIeventDetailsAsRepCB:SetChecked(true); end
        if GEM3UIEventSubs.state  == 4 then GEM3UIeventDetailsAsNCCB:SetChecked(true); end
     else
        if plsub.state == 3 then GEM3UIeventDetailsAsRepCB:SetChecked(true); end
        if plsub.state == 4 then GEM3UIeventDetailsAsNCCB:SetChecked(true); end
     end
     GEM3UI_SUB_Comment:SetText(GEM3UIEventSubs.comment or plsub.comment);
     GEM3UIEventSubsFormSubscribeButton:Enable();
   else
     local role, altrole;
     local p = GEM3_PLAY_GetPlayerInfos(GEM3UI_ActualPlayerTextLabel:GetText(), ev.channel);
      if not p then
        p = GEM3_PLAY_GetPlayerInfos(GEM3UI_ActualPlayerTextLabel:GetText());
      end

     if p == nil then
      role =  GEM3UI[UnitName("player")].DefaultRole;
      altrole = GEM3_ROLE_UNKNOWN;
     else
      role = GEM3UI[UnitName("player")].DefaultRole;
      altrole = p.alt_role;
     end
     GEM3UI_ActualRoleTextLabel.id = role;
     GEM3UI_ActualRoleTextLabel.value = role;
     GEM3UI_ActualRoleTextLabel:SetText(GEM3UI_Roles[GEM3UI_GetRoleIndex(role)].name_loc);
     
     GEM3UI_AlternateRoleTextLabel.id= altrole;
     GEM3UI_AlternateRoleTextLabel.value = altrole;
     GEM3UI_AlternateRoleTextLabel:SetText(GEM3UI_Roles[GEM3UI_GetRoleIndex(altrole)].name_loc);
     
     GEM3UIEventSubsFormSubscribeButton:SetText(GEM3UI_LocalizedStrings["_Subscribe"]);
     GEM3UIEventSubsFormSubscribeButton:SetScript("OnClick", GEM3UI_Subscribe);
     GEM3UIEventSubsFormSubscribeButton:Enable();
     --GEM3UIEventSubsFormCancelButton:Disable();
   end
  end
end


function GEM3UI_SortEventPlayer(e1,e2)
 local res = false;
 local e1q, e2q, e1pos, e2pos;
 
 
 if e1.current_queue ~= nil then
  e1q = e1.current_queue;
  e1pos = e1.queue_pos;
 else
  e1q = 10;
  e1pos = e1.update_time;
 end
 
 if e2.current_queue ~= nil then
  e2q = e2.current_queue;
  e2pos = e2.queue_pos;
 else
  e2q = 10;
  e2pos = e2.update_time;
 end
 
 if e2q > e1q then
   res = true;
 elseif e2q == e1q then
  if e1pos == nil then e1pos = 0; end
  if e2pos == nil then e2pos = 0; end
  if e2pos > e1pos then
   res = true;
  end
 end
 return res;
end

function GEM3UI_EventLinePopulate(evid)
 --mydbg("GEM3UI_EventLinePopulate");
 GEM3UI_DrawEventDetailsLimits();
 local ev
 if evid then 
    ev = GEM3UI_EventSource[evid]
 else
    ev = GEM3UIeventDetails.evt;
 end
 if not ev then return end
 local players = ev.players;
 local climits = ev.classes;
 local rlimits = ev.roles;
 local parent = getglobal("GEM3UI_eventSubscriptionList");
 local limitsframe = getglobal("GEM3UIeventDetailsLimitsFrame");
 GEM3UI_eventmembercount =0;
 if GEM3UI_EventPlayers == nil then
  GEM3UI_EventPlayers= GA_GetTable();
 else
  GEM3UI_EventPlayers = GA_WipeTable(GEM3UI_EventPlayers,0);
 end
 local playerslist = getglobal("GEM3UI_eventSubscriptionListScroll");
 
 if not GEM3UI_ShowArchive:GetChecked() then
  players = GEM3_CMD_GetNonAckedSubscriptions(ev.id);
  if players ~= nil then
   for _, pl_struct in ipairs(players) do
     if (pl_struct.force_queue == GEM3_SUB_FORCE_QUEUE_NOT_COMING) then
      pl_struct.current_queue = GEM3_SUB_STATE_NOT_COMING;
     end
     if (pl_struct.force_queue == GEM3_SUB_FORCE_QUEUE_REPLACEMENT) then
      pl_struct.current_queue = GEM3_SUB_STATE_REPLACEMENT;
     end
     if (GEM3UI_RoleFilter == nil and GEM3UI_ClassFilter == nil)
        or bit.band(GEM3UI_RoleFilter or 0, pl_struct.role) ~= 0
        or GEM3UI_ClassFilter == pl_struct.class
     then
      GEM3UI_eventmembercount = GEM3UI_eventmembercount +1;
      local p = MovixLib_TblCpy(pl_struct)
      local pl = nil
      if GEM3_QA_Players[ev.channel] and GEM3_QA_Players[ev.channel][p.name] then
        pl = GEM3_QA_Players[ev.channel][p.name]
        p.location = pl.location
        p.grank_name = pl.grank_name
        p.connected = pl.connected
        p.instance_type = pl.instance_type
      end
      p.evid = ev.id
      if p.name == ev.leader then
        p.isleader = 1
      elseif GEM3_EVT_IsAssistant(ev.id, p.name) then
        p.isleader = 2
      else
        p.isleader = 0
      end

      tinsert(GEM3UI_EventPlayers, p);
     end
   end
   GA_ReleaseTable(players);
  end
 end
 
 for name, pl_struct in pairs(ev.players) do
   local isNA = false;
   for i, pl in pairs(GEM3UI_EventPlayers) do
    if pl.name == pl_struct.name then
     isNA= true;
    end
   end
   if isNA == false then
     if (GEM3UI_RoleFilter == nil and GEM3UI_ClassFilter == nil)
        or bit.band(GEM3UI_RoleFilter or 0, pl_struct.role) ~= 0
        or GEM3UI_ClassFilter == pl_struct.class
     then
     GEM3UI_eventmembercount = GEM3UI_eventmembercount +1;
     local p = MovixLib_TblCpy(pl_struct)
     local pl = nil
     if GEM3_QA_Players[ev.channel] and GEM3_QA_Players[ev.channel][p.name] then
        pl = GEM3_QA_Players[ev.channel][p.name]
        p.location = pl.location
        p.grank_name = pl.grank_name
        p.instance_type = pl.instance_type
        p.connected = pl.connected
     end
      if p.name == ev.leader then
        p.isleader = 1
      elseif GEM3_EVT_IsAssistant(ev.id, p.name) then
        p.isleader = 2
      else
        p.isleader = 0
      end
     p.evid = ev.id
     tinsert(GEM3UI_EventPlayers, p);
    end
   end
 end
 
 local lbl;
 for i in pairs(GEM3UI_Classes) do
  if GEM3UI_Classes[i].active == true then
   local limindex = GEM3UI_Classes[i].gemid;
   local limitmax = climits[limindex].max;
   local limitmin = climits[limindex].min;
   local tit_count = climits[limindex].tit_count;
   local sub_count = climits[limindex].sub_count;
   local repl_count = climits[limindex].repl_count;
   if limitmax == nil then limitmax = ""; end
   if limitmin == nil then limitmin = ""; end
   if tit_count == 0 then tit_count = ""; end
   if sub_count == 0 then sub_count = ""; end
   if repl_count == 0 then repl_count = ""; end
   
   --lbl = getglobal("GEM3UIeventDetailsLimitsFrameLimit"..limindex .."TLabel");
   lbl=limitsframe.Classline[i].t
   lbl:SetText(tit_count);
   lbl:SetTextColor(1,1,1,1);
   
   --lbl=getglobal("GEM3UIeventDetailsLimitsFrameLimit"..limindex .."SLabel");
   lbl=limitsframe.Classline[i].s
   lbl:SetText(sub_count);
   lbl:SetTextColor(1,1,1,1);
   
   --lbl=getglobal("GEM3UIeventDetailsLimitsFrameLimit"..limindex .."RLabel");
   lbl=limitsframe.Classline[i].r
   lbl:SetText(repl_count);
   lbl:SetTextColor(1,1,1,1);
   
   --lbl = getglobal("GEM3UIeventDetailsLimitsFrameLimit"..limindex .."MiLabel");
   lbl=limitsframe.Classline[i].m
   lbl:SetText(limitmin);
   lbl:SetTextColor(1,1,1,1);
--   if ((tonumber(tit_count) or 0) + (tonumber(sub_count) or 0)) >= (tonumber(limitmin) or 0) then
   if (tonumber(tit_count) or 0) < (tonumber(limitmin) or 0) then
     lbl:SetTextColor(1,0,0,1);
   end
   
   --lbl = getglobal("GEM3UIeventDetailsLimitsFrameLimit"..limindex .."MaLabel");
   lbl=limitsframe.Classline[i].M
   lbl:SetText(limitmax);
   lbl:SetTextColor(1,1,1,1);
   --if ((tonumber(tit_count) or 0)+ (tonumber(sub_count) or 0)) > (tonumber(limitmax) or 0) then
--     lbl:SetTextColor(1,0,0,1);
   --end
  end
 end
 
 for i in pairs(GEM3UI_Roles) do
  if GEM3UI_Roles[i].active == true or i == 4 then
   if not (i == 4 and GEM3UI_ShowTemplates:GetChecked()) then   
    local limindex = GEM3UI_Roles[i].gemid;
    local limname = GEM3UI_Roles[i].name;
    if rlimits[limindex] ~= nil then
     local rmin = rlimits[limindex].min;
     local rmax = rlimits[limindex].max;
     local rtit = rlimits[limindex].tit_count;
     local rsub = rlimits[limindex].sub_count;
     local rrep = rlimits[limindex].repl_count;
     if rmax == nil then rmax = ""; end
     if rmin == nil then rmin = ""; end
     if rtit == 0 then rtit = ""; end
     if rsub == 0 then rsub = ""; end
     if rrep == 0 then rrep = ""; end
   
     
     lbl=limitsframe.Roleline[i].t
     --getglobal("GEM3UIeventDetailsLimitsFrameLimit"..limname.."TLabel");
     lbl:SetText(rtit);
     lbl:SetTextColor(1,1,1,1);
   
     --lbl=getglobal("GEM3UIeventDetailsLimitsFrameLimit"..limname.."SLabel");
     lbl=limitsframe.Roleline[i].s
     lbl:SetText(rsub);
     lbl:SetTextColor(1,1,1,1);
   
     --lbl=getglobal("GEM3UIeventDetailsLimitsFrameLimit"..limname.."RLabel");
     lbl=limitsframe.Roleline[i].r
     lbl:SetText(rrep);
     lbl:SetTextColor(1,1,1,1);
   
     --lbl = getglobal("GEM3UIeventDetailsLimitsFrameLimit"..limname .."MiLabel");
     lbl=limitsframe.Roleline[i].m
     lbl:SetText(rmin);
     lbl:SetTextColor(1,1,1,1);
     --if ((tonumber(rtit) or 0) + (tonumber(rsub) or 0)) >= (tonumber(rmin) or 0) then
     if (tonumber(rtit) or 0) < (tonumber(rmin) or 0) then
       lbl:SetTextColor(1,0,0,1);
     end
   
     --lbl = getglobal("GEM3UIeventDetailsLimitsFrameLimit"..limname .."MaLabel");
     lbl=limitsframe.Roleline[i].M
     lbl:SetText(rmax);
     lbl:SetTextColor(1,1,1,1);
     --if ((tonumber(rtit) or 0) + (tonumber(rsub) or 0)) > (tonumber(rmax) or 0) then
 --      lbl:SetTextColor(1,0,0,1);
     --end
    end
   end
  end
 end

 if GEM3UI.Gridstyle then 
      GEM3UI_FilleventPlayersList(GEM3UI_SelectedEvent)
 --else
    --tsort(GEM3UI_EventPlayers,GEM3UI_SortEventPlayer);
    --GEM3UI_EventMembersListScrollUpdate();
 end
 
 if GEM3UIMain:IsVisible() then
  local es = getglobal("GEM3UIEventSubs");
  es.ev_index = ev.id;
  if not GEM3UI_ShowArchive:GetChecked() then
   --if GEM3UIEventSubs.userIsEditing == nil then
    GEM3UI_SubsFromRefresh();
   --end
  end
 end
end

function GEM3UI_FilterPlayerListReset(self)
 mydbg("GEM3UI_FilterPlayerListReset");
 GEM3UI_RoleFilter = nil;
 GEM3UI_ClassFilter = nil;
 GEM3UI_EventLinePopulate();
 local classline = getglobal("GEM3UI_EventDetailsClassLimitsHL");
 if classline then
    classline:Hide();
 end
end

function GEM3UI_FilterPlayerListRole(self, id)
 mydbg("GEM3UI_FilterPlayerListRole");
 GEM3UI_RoleFilter = GEM3UI_Roles[id].gemid;
 GEM3UI_EventLinePopulate();
 GEM3UI_FilterPlayerListHighlight("ROLE", id)
end

function GEM3UI_FilterPlayerListClass(self,id)
 mydbg("GEM3UI_FilterPlayerListClass");
 GEM3UI_ClassFilter = GEM3UI_Classes[id].gemid;
 GEM3UI_EventLinePopulate();
 GEM3UI_FilterPlayerListHighlight("CLASS", id)
end


function GEM3UI_FilterPlayerListHighlight(ftype, id)
 mydbg("GEM3UI_FilterPlayerListHighlight");
 local parent = getglobal("GEM3UIeventDetailsLimitsFrame");
 local line = getglobal("GEM3UI_EventDetailsClassLimitsHL");
 
 local linep = nil
 if ftype == "CLASS" then
  linep = getglobal("GEM3UI_EventDetailsLimitsFrame"..GEM3UI_Classes[id].gemid.."Uline");
 else 
  linep = getglobal("GEM3UI_EventDetailsLimitsFrame"..GEM3UI_Roles[id].name.."Uline");
 end
 if line == nil then
    line  = parent:CreateTexture("GEM3UI_EventDetailsClassLimitsHL");
    line:SetHeight(15);
    line:SetWidth(parent:GetWidth()-10);
    line:SetDrawLayer("BORDER");
    line:SetTexture(0.4,0.4,0.4,0.4);
 end
 line:SetWidth(parent:GetWidth()-10);

 if ftype == "CLASS" then
        line:SetPoint("TOPLEFT", parent.Classline[id].lb, "TOPLEFT", 0, 0);
 else
        line:SetPoint("TOPLEFT", parent.Roleline[id].lb, "TOPLEFT", 0, 0);
 end
 line:Show();
end



function GEM3UI_SetLimitsframeWidth(self, button)
    local parent = GEM3UIeventDetailsLimitsFrame
    parent:ClearAllPoints()
    parent:SetPoint("TOPRIGHT", -3, -32)
    parent:SetHeight(270)
    if self == nil then
        if GEM3UI.eventLimitsWidth == 130 then
            GEM3UI.eventLimitsWidth = 244
        else
            GEM3UI.eventLimitsWidth = 130
        end
    end
    if not GEM3UI.Gridstyle then 
        GEM3UI.eventLimitsWidth = 130 
        parent.expandbutton:Hide()
    else
        parent.expandbutton:Show()
    end
    if GEM3UI.eventLimitsWidth == 130 then
        GEM3UI.eventLimitsWidth = 244
        for i, l in pairs(parent.Roleline) do
            l.name:Show()
        end
        for i, l in pairs(parent.Classline) do
            l.name:Show()
        end
        parent.expandbutton:SetNormalTexture("interface\\AddOns\\GridLib\\gfx\\arrow-r")
        parent.expandbutton:SetHighlightTexture("interface\\AddOns\\GridLib\\gfx\\arrow-r-h")
        parent.expandbutton:SetPushedTexture("interface\\AddOns\\GridLib\\gfx\\arrow-r-d")
    else
        GEM3UI.eventLimitsWidth = 130 
        for i, l in pairs(parent.Roleline) do
            l.name:Hide()
        end
        for i, l in pairs(parent.Classline) do
            l.name:Hide()
        end
        parent.expandbutton:SetNormalTexture("interface\\AddOns\\GridLib\\gfx\\arrow-l")
        parent.expandbutton:SetHighlightTexture("interface\\AddOns\\GridLib\\gfx\\arrow-l-h")
        parent.expandbutton:SetPushedTexture("interface\\AddOns\\GridLib\\gfx\\arrow-l-d")

    end
    GEM3UIeventDetailsLimitsFrame:SetWidth(GEM3UI.eventLimitsWidth)
    local line  = getglobal("GEM3UI_EventDetailsClassLimitsHL");
    line:SetWidth(GEM3UI.eventLimitsWidth-10);
    line  = getglobal("GEM3UI_EventDetailsRoleLimitsHL");
    line:SetWidth(GEM3UI.eventLimitsWidth-10);
    -- work aroung buggy behavior of details header icon, seems there is still a bug in the control recycling functions
    --if GEM3UI_EventDetailsStandAloneFrame and GEM3UI_EventDetailsStandAloneFrame.fr and GEM3UI_EventDetailsStandAloneFrame.fr.icon then
      --  GEM3UI_EventDetailsStandAloneFrame.fr.icon:Show()
    --end
end

function GEM3UI_DrawEventDetailsLimits(id)
  local font = "Fonts\\FRIZQT__.TTF"
  local parent = getglobal("GEM3UIeventDetailsLimitsFrame");
 
  local line  = getglobal("GEM3UI_EventDetailsClassLimitsHL");
  if line == nil then
    line  = parent:CreateTexture("GEM3UI_EventDetailsClassLimitsHL");
    line:SetHeight(15);
    line:SetDrawLayer("BORDER");
    line:SetTexture(0.4,0.4,0.4,0.4);
  end
  line:SetWidth(GEM3UI.eventLimitsWidth-10);
  line  = getglobal("GEM3UI_EventDetailsRoleLimitsHL");
  if line == nil then
    line = parent:CreateTexture("GEM3UI_EventDetailsRoleLimitsHL");
    line:SetHeight(15);
    line:SetWidth(parent:GetWidth()-10);
    line:SetDrawLayer("BORDER");
    line:SetTexture(0.4,0.4,0.4,0.4);
  end
  line:SetWidth(GEM3UI.eventLimitsWidth-10);
  parent.hlline = line
  
  local eb = parent.expandbutton
  if not parent.expandbutton then
    parent.expandbutton = MovixLib_GetControlObject(parent, "custombutton")
    eb = parent.expandbutton
    eb:SetNormalTexture("interface\\AddOns\\GridLib\\gfx\\arrow-r")
    eb:SetHighlightTexture("interface\\AddOns\\GridLib\\gfx\\arrow-r-h")
    eb:SetPushedTexture("interface\\AddOns\\GridLib\\gfx\\arrow-r-d")
    eb:ClearAllPoints()
    eb:SetPoint("TOPLEFT", 5,0)
    eb:SetWidth(20)
    eb:SetHeight(20)
  end
  eb:SetScript("OnClick", GEM3UI_SetLimitsframeWidth)


  local hdltt = GEM3UI_LocalizedStrings["_titularshort"] .. " = " .. GEM3UI_LocalizedStrings["tt_GEM3UIeventDetailsLimitsFrameLimitHeaderTIT1"]
  hdltt = hdltt .. "\n" .. GEM3UI_LocalizedStrings["_substituteshort"] .. " = " .. GEM3UI_LocalizedStrings["tt_GEM3UIeventDetailsLimitsFrameLimitHeaderSUB1"]
  hdltt = hdltt .. "\n" .. GEM3UI_LocalizedStrings["_replacementshort"] .. " = " .. GEM3UI_LocalizedStrings["tt_GEM3UIeventDetailsLimitsFrameLimitHeaderREP1"]
  hdltt = hdltt .. "\nm = " .. GEM3UI_LocalizedStrings["tt_GEM3UIeventDetailsLimitsFrameLimitHeaderMIN1"]
  hdltt = hdltt .. "\nM = " .. GEM3UI_LocalizedStrings["tt_GEM3UIeventDetailsLimitsFrameLimitHeaderMAX1"]

  parent.hlb = MovixLib_GetControlObject(parent, "custombutton")
  parent.hlb:ClearAllPoints()
  parent.hlb:SetPoint("TOPLEFT", parent, "TOPLEFT", 5,-22)
  parent.hlb:SetPoint("BOTTOMRIGHT", parent, "TOPRIGHT", -5,-33)
  parent.hlb:SetHighlightTexture("")
  parent.hlb:SetNormalTexture("")
  parent.hlb:SetPushedTexture("")
  parent.hlb:SetScript("OnEnter", function(self) GEM3UI_GameTooltipShow(self, hdltt) end)
  parent.hlb:SetScript("OnLeave", function(self) GEM3UI_HideTooltip() end)
  
  local hl = parent.Headline 
  if not parent.Headline  then 
    parent.Headline = MovixLib_GetControlObject(parent, "string")
    hl = parent.Headline 
    hl:ClearAllPoints()
    hl:SetPoint("TOPLEFT", parent, "TOPLEFT", 22,-3)
    hl:SetPoint("BOTTOMRIGHT", parent, "TOPRIGHT", -5,-17)
    hl:SetJustifyH("LEFT")
    hl:SetJustifyV("MIDDLE")
    hl:SetFont(font, 8);
    hl:SetText(GEM3UI_LocalizedStrings["_RolesNClasses"])
  end
  hl:Show()
  local hs = parent.HeaderSeperator 
  if not parent.HeaderSeperator then 
    parent.HeaderSeperator = MovixLib_GetControlObject(parent, "texture")
    hs = parent.HeaderSeperator 
    hs:ClearAllPoints()
    hs:SetPoint("TOPLEFT", parent, "TOPLEFT", 5,-20)
    hs:SetPoint("BOTTOMRIGHT", parent, "TOPRIGHT", -5,-21)
    hs:SetTexture(1,1,0,1)
  end
  hs:Show()
  local hmax = parent.HeadMax
  if not parent.HeadMax then 
    parent.HeadMax = MovixLib_GetControlObject(parent, "string")
    hmax = parent.HeadMax
    hmax:ClearAllPoints()
    hmax:SetPoint("TOPRIGHT", parent, "TOPRIGHT", -5,-22)
    hmax:SetWidth(20)
    hmax:SetHeight(12)
    hmax:SetJustifyH("CENTER")
    hmax:SetJustifyV("MIDDLE")
    hmax:SetFont(font, 8);
    hmax:SetTextColor(1,1,0,1);
    hmax:SetText("M")
  end
  local ms = parent.MaxSeperator 
  if not parent.MaxSeperator then 
    parent.MaxSeperator = MovixLib_GetControlObject(parent, "texture")
    ms = parent.MaxSeperator 
    ms:ClearAllPoints()
    ms:SetPoint("TOPRIGHT", hmax, "TOPLEFT", 0,0)
    ms:SetWidth(1)
    ms:SetHeight(245)
    ms:SetTexture(1,1,0,0.5)
  end
  ms:Show()
  local hmin = parent.HeadMin
  if not parent.HeadMin then 
    parent.HeadMin = MovixLib_GetControlObject(parent, "string")
    hmin = parent.HeadMin
    hmin:ClearAllPoints()
    hmin:SetPoint("TOPRIGHT", hmax, "TOPLEFT", 0,0)
    hmin:SetWidth(20)
    hmin:SetHeight(12)
    hmin:SetJustifyH("CENTER")
    hmin:SetJustifyV("MIDDLE")
    hmin:SetFont(font, 8);
    hmin:SetTextColor(1,1,0,1);
    hmin:SetText("m")
  end
  local ms = parent.MinSeperator 
  if not parent.MinSeperator then 
    parent.MinSeperator = MovixLib_GetControlObject(parent, "texture")
    ms = parent.MinSeperator 
    ms:ClearAllPoints()
    ms:SetPoint("TOPRIGHT", hmin, "TOPLEFT", 0,0)
    ms:SetWidth(1)
    ms:SetHeight(245)
    ms:SetTexture(1,1,0,0.5)
  end  
  ms:Show()
  local hrep = parent.HeadRepl
  if not parent.HeadRepl then 
    parent.HeadRepl = MovixLib_GetControlObject(parent, "string")
    hrep = parent.HeadRepl
    hrep:ClearAllPoints()
    hrep:SetPoint("TOPRIGHT", hmin, "TOPLEFT", 0,0)
    hrep:SetWidth(20)
    hrep:SetHeight(12)
    hrep:SetJustifyH("CENTER")
    hrep:SetJustifyV("MIDDLE")
    hrep:SetFont(font, 8);
    hrep:SetTextColor(1,1,0,1);
    hrep:SetText(GEM3UI_LocalizedStrings["_replacementshort"])
  end
  local ms = parent.RepSeperator
  if not parent.RepSeperator then 
    parent.RepSeperator = MovixLib_GetControlObject(parent, "texture")
    ms = parent.RepSeperator 
    ms:ClearAllPoints()
    ms:SetPoint("TOPRIGHT", hrep, "TOPLEFT", 0,0)
    ms:SetWidth(1)
    ms:SetHeight(245)
    ms:SetTexture(1,1,0,0.5)
  end
  ms:Show()
  local hsub = parent.HeadSubs
  if not parent.HeadSubs then 
    parent.HeadSubs = MovixLib_GetControlObject(parent, "string")
    hsub = parent.HeadSubs
    hsub:ClearAllPoints()
    hsub:SetPoint("TOPRIGHT", hrep, "TOPLEFT", 0,0)
    hsub:SetWidth(20)
    hsub:SetHeight(12)
    hsub:SetJustifyH("CENTER")
    hsub:SetJustifyV("MIDDLE")
    hsub:SetFont(font, 8);
    hsub:SetTextColor(1,1,0,1);
    hsub:SetText(GEM3UI_LocalizedStrings["_substituteshort"])
  end
  local ms = parent.SubSeperator
  if not parent.SubSeperator then 
    parent.SubSeperator = MovixLib_GetControlObject(parent, "texture")
    ms = parent.SubSeperator
    ms:ClearAllPoints()
    ms:SetPoint("TOPRIGHT", hsub, "TOPLEFT", 0,0)
    ms:SetWidth(1)
    ms:SetHeight(245)
    ms:SetTexture(1,1,0,0.5)
  end
  ms:Show()
  local htit = parent.HeadTit
  if not parent.HeadTit then 
    parent.HeadTit = MovixLib_GetControlObject(parent, "string")
    htit = parent.HeadTit
    htit:ClearAllPoints()
    htit:SetPoint("TOPRIGHT", hsub, "TOPLEFT", 0,0)
    htit:SetWidth(20)
    htit:SetHeight(12)
    htit:SetJustifyH("CENTER")
    htit:SetJustifyV("MIDDLE")
    htit:SetFont(font, 8);
    htit:SetTextColor(1,1,0,1);
    htit:SetText(GEM3UI_LocalizedStrings["_titularshort"])
  end
  local ms = parent.TitSeperator
  if not parent.TitSeperator then 
    parent.TitSeperator = MovixLib_GetControlObject(parent, "texture")
    ms = parent.TitSeperator
    ms:ClearAllPoints()
    ms:SetPoint("TOPRIGHT", htit, "TOPLEFT", 0,0)
    ms:SetWidth(1)
    ms:SetHeight(245)
    ms:SetTexture(1,1,0,0.5)
  end
  ms:Show()  
  if not parent.cdelimiter then
    parent.cdelimiter = MovixLib_GetControlObject(parent, "texture")
    parent.cdelimiter:ClearAllPoints()
    parent.cdelimiter:SetPoint("TOPLEFT", parent, "TOPLEFT", 5,-35)
    parent.cdelimiter:SetPoint("BOTTOMRIGHT", parent, "TOPRIGHT", -5,-37)
    parent.cdelimiter:SetTexture(1,1,1,0.5)
  end
  parent.cdelimiter:Show()
  local prl = parent.Roleline
  if not parent.Roleline then 
     parent.Roleline = {}
     prl = parent.Roleline
  end

  local anchorp = parent.cdelimiter
  for i,c in pairs(GEM3UI_Roles) do
    if i > 0 then
        if not prl[i] then 
            prl[i] = {}
            if i ~= 4 then
                GEM3UI_DrawLimitsLine(parent, anchorp, prl[i], "interface\\icons\\"..c.icon, c.name_loc,i,GEM3UI_FilterPlayerListRole)
            else
                GEM3UI_DrawLimitsLine(parent, anchorp, prl[i], "interface\\icons\\"..c.icon, "Total "..c.name_loc,i, GEM3UI_FilterPlayerListRole)
            end
        end
        anchorp = prl[i].delimiter
    end
  end

  local pcl = parent.Classline
  if not parent.Classline then 
     parent.Classline = {}
     pcl = parent.Classline
  end
  local cs = parent.HeaderSeperator 

  if not parent.ClassSeperator then 
    parent.ClassSeperator = MovixLib_GetControlObject(parent, "texture")
    cs = parent.ClassSeperator
    cs:ClearAllPoints()
    cs:SetPoint("TOPLEFT", anchorp, "TOPLEFT", 0,0)
    cs:SetPoint("BOTTOMRIGHT", anchorp, "TOPRIGHT", 0,-6)
    cs:SetTexture(1,1,1,0.5)
  end
  anchorp = cs

  for i,c in ipairs(GEM3UI_Classes) do
        if not pcl[i] then 
            pcl[i] = {}
            GEM3UI_DrawLimitsLine(parent, anchorp, pcl[i], GEM3UI_Players_Classes[GEM3UI_Classes[i].gemid].icon, c.name_loc, i, GEM3UI_FilterPlayerListClass)
        end

        anchorp = pcl[i].delimiter
  end
  GEM3UI_SetLimitsframeWidth()
end

function GEM3UI_DrawLimitsLine(parent, anchorp, dest, icon, text, index, foo)
        local font = "Fonts\\FRIZQT__.TTF"
            dest.lb = MovixLib_GetControlObject(parent, "custombutton")
            dest.lb:ClearAllPoints()
            dest.lb:SetPoint("TOPLEFT", anchorp, "BOTTOMLEFT", 0,0)
            dest.lb:SetPoint("BOTTOMRIGHT", anchorp, "BOTTOMRIGHT", 0,-15)
            dest.lb:SetHighlightTexture("")
            dest.lb:SetNormalTexture("")
            dest.lb:SetPushedTexture("")
            dest.lb:SetScript("OnEnter", function(self) foo(self,index) end)
            dest.lb:SetScript("OnLeave", function(self) GEM3UI_FilterPlayerListReset(self);end)

            dest.delimiter = MovixLib_GetControlObject(parent, "texture")
            dest.delimiter:ClearAllPoints()
            dest.delimiter:SetPoint("TOPLEFT", anchorp, "BOTTOMLEFT", 0,-14)
            dest.delimiter:SetPoint("BOTTOMRIGHT", anchorp, "BOTTOMRIGHT", 0,-15)
            dest.delimiter:SetTexture(1,1,1,0.3)
        
            dest.texture = MovixLib_GetControlObject(dest.lb, "custombutton")
            dest.texture:ClearAllPoints()
            dest.texture:SetPoint("TOPLEFT", anchorp, "BOTTOMLEFT", 2,-1)
            dest.texture:SetWidth(13)
            dest.texture:SetHeight(13)
            dest.texture:SetHighlightTexture("")
            dest.texture:SetNormalTexture(icon)
            dest.texture:SetPushedTexture(icon)
            dest.texture:SetScript("OnEnter", function(self) GEM3UI_GameTooltipShow(self, text) foo(dest.lb, index) end)
            dest.texture:SetScript("OnLeave", function(self) GEM3UI_HideTooltip() GEM3UI_FilterPlayerListReset(dest.lb)end)
        
            dest.M = MovixLib_GetControlObject(dest.lb, "string")
            dest.M:ClearAllPoints()
            dest.M:SetPoint("TOPRIGHT", dest.lb, "TOPRIGHT", 0,-1)
            dest.M:SetHeight(14)
            dest.M:SetWidth(20)
            dest.M:SetJustifyH("CENTER")
            dest.M:SetJustifyV("MIDDLE")
            dest.M:SetFont(font, 8);
            dest.M:SetTextColor(1,1,0,1);
            dest.M:SetText("..")
        
            dest.m = MovixLib_GetControlObject(dest.lb, "string")
            dest.m:ClearAllPoints()
            dest.m:SetPoint("TOPRIGHT", dest.M, "TOPLEFT", 0,0)
            dest.m:SetHeight(14)
            dest.m:SetWidth(20)
            dest.m:SetJustifyH("CENTER")
            dest.m:SetJustifyV("MIDDLE")
            dest.m:SetFont(font, 8);
            dest.m:SetTextColor(1,1,0,1);
            dest.m:SetText("..")
        
            dest.r = MovixLib_GetControlObject(dest.lb, "string")
            dest.r:ClearAllPoints()
            dest.r:SetPoint("TOPRIGHT", dest.m, "TOPLEFT", 0,0)
            dest.r:SetHeight(14)
            dest.r:SetWidth(20)
            dest.r:SetJustifyH("CENTER")
            dest.r:SetJustifyV("MIDDLE")
            dest.r:SetFont(font, 8);
            dest.r:SetTextColor(1,1,0,1);
            dest.r:SetText("..")
        
            dest.s = MovixLib_GetControlObject(dest.lb, "string")
            dest.s:ClearAllPoints()
            dest.s:SetPoint("TOPRIGHT", dest.r, "TOPLEFT", 0,0)
            dest.s:SetHeight(14)
            dest.s:SetWidth(20)
            dest.s:SetJustifyH("CENTER")
            dest.s:SetJustifyV("MIDDLE")
            dest.s:SetFont(font, 8);
            dest.s:SetTextColor(1,1,0,1);
            dest.s:SetText("..")
        
            dest.t = MovixLib_GetControlObject(dest.lb, "string")
            dest.t:ClearAllPoints()
            dest.t:SetPoint("TOPRIGHT", dest.s, "TOPLEFT", 0,0)
            dest.t:SetHeight(14)
            dest.t:SetWidth(20)
            dest.t:SetJustifyH("CENTER")
            dest.t:SetJustifyV("MIDDLE")
            dest.t:SetFont(font, 8);
            dest.t:SetTextColor(1,1,0,1);
            dest.t:SetText("..")
        
            dest.name = MovixLib_GetControlObject(dest.lb, "string")
            dest.name:ClearAllPoints()
            dest.name:SetPoint("TOPLEFT", dest.lb, "TOPLEFT", 20,-1)
            dest.name:SetPoint("BOTTOMRIGHT", dest.t, "BOTTOM", 0,0)
            dest.name:SetJustifyH("LEFT")
            dest.name:SetJustifyV("MIDDLE")
            dest.name:SetFont(font, 8);
            dest.name:SetTextColor(1,1,0,1);
            dest.name:SetText(text)
        
end



function GEM3UI_CreatePlainTexture(parent, texname, anchorparent, top, left, width, height, layer, cr, cg, cb, ca)
   local uline = getglobal(texname);
   if uline == nil then
    uline = parent:CreateTexture(texname);
    uline:SetPoint("TOPLEFT", anchorparent, "TOPLEFT", left, top);
    uline:SetHeight(height);
    uline:SetWidth(width);
    uline:SetTexture(cr,cg,cb,ca);
    uline:SetDrawLayer(layer);
   else
    uline:SetPoint("TOPLEFT", anchorparent, "TOPLEFT", left, top);
    uline:SetHeight(height);
    uline:SetWidth(width);
    uline:SetTexture(cr,cg,cb,ca);
    uline:SetDrawLayer(layer);
   end
end


function createDayEventline()
 local framename;
 local parent = getglobal("GEM3UIDay");
 local line;
 local i;
 for i=1,GEM3UI_DefaultDayEvents do
  framename = "GEM3UI_DayEventlineFrame"..i;
  line = getglobal(framename);
  if line == nil then
   line = CreateFrame("BUTTON", framename, parent, "DayEventLineTemplate");
  end
  if i > 1 then
    line:SetPoint("TOPLEFT", getglobal("GEM3UI_DayEventlineFrame"..(i-1)), "BOTTOMLEFT", 0, 0);
  else
    line:SetPoint("TOPLEFT", getglobal("GEM3UIDayEventScrollList"), "TOPLEFT", 3, 0);
  end 
  line:SetHeight(15);
  line:SetWidth(GEM3UIDayEventScrollList:GetWidth()+17);
  line:Hide();
  line:RegisterForClicks("LeftButtonUp", "RightButtonUp");
 end
end


function GEM3UI_fillDayEventLine(i, index)
 --if GEM3UI_ShowTemplates:GetChecked() then return; end
 local framename = "GEM3UI_DayEventlineFrame"..i;
 local line = getglobal(framename);
 line.index = index;
 local ev = GEM3UI_EventSource[MyEvent[GEM3UI_DayEvents[index] ].id];
 if not ev then return; end
 local r = 1;
 local g = 1;
 local b = 1;
 local a = 1;
 
 local rerolls =  GEM3_PLAY_GetMyRerolls();
 for i, pl in ipairs(rerolls) do
   local subsdet = ev.players[pl.name];
   if subsdet ~= nil then
    if subsdet.current_queue <= GEM3_SUB_STATE_NOT_ACKED and
       subsdet.current_queue > GEM3_SUB_STATE_NONE then     
            r = GEM3UI_EVSUBS[subsdet.current_queue].text_color.r;
            g = GEM3UI_EVSUBS[subsdet.current_queue].text_color.g;
            b = GEM3UI_EVSUBS[subsdet.current_queue].text_color.b;
            a = GEM3UI_EVSUBS[subsdet.current_queue].text_color.a;
    end
   end
 end
 
 local lbl = getglobal(framename.."EventTimeLabel");
 lbl:SetText(date(GEM3UI_TimeFormatString, MyEvent[GEM3UI_DayEvents[index] ].ev_date))--+(GEM3UI.ServerTimeOffSet*60*60)));
 lbl:SetTextColor(r,g,b,a);
 
 lbl = getglobal(framename.."EventNameLabel")
 lbl:SetText(MyEvent[GEM3UI_DayEvents[index] ].ev_place);
 lbl:SetTextColor(r,g,b,a);
 
 if GEM3UI_DayEventCount > GEM3UI_DefaultDayEvents then
   line:SetWidth(GEM3UIDayEventScrollList:GetWidth());
 else
   line:SetWidth(GEM3UIDayEventScrollList:GetWidth()+17);
 end
 GA_ReleaseTable(rerolls,0);
end

function GEM3UI_DayEventListScrollUpdate()
   local line; -- 1 through 5 of our window to scroll
   local lineplusoffset=0; -- an index into our data calculated from the scroll offset
   local cnt = GEM3UI_DayEventCount;
   local maxdatewidth = 0;
   for line=1,GEM3UI_DefaultDayEvents do
       getglobal("GEM3UI_DayEventlineFrame"..line):Hide();
   end
   FauxScrollFrame_Update(GEM3UIDayEventScrollList,cnt,GEM3UI_DefaultDayEvents,14);
   for line=1,GEM3UI_DefaultDayEvents do
     lineplusoffset = line + FauxScrollFrame_GetOffset(GEM3UIDayEventScrollList);
     if lineplusoffset < cnt+1 then
       GEM3UI_fillDayEventLine(line, lineplusoffset );
       getglobal("GEM3UI_DayEventlineFrame"..line):Show();
       local linedatewidth = getglobal("GEM3UI_DayEventlineFrame"..line.."EventTimeLabel"):GetStringWidth();
       if maxdatewidth < linedatewidth then
        maxdatewidth = linedatewidth 
       end
     end
   end
   for line=1,GEM3UI_DefaultDayEvents do
    getglobal("GEM3UI_DayEventlineFrame"..line.."EventTime"):SetWidth(maxdatewidth+5);
   end

   
   
 end



--[[
   local line; -- 1 through 5 of our window to scroll
   local lineplusoffset=0; -- an index into our data calculated from the scroll offset
   local cnt = GEM3UI_eventmembercount;

   for line=1,GEM3UI_DefaultPlayerLines do
       getglobal("GEM3UI_PlayerlineFrame"..line):Hide();
   end
   FauxScrollFrame_Update(GEM3UI_eventSubscriptionListScroll,cnt,GEM3UI_DefaultPlayerLines,14);
   for line=1,GEM3UI_DefaultPlayerLines do
     lineplusoffset = line + FauxScrollFrame_GetOffset(GEM3UI_eventSubscriptionListScroll);
     if lineplusoffset < cnt+1 then
       GEM3UI_fillPlayersLine(line, lineplusoffset );
       getglobal("GEM3UI_PlayerlineFrame"..line):Show();
     end
   end
 end]]--


function GEM3UI_PlayerLineShowTagPopup(line)
 if line.plname==nil then return; end
 local tagicon = getglobal ("GEM3UIPlayerTagToolTipIcon");
 if tagicon == nil then 
  tagicon = GameTooltip:CreateTexture("GEM3UIPlayerTagToolTipIcon");
  tagicon:SetPoint("TOPRIGHT", GameTooltip, "TOPLEFT", 2, -2);
  tagicon:SetHeight(60);
  tagicon:SetWidth(60);
  --tagicon:SetDrawLayer("HIGHLIGH");
 end
 tagicon:Show();
 local msg = ""; --        line.plname;
 --if line.tags ~= nil then
  
  
  for tagid, tag in pairs(line.tags) do
    local tid = tagid;
    tid = tag[GEM3_ACCESS_INST_TAG_NAME];
    if line.ev_inst_tag == tid and tid ~= 0 then
        msg = msg .. GEM3UI_LocalizedStrings[TaggedInstances[tid].name]
        if    tag[GEM3_ACCESS_INST_TAG_TYPE] == GEM3_INST_TAG_TYPE_RAID_10_NORMAL then
            msg = msg .. " 10"
        elseif tag[GEM3_ACCESS_INST_TAG_TYPE] == GEM3_INST_TAG_TYPE_RAID_25_NORMAL then
            msg = msg .. " 25"
        elseif tag[GEM3_ACCESS_INST_TAG_TYPE] == GEM3_INST_TAG_TYPE_RAID_10_HEROIC then
            msg = msg .. " 10 (H)"
        elseif tag[GEM3_ACCESS_INST_TAG_TYPE] == GEM3_INST_TAG_TYPE_RAID_25_HEROIC then
            msg = msg .. " 25 (H)"
        end
        msg = msg .. "\n".. "ID   : "..tag[GEM3_ACCESS_INST_TAG_ID];
        if tag[GEM3_ACCESS_INST_TAG_RESET] == 0 then
            msg = msg .. "\n".. "Reset: expired"
        else
            msg = msg .. "\n".. "Reset: "..GEM3UI_FormatDateString( tag[GEM3_ACCESS_INST_TAG_RESET], true);
        end
        if strfind(TaggedInstances[tid].icon, "lfgframe") ~= nil then
            tagicon:SetTexCoord(0,0.8,0,0.72);
        else
            tagicon:SetTexCoord(0,1,0,1);
        end
        tagicon:SetTexture(TaggedInstances[tid].icon);
        msg = msg .. "\n\n"
    end
 end
 GEM3UI_GameTooltipShow(line, msg, true, line.plname .. " IDs");
end

function GEM3UI_PlayerLineHideTagPopup()
 
 GameTooltip:Hide();
 local tagicon = getglobal ("GEM3UIPlayerTagToolTipIcon");
 if tagicon ~= nil then
  tagicon:Hide();
 end
end

function GEM3UI_fillPlayersLine(i, index)
 local framename = "GEM3UI_PlayerlineFrame"..i;
 local line = getglobal(framename);
 local P = GEM3UI_TblCpy(GEM3UI_EventPlayers[index]);
 local pl = GEM3_PLAY_GetPlayerInfos(P.name,GEM3UIeventDetails.evt.channel);
 if not pl then
  pl = GEM3_PLAY_GetPlayerInfos(P.name);
 end

 line.player_index = index;
 line.fqueue = GEM3UI_EventPlayers[index].force_queue
 local lbl = getglobal(framename.."PlayerNameLabel");
 lbl:SetText(P.name);
 local PlayerOnline = GEM3UI_IsPlayerOnline(GEM3UIeventDetails.evt.channel, P.name);

 line.classicon:SetTexture("");
 line.roleicon:SetTexture("");
 line.altroleicon:SetTexture("");
 line.tagicon:SetTexture("");
 line.commenticon:SetTexture("");
 line.tagicontext:SetText("")
 
 if (P.lead_force_queue or GEM3_SUB_FORCE_QUEUE_NONE) ~= GEM3_SUB_FORCE_QUEUE_NONE then
  line.hl:Show();
 else
  line.hl:Hide();
 end
 
 line.plname=nil;
 local player_tagged = nil;
 local tid = nil
 if pl ~= nil then
    for i,tag in pairs (TaggedInstances) do
        if GEM3UIeventDetails.evt.ev_inst_tag == i then
            for k, t in ipairs (pl.tags) do
                if i ==  t[GEM3_ACCESS_INST_TAG_NAME] then
                    if t[GEM3_ACCESS_INST_TAG_RESET] > GEM3UIeventDetails.evt.ev_date+GEM3UI.ServerTimeOffSet then
                        player_tagged = i;
                        tid = k
                    end
                end
            end
        end
    end
    if player_tagged then
      line.tagicon:SetTexture(TaggedInstances[player_tagged].icon);
      line.plname=pl.name;
      line.ev_inst_tag=GEM3UIeventDetails.evt.ev_inst_tag;
      line.tags = pl.tags;
      line.version = pl.version
      --[GEM3UIeventDetails.evt.ev_inst_tag][GEM3_ACCESS_INST_TAG_ID]
      --line.tagtime = pl.tags[GEM3UIeventDetails.evt.ev_inst_tag][GEM3_ACCESS_INST_TAG_RESET]
      if strfind(TaggedInstances[player_tagged].icon, "lfgframe") ~= nil then
       line.tagicon:SetTexCoord(0,0.8,0,0.72);
      else
       line.tagicon:SetTexCoord(0,1,0,1);
      end
      if tag[GEM3_ACCESS_INST_TAG_TYPE] == GEM3_INST_TAG_TYPE_RAID_10_NORMAL then
            line.tagicontext:SetText("10")
      elseif tag[GEM3_ACCESS_INST_TAG_TYPE] == GEM3_INST_TAG_TYPE_RAID_25_NORMAL then
            line.tagicontext:SetText("25")
      elseif tag[GEM3_ACCESS_INST_TAG_TYPE] == GEM3_INST_TAG_TYPE_RAID_10_HEROIC then
            line.tagicontext:SetText("10 (H)")
      elseif tag[GEM3_ACCESS_INST_TAG_TYPE] == GEM3_INST_TAG_TYPE_RAID_25_HEROIC then
            line.tagicontext:SetText("25 (H)")
      else
            line.tagicontext:SetText("")    
      end
    end
  end
 
 
 local col = {1,1,1,1};
 if PlayerOnline == true then 
  if UnitInParty(GEM3UI_EventPlayers[index].name) or UnitInRaid(GEM3UI_EventPlayers[index].name) then
   col = {0.3,0.3,0.8,1};
  else
    col = {0,1,0,1};
  end
 else
  if GEM3UI_EventPlayers[index].current_queue == GEM3_SUB_STATE_NOT_COMING then
   col = {0.6,0.1,0.1,1};
  else
   col = {1,1,1,1};
  end

 end
 lbl:SetTextColor(unpack(col)); 
 
 if GEM3UI_EventPlayers[index].current_queue == GEM3_SUB_STATE_NOT_COMING then
   col = {0.6,0.1,0.1,1};
 end
 
 if P.source == nil then P.source = GEM3_SUB_SOURCE_SELF; end
 if strsub(P.source, 1,1) == GEM3_SUB_SOURCE_EXTERNAL then
  line.subssourceicon:SetTexture("interface\\buttons\\ui-guildbutton-officernote-up");
 elseif strsub(P.source, 1,1) == GEM3_SUB_SOURCE_TEMPLATE then
  line.subssourceicon:SetTexture("interface\\buttons\\ui-sliderbar-button-horizontal");
 elseif strsub(P.source, 1,1) == GEM3_SUB_SOURCE_WEB then
  line.subssourceicon:SetTexture("interface\\ui-guildbutton-motd-up");
 elseif strsub(P.source, 1,1) == GEM3_SUB_SOURCE_SELF then
  line.subssourceicon:SetTexture("");
 end
 
 line.isofficericon:Hide();
 if GEM3UIeventDetails.evt.leader == P.name then
  line.isofficericon:SetTexture("interface\\groupframe\\ui-group-leadericon");
  line.isofficericon:Show();
 end

 if GEM3_EVT_IsAssistant(GEM3UIeventDetails.evt.id, P.name) then
  line.isofficericon:SetTexture("interface\\groupframe\\ui-group-assistanticon");
  line.isofficericon:Show();
 end

 if P.comment ~= "" then
     line.commenticon:SetTexture("interface\\buttons\\ui-guildbutton-publicnote-up");
 end
 
 
 lbl = getglobal(framename.."PlayerPosLabel")
 if P.current_queue ~= nil then
  if P.current_queue == GEM3_SUB_STATE_NOT_COMING
    or P.current_queue == GEM3_SUB_STATE_REPLACEMENT then
   lbl:SetText(GEM3UI_Queues[P.current_queue].short);
  else
   lbl:SetText(GEM3UI_Queues[P.current_queue].short..P.queue_pos);
  end
 else
  lbl:SetText(GEM3UI_LocalizedStrings["_not_acknedshort"]);
 end
 lbl:SetTextColor(unpack(col)); 
 
 
 
 lbl = getglobal(framename.."PlayerLvLLabel");
 lbl:SetText(P.level);
 lbl:SetTextColor(unpack(col));
 
 local classid = GEM3UI_GetClassIndex(P.class);
 local roleid = GEM3UI_GetRoleIndex(P.role);
 local altroleid = GEM3UI_GetRoleIndex(P.alt_role);
 if GEM3UI_Classes[classid] then line.classicon:SetTexture(GEM3UI_Players_Classes[P.class].icon); end
 if GEM3UI_Roles[roleid] then line.roleicon:SetTexture("interface\\icons\\"..GEM3UI_Roles[roleid].icon); end
 if GEM3UI_Roles[altroleid] then line.altroleicon:SetTexture("interface\\icons\\"..GEM3UI_Roles[altroleid].icon); end
 
 
 if GEM3UI_eventmembercount > GEM3UI_DefaultPlayerLines then
   line:SetWidth(GEM3UI_eventSubscriptionListScroll:GetWidth());
 else
   line:SetWidth(GEM3UI_eventSubscriptionListScroll:GetWidth()+18);
 end
 
 if GEM3UIeventDetails.recover ~= true then
  line:SetScript("OnClick", GEM3UI_PlayerLineOnClick);
 else
  line:SetScript("OnClick", nil)
 end
end


function createplayersline()
 local framename;
 local parent = getglobal("GEM3UI_eventSubscriptionList");
 local line;
 local i;
 for i=1,GEM3UI_DefaultPlayerLines do
  framename = "GEM3UI_PlayerlineFrame"..i;
  line = getglobal(framename);
  if line == nil then
   line = CreateFrame("BUTTON", framename, parent, "PlayerLineTemplate");
  end
  if i > 1 then
    line:SetPoint("TOPLEFT", getglobal("GEM3UI_PlayerlineFrame"..(i-1)), "BOTTOMLEFT", 0, 0);
  else
    line:SetPoint("TOPLEFT", getglobal("GEM3UI_eventSubscriptionList"), "TOPLEFT", 5, -18);
  end
  line:SetWidth(parent:GetWidth()-10);
  line:SetHeight(14);
  line.classicon = getglobal(framename.."ClassIconTexture");
  line.roleicon = getglobal(framename.."RoleIconTexture");
  line.altroleicon = getglobal(framename.."AltRoleIconTexture");
  
  line.tagicon = getglobal(framename.."TagIconTexture");
  line.tagicon:ClearAllPoints();
  line.tagicon:SetPoint("TOPRIGHT", line, "TOPRIGHT", -2, -1);
  line.tagicon:SetWidth(12);
  line.tagicon:SetHeight(12);
  line.tagicontext = getglobal(framename.."TagIconLabel");
  line.commenticon = getglobal(framename.."HasCommentTexture");
  line.commenticon:ClearAllPoints();
  line.commenticon:SetPoint("TOPRIGHT", line, "TOPRIGHT", -15, -1);
  line.commenticon:SetWidth(12);
  line.commenticon:SetHeight(12);
  
  line.subssourceicon = getglobal(framename.."SubsSourceTexture");
  line.subssourceicon:ClearAllPoints();
  line.subssourceicon:SetPoint("TOPRIGHT", line, "TOPRIGHT", -28, -1);
  line.subssourceicon:SetWidth(12);
  line.subssourceicon:SetHeight(12);
  
  line.isofficericon = getglobal(framename.."IsOfficerTexture");
  line.isofficericon:ClearAllPoints();
  line.isofficericon:SetPoint("TOPRIGHT", line, "TOPRIGHT", -41, -1);
  line.isofficericon:SetWidth(12);
  line.isofficericon:SetHeight(12);
  
  
  line.hl = getglobal(framename.."HLTexture"); 
  if line.hl  == nil then
  line.hl = line:CreateTexture(framename.."HLTexture", "ARTWORK");
  line.hl:SetTexture(1,1,1,0.1);
  
  line.hl:SetPoint("BOTTOMLEFT", getglobal(framename.."PlayerPos"), "BOTTOMLEFT", 0, 1);
  line.hl:SetWidth(8);
  line.hl:SetHeight(12);
 end
  
  
  line:RegisterForClicks("LeftButtonUp", "RightButtonUp");
  line:Hide();
  
 end
end


--[[function GEM3UI_EventListScrollUpdate()
   mydbg("GEM3UI_EventListScrollUpdate");
   local framename = "GEM3UI_lineFrame"
   local line; -- 1 through 5 of our window to scroll
   local lineplusoffset; -- an index into our data calculated from the scroll offset
   local cnt = GEM3UI_eventcount;
   local maxdatewidth = 0
   for line=1,GEM3UI_DefaultLines do
       getglobal("GEM3UI_lineFrame"..line):Hide();
   end
   FauxScrollFrame_Update(GEM3UIMainEventScrollList,cnt,GEM3UI_lines,14);
   for line=1,GEM3UI_lines do
     lineplusoffset = line + FauxScrollFrame_GetOffset(GEM3UIMainEventScrollList);
     local lineframe = getglobal(framename..line)
     if lineplusoffset < cnt+1 then
       GEM3UI_fillLine(line, lineplusoffset );
       lineframe:Show();
       local linedatewidth = getglobal(framename..line.."DateLabel"):GetStringWidth();
       if maxdatewidth < linedatewidth then
        maxdatewidth = linedatewidth 
       end
     end
   end
   for line=1,GEM3UI_lines do
    getglobal(framename..line.."Date"):SetWidth(maxdatewidth+5);
   end
   if cnt> 0 then
    GEM3UI_EventNameFilter:SetPoint("TOPLEFT", getglobal(framename.."1EventIcon"), "TOPLEFT", -2, 15)
    GEM3UI_LvlcolumnLabel:SetPoint("TOPRIGHT", getglobal(framename.."1Lvl"), "TOPRIGHT", -2, 15)
    GEM3UI_LeadercolumnLabel:SetPoint("TOPLEFT", getglobal(framename.."1LeaderStateIcon"), "TOPLEFT", 0, 15)
    GEM3UI_MemberscolumnLabel:SetPoint("TOPRIGHT", getglobal(framename.."1Members"), "TOPRIGHT", 0, 15)
   end
   if GEM3UI.ShowLeaderCol then GEM3UI_LeadercolumnLabel:Show(); else GEM3UI_LeadercolumnLabel:Hide(); end
   if GEM3UI.ShowLevelCol then GEM3UI_LvlcolumnLabel:Show(); else GEM3UI_LvlcolumnLabel:Hide(); end
   if GEM3UI.ShowSubsCol then GEM3UI_MemberscolumnLabel:Show(); else GEM3UI_MemberscolumnLabel:Hide(); end
   GEM3UI_IsEventExpanded();
   GEM3UI_SetStatusMessage(sformat(GEM3UI_LocalizedStrings["_EventsStatus"], GEM3UI_totalEvents , GEM3UI_closedEvents, GEM3UI_subsEvents, GEM3UI_ignoredEvents), 0);
end

function createuiline()
 local framename;
 local line;
 local i;
 for i=1,GEM3UI_DefaultLines do
  framename = "GEM3UI_lineFrame"..i;
  line = getglobal(framename);
  if line == nil then
   line = CreateFrame("BUTTON", framename, getglobal("GEM3UIMainMainPanelEventListMain"), "EventLineTemplate");
  end
  if i > 1 then
    line:SetPoint("TOPLEFT", getglobal("GEM3UI_lineFrame"..(i-1)), "BOTTOMLEFT", 0, 0);
--    line:SetPoint("BOTTOMRIGHT", getglobal("GEM3UI_lineFrame"..(i-1)), "BOTTOMLEFT", 0, 0);
  else
    line:SetPoint("TOPLEFT", getglobal("GEM3UIMainEventScrollList"), "TOPLEFT", GEM3UI_EventlineXOffset , 0); --GEM3UI_EventlineXOffset
--    line:SetPoint("BOTTOMRIGHT", getglobal("GEM3UI_lineFrame"..(i-1)), "BOTTOMLEFT", 0, 0);
  end
  line:Hide();
  line:RegisterForClicks("LeftButtonUp", "RightButtonUp");
  line.hltex = line:GetHighlightTexture();
  local stateico = getglobal(framename.."StateIcon");
  stateico .defw = stateico:GetWidth();
  local leadstateico = getglobal(framename.."LeaderStateIcon");
  leadstateico.defw = leadstateico:GetWidth()
  local evtico = getglobal(framename.."EventIcon");
  evtico.defw = evtico:GetWidth()
  local LimitsIcon = getglobal(framename.."LimitsIcon");
  LimitsIcon.defw = LimitsIcon:GetWidth()
  local lbl = getglobal(framename.."Leader"); 
  lbl.defw = lbl:GetWidth();
  local lbl = getglobal(framename.."Members"); 
  lbl.defw = lbl:GetWidth();
  local lbl = getglobal(framename.."Lvl"); 
  lbl.defw = lbl:GetWidth();
 end
end




function GEM3UI_fillLine(i, index)
 local id = MyEvent[index].id;
 local ev = GEM3UI_EventSource[id]
 local framename = "GEM3UI_lineFrame"..i;
 local lbl;
 local line = getglobal(framename);
 
 local stateico = getglobal(framename.."StateIconTexture");
 local stateicof = getglobal(framename.."StateIcon");
 local subsico = getglobal(framename.."SubsIconTexture");
 local leadstateico = getglobal(framename.."LeaderStateIconTexture");
 local leadstateicof = getglobal(framename.."LeaderStateIcon");
 local evticof = getglobal(framename.."EventIcon");
 local evtico = getglobal(framename.."EventIconTexture");
 local LimitsIconf = getglobal(framename.."LimitsIcon");
 local LimitsIcon = getglobal(framename.."LimitsIconTexture");
 LimitsIcon:SetTexture("interface\\targetingframe\\barfill2"); 
 if ev == nil then 
  mydbg(id, true);
  error ("EV = nil") 
 end
 
 if GEM3UI.ShowEventIconCol then
  evticof:Show()
  evticof:SetWidth(evticof.defw)
  evtico:SetTexture(GEM3UI_LocalizedStrings.EventTypes[ev.ev_type].tbin);
 else
   evticof:Hide()
   evticof:SetWidth(1)
 end
 local sc, ic;

 local STATE = GEM3UI_EV_STATE_NORMAL;
 local SUBS = GEM3_SUB_STATE_NONE;
 subsico:SetTexture(GEM3UI_EVLINE[SUBS].icon); 
 local alpha= nil;
 local texc = nil; 
 
 local sr = GEM3UI_EVSUBS[GEM3UI_EV_STATE_NORMAL].text_color.r;
 local sg = GEM3UI_EVSUBS[GEM3UI_EV_STATE_NORMAL].text_color.g;
 local sb = GEM3UI_EVSUBS[GEM3UI_EV_STATE_NORMAL].text_color.b;
 local sa = GEM3UI_EVSUBS[GEM3UI_EV_STATE_NORMAL].text_color.a;
 local er = GEM3UI_EVLINE[GEM3UI_EV_STATE_NORMAL].line_color.r;
 local eg = GEM3UI_EVLINE[GEM3UI_EV_STATE_NORMAL].line_color.g;
 local eb = GEM3UI_EVLINE[GEM3UI_EV_STATE_NORMAL].line_color.b;
 local ea = GEM3UI_EVLINE[GEM3UI_EV_STATE_NORMAL].line_color.a;
 
 line.ev_index = index;
 line.ignored = MyEvent[index].ignored;
 line.outdated = MyEvent[index].outdated;
 line.closed = MyEvent[index].closed;
 line.passed = MyEvent[index].passed;
 
 if GEM3UI_eventcount > GEM3UI_lines then
   line:SetWidth(GEM3UIMainEventScrollList:GetWidth()+GEM3UI_EventlineXOffset);
 else
   line:SetWidth(GEM3UIMainEventScrollList:GetWidth()+17+GEM3UI_EventlineXOffset);
 end
 
 
 
 
 --- Toggle Expand button
 local expbut = getglobal(framename.."ExpandButton");
 if (not line.ignored) then -- and not GEM3UI_ShowTemplates:GetChecked()) then 
  expbut:Show();
 else
   expbut:Hide();
 end

 if not GEM3UI_ShowArchive:GetChecked() and not GEM3UI_ShowTemplates:GetChecked() then
  if line.closed then
   STATE= GEM3UI_EV_STATE_CLOSED;
  end
  if line.ignored then
   STATE= GEM3UI_EV_STATE_IGNORED;
  end
  if line.outdated then
   STATE = GEM3UI_EV_STATE_OUTDATED;
  end
  if line.passed then
   STATE = GEM3UI_EV_STATE_PASSED;
  end
  
--- Check if Event new or updated since last list viewing  
  for i, ctype in ipairs(GEM3UI_newEvents) do
   if ctype.id == ev.id then
    STATE = GEM3UI_EV_STATE_NEW;
   end
  end
  
  
  
  local rerolls =  GEM3_PLAY_GetMyRerolls(ev.channel);
  for i, player in ipairs(rerolls) do
    if GEM3_QA_Events.subscribed[ev.id] ~= nil then
     local subsinfo = GEM3_SUB_GetSubscribedInfos(ev.id, player.name);
        if subsinfo then                                                              -- Subscribed YES
            local subsdet = ev.players[player.name];                        
            if subsdet ~= nil then                                                       -- has leader seen ?
                if subsdet.current_queue >= GEM3_SUB_STATE_NOT_ACKED or subsdet.current_queue == GEM3_SUB_STATE_NONE or subsdet.current_queue ~= subsinfo.state then                        -- Yes, seen, if subscription not aked
                    --    if subsico:GetTexture() ~= GEM3UI_EVLINE[GEM3UI_EV_STATE_SUBS].icon then  -- verify if another toon has aked subs for this ev
                    subsico:SetTexture(GEM3UI_EVLINE[GEM3UI_EV_STATE_NAK].icon);             -- else set nak ico
                    SUBS = subsinfo.state
                    --end
                else
                    subsico:SetTexture(GEM3UI_EVLINE[GEM3UI_EV_STATE_SUBS].icon);
                    SUBS = subsinfo.state
                end
            else
                subsico:SetTexture(GEM3UI_EVLINE[GEM3UI_EV_STATE_NAK].icon);            -- else set nak ico
                SUBS = subsinfo.state
            end
        end
    end
  end
 end

 if STATE == GEM3UI_EV_STATE_NORMAL or STATE == GEM3UI_EV_STATE_OUTDATED or STATE == GEM3UI_EV_STATE_NEW then
  --if SUBS ~= GEM3_SUB_STATE_NONE then
   sr = GEM3UI_EVSUBS[SUBS].text_color.r;
   sg = GEM3UI_EVSUBS[SUBS].text_color.g;
   sb = GEM3UI_EVSUBS[SUBS].text_color.b;
   sa = GEM3UI_EVSUBS[SUBS].text_color.a;
 end
 
 if STATE ~= GEM3UI_EV_STATE_NORMAL and STATE ~= GEM3UI_EV_STATE_OUTDATED and STATE ~= GEM3UI_EV_STATE_NEW then
   er = GEM3UI_EVLINE[STATE].line_color.r;
   eg = GEM3UI_EVLINE[STATE].line_color.g;
   eb = GEM3UI_EVLINE[STATE].line_color.b;
   ea = GEM3UI_EVLINE[STATE].line_color.a;
   sr = er;
   sg = eg;
   sb = eb;
   sa = ea;
 end
 
 
 
----- EventState Icon  (Ignored, Closed, Outdated)
 stateico:SetTexture(GEM3UI_EVLINE[STATE].icon); 
 sc = GEM3UI_EVLINE[STATE].icon_color;
 if sc then
  stateico:SetVertexColor(sc.r,sc.g,sc.b,sc.a);
 end
 if GEM3UI_EVLINE[STATE].texc then
  local texc = GEM3UI_EVLINE[STATE].texc ;
  stateico:SetTexCoord(texc.l,texc.r,texc.t,texc.b);
 else
   stateico:SetTexCoord(0,1,0,1);
 end
 
--- EventSubs Icon : Subscription or not
 ic = GEM3UI_EVSUBS[SUBS].icon_color;
 if ic then 
  subsico:SetVertexColor(ic.r,ic.g,ic.b,ic.a);
 end


---- Date Place and Subscription columns
 local lbl = getglobal(framename.."DateLabel");
 if not GEM3UI_ShowTemplates:GetChecked() then
  lbl:SetText(GEM3UI_FormatDateString(ev.ev_date+(GEM3UI.ServerTimeOffSet*60*60), true));
  lbl:SetTextColor(sr,sg,sb,sa);
 else
  lbl:SetText("");
 end
 
 local lbl = getglobal(framename.."TitleLabel");
 lbl:SetText(ev.ev_place);
 lbl:SetTextColor(sr,sg,sb,sa);
 
 if GEM3UI.ShowLimitsIconCol then
    LimitsIconf:SetWidth(LimitsIconf.defw);
    LimitsIconf:Show();
    if GEM3UI_CheckLimits(ev)  == 2 then
        LimitsIcon:SetVertexColor(0,1,0,1);
    elseif GEM3UI_CheckLimits(ev)  == 1 then
        LimitsIcon:SetVertexColor(1,1,0,1);
    else
        LimitsIcon:SetVertexColor(1,0,0,1);
    end
 else
    LimitsIconf:SetWidth(1);
    LimitsIconf:Hide();
 end


 local lbl = getglobal(framename.."MembersLabel");
 local lblf = getglobal(framename.."Members");
 if GEM3UI.ShowSubsCol then
  lblf:SetWidth(lblf.defw)
  lbl:SetText((ev.tit_count or "nil").."/"..(ev.max_count or "nil").." ("..(ev.sub_count or "nil")..")["..MyEvent[index]["Totals"] + MyEvent[index]["NAcount"].."]");
  lbl:SetTextColor(sr,sg,sb,sa);
 else
  lbl:SetText("");
  lblf:SetWidth(1);
 end

----- Leader Column 
 local lbl = getglobal(framename.."LeaderLabel"); 
 local lblf = getglobal(framename.."Leader")
 if GEM3UI.ShowLeaderCol then
    lbl:SetText(ev.leader);
    lblf:SetWidth(lblf.defw)
 else
    lbl:SetText("");
    lblf:SetWidth(1)
    leadstateicof:SetWidth(1);
    leadstateicof:Hide();
 end
 if GEM3UI.ShowLeaderIconCol then
    leadstateicof:SetWidth(leadstateicof.defw);
    leadstateicof:Show();
    if GEM3_PLAY_IsPlayerInChannel(ev.channel, ev.leader) then
        leadstateico:SetTexture("interface\\buttons\\ui-checkbox-check");
        if line.closed or line.ignored or line.outdated or line.passed then 
            lbl:SetTextColor(er,eg,eb,ea);
        else
            lbl:SetTextColor(0,1,0,1);
        end
    else
        leadstateico:SetTexture("interface\\spellshadow\\spell-shadow-unacceptable");
        lbl:SetTextColor(er,eg,eb,ea);
    end
    if GEM3_IsMyReroll(ev.leader) then
        leadstateico:SetTexture("interface\\groupframe\\ui-group-leadericon");
    end
    if GEM3_EVT_AmIAssistant(ev.id) then
        leadstateico:SetTexture("interface\\groupframe\\ui-group-assistanticon");
    end
 else
    leadstateicof:SetWidth(1);
    leadstateicof:Hide();
 end
----- EventLevel Column
 local lbl = getglobal(framename.."LvlLabel");
 local lblf = getglobal(framename.."Lvl");
 if GEM3UI.ShowLevelCol then
    lblf:SetWidth(lblf.defw)
    lbl:SetText((ev.min_lvl or "nil").."-"..(ev.max_lvl or "nil"));
    if UnitLevel("player") >= (ev.min_lvl or 1) and UnitLevel("player") <= (ev.max_lvl or GEM3UI_MaxLevel)
        or (line.closed or line.ignored or line.outdated or line.passed)
    then
        lbl:SetTextColor(er,eg,eb,ea);
    else
        lbl:SetTextColor(1,0,0,a);
    end
  else
   lblf:SetWidth(1)
   lbl:SetText("");
  end

-- if no special state, use the state icon to display the icon of tagged instances
 if GEM3UI.ShowTagiconCol then
  if STATE == GEM3UI_EV_STATE_NORMAL then
   for i, tag in pairs(TaggedInstances) do
    if ev.ev_inst_tag == i then
     if strfind(TaggedInstances[i].icon, "lfgframe") ~= nil then
      stateico:SetTexCoord(0,0.8,0,0.72);
     else
      stateico:SetTexCoord(0,1,0,1);
     end
     stateico:SetTexture(TaggedInstances[i].icon);
    end
   end
  end
  stateicof:Show()
  stateicof:SetWidth(stateicof.defw);
 else
  stateicof:Hide()
  stateicof:SetWidth(1);
 end
 GA_ReleaseTable(rerolls,0);
end
]]--
function GEM3UI_CheckLimits(ev)
 local iscomplete = 2;
 local mintot = 0;
 local titot = 0;
 for role, lims in pairs(ev.roles) do
  if (lims.min or 0) > (lims.tit_count or 0) then 
   if (lims.min or 0) <= (lims.repl_count or 0)+(lims.tit_count or 0) then iscomplete = 1; 
   else
   iscomplete = 0;
   end
  end
 end
 for class, lims in pairs(ev.classes) do
  if (lims.min or 0) > (lims.tit_count or 0) then 
   if (lims.min or 0) <= (lims.repl_count or 0)+(lims.tit_count or 0) then iscomplete = 1; 
   else
   iscomplete = 0;
   end
  end
 end
 return iscomplete;
end


function GEM3UI_EventDetailOnShow()
 --mydbg("GEM3UI_EventDetailOnShow");
 GEM3UI_EventLinePopulate();
 GEM3UI_eventSubscriptionListUnban:Disable();
 local ev = GEM3UIeventDetails.evt;
 if GEM3UIeventDetails.recover == true then
  GEM3UI_eventSubscriptionListAddMember:Disable();
  GEM3UI_eventSubscriptionListInvite:Disable();
  GEMUI_EventRecover_dateLabel:SetText(GEM3UI_FormatDateString(ev.ev_date+(GEM3UI.ServerTimeOffSet*60*60), true));
  GEMUI_EventRecover_ev_placeLabel:SetText(ev.ev_place);
  GEMUI_EventRecover_leaderLabel:SetText(ev.leader);
  GEMUI_EventRecover_commentLabel:SetText(ev.comment);
 end
 if ev.isTemplate ~= true then
  GEM3UI_EventLineHeaderDeadlineLabel:SetText(GEM3UI_FormatDateString( ev.deadline+(GEM3UI.ServerTimeOffSet*60*60), true));
  local hours = ev.ev_duration/60/60
  local minutes = ev.ev_duration - (hours * 60 * 60)
  GEM3UI_EventLineHeaderDurationLabel:SetText(sformat("%02d:%02d", hours,minutes ));
  GEM3UI_EventLineHeaderUpdateTimeLabel:SetText(GEM3UI_FormatDateString( ev.update_time+(GEM3UI.ServerTimeOffSet*60*60), true));
  GEM3UI_EventLineHeaderChannelLabel:SetText(ev.channel);
 end
 local tagnames = " <Tag: ";
 local tagcount = 0;
 local tagname = TaggedInstances[ev.ev_inst_tag].name;
 mydbg (tagname)
 local tname
 if GEM3UI_LocalizedStrings[tagname.."_Short"] then
    tname = GEM3UI_LocalizedStrings[tagname.."_Short"]
 else
    tname = GEM3UI_LocalizedStrings[tagname]
 end
 if strlen (tagname) > 0 then
  if tagcount > 1 then
   tagnames = tagnames.."-"..tname;
  else
   tagnames = tagnames..tname;
  end
 end
 local tagnames = tagnames ..">"
 if tagcount == 0 then tagnames = ""; end
 GEM3UI_EventLineHeaderEventTypeLabel:SetText(GEM3UI_LocalizedStrings.EventTypes[ev.ev_type].longtext..tagnames);
 --GEM3UI_EventLineHeaderEventTypeLabel:SetText(TaggedInstances[ev.sub_type].name);
 local bans = GEM3_EVT_GetBannedPlayers(ev.id);
 if #bans > 0 and GEM3_IsMyReroll(ev.leader) then
   GEM3UI_eventSubscriptionListUnban:Enable();
 end
 GA_ReleaseTable(bans,2)
end



------ LOST EVENT RECOVERING
function GEM3UI_RecoverEventDialog(event)
 local eventfrm = getglobal("GEM3UIeventDetails");
 local parent = getglobal("GEM3UIRecoverFrame");
 if eventfrm.events == nil then
  eventfrm.events = {};
 end
 tinsert(eventfrm.events, event);
 GEM3UIeventDetails.recover = true;
 parent.timer = 0;
 parent.inc = -0.015;
 parent:SetScript("OnUpdate", GEM3UI_EventRecoverFrameOnUpdate); 
 GEM3MinimapButton:SetScript("OnUpdate", GEM3UI_RecoverMiniMapOnUpdate);
 GEM3MinimapButton:SetScript("OnClick", GEM3UI_ShowRecoverFrame);
 PlaySound("Deathbind Sound");
end


function GEM3UI_ShowRecoverFrame()
 if GEM3UIMain:IsVisible() then
  GEM3UIMain:Hide();
 end
 GEM3UIRecoverFrame:Show();
end

function GEM3UI_RecoverMiniMapOnUpdate()
   if not GEM3UIRecoverFrame:IsVisible() then
    GEM3UIRecoverFrame.timer = GEM3UIRecoverFrame.timer +    GEM3UIRecoverFrame.inc;
    if GEM3UIRecoverFrame.timer > 1.3 then
       GEM3UIRecoverFrame.inc = -0.05;
    end
    if GEM3UIRecoverFrame.timer < 0 then
       GEM3UIRecoverFrame.inc = 0.15;
    end
   end
   GEM3MinimapButtonText:SetText("");
   GEM3MinimapButtonTexture:SetTexture("interface\\gossipframe\\activequesticon");
   GEM3MinimapButton:SetAlpha(GEM3UIRecoverFrame.timer);
end


function GEM3UI_EventRecoverFrameOnShow(self)
 local eventfrm = getglobal("GEM3UIeventDetails");
 local parent = getglobal("GEM3UIRecoverFrame");
 self.gridview = GEM3UI.Gridstyle
 GEM3UI.Gridstyle = false
 for i, event in ipairs(eventfrm.events) do
  if eventfrm.evt == nil then
   eventfrm.evt = event;
  end
 end
 GEM3UI_RecoverFrameDrawPrevNextButton();
 GEM3UI_GetPrevNextRecoverevent();
 eventfrm:SetParent(parent);
 eventfrm:SetPoint("TOPLEFT", 20,-115);
 eventfrm:Show();
 GEM3UI_EventDetailOnShow();
end


function GEM3UI_EventRecoverFrameOnHide(self)
 local eventfrm = getglobal("GEM3UIeventDetails");
 local nextevent = false;
 GEM3UI.Gridstyle = self.gridview
 for i, event in ipairs(eventfrm.events) do
  if event.id ~= eventfrm.evt.id then
   nextevent = event;
  end
 end
 for i, event in ipairs(eventfrm.events) do
   if event.id == eventfrm.evt.id then
    tremove(eventfrm.events, i);
   end
 end
 if nextevent then
  eventfrm.evt = nextevent;
  this:Show();
 else
  GEM3UIRecoverFrame:SetScript("OnUpdate", nil);
  GEM3MinimapButton:SetScript("OnUpdate", nil);
  GEM3MinimapButton:SetScript("OnClick", GEM3UI_Toggle);
  GEM3MinimapButton_Update();
  eventfrm.recover = false;
  eventfrm.evt = nil;
 end
end

function GEM3UI_EventRecoverFrameOnUpdate()
   GEM3UIRecoverFrame.timer = GEM3UIRecoverFrame.timer +    GEM3UIRecoverFrame.inc;
   if GEM3UIRecoverFrame.timer > 1.3 then
      GEM3UIRecoverFrame.inc = -0.015;
   end
   if GEM3UIRecoverFrame.timer < 0 then
      GEM3UIRecoverFrame.inc = 0.05;
   end
   GEM3UIRecoverFrameWARNING2Label:SetTextColor(1,GEM3UIRecoverFrame.timer,GEM3UIRecoverFrame.timer,GEM3UIRecoverFrame.timer);   
end

function GEM3UI_RecoverCancel(self, button)
 GEM3UIRecoverFrame:Hide();
end


function GEM3UI_RecoverButtonOnClick()
 GEM3UI_Popup(GEM3UI_DIALOG_CONFIRM_EVENT_RECOVER);
end

function GEM3UI_RecoverDeleteButtonOnClick(self, button)
 GEM3UI_Popup(GEM3UI_DIALOG_CONFIRM_EVENT_RECOVER_DELETE);
end

function GEM3UI_RecoverRejectButtonOnClick(self, button)
 GEM3UI_Popup(GEM3UI_DIALOG_CONFIRM_EVENT_RECOVER_REJECT);
end

function GEM3UI_ProceedEventRecoverReject()
 GEM3_EVT_RejectLostEvent(GEM3UIeventDetails.evt)
 GEM3UIRecoverFrame:Hide();
end


function GEM3UI_ProceedEventRecover()
 GEM3_EVT_RecoverLostEvent(GEM3UIeventDetails.evt);
 GEM3UIRecoverFrame:Hide();
end


function GEM3UI_ProceedEventRecoverDelete()
 GEM3_EVT_DeleteLostEvent(GEM3UIeventDetails.evt,"Delete by leader on Event Recovery");
 GEM3UIRecoverFrame:Hide();
end

function GEM3UI_GetPrevNextRecoverevent()
 local eventfrm = getglobal("GEM3UIeventDetails");
 local nextevent = true;
 local prevevent = false;
 for i, event in ipairs(eventfrm.events) do
   if event.id ~= eventfrm.evt.id and prevevent == false and nextevent ==true then
    prevevent = event;
   end
   if event.id == eventfrm.evt.id then
    nextevent = false
   end
   if event.id ~= eventfrm.evt.id and nextevent == false then
    nextevent = event;
   end
 end
 if prevevent then 
  GEM3UIRecoverFrameprevbut:Enable();
 else
  GEM3UIRecoverFrameprevbut:Disable();
 end
 if nextevent then
  GEM3UIRecoverFramenextbut:Enable();
 else
  GEM3UIRecoverFramenextbut:Disable();
 end
 GEM3UIRecoverFrameEventConterLabel:SetText(#eventfrm.events);
 return prevevent, nextevent;
end

function GEM3UI_PrevRecoverEvent()
 --mydbg("GEM3UI_PrevRecoverEvent");
 local eventfrm = getglobal("GEM3UIeventDetails");
 local prevevent, nextevent = GEM3UI_GetPrevNextRecoverevent();
 eventfrm.evt = prevevent;
 GEM3UI_GetPrevNextRecoverevent();
 GEM3UI_EventDetailOnShow();
end

function GEM3UI_NextRecoverEvent()
 --mydbg("GEM3UI_NextRecoverEvent");
 local eventfrm = getglobal("GEM3UIeventDetails");
 local prevevent, nextevent = GEM3UI_GetPrevNextRecoverevent();
 eventfrm.evt = nextevent;
 GEM3UI_GetPrevNextRecoverevent();
 GEM3UI_EventDetailOnShow();
end

function GEM3UI_RecoverFrameDrawPrevNextButton()
local parent = getglobal("GEM3UIRecoverFramePanel1");
 local prevbut = getglobal("GEM3UIRecoverFrameprevbut");
 if prevbut == nil then
  prevbut = CreateFrame("BUTTON", "GEM3UIRecoverFrameprevbut", parent, "PrevButtonTemplate");
  prevbut:SetPoint("TOPLEFT", parent, 303, -6);
  prevbut:SetWidth(16);
  prevbut:SetHeight(16);
  prevbut:SetScript("OnClick", GEM3UI_PrevRecoverEvent);
 end
 local nextbut = getglobal("GEM3UIRecoverFramenextbut");
 if nextbut == nil then
  nextbut= CreateFrame("BUTTON", "GEM3UIRecoverFramenextbut", parent, "NextButtonTemplate");
  nextbut:SetPoint("TOPLEFT", parent, 510, -6);
  nextbut:SetWidth(16);
  nextbut:SetHeight(16);
  nextbut:SetText(">");
  nextbut:SetScript("OnClick", GEM3UI_NextRecoverEvent);
 end
end


---- GROUPING FUNCTION
---- GROUPING FUNCTION


function GEM3UI_SendChatMessage(Message, chan, data, destination)
 if not GEM3UI.BlockWhispers then
  SendChatMessage(Message, chan, data, destination);
 end
end

function GEM3UI_InviteProcess(event, data)
 if event == GroupAnalyse.EVENT_MEMBER_JOINED 
  or event == GroupAnalyse.EVENT_MEMBER_LEFT then
  GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_ADD_OR_REMOVE", nil);
 end
 if GEM3UI_GroupingForEvent == nil then return; end
 local ev = GEM3_QA_Events.events[GEM3UI_GroupingForEvent];
 local groupcomplet = false;
--- MEMBER JOINED
 if event == GroupAnalyse.EVENT_MEMBER_JOINED then
  if UnitName("player") == data then return; end
    if ev.ev_inst_type == GEM3_INST_TYPE_RAID_10 then
        SetRaidDifficulty(1);
    end
    if ev.ev_inst_type == GEM3_INST_TYPE_RAID_25 then
        SetRaidDifficulty(2);
    end
    if ev.ev_inst_type == GEM3_INST_TYPE_RAID_10_HEROIC then
        SetRaidDifficulty(3);
    end
    if ev.ev_inst_type == GEM3_INST_TYPE_RAID_25_HEROIC then
        SetRaidDifficulty(4);
    end

  if ev.tit_count > 5 and GetNumRaidMembers() == 0 then
    ConvertToRaid();
  end
  local InviteMessage = sformat("GEM3: "..GEM3UI_LocalizedStrings["_WelcomeToEvent"], ev.ev_place);
  GEM3UI_SendChatMessage(InviteMessage, "WHISPER", nil, data);
  groupcomplet = GEM3UI_EventIsGroupFull(ev);
--- MEMBER LEFT 
 elseif event == GroupAnalyse.EVENT_MEMBER_LEFT then
   local InviteMessage = sformat("GEM3: "..GEM3UI_LocalizedStrings["_YouWereGrouped"], ev.ev_place);
   GEM3UI_SendChatMessage(InviteMessage, "WHISPER", nil, data);
--- GROUPMODE CHANGED 
 elseif event == GroupAnalyse.EVENT_GROUP_MODE_CHANGED then
  --  IF GROUP DISBANDED STOP GROUPING
  if data == GroupAnalyse.MODE_NONE or data == GroupAnalyse.MODE_SOLO then
   GEM3UI_GroupingForEvent = nil;
   GEM3UI_eventSubscriptionListInvite:SetText(GEM3UI_LocalizedStrings["_InviteAll"]);
  end
 end
 if groupcomplet and GEM3UI_GroupingForEvent then
   GEM3UI_EventInviteOnClick();
 end
end


function GEM3UI_EventIsGroupFull(ev)
  local groupcomplet  = true;
  for i,pl in pairs(ev.players) do
     if not (UnitInParty(pl.name) or UnitInRaid(pl.name)) then
       groupcomplet  = false;
     end
  end
  
  if not groupcomplet then 
   local grpcount = GetNumRaidMembers()
   if grpcount == 0 then 
    grpcount = GetNumPartyMembers();
   end
   if grpcount >= ev.max_count then
    groupcomplet = true;
   end
  end
  return groupcomplet;
end

function GEM3UI_EventInviteOnClick(self)
  if GEM3UI_GroupingForEvent ~= nil then
   GEM3UI_GroupingForEvent = nil;
   GEM3UI_eventSubscriptionListInvite:SetText(GEM3UI_LocalizedStrings["_InviteAll"]);
   GEM3UI_eventSubscriptionListInvite:SetScript("OnUpdate", nil);
   ChatFrame_RemoveMessageEventFilter("CHAT_MSG_WHISPER_INFORM", GEM3UI_InviteChatFilter);
   ChatFrame_RemoveMessageEventFilter("CHAT_MSG_SYSTEM", GEM3UI_InviteChatFilter);
   ERR_ALREADY_IN_GROUP_S = GEM3UI_OLD.ERR_ALREADY_IN_GROUP_S;
   ERR_DECLINE_GROUP_S = GEM3UI_OLD.ERR_DECLINE_GROUP_S;
  else
   local event = GEM3UIeventDetails.evt;
   GEM3UI_GroupingForEvent = event.id;
   GEM3UI_eventSubscriptionListInvite:SetText(GEM3UI_LocalizedStrings["_StopInvite"]);
   GEM3UI_eventSubscriptionListInvite.invTime = time();
   GEM3UI_eventSubscriptionListInvite:SetScript("OnUpdate", GEM3UIEventInviteOnUpdate);
   local channum =  GetChannelName("event.channel");
   local InviteMessage = sformat("GEM3: "..GEM3UI_LocalizedStrings["_PartRequestForEvent"], UnitName("Player"), event.ev_place);
   GEM3UI_SendChatMessage(InviteMessage, "CHANNEL", nil, "imo"); 
   ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", GEM3UI_InviteChatFilter);
   ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", GEM3UI_InviteChatFilter);
   GEM3UI_OLD.ERR_ALREADY_IN_GROUP_S = ERR_ALREADY_IN_GROUP_S ;
   GEM3UI_OLD.ERR_DECLINE_GROUP_S  = ERR_DECLINE_GROUP_S ;
   ERR_ALREADY_IN_GROUP_S = "GEM3 ALREADY IN GROUP:%s";
   ERR_DECLINE_GROUP_S = "GEM3 GROUP DECLINE:%s";
   GEM3UI_EventInviteLoop(true);
  end
end

function GEM3UIEventInviteOnUpdate()
  local ev = GEM3_QA_Events.events[GEM3UI_GroupingForEvent];
  if GEM3UI_GroupingForEvent ~= nil then
   if GEM3UI_eventSubscriptionListInvite.invTime < time() - GEM3UI.InvitePeriod then
     if (ev.ev_date + 60*60) > time() then
        GEM3UI_EventInviteLoop();
     else
      GEM3UI_GroupingForEvent = nil 
      GEM3UI_eventSubscriptionListInvite:SetScript("OnUpdate", nil);
     end
   end
  else
   GEM3UI_eventSubscriptionListInvite:SetScript("OnUpdate", nil);
  end
end

function GEM3UI_GlobalChatFilter(self, event, msg, player, ...)

  if strfind(msg, "GEM3: ") then
    return true
  end
end

function GEM3UI_InviteChatFilter(self, event, msg, player, ...)
  if strfind(msg, "GEM3: ") then
    return true
  end

  --if event == CHAT_MSG_WHISPER_INFORM and strfind(msg, strsub(ERR_ALREADY_IN_GROUP_S, 1, strlen(ERR_ALREADY_IN_GROUP_S)-2)) then
  if strfind(msg, strsub(ERR_ALREADY_IN_GROUP_S, 1, strlen(ERR_ALREADY_IN_GROUP_S)-2)) then
    --local player = strsub(msg, strlen(ERR_ALREADY_IN_GROUP_S)-1)
    local InviteMessage = sformat("GEM3: "..GEM3UI_LocalizedStrings["alreadygrouped"]);
    GEM3UI_SendChatMessage(InviteMessage, "WHISPER", nil, player);
    return true
  end
  
  --if event == CHAT_MSG_WHISPER_INFORM and strfind(msg, strsub(ERR_DECLINE_GROUP_S, 1, strlen(ERR_DECLINE_GROUP_S)-2)) then
  if strfind(msg, strsub(ERR_DECLINE_GROUP_S, 1, strlen(ERR_DECLINE_GROUP_S)-2)) then
    --local player = strsub(msg, strlen(ERR_DECLINE_GROUP_S)-1)
    local InviteMessage = sformat("GEM3: "..GEM3UI_LocalizedStrings["youareinagemparty"]);
    GEM3UI_SendChatMessage(InviteMessage, "WHISPER", nil, player);
    return true
  end
  
end

function GEM3UI_EventInviteLoop(firstrun)
  local invited = 0;
  local grpcount = GetNumRaidMembers()
  if grpcount > 0 then invited = -100; end
  local event = GEM3_QA_Events.events[GEM3UI_GroupingForEvent];
   for i,player in pairs(event.players) do
    local pl = GEM3_PLAY_GetPlayerInfos(player.name, event.channel);
    local connected = false;
    if UnitInParty(player.name) or UnitInRaid(player.name) then
      connected = false;
    else
      if pl == nil then 
        connected = true;
      else
        connected = pl.connected
      end
    end
    if ( connected and invited < 5 and player.name ~= UnitName("player") and player.current_queue == GEM3_SUB_STATE_TITULAR) then
       invited = invited + 1;
       local InviteMessage = sformat("GEM3: "..GEM3UI_LocalizedStrings["_PartRequestForEvent"], UnitName("Player"), event.ev_place);
       GEM3UI_SendChatMessage(InviteMessage, "WHISPER", nil, player.name);
       InviteUnit(player.name);
    end
  end
  GEM3UI_eventSubscriptionListInvite.invTime = time();
end


---- Unbann DD
function GEM3UI_FillDropDownBanned(self)
 local evt = GEM3UIeventDetails.evt;
 GEM3UI_DropDowninit(GEM3UI_LocalizedStrings["_Unban"]);
 local bans = GEM3_EVT_GetBannedPlayers(evt.id);
 for i, pl_name in ipairs(bans) do
  GEM3UI_DDAddLine(evt.id, pl_name.name, pl_name.name, true, false, GEM3UI_PlayerUnbanFromEvent);
 end
 GA_ReleaseTable(bans,2)
 GEM3UI_DDshow(self);
end

function GEM3UI_PlayerUnbanFromEvent(ev_id,player)
 GEM3_EVT_UnBanFromEvent(ev_id,player);
 local bans = GEM3_EVT_GetBannedPlayers(ev_id);
 if #bans > 0 then 
  GEM3UI_eventSubscriptionListUnban:Enable();
 else
  GEM3UI_eventSubscriptionListUnban:Disable();
 end
 GA_ReleaseTable(bans,2)
end


-- GRID RELATED

function GEM3UI_GetEventTypeTexture(id)
 if GEM3UI_LocalizedStrings then
  return GEM3UI_LocalizedStrings.EventTypes[id].tbin
 else
  return id 
 end
end

function GEM3UI_IsMyEvent(id)
 if GEM3_QA_Events.events[id] then
  if GEM3_IsMyReroll(GEM3_QA_Events.events[id].leader) then
    return "interface\\gossipframe\\availablequesticon"
  else
    return ""
  end
 end
end


function GEM3UI_GetTagName(t)
   for i, tag in pairs(TaggedInstances) do
      if t == i then
         return GEM3UI_LocalizedStrings[tag.name];
      end
   end
   return "?"
end


function GEM3UI_GetFriendlyAmILeader(id)
   if GEM3_QA_Events.events[id] then
      if GEM3_IsMyReroll(GEM3_QA_Events.events[id].leader) then
         return GEM3UI_LocalizedStrings["Iamleader"] or "I am the Leader"
      else
         return GEM3UI_LocalizedStrings["Iamnotleader"] or "I am not the Leader"
      end
   end
end


function GEM3UI_GetEventStatus(index, CMD)
 if CMD == "GET_NAME" then return "Event status color" end
 ---if not MyEvent[index] then return "ERROR" end
 local id = index --MyEvent[index].id;
 local ev = GEM3UI_EventSource[id]
 if not ev then return end
 local STATE = GEM3UI_EV_STATE_NORMAL;
 local SUBS = GEM3_SUB_STATE_NONE;
 local color = nil;
 local icon = "";
 local astext = "NotSubscribed"
 --local color = GEM3UI_EVSUBS[GEM3UI_EV_STATE_NORMAL].text_color

 for i, ctype in ipairs(GEM3UI_newEvents) do
   if ctype.id == ev.id then
    STATE = GEM3UI_EV_STATE_NEW;
    astext = "New" 
   end
 end

 
 local rerolls =  GEM3_PLAY_GetMyRerolls(ev.channel);
 for i, player in ipairs(rerolls) do
    if GEM3_QA_Events.subscribed[ev.id] ~= nil then
        local subsinfo = GEM3_SUB_GetSubscribedInfos(ev.id, player.name);
        if subsinfo then                                                              -- Subscribed YES
            local subsdet = ev.players[player.name];                        
            if subsdet ~= nil then                                                       -- has leader seen ?
                if subsdet.current_queue >= GEM3_SUB_STATE_NOT_ACKED or subsdet.current_queue == GEM3_SUB_STATE_NONE or subsdet.current_queue ~= subsinfo.state then                        -- Yes, seen, if subscription not aked
                    --    if subsico:GetTexture() ~= GEM3UI_EVLINE[GEM3UI_EV_STATE_SUBS].icon then  -- verify if another toon has aked subs for this ev
                    icon = GEM3UI_EVLINE[GEM3UI_EV_STATE_NAK].icon;             -- else set nak ico
                    SUBS = subsinfo.state
                    astext = "Not Acknoledged" 
                    --end
                else
                    icon = GEM3UI_EVLINE[GEM3UI_EV_STATE_SUBS].icon;
                    SUBS = subsinfo.state
                    astext = "Subscribed" 
                end
            else
                icon = GEM3UI_EVLINE[GEM3UI_EV_STATE_NAK].icon;            -- else set nak ico
                SUBS = subsinfo.state
                astext = "Not Acknoledged" 
            end
        end
    end
 end

 if STATE == GEM3UI_EV_STATE_NORMAL or STATE == GEM3UI_EV_STATE_OUTDATED or STATE == GEM3UI_EV_STATE_NEW then
   color = GEM3UI_EVSUBS[SUBS].text_color;
 end
 
 if STATE ~= GEM3UI_EV_STATE_NORMAL and STATE ~= GEM3UI_EV_STATE_OUTDATED and STATE ~= GEM3UI_EV_STATE_NEW then
   color = GEM3UI_EVLINE[STATE].line_color
 end
 if CMD == "GET_COLOR" then 
  return {color.r,color.g,color.b,color.a} 
 elseif CMD == "ASTEXT" then 
  return astext
 else
  return icon 
 end
end

function GEM3UI_GetEventStatusColor(val)
    return val
end


function GEM3UI_GetEventStatusFriendlyText(index)
    return GEM3UI_GetEventStatusTexture(index, "ASTEXT")
end

function GEM3UI_GetEventStatusTexture(index, CMD)
 local id = index --MyEvent[index].id;
 local ev = GEM3UI_EventSource[id]
 local icon = nil; 
 local STATE = GEM3UI_EV_STATE_NORMAL;
 local statetext = "Unknown";
 if ev.deadline < time() then
       STATE = GEM3UI_EV_STATE_OUTDATED;
       astext = "Outdated" 
 end
 if ev.ev_date < time() then
       STATE = GEM3UI_EV_STATE_PASSED;
       astext = "Passed" 
 end

 if GEM3_EVT_IsEventIgnored(ev.id) then
    STATE= GEM3UI_EV_STATE_IGNORED;
    astext = "Ignored" 
 end
 
 if ev.closed_comment ~= nil then
      STATE= GEM3UI_EV_STATE_CLOSED;
      astext = "Closed" 
 end


  
--- Check if Event new or updated since last list viewing  
  for i, ctype in ipairs(GEM3UI_newEvents) do
   if ctype.id == ev.id then
    STATE = GEM3UI_EV_STATE_NEW;
    statetext = "NEW"
   end
  end

  if STATE == GEM3UI_EV_STATE_NORMAL then
    icon = GEM3UI_LocalizedStrings.EventTypes[ev.ev_type].tbin
    statetext = GEM3UI_LocalizedStrings.EventTypes[ev.ev_type].longtext
  else
     icon = GEM3UI_EVLINE[STATE].icon;
  end
  if CMD == "ASTEXT" then 
   return statetext
  else
   return icon
  end
end

function GEM3UI_GetEventIgnoreIcon(isIgnored)
    if isIgnored then
        return "interface\\AddOns\\GEM3UI\\X"
    else
        return ""
    end
end



function GEM3UI_GetIsOutdatedIcon(isoutdated)
    if isoutdated then
        return "interface\\AddOns\\GEM3UI\\bell"
    else
        return ""
    end   
end

function GEM3UI_GetIsOutdatedFriendly(isoutdated)
    if isoutdated then
        return MovixLib_GetLocale("Outdated", "GEM3UI_EVENTS_Minimal")
    else
        return MovixLib_GetLocale("Accessible", "GEM3UI_EVENTS_Minimal")
    end   
end


function GEM3UI_GetTagIcon(t)
   for i, tag in pairs(TaggedInstances) do
        if t == i then
            --if string.find(TaggedInstances[i].icon, "lfgframe") ~= nil then
                --stateico:SetTexCoord(0,0.8,0,0.72);
            --else
                --stateico:SetTexCoord(0,1,0,1);
            --end
            return TaggedInstances[i].icon;
        end
   end
  return "interface\\icons\\inv_misc_questionmark"
end


function GEM3UI_EventGridFill()
    if not GEM3UI_EventGrid:IsVisible() then return end
    MovixLib_FillData(GEM3UI_EventGrid)
    MovixLib_RefreshGrid(GEM3UI_EventGrid, close)
end


function GEM3UI_GetLeaderStatusColor(e)
    if not e.channel then
        return {1,1,1,1}
    end
    if not e.leader then
        return {1,1,1,1}
    end
    if not GEM3_QA_Players[e.channel] then
        return {1,1,1,1}
    end
    local p = GEM3_QA_Players[e.channel][e.leader]
    
	local p = GEM3_PLAY_GetPlayerInfos(e.leader, e.channel);
	if not p then
		p = GEM3_PLAY_GetPlayerInfos(e.leader);
	end
	
    if p and GroupAnalyse.Members[p.name] and (GetNumPartyMembers() + GetNumRaidMembers()) > 0 then
        return {0.4,0.3,1,1}
    elseif p and  p.connected then
        return {0,1,0,1}
    elseif GEM3_IsMyReroll(e.leader) then
            return {0,0.8,0,0.9}            
    else
        return {1,1,1,1}
    end
end

function GEM3UI_GridEventLineOnEnter(p, row, col)
   local es = getglobal("GEM3UIEventSubs");
   if #p.data == 0 then
    es:Hide();
    return 
   end
   local es = getglobal("GEM3UIEventSubs");
   es.ev_index = p.data[row].MovixLibID
   es.evt= GEM3UI_EventSource[MyEvent[es.ev_index].id];
   es.form=false;
   if es:IsVisible() then
      es:Hide();
   end
   es:Show();
   if GEM3UI_SET_EVTCHANGE_TBL(es.evt, GEM3UI_EVENT_CHANGE_VIEWED) then
      GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_UPDATE", es.evt.id);
  end

end

function GEM3UI_GridEventLineOnLeave(p, row, col)
   local es = getglobal("GEM3UIEventSubs");
   local selrow = nil
   es:Hide();
   es.form=false;
   if p.SelectedRow then
    for key, line in pairs (p.SelectedRow) do
        if not selrow then selrow = key end
    end
   end
   if selrow and MyEvent[selrow] then
    es.ev_index = selrow
    es.evt= GEM3UI_EventSource[MyEvent[selrow].id];
    es:Hide();
    es:Show()
    es.form=true;
   else
    es:Hide();
   end
end



function GEM3UI_GetOutdatedColor(deadline)
    if deadline <= time() then
        return {1,0,0,1}
    else
        return nil
    end
end


function GEM3UI_GetZeroValueString(val)
    if val == 0 then
        return ""
    else
        return val
    end
end

function GEM3UI_GetLevelLimitColor(level)
    if level > UnitLevel("player") then
        return {1,0,0,1}
    else
        return nil
    end
end



function GEM3UI_EventDetailFrameResize(self)
    GEM3UI_GrideventSubscriptionList:ClearAllPoints()
    GEM3UI_GrideventSubscriptionList:SetPoint("TOPLEFT", 3,-32)
    GEM3UI_GrideventSubscriptionList:SetPoint("BOTTOMRIGHT", GEM3UIeventDetailsLimitsFrame, "BOTTOMLEFT", 3,24)
    
    GEM3UI_EventLineHeader:ClearAllPoints()
    GEM3UI_EventLineHeader:SetPoint("BOTTOMLEFT", GEM3UI_GrideventSubscriptionList, "TOPLEFT", 0 , 0)
    GEM3UI_EventLineHeader:SetPoint("TOPRIGHT", GEM3UIeventDetailsLimitsFrame, "TOPRIGHT", 0 , 33)
    
    GEM3UI_eventSubscriptionListAddMember:ClearAllPoints()
    GEM3UI_eventSubscriptionListAddMember:SetPoint("TOPLEFT", GEM3UI_GrideventSubscriptionList, "BOTTOMLEFT", 0, 3)
    GEM3UI_eventSubscriptionListAddMember:SetHeight(24)
    GEM3UI_eventSubscriptionListAddMember:SetWidth(80)
    
    GEM3UI_eventSubscriptionListUnban:ClearAllPoints()
    GEM3UI_eventSubscriptionListUnban:SetPoint("TOPRIGHT", GEM3UIeventDetailsLimitsFrame, "BOTTOMLEFT", 0, 24)
    GEM3UI_eventSubscriptionListUnban:SetHeight(24)
    GEM3UI_eventSubscriptionListUnban:SetWidth(80)
    
    GEM3UI_eventSubscriptionListInvite:ClearAllPoints()
    GEM3UI_eventSubscriptionListInvite:SetPoint("TOPLEFT", GEM3UI_eventSubscriptionListAddMember, "TOPRIGHT", 0, 0)
    GEM3UI_eventSubscriptionListInvite:SetPoint("BOTTOMRIGHT", GEM3UI_eventSubscriptionListUnban, "BOTTOMLEFT", 0, 0)
end

function GEM3UI_GetOpenButtonText()
    return "interface\\AddOns\\GEM3UI\\gfx\\more"
end

function GEM3UI_GridEventDetailsHide()
   local es = getglobal("GEM3UIEventSubs");
   local selrow = nil
   es:Hide();
   es.form=false;
end

function GEM3UI_GridEventLineOnClick(p, row, col)
   local evid = p.data[row].MovixLibID
   GEM3UI_SelectedEvent = MyEvent[evid].id
   local es = getglobal("GEM3UIEventSubs");
   GEM3UIEventSubs.userIsEditing = nil;
   es.ev_index = id
   es.evt= GEM3UI_EventSource[MyEvent[evid].id]
   es.form=true;
   es:Hide();
   es:Show()
   
   GEM3UI_SetDebugStatus(sformat("SELECTED EVENT ID : %s ", GEM3UI_SelectedEvent ),0);
end

function GEM3UI_GridEventLineOnDClick(p, row, col)
   local evid = p.data[row].MovixLibID
   GEM3UI_SelectedEvent = MyEvent[evid].id
   GEM3UI_GridEventLineopen(evid)
end

function GEM3UI_GridEventLineopen(id)
   local evid = id --GEM3UI_EventsList[id].MovixLibID
   GEM3UI_SelectedEvent = MyEvent[evid].id
   local es = getglobal("GEM3UIEventSubs");
   es.ev_index = id
   es.evt= GEM3UI_EventSource[MyEvent[evid].id]
   es.form=true;
   es:Hide();
   es:Show()

   local pe = nil
   local ne = nil

   if evid == 1 then
    pe = #MyEvent
   else
    pe = evid-1
   end
   if evid == #MyEvent then
    ne = 1
   else
    ne = evid +1
   end
   
   if not GEM3UI_EventDetailsStandAloneFrame then
    GEM3UI_EventDetailsStandAloneFrame = MovixLib_UIFrames.Createsimple(GEM3UIMainMainPanelEventListMain, "Event Details",527 , 373)
    GEM3UI_EventDetailsStandAloneFrame:SetPoint("CENTER",-5,0)
    GEM3UI_EventDetailsStandAloneFrame:SetScript("OnHide", GEM3UI_GridEventDetailsHide)
    tinsert(UISpecialFrames,GEM3UI_EventDetailsStandAloneFrame:GetName());
   end
   
   local f = GEM3UI_EventDetailsStandAloneFrame
   
   f:SetBackdrop({bgFile = "Interface/CharacterFrame/UI-Party-Background", 
                    edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                    tile = true, tileSize = 16, edgeSize = 16, 
                    insets = { left = 4, right = 4, top = 4, bottom = 4 }});
   f:SetBackdropColor(0, 0, 0, 1) 
   f:Raise()
   f:ClearAllPoints()
   f:SetAllPoints()
   local tb = f.Titlebar
   if not f.tcb then
    f.tcb = MovixLib_GetControlObject(tb, "button")
    f.tcb:ClearAllPoints()
    f.tcb:SetPoint("TOPLEFT", tb, "TOPLEFT", 183, 0)
    f.tcb:SetWidth(80)
    f.tcb:SetHeight(MovixLib_UIFrames.TitleHeight-4)   
    f.tcb:SetText(CLOSE)
    f.tcb:SetScript("OnClick", function (self, button) f:Hide() end)
    --f.tcb:SetFrameLevel(255)
    f.tcb:Show()
    
    f.tm = MovixLib_GetControlObject(tb, "button")
    f.tm:ClearAllPoints()
    f.tm:SetPoint("TOPLEFT", f.tcb, "TOPRIGHT", 0, 0)
    f.tm:SetWidth(80)
    f.tm:SetHeight(MovixLib_UIFrames.TitleHeight-4)   
    f.tm:SetText("Menu")
    --f.tcb:SetFrameLevel(255)
    f.tcb:Show()

    f.pb = MovixLib_GetControlObject(tb, "custombutton")
    f.pb:ClearAllPoints()
    f.pb:SetPoint("TOPRIGHT", f.tcb, "TOPLEFT", 0, 3)
    f.pb:SetWidth(20)
    f.pb:SetHeight(MovixLib_UIFrames.TitleHeight+1)   
    f.pb:SetNormalTexture("interface\\AddOns\\GridLib\\gfx\\arrow-l")
    f.pb:SetHighlightTexture("interface\\AddOns\\GridLib\\gfx\\arrow-l-h")
    f.pb:SetPushedTexture("interface\\AddOns\\GridLib\\gfx\\arrow-l-d")
    --f.pb:SetText("<")
    --f.tcb:SetFrameLevel(255)
    f.pb:Show()

    f.nb = MovixLib_GetControlObject(tb, "custombutton")
    f.nb:ClearAllPoints()
    f.nb:SetPoint("TOPLEFT", f.tm, "TOPRIGHT", 0, 3)
    f.nb:SetWidth(20)
    f.nb:SetHeight(MovixLib_UIFrames.TitleHeight+1)   
    f.nb:SetNormalTexture("interface\\AddOns\\GridLib\\gfx\\arrow-r")
    f.nb:SetHighlightTexture("interface\\AddOns\\GridLib\\gfx\\arrow-r-h")
    f.nb:SetPushedTexture("interface\\AddOns\\GridLib\\gfx\\arrow-r-d")
    --f.nb:SetText(">")
    --f.tcb:SetFrameLevel(255)
    f.pb:Show()

   end
   f.tm:SetScript("OnClick", function (self, button) local es = getglobal("GEM3UIEventSubs"); GEM3UI_DetailsEventMenu(es.evt) end)
   f.pb:SetScript("OnClick", function (self, button)  GEM3UI_EventDetailsStandAloneFrame:Hide() GEM3UI_GridEventLineopen(pe) end)
   f.nb:SetScript("OnClick", function (self, button) GEM3UI_EventDetailsStandAloneFrame:Hide() GEM3UI_GridEventLineopen(ne) end)

   
   
   GEM3UIeventDetails.evt = GEM3UI_EventSource[MyEvent[evid].id]
   GEM3UIeventDetails.recover = false;
   GEM3UIeventDetails:Show();
   GEM3UIeventDetails:ClearAllPoints()
   GEM3UIeventDetails:SetParent(f.Content);
   f:Show()
   GEM3UI_EventDetailOnShow()
   GEM3UIeventDetails:SetPoint("TOPLEFT", 0, -83);
   GEM3UIeventDetails:SetPoint("BOTTOMRIGHT", 0, 0);
   local e = GEM3UIeventDetails.evt
   
   local row = {MovixLibID = evid}
   if not f.fr then
    f.fr = MovixLib_GetControlObject(f.Content, "frame")
   end
   local d = f.fr
   d:ClearAllPoints()
   d:SetPoint("TOPLEFT", f.Content, "TOPLEFT", 3,-3)
   d:SetPoint("BOTTOMRIGHT", f.Content, "TOPLEFT", 522,-80)
   if not d.closebut then
    d.closebut = MovixLib_GetControlObject(d, "button")
    d.closebut:SetNormalTexture("")
    d.closebut:SetHighlightTexture("")
    d.closebut:SetPushedTexture("")
    d.closebut:SetAllPoints()
    d.closebut:SetScript("OnDoubleClick", function (self, button) f:Hide() end)
   end
   
   
   d.closebut:Show()
   
   GEM3UI_DrawEventHeader(p, row, d, "create", 1.3)
   GEM3UI_DrawEventHeader(p, row, d, nil, 1.3)
   f:SetScript("OnHide", function (self) GEM3UI_EventDetailsStandAloneFrame:Hide() GEM3UI_DrawEventHeader(nil, nil, d, "release") end )
end


function GEM3UI_DrawEventHeader(p, row, f, action, scale)
   local font = "Fonts\\FRIZQT__.TTF"
   scale = scale or 1
   
   if action == "create" then
   
    f.icon = MovixLib_GetControlObject(f, "texture")
    f.icon:SetPoint("TOPLEFT", f, "TOPLEFT", 2, -3)
    f.icon:SetWidth(60*scale)
    f.icon:SetHeight(60*scale)
    f.icon:SetVertexColor(1,1,1,1)

    f.ecnt = MovixLib_GetControlObject(f, "string")
    f.ecnt:SetJustifyH("RIGHT")
    f.ecnt:SetFont(font, 9*scale);
    f.ecnt:SetPoint("TOPRIGHT", f, "TOPRIGHT", 0, -3)
    f.ecnt:SetWidth(120*scale)
    f.ecnt:SetHeight(10*scale)
    f.ecnt:SetTextColor(1,1,0,1)

    f.elvl = MovixLib_GetControlObject(f, "string")
    f.elvl:SetJustifyH("RIGHT")
    f.elvl:SetJustifyV("TOP")
    f.elvl:SetPoint("TOPRIGHT", f, "TOPRIGHT", 0, -15*scale)
    f.elvl:SetFont(font, 9*scale);
    f.elvl:SetWidth(120*scale)
    f.elvl:SetHeight(10*scale)
    f.elvl:SetTextColor(1,1,0,1)

    f.subs = MovixLib_GetControlObject(f, "button")
    f.subs:SetPoint("TOPRIGHT", f, "TOPRIGHT", 3, -43*scale)
    f.subs:SetWidth(120*scale)
    f.subs:SetHeight(20*scale)   
    f.subs:SetFrameLevel(255)

    f.evdate= MovixLib_GetControlObject(f, "string")
    f.evdate :SetJustifyH("LEFT")
    f.evdate :SetFont(font, 8*scale);
    f.evdate:SetPoint("TOPLEFT", f.icon, "TOPRIGHT", 1, 3)
    f.evdate:SetWidth(80*scale)
    f.evdate:SetHeight(15*scale)
    f.evdate:SetTextColor(1,1,0,1)

    f.leader = MovixLib_GetControlObject(f, "string")
    f.leader:SetJustifyH("CENTER")
    f.leader:SetJustifyV("TOP")
    f.leader:SetPoint("TOPLEFT", f.evdate, "TOPRIGHT", 5, -5)
    f.leader:SetPoint("BOTTOMRIGHT", f.ecnt, "BOTTOMLEFT", 0, 0)
    f.leader:SetFont(font, 7*scale);
    f.leader:SetTextColor(1,1,1,1)

    f.ename= MovixLib_GetControlObject(f, "string")
    f.ename:SetJustifyH("LEFT")
    f.ename:SetFont(font, 11*scale);
    f.ename:SetPoint("TOPLEFT", f.evdate, "BOTTOMLEFT", 0, 7)
    f.ename:SetPoint("BOTTOMRIGHT", f.ecnt, "BOTTOMLEFT", -10, -26*scale)
    f.ename:SetTextColor(1,1,0,1)

    f.ecomment = MovixLib_GetControlObject(f, "string")
    f.ecomment :SetJustifyH("LEFT")
    f.ecomment :SetJustifyV("TOP")
    f.ecomment :SetPoint("TOPLEFT", f.icon, "TOPRIGHT", 0, -33*scale)
    f.ecomment :SetPoint("BOTTOMRIGHT", f.subs, "BOTTOMLEFT", -10, -4)
    f.ecomment :SetFont(font, 8);
    f.ecomment :SetTextColor(1,1,1,1)

    f.subsinfo= MovixLib_GetControlObject(f, "string")
    f.subsinfo:SetJustifyH("RIGHT")
    f.subsinfo:SetJustifyV("TOP")
    f.subsinfo:SetFont(font, 8*scale);
    f.subsinfo:SetPoint("TOPRIGHT", f, "TOPRIGHT", 0, -30*scale)
    f.subsinfo:SetWidth(120*scale)
    f.subsinfo:SetHeight(30*scale)   

    return f
   end
   if action == "release" then
    MovixLib_ReleaseControlObject(f.icon)
    MovixLib_ReleaseControlObject(f.ecnt)
    MovixLib_ReleaseControlObject(f.elvl)
    MovixLib_ReleaseControlObject(f.subs)
    MovixLib_ReleaseControlObject(f.evdate)
    MovixLib_ReleaseControlObject(f.leader)
    MovixLib_ReleaseControlObject(f.ename)
    MovixLib_ReleaseControlObject(f.ecomment)
    MovixLib_ReleaseControlObject(f.subsinfo)
    f.icon = nil
    f.ecnt = nil
    f.elvl = nil
    f.subs = nil
    f.evdate= nil
    f.leader = nil
    f.ename= nil
    f.ecomment = nil
    f.subsinfo= nil
    return nil
   end
   
   local evid = f.MovixLibID
   if row then
    evid = row.MovixLibID
   end
   local e = MyEvent[evid]
   f.MovixLibID = evid

   f.icon:SetTexture(GEM3UI_GetTagIcon(e.ev_inst_tag))
   f.ecnt:SetText(e.max_count.." "..MovixLib_GetLocale("Players", "GEM3UI_EVENTS_Leader"))
   f.elvl:SetText(MovixLib_GetLocale("LvL: ", "GEM3UI_EVENTS_Leader")..e.min_lvl.." - "..e.max_lvl)
   f.evdate :SetText(Movixlib_GetDateFormated(MovixLib_DefaultDateStrings, e.ev_date+(GEM3UI.ServerTimeOffSet*60*60)))
   f.leader:SetText(MovixLib_GetLocale("_Leader", "GEM3UI_EVENTS_Leader").." "..e.leader)
   f.ename:SetText(e.ev_place)
   f.ecomment:SetText(e.ev_comment)
   
   if e.outdated or e.passed then
    f.subs:Hide()
    f.subsinfo:SetText(MovixLib_GetLocale("cannotsubspassed", "GEM3UI_EVENTS_Leader"))
   else
    f.subs:Show()
    local subs = GEM3_SUB_GetSubscribedInfos(e.id, UnitName("player"))
    if not subs then
        local myrerolls = GEM3_PLAY_GetMyRerolls(e.channel)
        for i, reroll in pairs(myrerolls) do
            local s = GEM3_SUB_GetSubscribedInfos(e.id, reroll.name)
            if s then 
                subs = s
            end
        end
        GA_ReleaseTable(myrerolls, 0)
    end
    if subs and subs.force_queue ~= GEM3_SUB_FORCE_QUEUE_NOT_COMING then
        f.subs:SetText(MovixLib_GetLocale("_unsubscribe", "GEM3UI_EVENTS_Leader"))
        f.subs:SetScript("OnClick", function() GEM3UI_GridModifySubscribe(e, subs, GEM3_SUB_FORCE_QUEUE_NOT_COMING) end)
    else
        if subs then
            f.subs:SetScript("OnClick", function() GEM3UI_GridModifySubscribe(e, subs, GEM3_SUB_FORCE_QUEUE_NONE) end)
        else
            f.subs:SetScript("OnClick", function() GEM3UI_GridSubscribe(e) end)
        end
        f.subs:SetText(MovixLib_GetLocale("_Subscribe", "GEM3UI_EVENTS_Leader"))
    end
    if subs then
        f.subsinfo:SetText(subs.name..MovixLib_GetLocale(" is ", "GEM3UI_EVENTS_Leader")..GEM3UI_Queues[(subs.state or 0)].name)
        if subs.state == GEM3_SUB_STATE_TITULAR then
            f.subsinfo:SetTextColor(0,1,0,1)
        elseif subs.state == GEM3_SUB_STATE_REPLACEMENT then
            f.subsinfo:SetTextColor(0.7,0.6,0.4,1)
        else
            f.subsinfo:SetTextColor(1,0,0,1)
        end
    else
        f.subsinfo:SetText(MovixLib_GetLocale("not subscribed", "GEM3UI_EVENTS_Leader"))
        f.subsinfo:SetTextColor(1,1,1,1)
    end
   end
   return f
end

function GEM3UI_EventGridQuickSubscribe(id)
   local e = GEM3UI_EventSource[id]

   local subs = GEM3_SUB_GetSubscribedInfos(e.id, UnitName("player"))
   if not subs then
    local myrerolls = GEM3_PLAY_GetMyRerolls(e.channel)
    for i, reroll in pairs(myrerolls) do
        local s = GEM3_SUB_GetSubscribedInfos(e.id, reroll.name)
        if s then 
            subs = s
        end
    end
    GA_ReleaseTable(myrerolls, 0)
   end
   if subs and subs.force_queue ~= GEM3_SUB_FORCE_QUEUE_NOT_COMING then
    GEM3UI_GridModifySubscribe(e, subs, GEM3_SUB_FORCE_QUEUE_NOT_COMING)
   else
    if subs then
        GEM3UI_GridModifySubscribe(e, subs, GEM3_SUB_FORCE_QUEUE_NONE)
    else
        GEM3UI_GridSubscribe(e)
    end
   end
end

function GEM3UI_EventGridQuickSubscribeGetText1(id)
   local e = GEM3UI_EventSource[id]
   local subs = GEM3_SUB_GetSubscribedInfos(e.id, UnitName("player"))
   if not subs then
    local myrerolls = GEM3_PLAY_GetMyRerolls(e.channel)
    for i, reroll in pairs(myrerolls) do
        local s = GEM3_SUB_GetSubscribedInfos(e.id, reroll.name)
        if s then 
            subs = s
        end
    end
    GA_ReleaseTable(myrerolls, 0)
   end
   if subs and subs.force_queue ~= GEM3_SUB_FORCE_QUEUE_NOT_COMING then
    return MovixLib_GetLocale("_unsubscribe", "GEM3UI_EVENTS_Leader")
   else
    return MovixLib_GetLocale("_Subscribe", "GEM3UI_EVENTS_Leader")
   end
end


function GEM3UI_EventGridQuickSubscribeGetButton(p, row, f, action, scale)
   scale = scale or 1
   if action == "create" then
    f.button = MovixLib_GetControlObject(f, "custombutton")
    f.button:SetPoint("TOPRIGHT", f, "TOPRIGHT", 3, -43)
    f.button:ClearAllPoints()
    f.button:SetAllPoints()   
    f.button:SetNormalTexture("interface\\AddOns\\GEM3UI\\gfx\\delete")
    f.button:SetPushedTexture("interface\\AddOns\\GEM3UI\\gfx\\delete")
    f.button:SetHighlightTexture("interface\\AddOns\\GEM3UI\\gfx\\deletehl")
    f.button:SetScript("OnLeave", function (self) MovixLib_OnLeaveLine(self:GetParent():GetParent()) GameTooltip:Hide() end)
    f.button:SetScript("OnClick", function(self) GEM3UI_EventGridQuickSubscribe(self.evid) end )
    return f
   end
   if action == "release" then
    MovixLib_ReleaseControlObject(f.button)
    f.button = nil
    return
   end
   
   if GEM3UI_ShowTemplates:GetChecked() then
    f.button:Hide()
    return
   end
   if GEM3UI_ShowArchive:GetChecked() then
    f.button:Hide()
   end
   
   
   local evid = row.MovixLibID
   local e = MyEvent[evid]
   if not e then return end

   local subs = GEM3_SUB_GetSubscribedInfos(e.id, UnitName("player"))
   if not subs then
    local myrerolls = GEM3_PLAY_GetMyRerolls(e.channel)
    for i, reroll in pairs(myrerolls) do
        local s = GEM3_SUB_GetSubscribedInfos(e.id, reroll.name)
        if s then 
            subs = s
        end
    end
    GA_ReleaseTable(myrerolls, 0)
   end
   if subs and subs.force_queue ~= GEM3_SUB_FORCE_QUEUE_NOT_COMING then
    f.button:SetNormalTexture("interface\\AddOns\\GEM3UI\\gfx\\delete")
    f.button:SetPushedTexture("interface\\AddOns\\GEM3UI\\gfx\\delete")
    f.button:SetHighlightTexture("interface\\AddOns\\GEM3UI\\gfx\\deletehl")
    f.button:SetScript("OnEnter", function (self) MovixLib_OnEnterLine(self:GetParent():GetParent()) GEM3UI_GameTooltipShow(self, MovixLib_GetLocale("Revoke subscription for ", "GEM3UI_EVENTS_Leader")..subs.name, true) end)
   else
    f.button:SetNormalTexture("interface\\AddOns\\GEM3UI\\gfx\\accept")
    f.button:SetPushedTexture("interface\\AddOns\\GEM3UI\\gfx\\accept")
    f.button:SetHighlightTexture("interface\\AddOns\\GEM3UI\\gfx\\accepthl")
    --local pl = GEM3_PLAY_GetPlayerInfos(UnitName("player"), e.channel)
    if subs then
        f.button:SetScript("OnEnter", function (self) MovixLib_OnEnterLine(self:GetParent():GetParent()) GEM3UI_GameTooltipShow(self, MovixLib_GetLocale("_Subscribe", "GEM3UI_EVENTS_Leader").."\n"..subs.name, true) end)
    else
        f.button:SetScript("OnEnter", function (self) MovixLib_OnEnterLine(self:GetParent():GetParent()) GEM3UI_GameTooltipShow(self, MovixLib_GetLocale("_Subscribe", "GEM3UI_EVENTS_Leader").."\n"..UnitName("player"), true) end)
    end
   end
   if e.outdated or e.passed then
    f.button:Hide()
   else
    f.button:Show()
   end
   f.button.evid = e.id
end



function GEM3UI_GridModifySubscribe(e, subs, force_queue)
 local player = GEM3_PLAY_GetPlayerInfos(UnitName("player"), e.channel);
 if not player then
  player = GEM3_PLAY_GetPlayerInfos(UnitName("player"));
 end

 local subs, reason  = GEM3_SUB_SubscribeUpdate(
       e.id,
       subs.name,
       subs.guild,
       subs.level,
       subs.class,
       subs.role,
       "",
       force_queue,
       subs.alt_role or GEM3_ROLE_UNKNOWN
       );

 if subs then
  PlaySound("PVPENTERQUEUE");
 else
  PlaySound("igQuestFailed");
 end                    

 if GEM3UI_EventDetailsStandAloneFrame and GEM3UI_EventDetailsStandAloneFrame:IsVisible() then
  GEM3UI_EventDetailsStandAloneFrame:Hide()
 end
 GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_UPDATE", e.id);
 GEM3UI_SetStatusMessage(reason);
end 



function GEM3UI_GridSubscribe(e)
 local player = GEM3_PLAY_GetPlayerInfos(UnitName("player"), e.channel);
 if not player then
  player = GEM3_PLAY_GetPlayerInfos(UnitName("player"));
 end
 local subs, reason  = GEM3_SUB_Subscribe(
                    e.id,
                    player.name,
                    player.guild,
                    player.level,
                    player.class,
                    GEM3UI[UnitName("player")].DefaultRole,
                    "",
                    GEM3_SUB_FORCE_QUEUE_NONE,
                    GEM3UI[UnitName("player")].DefaultAltRole);
 if subs then
  PlaySound("PVPENTERQUEUE");
 else
  PlaySound("igQuestFailed");
 end                    

  if GEM3UI_EventDetailsStandAloneFrame and GEM3UI_EventDetailsStandAloneFrame:IsVisible() then
  GEM3UI_EventDetailsStandAloneFrame:Hide()
 end

 GEM3UI_RefreshView("GEM3UI_REFRESH_EVENT_UPDATE", e.id);
 GEM3UI_SetStatusMessage(reason);
end 


function GEM3UI_FilleventPlayersList(e)
 if not GEM3UI_GrideventSubscriptionList:IsVisible() then return end
 GEM3UI_GrideventSubscriptionList.event = e
 if not GridLib.Grids["GEM3UI_EventPlayers"] then
        GridLib.Grids["GEM3UI_EventPlayers"] = MovixLib_TblCpy(GEM3UI_EventsPlayersListGridDefaults)
 end
 if not GEM3UI_GrideventSubscriptionList.gridid then 
    MovixLib_GetGridDefaults(GEM3UI_GrideventSubscriptionList, "GEM3UI_EventPlayers", "GEM3UI_EventPlayers")
    MovixLib_Grid_RegisterColor("GEM3UI_EventPlayers", "Status color", "GEM3UI_GetStatusColor", nil, "Yellow = Online, White = Offline, Blue = in my raid or party")
    MovixLib_Grid_RegisterColor("GEM3UI_EventPlayers", "Class color", "GEM3UI_GetClassColor", "class", "")
    MovixLib_FillData(GEM3UI_GrideventSubscriptionList);
    MovixLib_RefreshGrid(GEM3UI_GrideventSubscriptionList, true, nil, true)
 else
    MovixLib_FillData(GEM3UI_GrideventSubscriptionList)
    MovixLib_RefreshGrid(GEM3UI_GrideventSubscriptionList)
 end
end

function GEM3UI_GetCommentIcon(comment)
   if strlen(comment or "") > 0  then
      return "interface\\buttons\\ui-guildbutton-publicnote-up"
   else
      return ""
   end
end


function GEM3UI_GetQueueString(q)
   if q == GEM3_SUB_FORCE_QUEUE_NONE then
    return ""
   elseif q then
    return GEM3UI_Queues[q].short
   else
      return GEM3UI_LocalizedStrings["_not_acknedshort"]
   end
end

function GEM3UI_GetForceQueueIcon(q)
   if q ~= GEM3_SUB_FORCE_QUEUE_NONE then
      return {1,1,1,0.3}
   else
      return ""
   end
end

function GEM3UI_GetPlayerCountColor(e)
    if (e.tit_count or 0) == (e.max or 0) then
        return {0,1,0,1}
    elseif (e.tit_count or 0) > ((e.max or 0)/2) then
        return {1,1,0,1}
    else
        return {1,0,0,1}
    end
end

function GEM3UI_EventPlayerLeaderIcon(isleader)
 if isleader == 1 then
    return "interface\\AddOns\\GEM3UI\\gfx\\UI-group-leadericon"
 elseif isleader == 2 then
    return "interface\\AddOns\\GEM3UI\\gfx\\UI-group-assistanticon"
 else
    return ""
 end
end


function GEM3UI_GetPlayerTaggedToInstance(name)
   local e = GEM3UI_EventSource[GEM3UI_SelectedEvent]
   local pl = GEM3_PLAY_GetPlayerInfos(name,e.channel);
   if not player then
    pl = GEM3_PLAY_GetPlayerInfos(name);
   end
   local showtt = nil
   if pl then
      for tagid, tag in pairs(pl.tags) do
        local tid = tag[GEM3_ACCESS_INST_TAG_NAME];
        local ttype = tag[GEM3_ACCESS_INST_TAG_TYPE];
--        if bit.band(e.ev_inst_tag, tid) ~= 0 and tid ~= 0 then
          if (e.ev_inst_tag == tid) and isSameTagType(ttype, e.ev_inst_type) then
            if tag[GEM3_ACCESS_INST_TAG_RESET] > e.ev_date+GEM3UI.ServerTimeOffSet then
                showtt = true
            end
        end
      end
   end
   if showtt then
        return "*"
   else
        return ""
   end
end

function isSameTagType(tagType, instType)
    return GEM3_INSTTAGTYPE_INSTTYPE_MATCHING[tagType] == instType; 
end

function GEM3UI_GetEmptyOnNil(val)
 if val == nil then 
    return ""
 else
    return val
 end
end

function GEM3UI_GetSourceIcon(source)
 if source == nil then source = GEM3_SUB_SOURCE_SELF; end
 if strsub(source, 1,1) == GEM3_SUB_SOURCE_EXTERNAL then
  return "interface\\buttons\\ui-guildbutton-officernote-up"
 elseif strsub(source, 1,1) == GEM3_SUB_SOURCE_TEMPLATE then
  return "interface\\buttons\\ui-sliderbar-button-horizontal"
 elseif strsub(source, 1,1) == GEM3_SUB_SOURCE_WEB then
  return "interface\\ui-guildbutton-motd-up"
 elseif strsub(source, 1,1) == GEM3_SUB_SOURCE_SELF then
  return ""
 end
end


function GEM3UI_EventPlayerOnEnter(p, row, col)
   local id = p.data[row].MovixLibID
   local e = GEM3UI_EventSource[GEM3UI_SelectedEvent]
   local pl = GEM3_PLAY_GetPlayerInfos(p.data[row].name,e.channel);
   if not pl then
    pl = GEM3_PLAY_GetPlayerInfos(p.data[row].name);
   end
   local showtt = nil
   GEM3UI_FillPlayerDetails(id);
   GEM3UIPlayerDetails:Show();
   
   if pl then
      for tagid, tag in pairs(pl.tags) do
        local tid = tag[GEM3_ACCESS_INST_TAG_NAME];
        if bit.band(e.ev_inst_tag, tid) ~= 0 and tid ~= 0 then
            if tag[GEM3_ACCESS_INST_TAG_RESET] > e.ev_date+GEM3UI.ServerTimeOffSet then
                showtt = true
            end
        end
      end
      if showtt then
        local l = GEM3UI_GrideventSubscriptionList
        l.plname=p.data[row].name;
        l.ev_inst_tag=e.ev_inst_tag;
        l.tags = pl.tags;
        l.version = pl.version
        GEM3UI_PlayerLineShowTagPopup(l);
      end
   end
end

function GEM3UI_EventPlayerOnLeave(p, row, col)
   local classline = getglobal("GEM3UI_EventDetailsClassLimitsHL");
   local roleline = getglobal("GEM3UI_EventDetailsRoleLimitsHL");
   roleline:Hide();
   classline:Hide();
   GEM3UIPlayerDetails:Hide();
   GEM3UI_PlayerLineHideTagPopup();
   local es = getglobal("GEM3UIEventSubs");
   es:Hide();
   es:Show()
end
